// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl

// clang-format off
#include "DictionarySequenceOrDictionary.h"

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ToV8ForCore.h"

namespace blink {

DictionarySequenceOrDictionary::DictionarySequenceOrDictionary() : m_type(SpecificTypeNone) {}

Dictionary DictionarySequenceOrDictionary::getAsDictionary() const {
  DCHECK(isDictionary());
  return m_dictionary;
}

void DictionarySequenceOrDictionary::setDictionary(Dictionary value) {
  DCHECK(isNull());
  m_dictionary = value;
  m_type = SpecificTypeDictionary;
}

DictionarySequenceOrDictionary DictionarySequenceOrDictionary::fromDictionary(Dictionary value) {
  DictionarySequenceOrDictionary container;
  container.setDictionary(value);
  return container;
}

const Vector<Dictionary>& DictionarySequenceOrDictionary::getAsDictionarySequence() const {
  DCHECK(isDictionarySequence());
  return m_dictionarySequence;
}

void DictionarySequenceOrDictionary::setDictionarySequence(const Vector<Dictionary>& value) {
  DCHECK(isNull());
  m_dictionarySequence = value;
  m_type = SpecificTypeDictionarySequence;
}

DictionarySequenceOrDictionary DictionarySequenceOrDictionary::fromDictionarySequence(const Vector<Dictionary>& value) {
  DictionarySequenceOrDictionary container;
  container.setDictionarySequence(value);
  return container;
}

DictionarySequenceOrDictionary::DictionarySequenceOrDictionary(const DictionarySequenceOrDictionary&) = default;
DictionarySequenceOrDictionary::~DictionarySequenceOrDictionary() = default;
DictionarySequenceOrDictionary& DictionarySequenceOrDictionary::operator=(const DictionarySequenceOrDictionary&) = default;

DEFINE_TRACE(DictionarySequenceOrDictionary) {
}

void V8DictionarySequenceOrDictionary::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, DictionarySequenceOrDictionary& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (HasCallableIteratorSymbol(isolate, v8Value, exceptionState)) {
    Vector<Dictionary> cppValue = NativeValueTraits<IDLSequence<Dictionary>>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setDictionarySequence(cppValue);
    return;
  }

  if (IsUndefinedOrNull(v8Value) || v8Value->IsObject()) {
    Dictionary cppValue = NativeValueTraits<Dictionary>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setDictionary(cppValue);
    return;
  }

  exceptionState.ThrowTypeError("The provided value is not of type '(sequence<Dictionary> or Dictionary)'");
}

v8::Local<v8::Value> ToV8(const DictionarySequenceOrDictionary& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case DictionarySequenceOrDictionary::SpecificTypeNone:
      return v8::Null(isolate);
    case DictionarySequenceOrDictionary::SpecificTypeDictionary:
      return impl.getAsDictionary().V8Value();
    case DictionarySequenceOrDictionary::SpecificTypeDictionarySequence:
      return ToV8(impl.getAsDictionarySequence(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

DictionarySequenceOrDictionary NativeValueTraits<DictionarySequenceOrDictionary>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  DictionarySequenceOrDictionary impl;
  V8DictionarySequenceOrDictionary::toImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
