// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl

// clang-format off
#include "FloatOrStringElementRecord.h"

#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ToV8ForCore.h"
#include "bindings/core/v8/V8Element.h"
#include "core/animation/ElementAnimation.h"
#include "core/dom/ChildNode.h"
#include "core/dom/NonDocumentTypeChildNode.h"
#include "core/dom/ParentNode.h"
#include "core/fullscreen/ElementFullscreen.h"

namespace blink {

FloatOrStringElementRecord::FloatOrStringElementRecord() : m_type(SpecificTypeNone) {}

float FloatOrStringElementRecord::getAsFloat() const {
  DCHECK(isFloat());
  return m_float;
}

void FloatOrStringElementRecord::setFloat(float value) {
  DCHECK(isNull());
  m_float = value;
  m_type = SpecificTypeFloat;
}

FloatOrStringElementRecord FloatOrStringElementRecord::fromFloat(float value) {
  FloatOrStringElementRecord container;
  container.setFloat(value);
  return container;
}

const HeapVector<std::pair<String, Member<Element>>>& FloatOrStringElementRecord::getAsStringElementRecord() const {
  DCHECK(isStringElementRecord());
  return m_stringElementRecord;
}

void FloatOrStringElementRecord::setStringElementRecord(const HeapVector<std::pair<String, Member<Element>>>& value) {
  DCHECK(isNull());
  m_stringElementRecord = value;
  m_type = SpecificTypeStringElementRecord;
}

FloatOrStringElementRecord FloatOrStringElementRecord::fromStringElementRecord(const HeapVector<std::pair<String, Member<Element>>>& value) {
  FloatOrStringElementRecord container;
  container.setStringElementRecord(value);
  return container;
}

FloatOrStringElementRecord::FloatOrStringElementRecord(const FloatOrStringElementRecord&) = default;
FloatOrStringElementRecord::~FloatOrStringElementRecord() = default;
FloatOrStringElementRecord& FloatOrStringElementRecord::operator=(const FloatOrStringElementRecord&) = default;

DEFINE_TRACE(FloatOrStringElementRecord) {
  visitor->Trace(m_stringElementRecord);
}

void V8FloatOrStringElementRecord::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, FloatOrStringElementRecord& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (v8Value->IsObject()) {
    HeapVector<std::pair<String, Member<Element>>> cppValue = NativeValueTraits<IDLRecord<IDLString, Element>>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setStringElementRecord(cppValue);
    return;
  }

  if (v8Value->IsNumber()) {
    float cppValue = NativeValueTraits<IDLFloat>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setFloat(cppValue);
    return;
  }

  {
    float cppValue = NativeValueTraits<IDLFloat>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setFloat(cppValue);
    return;
  }
}

v8::Local<v8::Value> ToV8(const FloatOrStringElementRecord& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case FloatOrStringElementRecord::SpecificTypeNone:
      return v8::Null(isolate);
    case FloatOrStringElementRecord::SpecificTypeFloat:
      return v8::Number::New(isolate, impl.getAsFloat());
    case FloatOrStringElementRecord::SpecificTypeStringElementRecord:
      return ToV8(impl.getAsStringElementRecord(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

FloatOrStringElementRecord NativeValueTraits<FloatOrStringElementRecord>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  FloatOrStringElementRecord impl;
  V8FloatOrStringElementRecord::toImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
