// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8HTMLTableElement.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8HTMLCollection.h"
#include "bindings/core/v8/V8HTMLTableCaptionElement.h"
#include "bindings/core/v8/V8HTMLTableRowElement.h"
#include "bindings/core/v8/V8HTMLTableSectionElement.h"
#include "core/HTMLNames.h"
#include "core/animation/ElementAnimation.h"
#include "core/dom/ClassCollection.h"
#include "core/dom/ExecutionContext.h"
#include "core/dom/TagCollection.h"
#include "core/fullscreen/ElementFullscreen.h"
#include "core/html/HTMLCollection.h"
#include "core/html/HTMLDataListOptionsCollection.h"
#include "core/html/HTMLFormControlsCollection.h"
#include "core/html/HTMLTableRowsCollection.h"
#include "core/html/custom/CEReactionsScope.h"
#include "core/html/custom/V0CustomElementProcessingStack.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8HTMLTableElement::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8HTMLTableElement::domTemplate,
    V8HTMLTableElement::Trace,
    V8HTMLTableElement::TraceWrappers,
    nullptr,
    "HTMLTableElement",
    &V8HTMLElement::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kNodeClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in HTMLTableElement.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& HTMLTableElement::wrapper_type_info_ = V8HTMLTableElement::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, HTMLTableElement>::value,
    "HTMLTableElement inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&HTMLTableElement::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "HTMLTableElement is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace HTMLTableElementV8Internal {

static void captionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->caption()), impl);
}

static void captionAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "HTMLTableElement", "caption");

  // Prepare the value to be set.
  HTMLTableCaptionElement* cppValue = V8HTMLTableCaptionElement::toImplWithTypeCheck(info.GetIsolate(), v8Value);

  // Type check per: http://heycam.github.io/webidl/#es-interface
  if (!cppValue && !IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("The provided value is not of type 'HTMLTableCaptionElement'.");
    return;
  }

  impl->setCaption(cppValue, exceptionState);
}

static void tHeadAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->tHead()), impl);
}

static void tHeadAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "HTMLTableElement", "tHead");

  // Prepare the value to be set.
  HTMLTableSectionElement* cppValue = V8HTMLTableSectionElement::toImplWithTypeCheck(info.GetIsolate(), v8Value);

  // Type check per: http://heycam.github.io/webidl/#es-interface
  if (!cppValue && !IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("The provided value is not of type 'HTMLTableSectionElement'.");
    return;
  }

  impl->setTHead(cppValue, exceptionState);
}

static void tFootAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->tFoot()), impl);
}

static void tFootAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "HTMLTableElement", "tFoot");

  // Prepare the value to be set.
  HTMLTableSectionElement* cppValue = V8HTMLTableSectionElement::toImplWithTypeCheck(info.GetIsolate(), v8Value);

  // Type check per: http://heycam.github.io/webidl/#es-interface
  if (!cppValue && !IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("The provided value is not of type 'HTMLTableSectionElement'.");
    return;
  }

  impl->setTFoot(cppValue, exceptionState);
}

static void tBodiesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->tBodies()), impl);
}

static void rowsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->rows()), impl);
}

static void alignAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::alignAttr), info.GetIsolate());
}

static void alignAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::alignAttr, cppValue);
}

static void borderAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::borderAttr), info.GetIsolate());
}

static void borderAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::borderAttr, cppValue);
}

static void frameAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::frameAttr), info.GetIsolate());
}

static void frameAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::frameAttr, cppValue);
}

static void rulesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::rulesAttr), info.GetIsolate());
}

static void rulesAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::rulesAttr, cppValue);
}

static void summaryAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::summaryAttr), info.GetIsolate());
}

static void summaryAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::summaryAttr, cppValue);
}

static void widthAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::widthAttr), info.GetIsolate());
}

static void widthAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::widthAttr, cppValue);
}

static void bgColorAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::bgcolorAttr), info.GetIsolate());
}

static void bgColorAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<kTreatNullAsEmptyString> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::bgcolorAttr, cppValue);
}

static void cellPaddingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::cellpaddingAttr), info.GetIsolate());
}

static void cellPaddingAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<kTreatNullAsEmptyString> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::cellpaddingAttr, cppValue);
}

static void cellSpacingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  V8SetReturnValueString(info, impl->FastGetAttribute(HTMLNames::cellspacingAttr), info.GetIsolate());
}

static void cellSpacingAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<kTreatNullAsEmptyString> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setAttribute(HTMLNames::cellspacingAttr, cppValue);
}

static void createCaptionMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  V8SetReturnValueFast(info, impl->createCaption(), impl);
}

static void deleteCaptionMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  impl->deleteCaption();
}

static void createTHeadMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  V8SetReturnValueFast(info, impl->createTHead(), impl);
}

static void deleteTHeadMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  impl->deleteTHead();
}

static void createTFootMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  V8SetReturnValueFast(info, impl->createTFoot(), impl);
}

static void deleteTFootMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  impl->deleteTFoot();
}

static void createTBodyMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  V8SetReturnValueFast(info, impl->createTBody(), impl);
}

static void insertRowMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "HTMLTableElement", "insertRow");

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  int32_t index;
  if (!info[0]->IsUndefined()) {
    index = NativeValueTraits<IDLLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
    if (exceptionState.HadException())
      return;
  } else {
    index = -1;
  }

  HTMLTableRowElement* result = impl->insertRow(index, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
  V8SetReturnValueFast(info, result, impl);
}

static void deleteRowMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "HTMLTableElement", "deleteRow");

  HTMLTableElement* impl = V8HTMLTableElement::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  int32_t index;
  index = NativeValueTraits<IDLLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  impl->deleteRow(index, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

} // namespace HTMLTableElementV8Internal

void V8HTMLTableElement::captionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::captionAttributeGetter(info);
}

void V8HTMLTableElement::captionAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  HTMLTableElementV8Internal::captionAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::tHeadAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::tHeadAttributeGetter(info);
}

void V8HTMLTableElement::tHeadAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  HTMLTableElementV8Internal::tHeadAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::tFootAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::tFootAttributeGetter(info);
}

void V8HTMLTableElement::tFootAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  HTMLTableElementV8Internal::tFootAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::tBodiesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::tBodiesAttributeGetter(info);
}

void V8HTMLTableElement::rowsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::rowsAttributeGetter(info);
}

void V8HTMLTableElement::alignAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::alignAttributeGetter(info);
}

void V8HTMLTableElement::alignAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::alignAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::borderAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::borderAttributeGetter(info);
}

void V8HTMLTableElement::borderAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::borderAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::frameAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::frameAttributeGetter(info);
}

void V8HTMLTableElement::frameAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::frameAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::rulesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::rulesAttributeGetter(info);
}

void V8HTMLTableElement::rulesAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::rulesAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::summaryAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::summaryAttributeGetter(info);
}

void V8HTMLTableElement::summaryAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::summaryAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::widthAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::widthAttributeGetter(info);
}

void V8HTMLTableElement::widthAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::widthAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::bgColorAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::bgColorAttributeGetter(info);
}

void V8HTMLTableElement::bgColorAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::bgColorAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::cellPaddingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::cellPaddingAttributeGetter(info);
}

void V8HTMLTableElement::cellPaddingAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::cellPaddingAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::cellSpacingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLTableElementV8Internal::cellSpacingAttributeGetter(info);
}

void V8HTMLTableElement::cellSpacingAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  CEReactionsScope ceReactionsScope;

  V0CustomElementProcessingStack::CallbackDeliveryScope deliveryScope;

  HTMLTableElementV8Internal::cellSpacingAttributeSetter(v8Value, info);
}

void V8HTMLTableElement::createCaptionMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::createCaptionMethod(info);
}

void V8HTMLTableElement::deleteCaptionMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::deleteCaptionMethod(info);
}

void V8HTMLTableElement::createTHeadMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::createTHeadMethod(info);
}

void V8HTMLTableElement::deleteTHeadMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::deleteTHeadMethod(info);
}

void V8HTMLTableElement::createTFootMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::createTFootMethod(info);
}

void V8HTMLTableElement::deleteTFootMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::deleteTFootMethod(info);
}

void V8HTMLTableElement::createTBodyMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::createTBodyMethod(info);
}

void V8HTMLTableElement::insertRowMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::insertRowMethod(info);
}

void V8HTMLTableElement::deleteRowMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  CEReactionsScope ceReactionsScope;
  HTMLTableElementV8Internal::deleteRowMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8HTMLTableElementAccessors[] = {
    { "caption", V8HTMLTableElement::captionAttributeGetterCallback, V8HTMLTableElement::captionAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "tHead", V8HTMLTableElement::tHeadAttributeGetterCallback, V8HTMLTableElement::tHeadAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "tFoot", V8HTMLTableElement::tFootAttributeGetterCallback, V8HTMLTableElement::tFootAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "tBodies", V8HTMLTableElement::tBodiesAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "rows", V8HTMLTableElement::rowsAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "align", V8HTMLTableElement::alignAttributeGetterCallback, V8HTMLTableElement::alignAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "border", V8HTMLTableElement::borderAttributeGetterCallback, V8HTMLTableElement::borderAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "frame", V8HTMLTableElement::frameAttributeGetterCallback, V8HTMLTableElement::frameAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "rules", V8HTMLTableElement::rulesAttributeGetterCallback, V8HTMLTableElement::rulesAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "summary", V8HTMLTableElement::summaryAttributeGetterCallback, V8HTMLTableElement::summaryAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "width", V8HTMLTableElement::widthAttributeGetterCallback, V8HTMLTableElement::widthAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "bgColor", V8HTMLTableElement::bgColorAttributeGetterCallback, V8HTMLTableElement::bgColorAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "cellPadding", V8HTMLTableElement::cellPaddingAttributeGetterCallback, V8HTMLTableElement::cellPaddingAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "cellSpacing", V8HTMLTableElement::cellSpacingAttributeGetterCallback, V8HTMLTableElement::cellSpacingAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8HTMLTableElementMethods[] = {
    {"createCaption", V8HTMLTableElement::createCaptionMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"deleteCaption", V8HTMLTableElement::deleteCaptionMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"createTHead", V8HTMLTableElement::createTHeadMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"deleteTHead", V8HTMLTableElement::deleteTHeadMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"createTFoot", V8HTMLTableElement::createTFootMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"deleteTFoot", V8HTMLTableElement::deleteTFootMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"createTBody", V8HTMLTableElement::createTBodyMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"insertRow", V8HTMLTableElement::insertRowMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"deleteRow", V8HTMLTableElement::deleteRowMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8HTMLTableElementTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8HTMLTableElement::wrapperTypeInfo.interface_name, V8HTMLElement::domTemplate(isolate, world), V8HTMLTableElement::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8HTMLTableElementAccessors, WTF_ARRAY_LENGTH(V8HTMLTableElementAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8HTMLTableElementMethods, WTF_ARRAY_LENGTH(V8HTMLTableElementMethods));

  // Custom signature

  V8HTMLTableElement::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8HTMLTableElement::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8HTMLTableElement::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8HTMLTableElementTemplate);
}

bool V8HTMLTableElement::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8HTMLTableElement::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

HTMLTableElement* V8HTMLTableElement::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

HTMLTableElement* NativeValueTraits<HTMLTableElement>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  HTMLTableElement* nativeValue = V8HTMLTableElement::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "HTMLTableElement"));
  }
  return nativeValue;
}

}  // namespace blink
