// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8IntersectionObserver.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8Element.h"
#include "bindings/core/v8/V8IntersectionObserverEntry.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/frame/UseCounter.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8IntersectionObserver::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8IntersectionObserver::domTemplate,
    V8IntersectionObserver::Trace,
    V8IntersectionObserver::TraceWrappers,
    nullptr,
    "IntersectionObserver",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in IntersectionObserver.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& IntersectionObserver::wrapper_type_info_ = V8IntersectionObserver::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, IntersectionObserver>::value,
    "IntersectionObserver inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&IntersectionObserver::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "IntersectionObserver is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace IntersectionObserverV8Internal {

static void rootAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  IntersectionObserver* impl = V8IntersectionObserver::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->root()), impl);
}

static void rootMarginAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  IntersectionObserver* impl = V8IntersectionObserver::toImpl(holder);

  V8SetReturnValueString(info, impl->rootMargin(), info.GetIsolate());
}

static void thresholdsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  IntersectionObserver* impl = V8IntersectionObserver::toImpl(holder);

  V8SetReturnValue(info, FreezeV8Object(ToV8(impl->thresholds(), info.Holder(), info.GetIsolate()), info.GetIsolate()));
}

static void observeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "IntersectionObserver", "observe");

  IntersectionObserver* impl = V8IntersectionObserver::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  Element* target;
  target = V8Element::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!target) {
    exceptionState.ThrowTypeError("parameter 1 is not of type 'Element'.");

    return;
  }

  impl->observe(target, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void unobserveMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "IntersectionObserver", "unobserve");

  IntersectionObserver* impl = V8IntersectionObserver::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  Element* target;
  target = V8Element::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!target) {
    exceptionState.ThrowTypeError("parameter 1 is not of type 'Element'.");

    return;
  }

  impl->unobserve(target, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void disconnectMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "IntersectionObserver", "disconnect");

  IntersectionObserver* impl = V8IntersectionObserver::toImpl(info.Holder());

  impl->disconnect(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void takeRecordsMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "IntersectionObserver", "takeRecords");

  IntersectionObserver* impl = V8IntersectionObserver::toImpl(info.Holder());

  HeapVector<Member<IntersectionObserverEntry>> result = impl->takeRecords(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
  V8SetReturnValue(info, ToV8(result, info.Holder(), info.GetIsolate()));
}

} // namespace IntersectionObserverV8Internal

void V8IntersectionObserver::rootAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  IntersectionObserverV8Internal::rootAttributeGetter(info);
}

void V8IntersectionObserver::rootMarginAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  IntersectionObserverV8Internal::rootMarginAttributeGetter(info);
}

void V8IntersectionObserver::thresholdsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  IntersectionObserverV8Internal::thresholdsAttributeGetter(info);
}

void V8IntersectionObserver::observeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  IntersectionObserverV8Internal::observeMethod(info);
}

void V8IntersectionObserver::unobserveMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  IntersectionObserverV8Internal::unobserveMethod(info);
}

void V8IntersectionObserver::disconnectMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  IntersectionObserverV8Internal::disconnectMethod(info);
}

void V8IntersectionObserver::takeRecordsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  IntersectionObserverV8Internal::takeRecordsMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8IntersectionObserverAccessors[] = {
    { "root", V8IntersectionObserver::rootAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "rootMargin", V8IntersectionObserver::rootMarginAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "thresholds", V8IntersectionObserver::thresholdsAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8IntersectionObserverMethods[] = {
    {"observe", V8IntersectionObserver::observeMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"unobserve", V8IntersectionObserver::unobserveMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"disconnect", V8IntersectionObserver::disconnectMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"takeRecords", V8IntersectionObserver::takeRecordsMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

void V8IntersectionObserver::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kIntersectionObserver_Constructor);
  if (!info.IsConstructCall()) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::ConstructorNotCallableAsFunction("IntersectionObserver"));
    return;
  }

  if (ConstructorMode::Current(info.GetIsolate()) == ConstructorMode::kWrapExistingObject) {
    V8SetReturnValue(info, info.Holder());
    return;
  }

  V8IntersectionObserver::constructorCustom(info);
}

static void installV8IntersectionObserverTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8IntersectionObserver::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8IntersectionObserver::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8IntersectionObserver::constructorCallback);
  interfaceTemplate->SetLength(1);

  if (!RuntimeEnabledFeatures::IntersectionObserverEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8IntersectionObserverAccessors, WTF_ARRAY_LENGTH(V8IntersectionObserverAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8IntersectionObserverMethods, WTF_ARRAY_LENGTH(V8IntersectionObserverMethods));

  // Custom signature

  V8IntersectionObserver::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8IntersectionObserver::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  if (!RuntimeEnabledFeatures::IntersectionObserverEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8IntersectionObserver::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8IntersectionObserverTemplate);
}

bool V8IntersectionObserver::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8IntersectionObserver::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

IntersectionObserver* V8IntersectionObserver::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

IntersectionObserver* NativeValueTraits<IntersectionObserver>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  IntersectionObserver* nativeValue = V8IntersectionObserver::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "IntersectionObserver"));
  }
  return nativeValue;
}

}  // namespace blink
