// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8Mojo.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8MojoCreateDataPipeOptions.h"
#include "bindings/core/v8/V8MojoCreateDataPipeResult.h"
#include "bindings/core/v8/V8MojoCreateMessagePipeResult.h"
#include "bindings/core/v8/V8MojoCreateSharedBufferResult.h"
#include "bindings/core/v8/V8MojoHandle.h"
#include "core/dom/ExecutionContext.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8Mojo::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8Mojo::domTemplate,
    V8Mojo::Trace,
    V8Mojo::TraceWrappers,
    nullptr,
    "Mojo",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kIndependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in Mojo.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& Mojo::wrapper_type_info_ = V8Mojo::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, Mojo>::value,
    "Mojo inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&Mojo::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "Mojo is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace MojoV8Internal {

static void createMessagePipeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoCreateMessagePipeResult result;
  Mojo::createMessagePipe(result);
  V8SetReturnValue(info, result, info.GetIsolate()->GetCurrentContext()->Global());
}

static void createDataPipeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Mojo", "createDataPipe");

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  MojoCreateDataPipeOptions options;
  if (!IsUndefinedOrNull(info[0]) && !info[0]->IsObject()) {
    exceptionState.ThrowTypeError("parameter 1 ('options') is not an object.");

    return;
  }
  V8MojoCreateDataPipeOptions::toImpl(info.GetIsolate(), info[0], options, exceptionState);
  if (exceptionState.HadException())
    return;

  MojoCreateDataPipeResult result;
  Mojo::createDataPipe(options, result);
  V8SetReturnValue(info, result, info.GetIsolate()->GetCurrentContext()->Global());
}

static void createSharedBufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Mojo", "createSharedBuffer");

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  uint32_t numBytes;
  numBytes = NativeValueTraits<IDLUnsignedLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  MojoCreateSharedBufferResult result;
  Mojo::createSharedBuffer(numBytes, result);
  V8SetReturnValue(info, result, info.GetIsolate()->GetCurrentContext()->Global());
}

static void bindInterfaceMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ScriptState* scriptState = ScriptState::ForFunctionObject(info);

  if (UNLIKELY(info.Length() < 2)) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::FailedToExecute("bindInterface", "Mojo", ExceptionMessages::NotEnoughArguments(2, info.Length())));
    return;
  }

  V8StringResource<> interfaceName;
  MojoHandle* request_handle;
  interfaceName = info[0];
  if (!interfaceName.Prepare())
    return;

  request_handle = V8MojoHandle::toImplWithTypeCheck(info.GetIsolate(), info[1]);
  if (!request_handle) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::FailedToExecute("bindInterface", "Mojo", "parameter 2 is not of type 'MojoHandle'."));

    return;
  }

  Mojo::bindInterface(scriptState, interfaceName, request_handle);
}

} // namespace MojoV8Internal

void V8Mojo::createMessagePipeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoV8Internal::createMessagePipeMethod(info);
}

void V8Mojo::createDataPipeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoV8Internal::createDataPipeMethod(info);
}

void V8Mojo::createSharedBufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoV8Internal::createSharedBufferMethod(info);
}

void V8Mojo::bindInterfaceMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoV8Internal::bindInterfaceMethod(info);
}

static const V8DOMConfiguration::MethodConfiguration V8MojoMethods[] = {
    {"createMessagePipe", V8Mojo::createMessagePipeMethodCallback, 0, v8::None, V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"createDataPipe", V8Mojo::createDataPipeMethodCallback, 1, v8::None, V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"createSharedBuffer", V8Mojo::createSharedBufferMethodCallback, 1, v8::None, V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"bindInterface", V8Mojo::bindInterfaceMethodCallback, 2, v8::None, V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8MojoTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8Mojo::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8Mojo::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  const V8DOMConfiguration::ConstantConfiguration V8MojoConstants[] = {
      {"RESULT_OK", 0, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_CANCELLED", 1, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_UNKNOWN", 2, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_INVALID_ARGUMENT", 3, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_DEADLINE_EXCEEDED", 4, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_NOT_FOUND", 5, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_ALREADY_EXISTS", 6, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_PERMISSION_DENIED", 7, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_RESOURCE_EXHAUSTED", 8, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_FAILED_PRECONDITION", 9, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_ABORTED", 10, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_OUT_OF_RANGE", 11, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_UNIMPLEMENTED", 12, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_INTERNAL", 13, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_UNAVAILABLE", 14, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_DATA_LOSS", 15, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_BUSY", 16, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"RESULT_SHOULD_WAIT", 17, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
  };
  V8DOMConfiguration::InstallConstants(
      isolate, interfaceTemplate, prototypeTemplate,
      V8MojoConstants, WTF_ARRAY_LENGTH(V8MojoConstants));
  static_assert(0 == Mojo::kResultOk, "the value of Mojo_kResultOk does not match with implementation");
  static_assert(1 == Mojo::kResultCancelled, "the value of Mojo_kResultCancelled does not match with implementation");
  static_assert(2 == Mojo::kResultUnknown, "the value of Mojo_kResultUnknown does not match with implementation");
  static_assert(3 == Mojo::kResultInvalidArgument, "the value of Mojo_kResultInvalidArgument does not match with implementation");
  static_assert(4 == Mojo::kResultDeadlineExceeded, "the value of Mojo_kResultDeadlineExceeded does not match with implementation");
  static_assert(5 == Mojo::kResultNotFound, "the value of Mojo_kResultNotFound does not match with implementation");
  static_assert(6 == Mojo::kResultAlreadyExists, "the value of Mojo_kResultAlreadyExists does not match with implementation");
  static_assert(7 == Mojo::kResultPermissionDenied, "the value of Mojo_kResultPermissionDenied does not match with implementation");
  static_assert(8 == Mojo::kResultResourceExhausted, "the value of Mojo_kResultResourceExhausted does not match with implementation");
  static_assert(9 == Mojo::kResultFailedPrecondition, "the value of Mojo_kResultFailedPrecondition does not match with implementation");
  static_assert(10 == Mojo::kResultAborted, "the value of Mojo_kResultAborted does not match with implementation");
  static_assert(11 == Mojo::kResultOutOfRange, "the value of Mojo_kResultOutOfRange does not match with implementation");
  static_assert(12 == Mojo::kResultUnimplemented, "the value of Mojo_kResultUnimplemented does not match with implementation");
  static_assert(13 == Mojo::kResultInternal, "the value of Mojo_kResultInternal does not match with implementation");
  static_assert(14 == Mojo::kResultUnavailable, "the value of Mojo_kResultUnavailable does not match with implementation");
  static_assert(15 == Mojo::kResultDataLoss, "the value of Mojo_kResultDataLoss does not match with implementation");
  static_assert(16 == Mojo::kResultBusy, "the value of Mojo_kResultBusy does not match with implementation");
  static_assert(17 == Mojo::kResultShouldWait, "the value of Mojo_kResultShouldWait does not match with implementation");
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8MojoMethods, WTF_ARRAY_LENGTH(V8MojoMethods));

  // Custom signature

  V8Mojo::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8Mojo::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8Mojo::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8MojoTemplate);
}

bool V8Mojo::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8Mojo::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

Mojo* V8Mojo::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

Mojo* NativeValueTraits<Mojo>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  Mojo* nativeValue = V8Mojo::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "Mojo"));
  }
  return nativeValue;
}

}  // namespace blink
