// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8MojoInterfaceInterceptor.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/LocalDOMWindow.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8MojoInterfaceInterceptor::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8MojoInterfaceInterceptor::domTemplate,
    V8MojoInterfaceInterceptor::Trace,
    V8MojoInterfaceInterceptor::TraceWrappers,
    nullptr,
    "MojoInterfaceInterceptor",
    &V8EventTarget::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in MojoInterfaceInterceptor.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& MojoInterfaceInterceptor::wrapper_type_info_ = V8MojoInterfaceInterceptor::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappableBase, MojoInterfaceInterceptor>::value,
    "MojoInterfaceInterceptor does not inherit from ActiveScriptWrappable<>, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&MojoInterfaceInterceptor::HasPendingActivity),
                  decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "MojoInterfaceInterceptor is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace MojoInterfaceInterceptorV8Internal {

static void oninterfacerequestAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MojoInterfaceInterceptor* impl = V8MojoInterfaceInterceptor::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->oninterfacerequest()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void oninterfacerequestAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  MojoInterfaceInterceptor* impl = V8MojoInterfaceInterceptor::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->oninterfacerequest(), v8Value, V8MojoInterfaceInterceptor::eventListenerCacheIndex);

  impl->setOninterfacerequest(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void startMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "MojoInterfaceInterceptor", "start");

  MojoInterfaceInterceptor* impl = V8MojoInterfaceInterceptor::toImpl(info.Holder());

  impl->start(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void stopMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoInterfaceInterceptor* impl = V8MojoInterfaceInterceptor::toImpl(info.Holder());

  impl->stop();
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::FailedToConstruct("MojoInterfaceInterceptor", ExceptionMessages::NotEnoughArguments(1, info.Length())));
    return;
  }

  V8StringResource<> interfaceName;
  interfaceName = info[0];
  if (!interfaceName.Prepare())
    return;

  MojoInterfaceInterceptor* impl = MojoInterfaceInterceptor::Create(scriptState, interfaceName);
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->AssociateWithWrapper(info.GetIsolate(), &V8MojoInterfaceInterceptor::wrapperTypeInfo, wrapper);
  V8SetReturnValue(info, wrapper);
}

} // namespace MojoInterfaceInterceptorV8Internal

void V8MojoInterfaceInterceptor::oninterfacerequestAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoInterfaceInterceptorV8Internal::oninterfacerequestAttributeGetter(info);
}

void V8MojoInterfaceInterceptor::oninterfacerequestAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  MojoInterfaceInterceptorV8Internal::oninterfacerequestAttributeSetter(v8Value, info);
}

void V8MojoInterfaceInterceptor::startMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoInterfaceInterceptorV8Internal::startMethod(info);
}

void V8MojoInterfaceInterceptor::stopMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MojoInterfaceInterceptorV8Internal::stopMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8MojoInterfaceInterceptorAccessors[] = {
    { "oninterfacerequest", V8MojoInterfaceInterceptor::oninterfacerequestAttributeGetterCallback, V8MojoInterfaceInterceptor::oninterfacerequestAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8MojoInterfaceInterceptorMethods[] = {
    {"start", V8MojoInterfaceInterceptor::startMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"stop", V8MojoInterfaceInterceptor::stopMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

void V8MojoInterfaceInterceptor::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::ConstructorNotCallableAsFunction("MojoInterfaceInterceptor"));
    return;
  }

  if (ConstructorMode::Current(info.GetIsolate()) == ConstructorMode::kWrapExistingObject) {
    V8SetReturnValue(info, info.Holder());
    return;
  }

  MojoInterfaceInterceptorV8Internal::constructor(info);
}

static void installV8MojoInterfaceInterceptorTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8MojoInterfaceInterceptor::wrapperTypeInfo.interface_name, V8EventTarget::domTemplate(isolate, world), V8MojoInterfaceInterceptor::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8MojoInterfaceInterceptor::constructorCallback);
  interfaceTemplate->SetLength(1);

  if (!RuntimeEnabledFeatures::MojoJSTestEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8MojoInterfaceInterceptorAccessors, WTF_ARRAY_LENGTH(V8MojoInterfaceInterceptorAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8MojoInterfaceInterceptorMethods, WTF_ARRAY_LENGTH(V8MojoInterfaceInterceptorMethods));

  // Custom signature

  V8MojoInterfaceInterceptor::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8MojoInterfaceInterceptor::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  if (!RuntimeEnabledFeatures::MojoJSTestEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8MojoInterfaceInterceptor::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8MojoInterfaceInterceptorTemplate);
}

bool V8MojoInterfaceInterceptor::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8MojoInterfaceInterceptor::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

MojoInterfaceInterceptor* V8MojoInterfaceInterceptor::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

MojoInterfaceInterceptor* NativeValueTraits<MojoInterfaceInterceptor>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  MojoInterfaceInterceptor* nativeValue = V8MojoInterfaceInterceptor::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "MojoInterfaceInterceptor"));
  }
  return nativeValue;
}

}  // namespace blink
