// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl

// clang-format off
#include "AudioContextLatencyCategoryOrDouble.h"

#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ToV8ForCore.h"

namespace blink {

AudioContextLatencyCategoryOrDouble::AudioContextLatencyCategoryOrDouble() : m_type(SpecificTypeNone) {}

const String& AudioContextLatencyCategoryOrDouble::getAsAudioContextLatencyCategory() const {
  DCHECK(isAudioContextLatencyCategory());
  return m_audioContextLatencyCategory;
}

void AudioContextLatencyCategoryOrDouble::setAudioContextLatencyCategory(const String& value) {
  DCHECK(isNull());
  NonThrowableExceptionState exceptionState;
  const char* validValues[] = {
      "balanced",
      "interactive",
      "playback",
  };
  if (!IsValidEnum(value, validValues, WTF_ARRAY_LENGTH(validValues), "AudioContextLatencyCategory", exceptionState)) {
    NOTREACHED();
    return;
  }
  m_audioContextLatencyCategory = value;
  m_type = SpecificTypeAudioContextLatencyCategory;
}

AudioContextLatencyCategoryOrDouble AudioContextLatencyCategoryOrDouble::fromAudioContextLatencyCategory(const String& value) {
  AudioContextLatencyCategoryOrDouble container;
  container.setAudioContextLatencyCategory(value);
  return container;
}

double AudioContextLatencyCategoryOrDouble::getAsDouble() const {
  DCHECK(isDouble());
  return m_double;
}

void AudioContextLatencyCategoryOrDouble::setDouble(double value) {
  DCHECK(isNull());
  m_double = value;
  m_type = SpecificTypeDouble;
}

AudioContextLatencyCategoryOrDouble AudioContextLatencyCategoryOrDouble::fromDouble(double value) {
  AudioContextLatencyCategoryOrDouble container;
  container.setDouble(value);
  return container;
}

AudioContextLatencyCategoryOrDouble::AudioContextLatencyCategoryOrDouble(const AudioContextLatencyCategoryOrDouble&) = default;
AudioContextLatencyCategoryOrDouble::~AudioContextLatencyCategoryOrDouble() = default;
AudioContextLatencyCategoryOrDouble& AudioContextLatencyCategoryOrDouble::operator=(const AudioContextLatencyCategoryOrDouble&) = default;

DEFINE_TRACE(AudioContextLatencyCategoryOrDouble) {
}

void V8AudioContextLatencyCategoryOrDouble::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AudioContextLatencyCategoryOrDouble& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (v8Value->IsNumber()) {
    double cppValue = NativeValueTraits<IDLDouble>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setDouble(cppValue);
    return;
  }

  {
    V8StringResource<> cppValue = v8Value;
    if (!cppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "balanced",
        "interactive",
        "playback",
    };
    if (!IsValidEnum(cppValue, validValues, WTF_ARRAY_LENGTH(validValues), "AudioContextLatencyCategory", exceptionState))
      return;
    impl.setAudioContextLatencyCategory(cppValue);
    return;
  }
}

v8::Local<v8::Value> ToV8(const AudioContextLatencyCategoryOrDouble& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case AudioContextLatencyCategoryOrDouble::SpecificTypeNone:
      return v8::Null(isolate);
    case AudioContextLatencyCategoryOrDouble::SpecificTypeAudioContextLatencyCategory:
      return V8String(isolate, impl.getAsAudioContextLatencyCategory());
    case AudioContextLatencyCategoryOrDouble::SpecificTypeDouble:
      return v8::Number::New(isolate, impl.getAsDouble());
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

AudioContextLatencyCategoryOrDouble NativeValueTraits<AudioContextLatencyCategoryOrDouble>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AudioContextLatencyCategoryOrDouble impl;
  V8AudioContextLatencyCategoryOrDouble::toImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
