// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl

// clang-format off
#include "V8AuthenticatorSelectionCriteria.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8AuthenticatorSelectionCriteriaKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "attachment",
    "requireResidentKey",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8AuthenticatorSelectionCriteria::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AuthenticatorSelectionCriteria& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8AuthenticatorSelectionCriteriaKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> attachmentValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&attachmentValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (attachmentValue.IsEmpty() || attachmentValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> attachmentCppValue = attachmentValue;
    if (!attachmentCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "platform",
        "cross-platform",
    };
    if (!IsValidEnum(attachmentCppValue, validValues, WTF_ARRAY_LENGTH(validValues), "AuthenticatorAttachment", exceptionState))
      return;
    impl.setAttachment(attachmentCppValue);
  }

  v8::Local<v8::Value> requireResidentKeyValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&requireResidentKeyValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (requireResidentKeyValue.IsEmpty() || requireResidentKeyValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool requireResidentKeyCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, requireResidentKeyValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setRequireResidentKey(requireResidentKeyCppValue);
  }
}

v8::Local<v8::Value> AuthenticatorSelectionCriteria::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8AuthenticatorSelectionCriteria(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8AuthenticatorSelectionCriteria(const AuthenticatorSelectionCriteria& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8AuthenticatorSelectionCriteriaKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> attachmentValue;
  bool attachmentHasValueOrDefault = false;
  if (impl.hasAttachment()) {
    attachmentValue = V8String(isolate, impl.attachment());
    attachmentHasValueOrDefault = true;
  }
  if (attachmentHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), attachmentValue))) {
    return false;
  }

  v8::Local<v8::Value> requireResidentKeyValue;
  bool requireResidentKeyHasValueOrDefault = false;
  if (impl.hasRequireResidentKey()) {
    requireResidentKeyValue = v8::Boolean::New(isolate, impl.requireResidentKey());
    requireResidentKeyHasValueOrDefault = true;
  } else {
    requireResidentKeyValue = v8::Boolean::New(isolate, false);
    requireResidentKeyHasValueOrDefault = true;
  }
  if (requireResidentKeyHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), requireResidentKeyValue))) {
    return false;
  }

  return true;
}

AuthenticatorSelectionCriteria NativeValueTraits<AuthenticatorSelectionCriteria>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AuthenticatorSelectionCriteria impl;
  V8AuthenticatorSelectionCriteria::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
