// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8DeprecatedStorageInfo.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/modules/v8/V8StorageErrorCallback.h"
#include "bindings/modules/v8/V8StorageQuotaCallback.h"
#include "bindings/modules/v8/V8StorageUsageCallback.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/UseCounter.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8DeprecatedStorageInfo::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8DeprecatedStorageInfo::domTemplate,
    V8DeprecatedStorageInfo::Trace,
    V8DeprecatedStorageInfo::TraceWrappers,
    nullptr,
    "DeprecatedStorageInfo",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kIndependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in DeprecatedStorageInfo.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& DeprecatedStorageInfo::wrapper_type_info_ = V8DeprecatedStorageInfo::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, DeprecatedStorageInfo>::value,
    "DeprecatedStorageInfo inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&DeprecatedStorageInfo::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "DeprecatedStorageInfo is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace DeprecatedStorageInfoV8Internal {

static void queryUsageAndQuotaMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "DeprecatedStorageInfo", "queryUsageAndQuota");

  DeprecatedStorageInfo* impl = V8DeprecatedStorageInfo::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  uint16_t storageType;
  StorageUsageCallback* usageCallback;
  StorageErrorCallback* errorCallback;
  storageType = NativeValueTraits<IDLUnsignedShort>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  if (!IsUndefinedOrNull(info[1])) {
    if (!info[1]->IsFunction()) {
      exceptionState.ThrowTypeError("The callback provided as parameter 2 is not a function.");

      return;
    }
    usageCallback = V8StorageUsageCallback::Create(v8::Local<v8::Function>::Cast(info[1]), ScriptState::Current(info.GetIsolate()));
  } else {
    usageCallback = nullptr;
  }

  if (!IsUndefinedOrNull(info[2])) {
    if (!info[2]->IsFunction()) {
      exceptionState.ThrowTypeError("The callback provided as parameter 3 is not a function.");

      return;
    }
    errorCallback = V8StorageErrorCallback::Create(v8::Local<v8::Function>::Cast(info[2]), ScriptState::Current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  impl->queryUsageAndQuota(scriptState, storageType, usageCallback, errorCallback);
}

static void requestQuotaMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "DeprecatedStorageInfo", "requestQuota");

  DeprecatedStorageInfo* impl = V8DeprecatedStorageInfo::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(2, info.Length()));
    return;
  }

  uint16_t storageType;
  uint64_t newQuotaInBytes;
  StorageQuotaCallback* quotaCallback;
  StorageErrorCallback* errorCallback;
  storageType = NativeValueTraits<IDLUnsignedShort>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  newQuotaInBytes = NativeValueTraits<IDLUnsignedLongLong>::NativeValue(info.GetIsolate(), info[1], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  if (!IsUndefinedOrNull(info[2])) {
    if (!info[2]->IsFunction()) {
      exceptionState.ThrowTypeError("The callback provided as parameter 3 is not a function.");

      return;
    }
    quotaCallback = V8StorageQuotaCallback::Create(v8::Local<v8::Function>::Cast(info[2]), ScriptState::Current(info.GetIsolate()));
  } else {
    quotaCallback = nullptr;
  }

  if (!IsUndefinedOrNull(info[3])) {
    if (!info[3]->IsFunction()) {
      exceptionState.ThrowTypeError("The callback provided as parameter 4 is not a function.");

      return;
    }
    errorCallback = V8StorageErrorCallback::Create(v8::Local<v8::Function>::Cast(info[3]), ScriptState::Current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  impl->requestQuota(scriptState, storageType, newQuotaInBytes, quotaCallback, errorCallback);
}

} // namespace DeprecatedStorageInfoV8Internal

void V8DeprecatedStorageInfo::queryUsageAndQuotaMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8DeprecatedStorageInfo_QueryUsageAndQuota_Method);
  DeprecatedStorageInfoV8Internal::queryUsageAndQuotaMethod(info);
}

void V8DeprecatedStorageInfo::requestQuotaMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8DeprecatedStorageInfo_RequestQuota_Method);
  DeprecatedStorageInfoV8Internal::requestQuotaMethod(info);
}

static const V8DOMConfiguration::MethodConfiguration V8DeprecatedStorageInfoMethods[] = {
    {"queryUsageAndQuota", V8DeprecatedStorageInfo::queryUsageAndQuotaMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"requestQuota", V8DeprecatedStorageInfo::requestQuotaMethodCallback, 2, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8DeprecatedStorageInfoTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8DeprecatedStorageInfo::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8DeprecatedStorageInfo::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  const V8DOMConfiguration::ConstantConfiguration V8DeprecatedStorageInfoConstants[] = {
      {"TEMPORARY", 0, 0, V8DOMConfiguration::kConstantTypeUnsignedShort},
      {"PERSISTENT", 1, 0, V8DOMConfiguration::kConstantTypeUnsignedShort},
  };
  V8DOMConfiguration::InstallConstants(
      isolate, interfaceTemplate, prototypeTemplate,
      V8DeprecatedStorageInfoConstants, WTF_ARRAY_LENGTH(V8DeprecatedStorageInfoConstants));
  static_assert(0 == DeprecatedStorageInfo::kTemporary, "the value of DeprecatedStorageInfo_kTemporary does not match with implementation");
  static_assert(1 == DeprecatedStorageInfo::kPersistent, "the value of DeprecatedStorageInfo_kPersistent does not match with implementation");
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8DeprecatedStorageInfoMethods, WTF_ARRAY_LENGTH(V8DeprecatedStorageInfoMethods));

  // Custom signature

  V8DeprecatedStorageInfo::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8DeprecatedStorageInfo::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8DeprecatedStorageInfo::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8DeprecatedStorageInfoTemplate);
}

bool V8DeprecatedStorageInfo::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8DeprecatedStorageInfo::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

DeprecatedStorageInfo* V8DeprecatedStorageInfo::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

DeprecatedStorageInfo* NativeValueTraits<DeprecatedStorageInfo>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  DeprecatedStorageInfo* nativeValue = V8DeprecatedStorageInfo::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "DeprecatedStorageInfo"));
  }
  return nativeValue;
}

}  // namespace blink
