// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl

// clang-format off
#include "V8FormDataOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8FormDataOptionsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "idName",
    "passwordName",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8FormDataOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, FormDataOptions& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8FormDataOptionsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> idNameValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&idNameValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (idNameValue.IsEmpty() || idNameValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> idNameCppValue = idNameValue;
    if (!idNameCppValue.Prepare(exceptionState))
      return;
    impl.setIdName(idNameCppValue);
  }

  v8::Local<v8::Value> passwordNameValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&passwordNameValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (passwordNameValue.IsEmpty() || passwordNameValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> passwordNameCppValue = passwordNameValue;
    if (!passwordNameCppValue.Prepare(exceptionState))
      return;
    impl.setPasswordName(passwordNameCppValue);
  }
}

v8::Local<v8::Value> FormDataOptions::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8FormDataOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8FormDataOptions(const FormDataOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8FormDataOptionsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> idNameValue;
  bool idNameHasValueOrDefault = false;
  if (impl.hasIdName()) {
    idNameValue = V8String(isolate, impl.idName());
    idNameHasValueOrDefault = true;
  } else {
    idNameValue = V8String(isolate, "username");
    idNameHasValueOrDefault = true;
  }
  if (idNameHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), idNameValue))) {
    return false;
  }

  v8::Local<v8::Value> passwordNameValue;
  bool passwordNameHasValueOrDefault = false;
  if (impl.hasPasswordName()) {
    passwordNameValue = V8String(isolate, impl.passwordName());
    passwordNameHasValueOrDefault = true;
  } else {
    passwordNameValue = V8String(isolate, "password");
    passwordNameHasValueOrDefault = true;
  }
  if (passwordNameHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), passwordNameValue))) {
    return false;
  }

  return true;
}

FormDataOptions NativeValueTraits<FormDataOptions>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  FormDataOptions impl;
  V8FormDataOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
