// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/partial_interface.cpp.tmpl

// clang-format off
#include "V8HTMLCanvasElementPartial.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8CanvasContextCreationAttributes.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8HTMLCanvasElement.h"
#include "bindings/core/v8/V8OffscreenCanvas.h"
#include "bindings/modules/v8/V8CanvasRenderingContext2D.h"
#include "bindings/modules/v8/V8ImageBitmapRenderingContext.h"
#include "bindings/modules/v8/V8MediaStream.h"
#include "bindings/modules/v8/V8WebGL2RenderingContext.h"
#include "bindings/modules/v8/V8WebGLRenderingContext.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/UseCounter.h"
#include "modules/canvas/HTMLCanvasElementModule.h"
#include "modules/mediacapturefromelement/HTMLCanvasElementCapture.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

namespace HTMLCanvasElementPartialV8Internal {

static void getContextMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "HTMLCanvasElement", "getContext");

  HTMLCanvasElement* impl = V8HTMLCanvasElement::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<> contextId;
  CanvasContextCreationAttributes attributes;
  contextId = info[0];
  if (!contextId.Prepare())
    return;

  V8CanvasContextCreationAttributes::toImpl(info.GetIsolate(), info[1], attributes, exceptionState);
  if (exceptionState.HadException())
    return;

  CanvasRenderingContext2DOrWebGLRenderingContextOrWebGL2RenderingContextOrImageBitmapRenderingContext result;
  HTMLCanvasElementModule::getContext(*impl, contextId, attributes, exceptionState, result);
  if (exceptionState.HadException()) {
    return;
  }
  V8SetReturnValue(info, result);
}

static void transferControlToOffscreenMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "HTMLCanvasElement", "transferControlToOffscreen");

  HTMLCanvasElement* impl = V8HTMLCanvasElement::toImpl(info.Holder());

  OffscreenCanvas* result = HTMLCanvasElementModule::transferControlToOffscreen(*impl, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
  V8SetReturnValueFast(info, result, impl);
}

static void captureStreamMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "HTMLCanvasElement", "captureStream");

  HTMLCanvasElement* impl = V8HTMLCanvasElement::toImpl(info.Holder());

  double frameRate;
  int numArgsPassed = info.Length();
  while (numArgsPassed > 0) {
    if (!info[numArgsPassed - 1]->IsUndefined())
      break;
    --numArgsPassed;
  }
  if (UNLIKELY(numArgsPassed <= 0)) {
    MediaStream* result = HTMLCanvasElementCapture::captureStream(*impl, exceptionState);
    if (exceptionState.HadException()) {
      return;
    }
    V8SetReturnValueFast(info, result, impl);
    return;
  }
  frameRate = NativeValueTraits<IDLDouble>::NativeValue(info.GetIsolate(), info[0], exceptionState);
  if (exceptionState.HadException())
    return;

  MediaStream* result = HTMLCanvasElementCapture::captureStream(*impl, frameRate, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
  V8SetReturnValueFast(info, result, impl);
}

} // namespace HTMLCanvasElementPartialV8Internal

void V8HTMLCanvasElementPartial::getContextMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLCanvasElementPartialV8Internal::getContextMethod(info);
}

void V8HTMLCanvasElementPartial::transferControlToOffscreenMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kOffscreenCanvas);
  HTMLCanvasElementPartialV8Internal::transferControlToOffscreenMethod(info);
}

void V8HTMLCanvasElementPartial::captureStreamMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HTMLCanvasElementPartialV8Internal::captureStreamMethod(info);
}

static const V8DOMConfiguration::MethodConfiguration V8HTMLCanvasElementMethods[] = {
    {"getContext", V8HTMLCanvasElementPartial::getContextMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

void V8HTMLCanvasElementPartial::installV8HTMLCanvasElementTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8HTMLCanvasElement::installV8HTMLCanvasElementTemplate(isolate, world, interfaceTemplate);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8HTMLCanvasElementMethods, WTF_ARRAY_LENGTH(V8HTMLCanvasElementMethods));

  // Custom signature

  V8HTMLCanvasElementPartial::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8HTMLCanvasElementPartial::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  V8HTMLCanvasElement::InstallRuntimeEnabledFeaturesOnTemplate(isolate, world, interface_template);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
  if (RuntimeEnabledFeatures::ExperimentalCanvasFeaturesEnabled()) {
    const V8DOMConfiguration::MethodConfiguration transferControlToOffscreenMethodConfiguration[] = {
      {"transferControlToOffscreen", V8HTMLCanvasElementPartial::transferControlToOffscreenMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : transferControlToOffscreenMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, instance_template, prototype_template, interface_template, signature, methodConfig);
  }
  if (RuntimeEnabledFeatures::MediaCaptureFromCanvasEnabled()) {
    const V8DOMConfiguration::MethodConfiguration captureStreamMethodConfiguration[] = {
      {"captureStream", V8HTMLCanvasElementPartial::captureStreamMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : captureStreamMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, instance_template, prototype_template, interface_template, signature, methodConfig);
  }
}

void V8HTMLCanvasElementPartial::initialize() {
  // Should be invoked from ModulesInitializer.
  V8HTMLCanvasElement::UpdateWrapperTypeInfo(
      &V8HTMLCanvasElementPartial::installV8HTMLCanvasElementTemplate,
      nullptr,
      &V8HTMLCanvasElementPartial::InstallRuntimeEnabledFeaturesOnTemplate,
      nullptr);
}

}  // namespace blink
