// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8SpeechRecognition.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/modules/v8/V8MediaStreamTrack.h"
#include "bindings/modules/v8/V8SpeechGrammarList.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/frame/UseCounter.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8SpeechRecognition::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8SpeechRecognition::domTemplate,
    V8SpeechRecognition::Trace,
    V8SpeechRecognition::TraceWrappers,
    nullptr,
    "SpeechRecognition",
    &V8EventTarget::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in SpeechRecognition.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& SpeechRecognition::wrapper_type_info_ = V8SpeechRecognition::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappableBase, SpeechRecognition>::value,
    "SpeechRecognition does not inherit from ActiveScriptWrappable<>, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&SpeechRecognition::HasPendingActivity),
                  decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "SpeechRecognition is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace SpeechRecognitionV8Internal {

static void grammarsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->grammars()), impl);
}

static void grammarsAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "SpeechRecognition", "grammars");

  // Prepare the value to be set.
  SpeechGrammarList* cppValue = V8SpeechGrammarList::toImplWithTypeCheck(info.GetIsolate(), v8Value);

  // Type check per: http://heycam.github.io/webidl/#es-interface
  if (!cppValue) {
    exceptionState.ThrowTypeError("The provided value is not of type 'SpeechGrammarList'.");
    return;
  }

  impl->setGrammars(cppValue);
}

static void langAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  V8SetReturnValueString(info, impl->lang(), info.GetIsolate());
}

static void langAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setLang(cppValue);
}

static void continuousAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  V8SetReturnValueBool(info, impl->continuous());
}

static void continuousAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "SpeechRecognition", "continuous");

  // Prepare the value to be set.
  bool cppValue = NativeValueTraits<IDLBoolean>::NativeValue(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->setContinuous(cppValue);
}

static void interimResultsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  V8SetReturnValueBool(info, impl->interimResults());
}

static void interimResultsAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "SpeechRecognition", "interimResults");

  // Prepare the value to be set.
  bool cppValue = NativeValueTraits<IDLBoolean>::NativeValue(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->setInterimResults(cppValue);
}

static void maxAlternativesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  V8SetReturnValueUnsigned(info, impl->maxAlternatives());
}

static void maxAlternativesAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "SpeechRecognition", "maxAlternatives");

  // Prepare the value to be set.
  uint32_t cppValue = NativeValueTraits<IDLUnsignedLong>::NativeValue(info.GetIsolate(), v8Value, exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  impl->setMaxAlternatives(cppValue);
}

static void audioTrackAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  V8SetReturnValueFast(info, WTF::GetPtr(impl->audioTrack()), impl);
}

static void audioTrackAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "SpeechRecognition", "audioTrack");

  // Prepare the value to be set.
  MediaStreamTrack* cppValue = V8MediaStreamTrack::toImplWithTypeCheck(info.GetIsolate(), v8Value);

  // Type check per: http://heycam.github.io/webidl/#es-interface
  if (!cppValue && !IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("The provided value is not of type 'MediaStreamTrack'.");
    return;
  }

  impl->setAudioTrack(cppValue);
}

static void onaudiostartAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onaudiostart()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onaudiostartAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onaudiostart(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnaudiostart(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onsoundstartAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onsoundstart()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onsoundstartAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onsoundstart(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnsoundstart(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onspeechstartAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onspeechstart()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onspeechstartAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onspeechstart(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnspeechstart(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onspeechendAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onspeechend()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onspeechendAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onspeechend(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnspeechend(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onsoundendAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onsoundend()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onsoundendAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onsoundend(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnsoundend(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onaudioendAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onaudioend()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onaudioendAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onaudioend(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnaudioend(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onresultAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onresult()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onresultAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onresult(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnresult(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onnomatchAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onnomatch()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onnomatchAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onnomatch(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnnomatch(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onerrorAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onerror()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onerrorAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onerror(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnerror(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onstartAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onstart()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onstartAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onstart(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnstart(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onendAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onend()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onendAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onend(), v8Value, V8SpeechRecognition::eventListenerCacheIndex);

  impl->setOnend(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void startMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "SpeechRecognition", "start");

  SpeechRecognition* impl = V8SpeechRecognition::toImpl(info.Holder());

  impl->start(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void stopMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognition* impl = V8SpeechRecognition::toImpl(info.Holder());

  impl->stopFunction();
}

static void abortMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognition* impl = V8SpeechRecognition::toImpl(info.Holder());

  impl->abort();
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExecutionContext* executionContext = CurrentExecutionContext(info.GetIsolate());
  SpeechRecognition* impl = SpeechRecognition::Create(executionContext);
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->AssociateWithWrapper(info.GetIsolate(), &V8SpeechRecognition::wrapperTypeInfo, wrapper);
  V8SetReturnValue(info, wrapper);
}

} // namespace SpeechRecognitionV8Internal

void V8SpeechRecognition::grammarsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::grammarsAttributeGetter(info);
}

void V8SpeechRecognition::grammarsAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::grammarsAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::langAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::langAttributeGetter(info);
}

void V8SpeechRecognition::langAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::langAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::continuousAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::continuousAttributeGetter(info);
}

void V8SpeechRecognition::continuousAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::continuousAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::interimResultsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::interimResultsAttributeGetter(info);
}

void V8SpeechRecognition::interimResultsAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::interimResultsAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::maxAlternativesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::maxAlternativesAttributeGetter(info);
}

void V8SpeechRecognition::maxAlternativesAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::maxAlternativesAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::audioTrackAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::audioTrackAttributeGetter(info);
}

void V8SpeechRecognition::audioTrackAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::audioTrackAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onaudiostartAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onaudiostartAttributeGetter(info);
}

void V8SpeechRecognition::onaudiostartAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onaudiostartAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onsoundstartAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onsoundstartAttributeGetter(info);
}

void V8SpeechRecognition::onsoundstartAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onsoundstartAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onspeechstartAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onspeechstartAttributeGetter(info);
}

void V8SpeechRecognition::onspeechstartAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onspeechstartAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onspeechendAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onspeechendAttributeGetter(info);
}

void V8SpeechRecognition::onspeechendAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onspeechendAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onsoundendAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onsoundendAttributeGetter(info);
}

void V8SpeechRecognition::onsoundendAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onsoundendAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onaudioendAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onaudioendAttributeGetter(info);
}

void V8SpeechRecognition::onaudioendAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onaudioendAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onresultAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onresultAttributeGetter(info);
}

void V8SpeechRecognition::onresultAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onresultAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onnomatchAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onnomatchAttributeGetter(info);
}

void V8SpeechRecognition::onnomatchAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onnomatchAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onerrorAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onerrorAttributeGetter(info);
}

void V8SpeechRecognition::onerrorAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onerrorAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onstartAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onstartAttributeGetter(info);
}

void V8SpeechRecognition::onstartAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onstartAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::onendAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::onendAttributeGetter(info);
}

void V8SpeechRecognition::onendAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  SpeechRecognitionV8Internal::onendAttributeSetter(v8Value, info);
}

void V8SpeechRecognition::startMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8SpeechRecognition_Start_Method);
  SpeechRecognitionV8Internal::startMethod(info);
}

void V8SpeechRecognition::stopMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::stopMethod(info);
}

void V8SpeechRecognition::abortMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  SpeechRecognitionV8Internal::abortMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8SpeechRecognitionAccessors[] = {
    { "grammars", V8SpeechRecognition::grammarsAttributeGetterCallback, V8SpeechRecognition::grammarsAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "lang", V8SpeechRecognition::langAttributeGetterCallback, V8SpeechRecognition::langAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "continuous", V8SpeechRecognition::continuousAttributeGetterCallback, V8SpeechRecognition::continuousAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "interimResults", V8SpeechRecognition::interimResultsAttributeGetterCallback, V8SpeechRecognition::interimResultsAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "maxAlternatives", V8SpeechRecognition::maxAlternativesAttributeGetterCallback, V8SpeechRecognition::maxAlternativesAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onaudiostart", V8SpeechRecognition::onaudiostartAttributeGetterCallback, V8SpeechRecognition::onaudiostartAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onsoundstart", V8SpeechRecognition::onsoundstartAttributeGetterCallback, V8SpeechRecognition::onsoundstartAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onspeechstart", V8SpeechRecognition::onspeechstartAttributeGetterCallback, V8SpeechRecognition::onspeechstartAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onspeechend", V8SpeechRecognition::onspeechendAttributeGetterCallback, V8SpeechRecognition::onspeechendAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onsoundend", V8SpeechRecognition::onsoundendAttributeGetterCallback, V8SpeechRecognition::onsoundendAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onaudioend", V8SpeechRecognition::onaudioendAttributeGetterCallback, V8SpeechRecognition::onaudioendAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onresult", V8SpeechRecognition::onresultAttributeGetterCallback, V8SpeechRecognition::onresultAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onnomatch", V8SpeechRecognition::onnomatchAttributeGetterCallback, V8SpeechRecognition::onnomatchAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onerror", V8SpeechRecognition::onerrorAttributeGetterCallback, V8SpeechRecognition::onerrorAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onstart", V8SpeechRecognition::onstartAttributeGetterCallback, V8SpeechRecognition::onstartAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onend", V8SpeechRecognition::onendAttributeGetterCallback, V8SpeechRecognition::onendAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8SpeechRecognitionMethods[] = {
    {"start", V8SpeechRecognition::startMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"stop", V8SpeechRecognition::stopMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"abort", V8SpeechRecognition::abortMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

void V8SpeechRecognition::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::ConstructorNotCallableAsFunction("SpeechRecognition"));
    return;
  }

  if (ConstructorMode::Current(info.GetIsolate()) == ConstructorMode::kWrapExistingObject) {
    V8SetReturnValue(info, info.Holder());
    return;
  }

  SpeechRecognitionV8Internal::constructor(info);
}

static void installV8SpeechRecognitionTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8SpeechRecognition::wrapperTypeInfo.interface_name, V8EventTarget::domTemplate(isolate, world), V8SpeechRecognition::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8SpeechRecognition::constructorCallback);
  interfaceTemplate->SetLength(0);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8SpeechRecognitionAccessors, WTF_ARRAY_LENGTH(V8SpeechRecognitionAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8SpeechRecognitionMethods, WTF_ARRAY_LENGTH(V8SpeechRecognitionMethods));

  // Custom signature

  V8SpeechRecognition::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8SpeechRecognition::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  if (RuntimeEnabledFeatures::MediaStreamSpeechEnabled()) {
    static const V8DOMConfiguration::AccessorConfiguration accessor_configurations[] = {
        { "audioTrack", V8SpeechRecognition::audioTrackAttributeGetterCallback, V8SpeechRecognition::audioTrackAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
    };
    V8DOMConfiguration::InstallAccessors(
        isolate, world, instance_template, prototype_template, interface_template,
        signature, accessor_configurations,
        WTF_ARRAY_LENGTH(accessor_configurations));
  }

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8SpeechRecognition::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8SpeechRecognitionTemplate);
}

bool V8SpeechRecognition::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8SpeechRecognition::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

SpeechRecognition* V8SpeechRecognition::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

SpeechRecognition* NativeValueTraits<SpeechRecognition>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  SpeechRecognition* nativeValue = V8SpeechRecognition::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "SpeechRecognition"));
  }
  return nativeValue;
}

}  // namespace blink
