// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8WebGLDrawBuffers.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "core/dom/ExecutionContext.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8WebGLDrawBuffers::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8WebGLDrawBuffers::domTemplate,
    V8WebGLDrawBuffers::Trace,
    V8WebGLDrawBuffers::TraceWrappers,
    nullptr,
    "WebGLDrawBuffers",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in WebGLDrawBuffers.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& WebGLDrawBuffers::wrapper_type_info_ = V8WebGLDrawBuffers::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, WebGLDrawBuffers>::value,
    "WebGLDrawBuffers inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&WebGLDrawBuffers::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "WebGLDrawBuffers is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace WebGLDrawBuffersV8Internal {

static void drawBuffersWEBGLMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "WebGLDrawBuffers", "drawBuffersWEBGL");

  WebGLDrawBuffers* impl = V8WebGLDrawBuffers::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  Vector<uint32_t> buffers;
  buffers = NativeValueTraits<IDLSequence<IDLUnsignedLong>>::NativeValue(info.GetIsolate(), info[0], exceptionState);
  if (exceptionState.HadException())
    return;

  impl->drawBuffersWEBGL(buffers);
}

} // namespace WebGLDrawBuffersV8Internal

void V8WebGLDrawBuffers::drawBuffersWEBGLMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  WebGLDrawBuffersV8Internal::drawBuffersWEBGLMethod(info);
}

static const V8DOMConfiguration::MethodConfiguration V8WebGLDrawBuffersMethods[] = {
    {"drawBuffersWEBGL", V8WebGLDrawBuffers::drawBuffersWEBGLMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8WebGLDrawBuffersTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8WebGLDrawBuffers::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8WebGLDrawBuffers::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  const V8DOMConfiguration::ConstantConfiguration V8WebGLDrawBuffersConstants[] = {
      {"COLOR_ATTACHMENT0_WEBGL", 0x8CE0, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT1_WEBGL", 0x8CE1, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT2_WEBGL", 0x8CE2, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT3_WEBGL", 0x8CE3, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT4_WEBGL", 0x8CE4, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT5_WEBGL", 0x8CE5, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT6_WEBGL", 0x8CE6, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT7_WEBGL", 0x8CE7, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT8_WEBGL", 0x8CE8, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT9_WEBGL", 0x8CE9, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT10_WEBGL", 0x8CEA, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT11_WEBGL", 0x8CEB, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT12_WEBGL", 0x8CEC, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT13_WEBGL", 0x8CED, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT14_WEBGL", 0x8CEE, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"COLOR_ATTACHMENT15_WEBGL", 0x8CEF, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER0_WEBGL", 0x8825, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER1_WEBGL", 0x8826, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER2_WEBGL", 0x8827, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER3_WEBGL", 0x8828, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER4_WEBGL", 0x8829, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER5_WEBGL", 0x882A, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER6_WEBGL", 0x882B, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER7_WEBGL", 0x882C, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER8_WEBGL", 0x882D, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER9_WEBGL", 0x882E, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER10_WEBGL", 0x882F, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER11_WEBGL", 0x8830, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER12_WEBGL", 0x8831, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER13_WEBGL", 0x8832, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER14_WEBGL", 0x8833, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"DRAW_BUFFER15_WEBGL", 0x8834, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"MAX_COLOR_ATTACHMENTS_WEBGL", 0x8CDF, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"MAX_DRAW_BUFFERS_WEBGL", 0x8824, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
  };
  V8DOMConfiguration::InstallConstants(
      isolate, interfaceTemplate, prototypeTemplate,
      V8WebGLDrawBuffersConstants, WTF_ARRAY_LENGTH(V8WebGLDrawBuffersConstants));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8WebGLDrawBuffersMethods, WTF_ARRAY_LENGTH(V8WebGLDrawBuffersMethods));

  // Custom signature

  V8WebGLDrawBuffers::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8WebGLDrawBuffers::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8WebGLDrawBuffers::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8WebGLDrawBuffersTemplate);
}

bool V8WebGLDrawBuffers::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8WebGLDrawBuffers::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

WebGLDrawBuffers* V8WebGLDrawBuffers::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

WebGLDrawBuffers* NativeValueTraits<WebGLDrawBuffers>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  WebGLDrawBuffers* nativeValue = V8WebGLDrawBuffers::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "WebGLDrawBuffers"));
  }
  return nativeValue;
}

}  // namespace blink
