// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/ElementTypeHelpers.cpp.tmpl
// and input files:
//   ../../../../src/3rdparty/chromium/third_party/WebKit/Source/core/html/HTMLTagNames.json5


#include "HTMLElementTypeHelpers.h"

#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/wtf/HashMap.h"

namespace blink {
using HTMLTypeMap = HashMap<AtomicString, HTMLElementType>;

static HTMLTypeMap* html_type_map = 0;

void createHTMLTypeMap() {
  DCHECK(!html_type_map);
  html_type_map = new HTMLTypeMap;
  html_type_map->Set(AtomicString("a"), HTMLElementType::kHTMLAnchorElement);
  html_type_map->Set(AtomicString("area"), HTMLElementType::kHTMLAreaElement);
  html_type_map->Set(AtomicString("audio"), HTMLElementType::kHTMLAudioElement);
  html_type_map->Set(AtomicString("br"), HTMLElementType::kHTMLBRElement);
  html_type_map->Set(AtomicString("base"), HTMLElementType::kHTMLBaseElement);
  html_type_map->Set(AtomicString("body"), HTMLElementType::kHTMLBodyElement);
  html_type_map->Set(AtomicString("button"), HTMLElementType::kHTMLButtonElement);
  html_type_map->Set(AtomicString("canvas"), HTMLElementType::kHTMLCanvasElement);
  html_type_map->Set(AtomicString("content"), HTMLElementType::kHTMLContentElement);
  html_type_map->Set(AtomicString("dl"), HTMLElementType::kHTMLDListElement);
  html_type_map->Set(AtomicString("datalist"), HTMLElementType::kHTMLDataListElement);
  html_type_map->Set(AtomicString("details"), HTMLElementType::kHTMLDetailsElement);
  html_type_map->Set(AtomicString("dialog"), HTMLElementType::kHTMLDialogElement);
  html_type_map->Set(AtomicString("dir"), HTMLElementType::kHTMLDirectoryElement);
  html_type_map->Set(AtomicString("div"), HTMLElementType::kHTMLDivElement);
  html_type_map->Set(AtomicString("abbr"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("acronym"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("address"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("article"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("aside"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("b"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("basefont"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("bdo"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("big"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("center"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("cite"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("code"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("dd"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("dfn"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("dt"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("em"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("figcaption"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("figure"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("footer"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("header"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("hgroup"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("i"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("kbd"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("layer"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("main"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("mark"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("nav"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("nobr"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("noframes"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("nolayer"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("plaintext"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("rb"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("rp"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("rtc"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("s"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("samp"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("section"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("small"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("strike"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("strong"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("sub"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("sup"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("tt"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("u"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("var"), HTMLElementType::kHTMLElement);
  html_type_map->Set(AtomicString("fieldset"), HTMLElementType::kHTMLFieldSetElement);
  html_type_map->Set(AtomicString("font"), HTMLElementType::kHTMLFontElement);
  html_type_map->Set(AtomicString("form"), HTMLElementType::kHTMLFormElement);
  html_type_map->Set(AtomicString("frame"), HTMLElementType::kHTMLFrameElement);
  html_type_map->Set(AtomicString("frameset"), HTMLElementType::kHTMLFrameSetElement);
  html_type_map->Set(AtomicString("hr"), HTMLElementType::kHTMLHRElement);
  html_type_map->Set(AtomicString("head"), HTMLElementType::kHTMLHeadElement);
  html_type_map->Set(AtomicString("h1"), HTMLElementType::kHTMLHeadingElement);
  html_type_map->Set(AtomicString("h2"), HTMLElementType::kHTMLHeadingElement);
  html_type_map->Set(AtomicString("h3"), HTMLElementType::kHTMLHeadingElement);
  html_type_map->Set(AtomicString("h4"), HTMLElementType::kHTMLHeadingElement);
  html_type_map->Set(AtomicString("h5"), HTMLElementType::kHTMLHeadingElement);
  html_type_map->Set(AtomicString("h6"), HTMLElementType::kHTMLHeadingElement);
  html_type_map->Set(AtomicString("html"), HTMLElementType::kHTMLHtmlElement);
  html_type_map->Set(AtomicString("iframe"), HTMLElementType::kHTMLIFrameElement);
  html_type_map->Set(AtomicString("li"), HTMLElementType::kHTMLLIElement);
  html_type_map->Set(AtomicString("label"), HTMLElementType::kHTMLLabelElement);
  html_type_map->Set(AtomicString("legend"), HTMLElementType::kHTMLLegendElement);
  html_type_map->Set(AtomicString("map"), HTMLElementType::kHTMLMapElement);
  html_type_map->Set(AtomicString("marquee"), HTMLElementType::kHTMLMarqueeElement);
  html_type_map->Set(AtomicString("menu"), HTMLElementType::kHTMLMenuElement);
  html_type_map->Set(AtomicString("meta"), HTMLElementType::kHTMLMetaElement);
  html_type_map->Set(AtomicString("meter"), HTMLElementType::kHTMLMeterElement);
  html_type_map->Set(AtomicString("del"), HTMLElementType::kHTMLModElement);
  html_type_map->Set(AtomicString("ins"), HTMLElementType::kHTMLModElement);
  html_type_map->Set(AtomicString("ol"), HTMLElementType::kHTMLOListElement);
  html_type_map->Set(AtomicString("optgroup"), HTMLElementType::kHTMLOptGroupElement);
  html_type_map->Set(AtomicString("option"), HTMLElementType::kHTMLOptionElement);
  html_type_map->Set(AtomicString("output"), HTMLElementType::kHTMLOutputElement);
  html_type_map->Set(AtomicString("p"), HTMLElementType::kHTMLParagraphElement);
  html_type_map->Set(AtomicString("param"), HTMLElementType::kHTMLParamElement);
  html_type_map->Set(AtomicString("picture"), HTMLElementType::kHTMLPictureElement);
  html_type_map->Set(AtomicString("pre"), HTMLElementType::kHTMLPreElement);
  html_type_map->Set(AtomicString("listing"), HTMLElementType::kHTMLPreElement);
  html_type_map->Set(AtomicString("xmp"), HTMLElementType::kHTMLPreElement);
  html_type_map->Set(AtomicString("progress"), HTMLElementType::kHTMLProgressElement);
  html_type_map->Set(AtomicString("blockquote"), HTMLElementType::kHTMLQuoteElement);
  html_type_map->Set(AtomicString("q"), HTMLElementType::kHTMLQuoteElement);
  html_type_map->Set(AtomicString("select"), HTMLElementType::kHTMLSelectElement);
  html_type_map->Set(AtomicString("shadow"), HTMLElementType::kHTMLShadowElement);
  html_type_map->Set(AtomicString("slot"), HTMLElementType::kHTMLSlotElement);
  html_type_map->Set(AtomicString("source"), HTMLElementType::kHTMLSourceElement);
  html_type_map->Set(AtomicString("span"), HTMLElementType::kHTMLSpanElement);
  html_type_map->Set(AtomicString("caption"), HTMLElementType::kHTMLTableCaptionElement);
  html_type_map->Set(AtomicString("td"), HTMLElementType::kHTMLTableCellElement);
  html_type_map->Set(AtomicString("th"), HTMLElementType::kHTMLTableCellElement);
  html_type_map->Set(AtomicString("col"), HTMLElementType::kHTMLTableColElement);
  html_type_map->Set(AtomicString("colgroup"), HTMLElementType::kHTMLTableColElement);
  html_type_map->Set(AtomicString("table"), HTMLElementType::kHTMLTableElement);
  html_type_map->Set(AtomicString("tr"), HTMLElementType::kHTMLTableRowElement);
  html_type_map->Set(AtomicString("tbody"), HTMLElementType::kHTMLTableSectionElement);
  html_type_map->Set(AtomicString("tfoot"), HTMLElementType::kHTMLTableSectionElement);
  html_type_map->Set(AtomicString("thead"), HTMLElementType::kHTMLTableSectionElement);
  html_type_map->Set(AtomicString("template"), HTMLElementType::kHTMLTemplateElement);
  html_type_map->Set(AtomicString("textarea"), HTMLElementType::kHTMLTextAreaElement);
  html_type_map->Set(AtomicString("title"), HTMLElementType::kHTMLTitleElement);
  html_type_map->Set(AtomicString("track"), HTMLElementType::kHTMLTrackElement);
  html_type_map->Set(AtomicString("ul"), HTMLElementType::kHTMLUListElement);
  html_type_map->Set(AtomicString("applet"), HTMLElementType::kHTMLUnknownElement);
  html_type_map->Set(AtomicString("bgsound"), HTMLElementType::kHTMLUnknownElement);
  html_type_map->Set(AtomicString("command"), HTMLElementType::kHTMLUnknownElement);
  html_type_map->Set(AtomicString("image"), HTMLElementType::kHTMLUnknownElement);
  html_type_map->Set(AtomicString("keygen"), HTMLElementType::kHTMLUnknownElement);
  html_type_map->Set(AtomicString("video"), HTMLElementType::kHTMLVideoElement);
  html_type_map->Set(AtomicString("embed"), HTMLElementType::kHTMLEmbedElement);
  html_type_map->Set(AtomicString("img"), HTMLElementType::kHTMLImageElement);
  html_type_map->Set(AtomicString("input"), HTMLElementType::kHTMLInputElement);
  html_type_map->Set(AtomicString("link"), HTMLElementType::kHTMLLinkElement);
  html_type_map->Set(AtomicString("object"), HTMLElementType::kHTMLObjectElement);
  html_type_map->Set(AtomicString("script"), HTMLElementType::kHTMLScriptElement);
  html_type_map->Set(AtomicString("style"), HTMLElementType::kHTMLStyleElement);
  html_type_map->Set(AtomicString("bdi"), HTMLElementType::kHTMLBDIElement);
  html_type_map->Set(AtomicString("noembed"), HTMLElementType::kHTMLNoEmbedElement);
  html_type_map->Set(AtomicString("noscript"), HTMLElementType::kHTMLNoScriptElement);
  html_type_map->Set(AtomicString("rt"), HTMLElementType::kHTMLRTElement);
  html_type_map->Set(AtomicString("ruby"), HTMLElementType::kHTMLRubyElement);
  html_type_map->Set(AtomicString("summary"), HTMLElementType::kHTMLSummaryElement);
  html_type_map->Set(AtomicString("wbr"), HTMLElementType::kHTMLWBRElement);
}

HTMLElementType htmlElementTypeForTag(const AtomicString& tagName) {
  if (!html_type_map) createHTMLTypeMap();
  if (html_type_map->Contains(tagName)) {
    return html_type_map->at(tagName);
  } else {
    return HTMLElementType::kHTMLUnknownElement;
  }
}
} // namespace blink
