// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/OriginTrials.cpp.tmpl
// and input files:
//   ../../../../src/3rdparty/chromium/third_party/WebKit/Source/platform/RuntimeEnabledFeatures.json5


#include "core/origin_trials/OriginTrials.h"

#include "core/origin_trials/OriginTrialContext.h"
#include "platform/RuntimeEnabledFeatures.h"

namespace blink {

const char OriginTrials::kBudgetQueryTrialName[] = "BudgetQuery";
const char OriginTrials::kForeignFetchTrialName[] = "ForeignFetch";
const char OriginTrials::kGamepadExtensionsTrialName[] = "WebVR1.1";
const char OriginTrials::kInstalledAppTrialName[] = "InstalledApp";
const char OriginTrials::kLinkServiceWorkerTrialName[] = "ForeignFetch";
const char OriginTrials::kOriginTrialsSampleAPITrialName[] = "Frobulate";
const char OriginTrials::kWebVRTrialName[] = "WebVR1.1";


bool OriginTrials::budgetQueryEnabled(ExecutionContext* executionContext) {
  if (RuntimeEnabledFeatures::BudgetQueryEnabled())
    return true;

  OriginTrialContext* context = OriginTrialContext::From(executionContext,
      OriginTrialContext::kDontCreateIfNotExists);
  return context && context->IsTrialEnabled(OriginTrials::kBudgetQueryTrialName);
}


bool OriginTrials::foreignFetchEnabled(ExecutionContext* executionContext) {
  if (RuntimeEnabledFeatures::ForeignFetchEnabled())
    return true;

  OriginTrialContext* context = OriginTrialContext::From(executionContext,
      OriginTrialContext::kDontCreateIfNotExists);
  return context && context->IsTrialEnabled(OriginTrials::kForeignFetchTrialName);
}


bool OriginTrials::gamepadExtensionsEnabled(ExecutionContext* executionContext) {
  if (RuntimeEnabledFeatures::GamepadExtensionsEnabled())
    return true;

  OriginTrialContext* context = OriginTrialContext::From(executionContext,
      OriginTrialContext::kDontCreateIfNotExists);
  return context && context->IsTrialEnabled(OriginTrials::kGamepadExtensionsTrialName);
}


bool OriginTrials::installedAppEnabled(ExecutionContext* executionContext) {
  if (RuntimeEnabledFeatures::InstalledAppEnabled())
    return true;

  OriginTrialContext* context = OriginTrialContext::From(executionContext,
      OriginTrialContext::kDontCreateIfNotExists);
  return context && context->IsTrialEnabled(OriginTrials::kInstalledAppTrialName);
}


bool OriginTrials::linkServiceWorkerEnabled(ExecutionContext* executionContext) {
  if (RuntimeEnabledFeatures::LinkServiceWorkerEnabled())
    return true;

  OriginTrialContext* context = OriginTrialContext::From(executionContext,
      OriginTrialContext::kDontCreateIfNotExists);
  return context && context->IsTrialEnabled(OriginTrials::kLinkServiceWorkerTrialName);
}


bool OriginTrials::originTrialsSampleAPIEnabled(ExecutionContext* executionContext) {
  if (RuntimeEnabledFeatures::OriginTrialsSampleAPIEnabled())
    return true;

  OriginTrialContext* context = OriginTrialContext::From(executionContext,
      OriginTrialContext::kDontCreateIfNotExists);
  return context && context->IsTrialEnabled(OriginTrials::kOriginTrialsSampleAPITrialName);
}


bool OriginTrials::webVREnabled(ExecutionContext* executionContext) {
  if (RuntimeEnabledFeatures::WebVREnabled())
    return true;

  OriginTrialContext* context = OriginTrialContext::From(executionContext,
      OriginTrialContext::kDontCreateIfNotExists);
  return context && context->IsTrialEnabled(OriginTrials::kWebVRTrialName);
}


} // namespace blink
