// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   /ProbeSink.h.tmpl
// and input files:
//   PlatformProbes.pidl



#ifndef PlatformProbeSink_h
#define PlatformProbeSink_h

#include "platform/heap/HeapAllocator.h"

namespace blink {

class PlatformTraceEventsAgent;

class PLATFORM_EXPORT PlatformProbeSink : public GarbageCollected<PlatformProbeSink> {
  WTF_MAKE_NONCOPYABLE(PlatformProbeSink);

 public:
  PlatformProbeSink();
  DECLARE_TRACE();

  bool hasPlatformTraceEventsAgents() const { return m_hasPlatformTraceEventsAgents; }
  const HeapHashSet<Member<PlatformTraceEventsAgent>>& platformTraceEventsAgents() const { return m_platformTraceEventsAgents; }
  void addPlatformTraceEventsAgent(PlatformTraceEventsAgent* agent);
  void removePlatformTraceEventsAgent(PlatformTraceEventsAgent* agent);

 private:
  HeapHashSet<Member<PlatformTraceEventsAgent>> m_platformTraceEventsAgents;
  bool m_hasPlatformTraceEventsAgents = false;
};

} // namespace blink

#endif // !defined(PlatformProbeSink_h)
