// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   /InstrumentingProbesImpl.cpp.tmpl
// and input files:
//   PlatformProbes.pidl


#include "PlatformProbesInl.h"
#include "PlatformProbeSink.h"
#include "platform/probe/PlatformTraceEventsAgent.h"

namespace blink {

PlatformProbeSink::PlatformProbeSink() {}

void PlatformProbeSink::addPlatformTraceEventsAgent(PlatformTraceEventsAgent* agent) {
  m_platformTraceEventsAgents.insert(agent);
  m_hasPlatformTraceEventsAgents = true;
}

void PlatformProbeSink::removePlatformTraceEventsAgent(PlatformTraceEventsAgent* agent) {
  m_platformTraceEventsAgents.erase(agent);
  m_hasPlatformTraceEventsAgents = !m_platformTraceEventsAgents.IsEmpty();
}

DEFINE_TRACE(PlatformProbeSink)
{
  visitor->Trace(m_platformTraceEventsAgents);
}

namespace probe {

PlatformSendRequest::PlatformSendRequest(FetchContext* paramFetchContext, unsigned long identifier, ResourceRequest& paramResourceRequest, const ResourceResponse& redirectResponse, const FetchInitiatorInfo& paramFetchInitiatorInfo) :
    paramFetchContext(paramFetchContext),
    identifier(identifier),
    paramResourceRequest(paramResourceRequest),
    redirectResponse(redirectResponse),
    paramFetchInitiatorInfo(paramFetchInitiatorInfo) {
  probe_sink = ToPlatformProbeSink(paramFetchContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasPlatformTraceEventsAgents()) {
    for (PlatformTraceEventsAgent* agent : probe_sink->platformTraceEventsAgents())
      agent->Will(*this);
  }
}

PlatformSendRequest::~PlatformSendRequest() {
  if (!probe_sink)
    return;
  if (probe_sink->hasPlatformTraceEventsAgents()) {
    for (PlatformTraceEventsAgent* agent : probe_sink->platformTraceEventsAgents())
      agent->Did(*this);
  }
}


} // namespace probe
} // namespace blink
