// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/RuntimeEnabledFeatures.h.tmpl
// and input files:
//   ../../../../src/3rdparty/chromium/third_party/WebKit/Source/platform/RuntimeEnabledFeatures.json5


#ifndef RuntimeEnabledFeatures_h
#define RuntimeEnabledFeatures_h

#include <string>

#include "platform/PlatformExport.h"
#include "platform/wtf/Allocator.h"
#include "platform/wtf/Forward.h"
#include "platform/wtf/build_config.h"

namespace blink {

// A class that stores static enablers for all experimental features.

class PLATFORM_EXPORT RuntimeEnabledFeatures {
  STATIC_ONLY(RuntimeEnabledFeatures);
 public:
  class PLATFORM_EXPORT Backup {
   public:
    explicit Backup();
    void Restore();

   private:
    bool accelerated2dCanvas_;
    bool accessibilityObjectModel_;
    bool allowContentInitiatedDataUrlNavigations_;
    bool asyncClipboard_;
    bool audioOutputDevices_;
    bool audioVideoTracks_;
    bool audioWorklet_;
    bool autoplayMutedVideos_;
    bool auxclick_;
    bool backgroundFetch_;
    bool backgroundSync_;
    bool backgroundVideoTrackOptimization_;
    bool blinkRuntimeCallStats_;
    bool blockCredentialedSubresources_;
    bool blockLegacySubresources_;
    bool broadcastChannel_;
    bool budget_;
    bool budgetQuery_;
    bool canMakePayment_;
    bool canvas2dFixedRenderingMode_;
    bool canvas2dImageChromium_;
    bool clickRetargetting_;
    bool clientHints_;
    bool clientPlaceholdersForServerLoFi_;
    bool coalescedEvents_;
    bool colorCanvasExtensions_;
    bool colorCorrectRendering_;
    bool compositedSelectionUpdate_;
    bool compositeOpaqueFixedPosition_;
    bool compositeOpaqueScrollers_;
    bool compositorTouchAction_;
    bool compositorWorker_;
    bool computedAccessibilityInfo_;
    bool conicGradient_;
    bool contextMenu_;
    bool corsRFC1918_;
    bool css3Text_;
    bool css3TextDecorations_;
    bool cssAdditiveAnimations_;
    bool cssApplyAtRules_;
    bool cssBackdropFilter_;
    bool cssContainment_;
    bool cssDisplayContents_;
    bool cssFontDisplay_;
    bool cssFontSizeAdjust_;
    bool cssGridLayout_;
    bool cssHexAlphaColor_;
    bool cssHyphens_;
    bool cssInBodyDoesNotBlockPaint_;
    bool cssIndependentTransformProperties_;
    bool cssLineBreak_;
    bool cssMaskSourceType_;
    bool cssOffsetPathRay_;
    bool cssOffsetPathRayContain_;
    bool cssOffsetPositionAnchor_;
    bool cssomSmoothScroll_;
    bool cssPaintAPI_;
    bool cssPaintAPIArguments_;
    bool cssScrollBoundaryBehavior_;
    bool cssScrollSnapPoints_;
    bool cssSelectorsFocusWithin_;
    bool cssSnapSize_;
    bool cssStickyPosition_;
    bool cssTransformBox_;
    bool cssTypedOM_;
    bool cssVariableFonts_;
    bool cssVariables2_;
    bool cssViewport_;
    bool customElementsBuiltin_;
    bool customSchemeHandler_;
    bool database_;
    bool decodeToYUV_;
    bool desktopCaptureDisableLocalEchoControl_;
    bool deviceMemoryHeader_;
    bool displayList2dCanvas_;
    bool displayNoneIFrameCreatesNoLayoutObject_;
    bool documentCookie_;
    bool documentDomain_;
    bool documentWrite_;
    bool documentWriteEvaluator_;
    bool dOMConvenienceAPI_;
    bool durableStorage_;
    bool embedderCSPEnforcement_;
    bool encryptedMediaHdcpPolicyCheck_;
    bool execCommandInJavaScript_;
    bool expensiveBackgroundTimerThrottling_;
    bool experimentalCanvasFeatures_;
    bool experimentalContentSecurityPolicyFeatures_;
    bool experimentalV8Extras_;
    bool fastMobileScrolling_;
    bool featurePolicy_;
    bool featurePolicyExperimentalFeatures_;
    bool fetchRequestCache_;
    bool fileAPIBlobClose_;
    bool fileSystem_;
    bool fontCacheScaling_;
    bool forceDisable2dCanvasCopyOnWrite_;
    bool forceDisplayList2dCanvas_;
    bool forceOverlayFullscreenVideo_;
    bool forceTallerSelectPopup_;
    bool foreignFetch_;
    bool fractionalScrollOffsets_;
    bool framebustingNeedsSameOriginOrUserGesture_;
    bool framesTimingFunction_;
    bool frameTimingSupport_;
    bool fullscreenUnprefixed_;
    bool gamepadExtensions_;
    bool geometryInterfaces_;
    bool getUserMedia_;
    bool globalCacheStorage_;
    bool heapCompaction_;
    bool hideNonceContentAttribute_;
    bool htmlImportsStyleApplication_;
    bool iDBObserver_;
    bool idleTimeColdModeSpellChecking_;
    bool idleTimeSpellChecking_;
    bool imageCapture_;
    bool imageOrientation_;
    bool inertAttribute_;
    bool inputEvent_;
    bool inputModeAttribute_;
    bool inputMultipleFieldsUI_;
    bool installedApp_;
    bool intersectionObserver_;
    bool jsImageDecode_;
    bool keyboardLock_;
    bool langAttributeAwareFormControlUI_;
    bool layoutNG_;
    bool lazyInitializeMediaControls_;
    bool lazyParseCSS_;
    bool linkServiceWorker_;
    bool loadingWithMojo_;
    bool longTaskObserver_;
    bool mediaCapabilities_;
    bool mediaCapture_;
    bool mediaCaptureDepth_;
    bool mediaCaptureFromCanvas_;
    bool mediaCaptureFromVideo_;
    bool mediaCastOverlayButton_;
    bool mediaControlsOverlayPlayButton_;
    bool mediaDocumentDownloadButton_;
    bool mediaQueryShape_;
    bool mediaSession_;
    bool mediaSourceExperimental_;
    bool mediaSourceNewAbortAndDuration_;
    bool mediaStreamSpeech_;
    bool mediaStreamTrackContentHint_;
    bool mediaTrackApplyConstraints_;
    bool mediaTrackCapabilities_;
    bool memoryInfoInWorkers_;
    bool middleClickAutoscroll_;
    bool mobileLayoutTheme_;
    bool moduleScripts_;
    bool mojoBlobs_;
    bool mojoJS_;
    bool mojoJSTest_;
    bool multipleColorStopPositions_;
    bool navigatorContentUtils_;
    bool netInfoDownlink_;
    bool netInfoDownlinkMax_;
    bool netInfoEffectiveType_;
    bool netInfoRtt_;
    bool newRemotePlaybackPipeline_;
    bool notificationBadge_;
    bool notificationConstructor_;
    bool notificationContentImage_;
    bool notificationInlineReplies_;
    bool notifications_;
    bool nullableDocumentDomain_;
    bool offMainThreadFetch_;
    bool onDeviceChange_;
    bool orientationEvent_;
    bool originTrials_;
    bool originTrialsSampleAPI_;
    bool outOfBlinkCORS_;
    bool overlayScrollbars_;
    bool pagePopup_;
    bool paintUnderInvalidationChecking_;
    bool passiveDocumentEventListeners_;
    bool passPaintVisualRectToCompositor_;
    bool paymentApp_;
    bool paymentDetailsModifierData_;
    bool paymentRequest_;
    bool paymentRequestBasicCard_;
    bool performanceNavigationTiming2_;
    bool performanceObserver_;
    bool performancePaintTiming_;
    bool permissionDelegation_;
    bool permissions_;
    bool permissionsRequestRevoke_;
    bool preciseMemoryInfo_;
    bool preferredImageRasterBounds_;
    bool prefixedVideoFullscreen_;
    bool presentation_;
    bool presentationReceiver_;
    bool printBrowser_;
    bool pushMessaging_;
    bool reducedReferrerGranularity_;
    bool remotePlayback_;
    bool remotePlaybackBackend_;
    bool renderingPipelineThrottling_;
    bool renderingPipelineThrottlingLoadingIframes_;
    bool renderUnicodeControlCharacters_;
    bool resizeObserver_;
    bool resourceLoadScheduler_;
    bool restrictCanRequestURLCharacterSet_;
    bool rootLayerScrolling_;
    bool rTCRtpSender_;
    bool scriptedSpeech_;
    bool scrollAnchoring_;
    bool scrollCustomization_;
    bool scrollTopLeftInterop_;
    bool sendBeaconThrowForBlobWithNonSimpleType_;
    bool sendMouseEventsDisabledFormControls_;
    bool sensor_;
    bool serverTiming_;
    bool serviceWorkerNavigationPreload_;
    bool serviceWorkerScriptStreaming_;
    bool setRootScroller_;
    bool shadowPiercingDescendantCombinator_;
    bool shapeDetection_;
    bool sharedArrayBuffer_;
    bool sharedWorker_;
    bool skipCompositingSmallScrollers_;
    bool slimmingPaintStrictCullRectClipping_;
    bool slimmingPaintV2_;
    bool smil_;
    bool smoothScrollJSIntervention_;
    bool stableBlinkFeatures_;
    bool stackedCSSPropertyAnimations_;
    bool storageEstimate_;
    bool styleSharing_;
    bool suborigins_;
    bool timerThrottlingForBackgroundTabs_;
    bool timerThrottlingForHiddenFrames_;
    bool topNavByUserActivationInSandbox_;
    bool touchEventFeatureDetection_;
    bool touchpadAndWheelScrollLatching_;
    bool trustedEventsDefaultAction_;
    bool unclosedFormControlIsInvalid_;
    bool updateHoverPostLayout_;
    bool v8IdleTasks_;
    bool validationBubbleInRenderer_;
    bool vibrateRequiresUserGesture_;
    bool videoFullscreenDetection_;
    bool videoFullscreenOrientationLock_;
    bool videoRotateToFullscreen_;
    bool visualViewportAPI_;
    bool wakeLock_;
    bool webAnimationsAPI_;
    bool webAnimationsSVG_;
    bool webAssemblyStreaming_;
    bool webAuth_;
    bool webBluetooth_;
    bool webFontsCacheAwareTimeoutAdaptation_;
    bool webFontsInterventionTrigger_;
    bool webFontsInterventionV2With2G_;
    bool webFontsInterventionV2With3G_;
    bool webFontsInterventionV2WithSlow2G_;
    bool webGLDraftExtensions_;
    bool webGLImageChromium_;
    bool webNFC_;
    bool webShare_;
    bool webUSB_;
    bool webVR_;
    bool webVRExperimentalRendering_;
    bool webVTTRegions_;
    bool worklet_;
    bool xslt_;
  };

  static void SetStableFeaturesEnabled(bool);
  static void SetExperimentalFeaturesEnabled(bool);
  static void SetTestFeaturesEnabled(bool);
  static void SetOriginTrialControlledFeaturesEnabled(bool);

  static void SetFeatureEnabledFromString(const std::string& name, bool isEnabled);

  static void SetAccelerated2dCanvasEnabled(bool isEnabled) { isAccelerated2dCanvasEnabled = isEnabled; }
  static bool Accelerated2dCanvasEnabled() { return isAccelerated2dCanvasEnabled; }

  static void SetAccessibilityObjectModelEnabled(bool isEnabled) { isAccessibilityObjectModelEnabled = isEnabled; }
  static bool AccessibilityObjectModelEnabled() { return isAccessibilityObjectModelEnabled; }

  static void SetAllowContentInitiatedDataUrlNavigationsEnabled(bool isEnabled) { isAllowContentInitiatedDataUrlNavigationsEnabled = isEnabled; }
  static bool AllowContentInitiatedDataUrlNavigationsEnabled() { return isAllowContentInitiatedDataUrlNavigationsEnabled; }

  static void SetAsyncClipboardEnabled(bool isEnabled) { isAsyncClipboardEnabled = isEnabled; }
  static bool AsyncClipboardEnabled() { return isAsyncClipboardEnabled; }

  static void SetAudioOutputDevicesEnabled(bool isEnabled) { isAudioOutputDevicesEnabled = isEnabled; }
  static bool AudioOutputDevicesEnabled() { return isAudioOutputDevicesEnabled; }

  static void SetAudioVideoTracksEnabled(bool isEnabled) { isAudioVideoTracksEnabled = isEnabled; }
  static bool AudioVideoTracksEnabled() { return isAudioVideoTracksEnabled; }

  static void SetAudioWorkletEnabled(bool isEnabled) { isAudioWorkletEnabled = isEnabled; }
  static bool AudioWorkletEnabled() { return isAudioWorkletEnabled; }

  static void SetAutoplayMutedVideosEnabled(bool isEnabled) { isAutoplayMutedVideosEnabled = isEnabled; }
  static bool AutoplayMutedVideosEnabled() { return isAutoplayMutedVideosEnabled; }

  static void SetAuxclickEnabled(bool isEnabled) { isAuxclickEnabled = isEnabled; }
  static bool AuxclickEnabled() { return isAuxclickEnabled; }

  static void SetBackgroundFetchEnabled(bool isEnabled) { isBackgroundFetchEnabled = isEnabled; }
  static bool BackgroundFetchEnabled() { return isBackgroundFetchEnabled; }

  static void SetBackgroundSyncEnabled(bool isEnabled) { isBackgroundSyncEnabled = isEnabled; }
  static bool BackgroundSyncEnabled() { return isBackgroundSyncEnabled; }

  static void SetBackgroundVideoTrackOptimizationEnabled(bool isEnabled) { isBackgroundVideoTrackOptimizationEnabled = isEnabled; }
  static bool BackgroundVideoTrackOptimizationEnabled() { return isBackgroundVideoTrackOptimizationEnabled; }

  static void SetBlinkRuntimeCallStatsEnabled(bool isEnabled) { isBlinkRuntimeCallStatsEnabled = isEnabled; }
  static bool BlinkRuntimeCallStatsEnabled() { return isBlinkRuntimeCallStatsEnabled; }

  static void SetBlockCredentialedSubresourcesEnabled(bool isEnabled) { isBlockCredentialedSubresourcesEnabled = isEnabled; }
  static bool BlockCredentialedSubresourcesEnabled() { return isBlockCredentialedSubresourcesEnabled; }

  static void SetBlockLegacySubresourcesEnabled(bool isEnabled) { isBlockLegacySubresourcesEnabled = isEnabled; }
  static bool BlockLegacySubresourcesEnabled() { return isBlockLegacySubresourcesEnabled; }

  static void SetBroadcastChannelEnabled(bool isEnabled) { isBroadcastChannelEnabled = isEnabled; }
  static bool BroadcastChannelEnabled() { return isBroadcastChannelEnabled; }

  static void SetBudgetEnabled(bool isEnabled) { isBudgetEnabled = isEnabled; }
  static bool BudgetEnabled() { return isBudgetEnabled; }

  static void SetBudgetQueryEnabled(bool isEnabled) { isBudgetQueryEnabled = isEnabled; }
  static bool BudgetQueryEnabled() { return isBudgetQueryEnabled; }

  static void SetCanMakePaymentEnabled(bool isEnabled) { isCanMakePaymentEnabled = isEnabled; }
  static bool CanMakePaymentEnabled() { return isCanMakePaymentEnabled; }

  static void SetCanvas2dFixedRenderingModeEnabled(bool isEnabled) { isCanvas2dFixedRenderingModeEnabled = isEnabled; }
  static bool Canvas2dFixedRenderingModeEnabled() { return isCanvas2dFixedRenderingModeEnabled; }

  static void SetCanvas2dImageChromiumEnabled(bool isEnabled) { isCanvas2dImageChromiumEnabled = isEnabled; }
  static bool Canvas2dImageChromiumEnabled() { return isCanvas2dImageChromiumEnabled; }

  static void SetClickRetargettingEnabled(bool isEnabled) { isClickRetargettingEnabled = isEnabled; }
  static bool ClickRetargettingEnabled() { return isClickRetargettingEnabled; }

  static void SetClientHintsEnabled(bool isEnabled) { isClientHintsEnabled = isEnabled; }
  static bool ClientHintsEnabled() { return isClientHintsEnabled; }

  static void SetClientPlaceholdersForServerLoFiEnabled(bool isEnabled) { isClientPlaceholdersForServerLoFiEnabled = isEnabled; }
  static bool ClientPlaceholdersForServerLoFiEnabled() { return isClientPlaceholdersForServerLoFiEnabled; }

  static void SetCoalescedEventsEnabled(bool isEnabled) { isCoalescedEventsEnabled = isEnabled; }
  static bool CoalescedEventsEnabled() { return isCoalescedEventsEnabled; }

  static void SetColorCanvasExtensionsEnabled(bool isEnabled) { isColorCanvasExtensionsEnabled = isEnabled; }
  static bool ColorCanvasExtensionsEnabled() { return isColorCanvasExtensionsEnabled; }

  static void SetColorCorrectRenderingEnabled(bool isEnabled) { isColorCorrectRenderingEnabled = isEnabled; }
  static bool ColorCorrectRenderingEnabled() { return isColorCorrectRenderingEnabled; }

  static void SetCompositedSelectionUpdateEnabled(bool isEnabled) { isCompositedSelectionUpdateEnabled = isEnabled; }
  static bool CompositedSelectionUpdateEnabled() { return isCompositedSelectionUpdateEnabled; }

  static void SetCompositeOpaqueFixedPositionEnabled(bool isEnabled) { isCompositeOpaqueFixedPositionEnabled = isEnabled; }
  static bool CompositeOpaqueFixedPositionEnabled() { return isCompositeOpaqueFixedPositionEnabled; }

  static void SetCompositeOpaqueScrollersEnabled(bool isEnabled) { isCompositeOpaqueScrollersEnabled = isEnabled; }
  static bool CompositeOpaqueScrollersEnabled() { return isCompositeOpaqueScrollersEnabled; }

  static void SetCompositorTouchActionEnabled(bool isEnabled) { isCompositorTouchActionEnabled = isEnabled; }
  static bool CompositorTouchActionEnabled() { return isCompositorTouchActionEnabled; }

  static void SetCompositorWorkerEnabled(bool isEnabled) { isCompositorWorkerEnabled = isEnabled; }
  static bool CompositorWorkerEnabled() { return isCompositorWorkerEnabled; }

  static void SetComputedAccessibilityInfoEnabled(bool isEnabled) { isComputedAccessibilityInfoEnabled = isEnabled; }
  static bool ComputedAccessibilityInfoEnabled() { return isComputedAccessibilityInfoEnabled; }

  static void SetConicGradientEnabled(bool isEnabled) { isConicGradientEnabled = isEnabled; }
  static bool ConicGradientEnabled() { return isConicGradientEnabled; }

  static void SetContextMenuEnabled(bool isEnabled) { isContextMenuEnabled = isEnabled; }
  static bool ContextMenuEnabled() { return isContextMenuEnabled; }

  static void SetCorsRFC1918Enabled(bool isEnabled) { isCorsRFC1918Enabled = isEnabled; }
  static bool CorsRFC1918Enabled() { return isCorsRFC1918Enabled; }

  static void SetCSS3TextEnabled(bool isEnabled) { isCSS3TextEnabled = isEnabled; }
  static bool CSS3TextEnabled() { return isCSS3TextEnabled; }

  static void SetCSS3TextDecorationsEnabled(bool isEnabled) { isCSS3TextDecorationsEnabled = isEnabled; }
  static bool CSS3TextDecorationsEnabled() { return isCSS3TextDecorationsEnabled; }

  static void SetCSSAdditiveAnimationsEnabled(bool isEnabled) { isCSSAdditiveAnimationsEnabled = isEnabled; }
  static bool CSSAdditiveAnimationsEnabled() { return isCSSAdditiveAnimationsEnabled && isStackedCSSPropertyAnimationsEnabled; }

  static void SetCSSApplyAtRulesEnabled(bool isEnabled) { isCSSApplyAtRulesEnabled = isEnabled; }
  static bool CSSApplyAtRulesEnabled() { return isCSSApplyAtRulesEnabled; }

  static void SetCSSBackdropFilterEnabled(bool isEnabled) { isCSSBackdropFilterEnabled = isEnabled; }
  static bool CSSBackdropFilterEnabled() { return isCSSBackdropFilterEnabled; }

  static void SetCSSContainmentEnabled(bool isEnabled) { isCSSContainmentEnabled = isEnabled; }
  static bool CSSContainmentEnabled() { return isCSSContainmentEnabled; }

  static void SetCSSDisplayContentsEnabled(bool isEnabled) { isCSSDisplayContentsEnabled = isEnabled; }
  static bool CSSDisplayContentsEnabled() { return isCSSDisplayContentsEnabled; }

  static void SetCSSFontDisplayEnabled(bool isEnabled) { isCSSFontDisplayEnabled = isEnabled; }
  static bool CSSFontDisplayEnabled() { return isCSSFontDisplayEnabled; }

  static void SetCSSFontSizeAdjustEnabled(bool isEnabled) { isCSSFontSizeAdjustEnabled = isEnabled; }
  static bool CSSFontSizeAdjustEnabled() { return isCSSFontSizeAdjustEnabled; }

  static void SetCSSGridLayoutEnabled(bool isEnabled) { isCSSGridLayoutEnabled = isEnabled; }
  static bool CSSGridLayoutEnabled() { return isCSSGridLayoutEnabled; }

  static void SetCSSHexAlphaColorEnabled(bool isEnabled) { isCSSHexAlphaColorEnabled = isEnabled; }
  static bool CSSHexAlphaColorEnabled() { return isCSSHexAlphaColorEnabled; }

  static void SetCSSHyphensEnabled(bool isEnabled) { isCSSHyphensEnabled = isEnabled; }
  static bool CSSHyphensEnabled() { return isCSSHyphensEnabled; }

  static void SetCSSInBodyDoesNotBlockPaintEnabled(bool isEnabled) { isCSSInBodyDoesNotBlockPaintEnabled = isEnabled; }
  static bool CSSInBodyDoesNotBlockPaintEnabled() { return isCSSInBodyDoesNotBlockPaintEnabled; }

  static void SetCSSIndependentTransformPropertiesEnabled(bool isEnabled) { isCSSIndependentTransformPropertiesEnabled = isEnabled; }
  static bool CSSIndependentTransformPropertiesEnabled() { return isCSSIndependentTransformPropertiesEnabled; }

  static void SetCSSLineBreakEnabled(bool isEnabled) { isCSSLineBreakEnabled = isEnabled; }
  static bool CSSLineBreakEnabled() { return isCSSLineBreakEnabled; }

  static void SetCSSMaskSourceTypeEnabled(bool isEnabled) { isCSSMaskSourceTypeEnabled = isEnabled; }
  static bool CSSMaskSourceTypeEnabled() { return isCSSMaskSourceTypeEnabled; }

  static void SetCSSOffsetPathRayEnabled(bool isEnabled) { isCSSOffsetPathRayEnabled = isEnabled; }
  static bool CSSOffsetPathRayEnabled() { return isCSSOffsetPathRayEnabled; }

  static void SetCSSOffsetPathRayContainEnabled(bool isEnabled) { isCSSOffsetPathRayContainEnabled = isEnabled; }
  static bool CSSOffsetPathRayContainEnabled() { return isCSSOffsetPathRayContainEnabled; }

  static void SetCSSOffsetPositionAnchorEnabled(bool isEnabled) { isCSSOffsetPositionAnchorEnabled = isEnabled; }
  static bool CSSOffsetPositionAnchorEnabled() { return isCSSOffsetPositionAnchorEnabled; }

  static void SetCSSOMSmoothScrollEnabled(bool isEnabled) { isCSSOMSmoothScrollEnabled = isEnabled; }
  static bool CSSOMSmoothScrollEnabled() { return isCSSOMSmoothScrollEnabled; }

  static void SetCSSPaintAPIEnabled(bool isEnabled) { isCSSPaintAPIEnabled = isEnabled; }
  static bool CSSPaintAPIEnabled() { return isCSSPaintAPIEnabled && isWorkletEnabled; }

  static void SetCSSPaintAPIArgumentsEnabled(bool isEnabled) { isCSSPaintAPIArgumentsEnabled = isEnabled; }
  static bool CSSPaintAPIArgumentsEnabled() { return isCSSPaintAPIArgumentsEnabled && isCSSPaintAPIEnabled; }

  static void SetCSSScrollBoundaryBehaviorEnabled(bool isEnabled) { isCSSScrollBoundaryBehaviorEnabled = isEnabled; }
  static bool CSSScrollBoundaryBehaviorEnabled() { return isCSSScrollBoundaryBehaviorEnabled; }

  static void SetCSSScrollSnapPointsEnabled(bool isEnabled) { isCSSScrollSnapPointsEnabled = isEnabled; }
  static bool CSSScrollSnapPointsEnabled() { return isCSSScrollSnapPointsEnabled; }

  static void SetCSSSelectorsFocusWithinEnabled(bool isEnabled) { isCSSSelectorsFocusWithinEnabled = isEnabled; }
  static bool CSSSelectorsFocusWithinEnabled() { return isCSSSelectorsFocusWithinEnabled; }

  static void SetCSSSnapSizeEnabled(bool isEnabled) { isCSSSnapSizeEnabled = isEnabled; }
  static bool CSSSnapSizeEnabled() { return isCSSSnapSizeEnabled; }

  static void SetCSSStickyPositionEnabled(bool isEnabled) { isCSSStickyPositionEnabled = isEnabled; }
  static bool CSSStickyPositionEnabled() { return isCSSStickyPositionEnabled; }

  static void SetCSSTransformBoxEnabled(bool isEnabled) { isCSSTransformBoxEnabled = isEnabled; }
  static bool CSSTransformBoxEnabled() { return isCSSTransformBoxEnabled; }

  static void SetCSSTypedOMEnabled(bool isEnabled) { isCSSTypedOMEnabled = isEnabled; }
  static bool CSSTypedOMEnabled() { return isCSSTypedOMEnabled; }

  static void SetCSSVariableFontsEnabled(bool isEnabled) { isCSSVariableFontsEnabled = isEnabled; }
  static bool CSSVariableFontsEnabled() { return isCSSVariableFontsEnabled; }

  static void SetCSSVariables2Enabled(bool isEnabled) { isCSSVariables2Enabled = isEnabled; }
  static bool CSSVariables2Enabled() { return isCSSVariables2Enabled; }

  static void SetCSSViewportEnabled(bool isEnabled) { isCSSViewportEnabled = isEnabled; }
  static bool CSSViewportEnabled() { return isCSSViewportEnabled; }

  static void SetCustomElementsBuiltinEnabled(bool isEnabled) { isCustomElementsBuiltinEnabled = isEnabled; }
  static bool CustomElementsBuiltinEnabled() { return isCustomElementsBuiltinEnabled; }

  static void SetCustomSchemeHandlerEnabled(bool isEnabled) { isCustomSchemeHandlerEnabled = isEnabled; }
  static bool CustomSchemeHandlerEnabled() { return isCustomSchemeHandlerEnabled && isNavigatorContentUtilsEnabled; }

  static void SetDatabaseEnabled(bool isEnabled) { isDatabaseEnabled = isEnabled; }
  static bool DatabaseEnabled() { return isDatabaseEnabled; }

  static void SetDecodeToYUVEnabled(bool isEnabled) { isDecodeToYUVEnabled = isEnabled; }
  static bool DecodeToYUVEnabled() { return isDecodeToYUVEnabled; }

  static void SetDesktopCaptureDisableLocalEchoControlEnabled(bool isEnabled) { isDesktopCaptureDisableLocalEchoControlEnabled = isEnabled; }
  static bool DesktopCaptureDisableLocalEchoControlEnabled() { return isDesktopCaptureDisableLocalEchoControlEnabled; }

  static void SetDeviceMemoryHeaderEnabled(bool isEnabled) { isDeviceMemoryHeaderEnabled = isEnabled; }
  static bool DeviceMemoryHeaderEnabled() { return isDeviceMemoryHeaderEnabled; }

  static void SetDisplayList2dCanvasEnabled(bool isEnabled) { isDisplayList2dCanvasEnabled = isEnabled; }
  static bool DisplayList2dCanvasEnabled() { return isDisplayList2dCanvasEnabled; }

  static void SetDisplayNoneIFrameCreatesNoLayoutObjectEnabled(bool isEnabled) { isDisplayNoneIFrameCreatesNoLayoutObjectEnabled = isEnabled; }
  static bool DisplayNoneIFrameCreatesNoLayoutObjectEnabled() { return isDisplayNoneIFrameCreatesNoLayoutObjectEnabled; }

  static void SetDocumentCookieEnabled(bool isEnabled) { isDocumentCookieEnabled = isEnabled; }
  static bool DocumentCookieEnabled() { return isDocumentCookieEnabled; }

  static void SetDocumentDomainEnabled(bool isEnabled) { isDocumentDomainEnabled = isEnabled; }
  static bool DocumentDomainEnabled() { return isDocumentDomainEnabled; }

  static void SetDocumentWriteEnabled(bool isEnabled) { isDocumentWriteEnabled = isEnabled; }
  static bool DocumentWriteEnabled() { return isDocumentWriteEnabled; }

  static void SetDocumentWriteEvaluatorEnabled(bool isEnabled) { isDocumentWriteEvaluatorEnabled = isEnabled; }
  static bool DocumentWriteEvaluatorEnabled() { return isDocumentWriteEvaluatorEnabled; }

  static void SetDOMConvenienceAPIEnabled(bool isEnabled) { isDOMConvenienceAPIEnabled = isEnabled; }
  static bool DOMConvenienceAPIEnabled() { return isDOMConvenienceAPIEnabled; }

  static void SetDurableStorageEnabled(bool isEnabled) { isDurableStorageEnabled = isEnabled; }
  static bool DurableStorageEnabled() { return isDurableStorageEnabled; }

  static void SetEmbedderCSPEnforcementEnabled(bool isEnabled) { isEmbedderCSPEnforcementEnabled = isEnabled; }
  static bool EmbedderCSPEnforcementEnabled() { return isEmbedderCSPEnforcementEnabled; }

  static void SetEncryptedMediaHdcpPolicyCheckEnabled(bool isEnabled) { isEncryptedMediaHdcpPolicyCheckEnabled = isEnabled; }
  static bool EncryptedMediaHdcpPolicyCheckEnabled() { return isEncryptedMediaHdcpPolicyCheckEnabled; }

  static void SetExecCommandInJavaScriptEnabled(bool isEnabled) { isExecCommandInJavaScriptEnabled = isEnabled; }
  static bool ExecCommandInJavaScriptEnabled() { return isExecCommandInJavaScriptEnabled; }

  static void SetExpensiveBackgroundTimerThrottlingEnabled(bool isEnabled) { isExpensiveBackgroundTimerThrottlingEnabled = isEnabled; }
  static bool ExpensiveBackgroundTimerThrottlingEnabled() { return isExpensiveBackgroundTimerThrottlingEnabled; }

  static void SetExperimentalCanvasFeaturesEnabled(bool isEnabled) { isExperimentalCanvasFeaturesEnabled = isEnabled; }
  static bool ExperimentalCanvasFeaturesEnabled() { return isExperimentalCanvasFeaturesEnabled; }

  static void SetExperimentalContentSecurityPolicyFeaturesEnabled(bool isEnabled) { isExperimentalContentSecurityPolicyFeaturesEnabled = isEnabled; }
  static bool ExperimentalContentSecurityPolicyFeaturesEnabled() { return isExperimentalContentSecurityPolicyFeaturesEnabled; }

  static void SetExperimentalV8ExtrasEnabled(bool isEnabled) { isExperimentalV8ExtrasEnabled = isEnabled; }
  static bool ExperimentalV8ExtrasEnabled() { return isExperimentalV8ExtrasEnabled; }

  static void SetFastMobileScrollingEnabled(bool isEnabled) { isFastMobileScrollingEnabled = isEnabled; }
  static bool FastMobileScrollingEnabled() { return isFastMobileScrollingEnabled; }

  static void SetFeaturePolicyEnabled(bool isEnabled) { isFeaturePolicyEnabled = isEnabled; }
  static bool FeaturePolicyEnabled() { return isFeaturePolicyEnabled; }

  static void SetFeaturePolicyExperimentalFeaturesEnabled(bool isEnabled) { isFeaturePolicyExperimentalFeaturesEnabled = isEnabled; }
  static bool FeaturePolicyExperimentalFeaturesEnabled() { return isFeaturePolicyExperimentalFeaturesEnabled; }

  static void SetFetchRequestCacheEnabled(bool isEnabled) { isFetchRequestCacheEnabled = isEnabled; }
  static bool FetchRequestCacheEnabled() { return isFetchRequestCacheEnabled; }

  static void SetFileAPIBlobCloseEnabled(bool isEnabled) { isFileAPIBlobCloseEnabled = isEnabled; }
  static bool FileAPIBlobCloseEnabled() { return isFileAPIBlobCloseEnabled; }

  static void SetFileSystemEnabled(bool isEnabled) { isFileSystemEnabled = isEnabled; }
  static bool FileSystemEnabled() { return isFileSystemEnabled; }

  static void SetFontCacheScalingEnabled(bool isEnabled) { isFontCacheScalingEnabled = isEnabled; }
  static bool FontCacheScalingEnabled() { return isFontCacheScalingEnabled; }

  static void SetForceDisable2dCanvasCopyOnWriteEnabled(bool isEnabled) { isForceDisable2dCanvasCopyOnWriteEnabled = isEnabled; }
  static bool ForceDisable2dCanvasCopyOnWriteEnabled() { return isForceDisable2dCanvasCopyOnWriteEnabled; }

  static void SetForceDisplayList2dCanvasEnabled(bool isEnabled) { isForceDisplayList2dCanvasEnabled = isEnabled; }
  static bool ForceDisplayList2dCanvasEnabled() { return isForceDisplayList2dCanvasEnabled; }

  static void SetForceOverlayFullscreenVideoEnabled(bool isEnabled) { isForceOverlayFullscreenVideoEnabled = isEnabled; }
  static bool ForceOverlayFullscreenVideoEnabled() { return isForceOverlayFullscreenVideoEnabled; }

  static void SetForceTallerSelectPopupEnabled(bool isEnabled) { isForceTallerSelectPopupEnabled = isEnabled; }
  static bool ForceTallerSelectPopupEnabled() { return isForceTallerSelectPopupEnabled; }

  static void SetForeignFetchEnabled(bool isEnabled) { isForeignFetchEnabled = isEnabled; }
  static bool ForeignFetchEnabled() { return isForeignFetchEnabled; }

  static void SetFractionalScrollOffsetsEnabled(bool isEnabled) { isFractionalScrollOffsetsEnabled = isEnabled; }
  static bool FractionalScrollOffsetsEnabled() { return isFractionalScrollOffsetsEnabled; }

  static void SetFramebustingNeedsSameOriginOrUserGestureEnabled(bool isEnabled) { isFramebustingNeedsSameOriginOrUserGestureEnabled = isEnabled; }
  static bool FramebustingNeedsSameOriginOrUserGestureEnabled() { return isFramebustingNeedsSameOriginOrUserGestureEnabled; }

  static void SetFramesTimingFunctionEnabled(bool isEnabled) { isFramesTimingFunctionEnabled = isEnabled; }
  static bool FramesTimingFunctionEnabled() { return isFramesTimingFunctionEnabled; }

  static void SetFrameTimingSupportEnabled(bool isEnabled) { isFrameTimingSupportEnabled = isEnabled; }
  static bool FrameTimingSupportEnabled() { return isFrameTimingSupportEnabled; }

  static void SetFullscreenUnprefixedEnabled(bool isEnabled) { isFullscreenUnprefixedEnabled = isEnabled; }
  static bool FullscreenUnprefixedEnabled() { return isFullscreenUnprefixedEnabled; }

  static void SetGamepadExtensionsEnabled(bool isEnabled) { isGamepadExtensionsEnabled = isEnabled; }
  static bool GamepadExtensionsEnabled() { return isGamepadExtensionsEnabled; }

  static void SetGeometryInterfacesEnabled(bool isEnabled) { isGeometryInterfacesEnabled = isEnabled; }
  static bool GeometryInterfacesEnabled() { return isGeometryInterfacesEnabled || isCompositorWorkerEnabled; }

  static void SetGetUserMediaEnabled(bool isEnabled) { isGetUserMediaEnabled = isEnabled; }
  static bool GetUserMediaEnabled() { return isGetUserMediaEnabled; }

  static void SetGlobalCacheStorageEnabled(bool isEnabled) { isGlobalCacheStorageEnabled = isEnabled; }
  static bool GlobalCacheStorageEnabled() { return isGlobalCacheStorageEnabled; }

  static void SetHeapCompactionEnabled(bool isEnabled) { isHeapCompactionEnabled = isEnabled; }
  static bool HeapCompactionEnabled() { return isHeapCompactionEnabled; }

  static void SetHideNonceContentAttributeEnabled(bool isEnabled) { isHideNonceContentAttributeEnabled = isEnabled; }
  static bool HideNonceContentAttributeEnabled() { return isHideNonceContentAttributeEnabled; }

  static void SetHTMLImportsStyleApplicationEnabled(bool isEnabled) { isHTMLImportsStyleApplicationEnabled = isEnabled; }
  static bool HTMLImportsStyleApplicationEnabled() { return isHTMLImportsStyleApplicationEnabled; }

  static void SetIDBObserverEnabled(bool isEnabled) { isIDBObserverEnabled = isEnabled; }
  static bool IDBObserverEnabled() { return isIDBObserverEnabled; }

  static void SetIdleTimeColdModeSpellCheckingEnabled(bool isEnabled) { isIdleTimeColdModeSpellCheckingEnabled = isEnabled; }
  static bool IdleTimeColdModeSpellCheckingEnabled() { return isIdleTimeColdModeSpellCheckingEnabled && isIdleTimeSpellCheckingEnabled; }

  static void SetIdleTimeSpellCheckingEnabled(bool isEnabled) { isIdleTimeSpellCheckingEnabled = isEnabled; }
  static bool IdleTimeSpellCheckingEnabled() { return isIdleTimeSpellCheckingEnabled; }

  static void SetImageCaptureEnabled(bool isEnabled) { isImageCaptureEnabled = isEnabled; }
  static bool ImageCaptureEnabled() { return isImageCaptureEnabled; }

  static void SetImageOrientationEnabled(bool isEnabled) { isImageOrientationEnabled = isEnabled; }
  static bool ImageOrientationEnabled() { return isImageOrientationEnabled; }

  static void SetInertAttributeEnabled(bool isEnabled) { isInertAttributeEnabled = isEnabled; }
  static bool InertAttributeEnabled() { return isInertAttributeEnabled; }

  static void SetInputEventEnabled(bool isEnabled) { isInputEventEnabled = isEnabled; }
  static bool InputEventEnabled() { return isInputEventEnabled; }

  static void SetInputModeAttributeEnabled(bool isEnabled) { isInputModeAttributeEnabled = isEnabled; }
  static bool InputModeAttributeEnabled() { return isInputModeAttributeEnabled; }

  static void SetInputMultipleFieldsUIEnabled(bool isEnabled) { isInputMultipleFieldsUIEnabled = isEnabled; }
  static bool InputMultipleFieldsUIEnabled() { return isInputMultipleFieldsUIEnabled; }

  static void SetInstalledAppEnabled(bool isEnabled) { isInstalledAppEnabled = isEnabled; }
  static bool InstalledAppEnabled() { return isInstalledAppEnabled; }

  static void SetIntersectionObserverEnabled(bool isEnabled) { isIntersectionObserverEnabled = isEnabled; }
  static bool IntersectionObserverEnabled() { return isIntersectionObserverEnabled; }

  static void SetJSImageDecodeEnabled(bool isEnabled) { isJSImageDecodeEnabled = isEnabled; }
  static bool JSImageDecodeEnabled() { return isJSImageDecodeEnabled; }

  static void SetKeyboardLockEnabled(bool isEnabled) { isKeyboardLockEnabled = isEnabled; }
  static bool KeyboardLockEnabled() { return isKeyboardLockEnabled; }

  static void SetLangAttributeAwareFormControlUIEnabled(bool isEnabled) { isLangAttributeAwareFormControlUIEnabled = isEnabled; }
  static bool LangAttributeAwareFormControlUIEnabled() { return isLangAttributeAwareFormControlUIEnabled; }

  static void SetLayoutNGEnabled(bool isEnabled) { isLayoutNGEnabled = isEnabled; }
  static bool LayoutNGEnabled() { return isLayoutNGEnabled; }

  static void SetLazyInitializeMediaControlsEnabled(bool isEnabled) { isLazyInitializeMediaControlsEnabled = isEnabled; }
  static bool LazyInitializeMediaControlsEnabled() { return isLazyInitializeMediaControlsEnabled; }

  static void SetLazyParseCSSEnabled(bool isEnabled) { isLazyParseCSSEnabled = isEnabled; }
  static bool LazyParseCSSEnabled() { return isLazyParseCSSEnabled; }

  static void SetLinkServiceWorkerEnabled(bool isEnabled) { isLinkServiceWorkerEnabled = isEnabled; }
  static bool LinkServiceWorkerEnabled() { return isLinkServiceWorkerEnabled; }

  static void SetLoadingWithMojoEnabled(bool isEnabled) { isLoadingWithMojoEnabled = isEnabled; }
  static bool LoadingWithMojoEnabled() { return isLoadingWithMojoEnabled; }

  static void SetLongTaskObserverEnabled(bool isEnabled) { isLongTaskObserverEnabled = isEnabled; }
  static bool LongTaskObserverEnabled() { return isLongTaskObserverEnabled; }

  static void SetMediaCapabilitiesEnabled(bool isEnabled) { isMediaCapabilitiesEnabled = isEnabled; }
  static bool MediaCapabilitiesEnabled() { return isMediaCapabilitiesEnabled; }

  static void SetMediaCaptureEnabled(bool isEnabled) { isMediaCaptureEnabled = isEnabled; }
  static bool MediaCaptureEnabled() { return isMediaCaptureEnabled; }

  static void SetMediaCaptureDepthEnabled(bool isEnabled) { isMediaCaptureDepthEnabled = isEnabled; }
  static bool MediaCaptureDepthEnabled() { return isMediaCaptureDepthEnabled; }

  static void SetMediaCaptureFromCanvasEnabled(bool isEnabled) { isMediaCaptureFromCanvasEnabled = isEnabled; }
  static bool MediaCaptureFromCanvasEnabled() { return isMediaCaptureFromCanvasEnabled; }

  static void SetMediaCaptureFromVideoEnabled(bool isEnabled) { isMediaCaptureFromVideoEnabled = isEnabled; }
  static bool MediaCaptureFromVideoEnabled() { return isMediaCaptureFromVideoEnabled; }

  static void SetMediaCastOverlayButtonEnabled(bool isEnabled) { isMediaCastOverlayButtonEnabled = isEnabled; }
  static bool MediaCastOverlayButtonEnabled() { return isMediaCastOverlayButtonEnabled; }

  static void SetMediaControlsOverlayPlayButtonEnabled(bool isEnabled) { isMediaControlsOverlayPlayButtonEnabled = isEnabled; }
  static bool MediaControlsOverlayPlayButtonEnabled() { return isMediaControlsOverlayPlayButtonEnabled; }

  static void SetMediaDocumentDownloadButtonEnabled(bool isEnabled) { isMediaDocumentDownloadButtonEnabled = isEnabled; }
  static bool MediaDocumentDownloadButtonEnabled() { return isMediaDocumentDownloadButtonEnabled; }

  static void SetMediaQueryShapeEnabled(bool isEnabled) { isMediaQueryShapeEnabled = isEnabled; }
  static bool MediaQueryShapeEnabled() { return isMediaQueryShapeEnabled; }

  static void SetMediaSessionEnabled(bool isEnabled) { isMediaSessionEnabled = isEnabled; }
  static bool MediaSessionEnabled() { return isMediaSessionEnabled; }

  static void SetMediaSourceExperimentalEnabled(bool isEnabled) { isMediaSourceExperimentalEnabled = isEnabled; }
  static bool MediaSourceExperimentalEnabled() { return isMediaSourceExperimentalEnabled; }

  static void SetMediaSourceNewAbortAndDurationEnabled(bool isEnabled) { isMediaSourceNewAbortAndDurationEnabled = isEnabled; }
  static bool MediaSourceNewAbortAndDurationEnabled() { return isMediaSourceNewAbortAndDurationEnabled; }

  static void SetMediaStreamSpeechEnabled(bool isEnabled) { isMediaStreamSpeechEnabled = isEnabled; }
  static bool MediaStreamSpeechEnabled() { return isMediaStreamSpeechEnabled; }

  static void SetMediaStreamTrackContentHintEnabled(bool isEnabled) { isMediaStreamTrackContentHintEnabled = isEnabled; }
  static bool MediaStreamTrackContentHintEnabled() { return isMediaStreamTrackContentHintEnabled; }

  static void SetMediaTrackApplyConstraintsEnabled(bool isEnabled) { isMediaTrackApplyConstraintsEnabled = isEnabled; }
  static bool MediaTrackApplyConstraintsEnabled() { return isMediaTrackApplyConstraintsEnabled || isImageCaptureEnabled; }

  static void SetMediaTrackCapabilitiesEnabled(bool isEnabled) { isMediaTrackCapabilitiesEnabled = isEnabled; }
  static bool MediaTrackCapabilitiesEnabled() { return isMediaTrackCapabilitiesEnabled || isImageCaptureEnabled; }

  static void SetMemoryInfoInWorkersEnabled(bool isEnabled) { isMemoryInfoInWorkersEnabled = isEnabled; }
  static bool MemoryInfoInWorkersEnabled() { return isMemoryInfoInWorkersEnabled; }

  static void SetMiddleClickAutoscrollEnabled(bool isEnabled) { isMiddleClickAutoscrollEnabled = isEnabled; }
  static bool MiddleClickAutoscrollEnabled() { return isMiddleClickAutoscrollEnabled; }

  static void SetMobileLayoutThemeEnabled(bool isEnabled) { isMobileLayoutThemeEnabled = isEnabled; }
  static bool MobileLayoutThemeEnabled() { return isMobileLayoutThemeEnabled; }

  static void SetModuleScriptsEnabled(bool isEnabled) { isModuleScriptsEnabled = isEnabled; }
  static bool ModuleScriptsEnabled() { return isModuleScriptsEnabled; }

  static void SetMojoBlobsEnabled(bool isEnabled) { isMojoBlobsEnabled = isEnabled; }
  static bool MojoBlobsEnabled() { return isMojoBlobsEnabled; }

  static void SetMojoJSEnabled(bool isEnabled) { isMojoJSEnabled = isEnabled; }
  static bool MojoJSEnabled() { return isMojoJSEnabled; }

  static void SetMojoJSTestEnabled(bool isEnabled) { isMojoJSTestEnabled = isEnabled; }
  static bool MojoJSTestEnabled() { return isMojoJSTestEnabled; }

  static void SetMultipleColorStopPositionsEnabled(bool isEnabled) { isMultipleColorStopPositionsEnabled = isEnabled; }
  static bool MultipleColorStopPositionsEnabled() { return isMultipleColorStopPositionsEnabled; }

  static void SetNavigatorContentUtilsEnabled(bool isEnabled) { isNavigatorContentUtilsEnabled = isEnabled; }
  static bool NavigatorContentUtilsEnabled() { return isNavigatorContentUtilsEnabled; }

  static void SetNetInfoDownlinkEnabled(bool isEnabled) { isNetInfoDownlinkEnabled = isEnabled; }
  static bool NetInfoDownlinkEnabled() { return isNetInfoDownlinkEnabled; }

  static void SetNetInfoDownlinkMaxEnabled(bool isEnabled) { isNetInfoDownlinkMaxEnabled = isEnabled; }
  static bool NetInfoDownlinkMaxEnabled() { return isNetInfoDownlinkMaxEnabled; }

  static void SetNetInfoEffectiveTypeEnabled(bool isEnabled) { isNetInfoEffectiveTypeEnabled = isEnabled; }
  static bool NetInfoEffectiveTypeEnabled() { return isNetInfoEffectiveTypeEnabled; }

  static void SetNetInfoRttEnabled(bool isEnabled) { isNetInfoRttEnabled = isEnabled; }
  static bool NetInfoRttEnabled() { return isNetInfoRttEnabled; }

  static void SetNewRemotePlaybackPipelineEnabled(bool isEnabled) { isNewRemotePlaybackPipelineEnabled = isEnabled; }
  static bool NewRemotePlaybackPipelineEnabled() { return isNewRemotePlaybackPipelineEnabled; }

  static void SetNotificationBadgeEnabled(bool isEnabled) { isNotificationBadgeEnabled = isEnabled; }
  static bool NotificationBadgeEnabled() { return isNotificationBadgeEnabled; }

  static void SetNotificationConstructorEnabled(bool isEnabled) { isNotificationConstructorEnabled = isEnabled; }
  static bool NotificationConstructorEnabled() { return isNotificationConstructorEnabled; }

  static void SetNotificationContentImageEnabled(bool isEnabled) { isNotificationContentImageEnabled = isEnabled; }
  static bool NotificationContentImageEnabled() { return isNotificationContentImageEnabled; }

  static void SetNotificationInlineRepliesEnabled(bool isEnabled) { isNotificationInlineRepliesEnabled = isEnabled; }
  static bool NotificationInlineRepliesEnabled() { return isNotificationInlineRepliesEnabled; }

  static void SetNotificationsEnabled(bool isEnabled) { isNotificationsEnabled = isEnabled; }
  static bool NotificationsEnabled() { return isNotificationsEnabled; }

  static void SetNullableDocumentDomainEnabled(bool isEnabled) { isNullableDocumentDomainEnabled = isEnabled; }
  static bool NullableDocumentDomainEnabled() { return isNullableDocumentDomainEnabled; }

  static void SetOffMainThreadFetchEnabled(bool isEnabled) { isOffMainThreadFetchEnabled = isEnabled; }
  static bool OffMainThreadFetchEnabled() { return isOffMainThreadFetchEnabled; }

  static void SetOnDeviceChangeEnabled(bool isEnabled) { isOnDeviceChangeEnabled = isEnabled; }
  static bool OnDeviceChangeEnabled() { return isOnDeviceChangeEnabled; }

  static void SetOrientationEventEnabled(bool isEnabled) { isOrientationEventEnabled = isEnabled; }
  static bool OrientationEventEnabled() { return isOrientationEventEnabled; }

  static void SetOriginTrialsEnabled(bool isEnabled) { isOriginTrialsEnabled = isEnabled; }
  static bool OriginTrialsEnabled() { return isOriginTrialsEnabled; }

  static void SetOriginTrialsSampleAPIEnabled(bool isEnabled) { isOriginTrialsSampleAPIEnabled = isEnabled; }
  static bool OriginTrialsSampleAPIEnabled() { return isOriginTrialsSampleAPIEnabled; }

  static void SetOutOfBlinkCORSEnabled(bool isEnabled) { isOutOfBlinkCORSEnabled = isEnabled; }
  static bool OutOfBlinkCORSEnabled() { return isOutOfBlinkCORSEnabled; }

  static void SetOverlayScrollbarsEnabled(bool isEnabled) { isOverlayScrollbarsEnabled = isEnabled; }
  static bool OverlayScrollbarsEnabled() { return isOverlayScrollbarsEnabled; }

  static void SetPagePopupEnabled(bool isEnabled) { isPagePopupEnabled = isEnabled; }
  static bool PagePopupEnabled() { return isPagePopupEnabled; }

  static void SetPaintUnderInvalidationCheckingEnabled(bool isEnabled) { isPaintUnderInvalidationCheckingEnabled = isEnabled; }
  static bool PaintUnderInvalidationCheckingEnabled() { return isPaintUnderInvalidationCheckingEnabled; }

  static void SetPassiveDocumentEventListenersEnabled(bool isEnabled) { isPassiveDocumentEventListenersEnabled = isEnabled; }
  static bool PassiveDocumentEventListenersEnabled() { return isPassiveDocumentEventListenersEnabled; }

  static void SetPassPaintVisualRectToCompositorEnabled(bool isEnabled) { isPassPaintVisualRectToCompositorEnabled = isEnabled; }
  static bool PassPaintVisualRectToCompositorEnabled() { return isPassPaintVisualRectToCompositorEnabled; }

  static void SetPaymentAppEnabled(bool isEnabled) { isPaymentAppEnabled = isEnabled; }
  static bool PaymentAppEnabled() { return isPaymentAppEnabled; }

  static void SetPaymentDetailsModifierDataEnabled(bool isEnabled) { isPaymentDetailsModifierDataEnabled = isEnabled; }
  static bool PaymentDetailsModifierDataEnabled() { return isPaymentDetailsModifierDataEnabled; }

  static void SetPaymentRequestEnabled(bool isEnabled) { isPaymentRequestEnabled = isEnabled; }
  static bool PaymentRequestEnabled() { return isPaymentRequestEnabled; }

  static void SetPaymentRequestBasicCardEnabled(bool isEnabled) { isPaymentRequestBasicCardEnabled = isEnabled; }
  static bool PaymentRequestBasicCardEnabled() { return isPaymentRequestBasicCardEnabled; }

  static void SetPerformanceNavigationTiming2Enabled(bool isEnabled) { isPerformanceNavigationTiming2Enabled = isEnabled; }
  static bool PerformanceNavigationTiming2Enabled() { return isPerformanceNavigationTiming2Enabled; }

  static void SetPerformanceObserverEnabled(bool isEnabled) { isPerformanceObserverEnabled = isEnabled; }
  static bool PerformanceObserverEnabled() { return isPerformanceObserverEnabled; }

  static void SetPerformancePaintTimingEnabled(bool isEnabled) { isPerformancePaintTimingEnabled = isEnabled; }
  static bool PerformancePaintTimingEnabled() { return isPerformancePaintTimingEnabled; }

  static void SetPermissionDelegationEnabled(bool isEnabled) { isPermissionDelegationEnabled = isEnabled; }
  static bool PermissionDelegationEnabled() { return isPermissionDelegationEnabled; }

  static void SetPermissionsEnabled(bool isEnabled) { isPermissionsEnabled = isEnabled; }
  static bool PermissionsEnabled() { return isPermissionsEnabled; }

  static void SetPermissionsRequestRevokeEnabled(bool isEnabled) { isPermissionsRequestRevokeEnabled = isEnabled; }
  static bool PermissionsRequestRevokeEnabled() { return isPermissionsRequestRevokeEnabled; }

  static void SetPreciseMemoryInfoEnabled(bool isEnabled) { isPreciseMemoryInfoEnabled = isEnabled; }
  static bool PreciseMemoryInfoEnabled() { return isPreciseMemoryInfoEnabled; }

  static void SetPreferredImageRasterBoundsEnabled(bool isEnabled) { isPreferredImageRasterBoundsEnabled = isEnabled; }
  static bool PreferredImageRasterBoundsEnabled() { return isPreferredImageRasterBoundsEnabled; }

  static void SetPrefixedVideoFullscreenEnabled(bool isEnabled) { isPrefixedVideoFullscreenEnabled = isEnabled; }
  static bool PrefixedVideoFullscreenEnabled() { return isPrefixedVideoFullscreenEnabled; }

  static void SetPresentationEnabled(bool isEnabled) { isPresentationEnabled = isEnabled; }
  static bool PresentationEnabled() { return isPresentationEnabled; }

  static void SetPresentationReceiverEnabled(bool isEnabled) { isPresentationReceiverEnabled = isEnabled; }
  static bool PresentationReceiverEnabled() { return isPresentationReceiverEnabled; }

  static void SetPrintBrowserEnabled(bool isEnabled) { isPrintBrowserEnabled = isEnabled; }
  static bool PrintBrowserEnabled() { return isPrintBrowserEnabled; }

  static void SetPushMessagingEnabled(bool isEnabled) { isPushMessagingEnabled = isEnabled; }
  static bool PushMessagingEnabled() { return isPushMessagingEnabled; }

  static void SetReducedReferrerGranularityEnabled(bool isEnabled) { isReducedReferrerGranularityEnabled = isEnabled; }
  static bool ReducedReferrerGranularityEnabled() { return isReducedReferrerGranularityEnabled; }

  static void SetRemotePlaybackEnabled(bool isEnabled) { isRemotePlaybackEnabled = isEnabled; }
  static bool RemotePlaybackEnabled() { return isRemotePlaybackEnabled; }

  static void SetRemotePlaybackBackendEnabled(bool isEnabled) { isRemotePlaybackBackendEnabled = isEnabled; }
  static bool RemotePlaybackBackendEnabled() { return isRemotePlaybackBackendEnabled; }

  static void SetRenderingPipelineThrottlingEnabled(bool isEnabled) { isRenderingPipelineThrottlingEnabled = isEnabled; }
  static bool RenderingPipelineThrottlingEnabled() { return isRenderingPipelineThrottlingEnabled; }

  static void SetRenderingPipelineThrottlingLoadingIframesEnabled(bool isEnabled) { isRenderingPipelineThrottlingLoadingIframesEnabled = isEnabled; }
  static bool RenderingPipelineThrottlingLoadingIframesEnabled() { return isRenderingPipelineThrottlingLoadingIframesEnabled; }

  static void SetRenderUnicodeControlCharactersEnabled(bool isEnabled) { isRenderUnicodeControlCharactersEnabled = isEnabled; }
  static bool RenderUnicodeControlCharactersEnabled() { return isRenderUnicodeControlCharactersEnabled; }

  static void SetResizeObserverEnabled(bool isEnabled) { isResizeObserverEnabled = isEnabled; }
  static bool ResizeObserverEnabled() { return isResizeObserverEnabled; }

  static void SetResourceLoadSchedulerEnabled(bool isEnabled) { isResourceLoadSchedulerEnabled = isEnabled; }
  static bool ResourceLoadSchedulerEnabled() { return isResourceLoadSchedulerEnabled; }

  static void SetRestrictCanRequestURLCharacterSetEnabled(bool isEnabled) { isRestrictCanRequestURLCharacterSetEnabled = isEnabled; }
  static bool RestrictCanRequestURLCharacterSetEnabled() { return isRestrictCanRequestURLCharacterSetEnabled; }

  static void SetRootLayerScrollingEnabled(bool isEnabled) { isRootLayerScrollingEnabled = isEnabled; }
  static bool RootLayerScrollingEnabled() { return isRootLayerScrollingEnabled; }

  static void SetRTCRtpSenderEnabled(bool isEnabled) { isRTCRtpSenderEnabled = isEnabled; }
  static bool RTCRtpSenderEnabled() { return isRTCRtpSenderEnabled; }

  static void SetScriptedSpeechEnabled(bool isEnabled) { isScriptedSpeechEnabled = isEnabled; }
  static bool ScriptedSpeechEnabled() { return isScriptedSpeechEnabled; }

  static void SetScrollAnchoringEnabled(bool isEnabled) { isScrollAnchoringEnabled = isEnabled; }
  static bool ScrollAnchoringEnabled() { return isScrollAnchoringEnabled; }

  static void SetScrollCustomizationEnabled(bool isEnabled) { isScrollCustomizationEnabled = isEnabled; }
  static bool ScrollCustomizationEnabled() { return isScrollCustomizationEnabled; }

  static void SetScrollTopLeftInteropEnabled(bool isEnabled) { isScrollTopLeftInteropEnabled = isEnabled; }
  static bool ScrollTopLeftInteropEnabled() { return isScrollTopLeftInteropEnabled; }

  static void SetSendBeaconThrowForBlobWithNonSimpleTypeEnabled(bool isEnabled) { isSendBeaconThrowForBlobWithNonSimpleTypeEnabled = isEnabled; }
  static bool SendBeaconThrowForBlobWithNonSimpleTypeEnabled() { return isSendBeaconThrowForBlobWithNonSimpleTypeEnabled; }

  static void SetSendMouseEventsDisabledFormControlsEnabled(bool isEnabled) { isSendMouseEventsDisabledFormControlsEnabled = isEnabled; }
  static bool SendMouseEventsDisabledFormControlsEnabled() { return isSendMouseEventsDisabledFormControlsEnabled; }

  static void SetSensorEnabled(bool isEnabled) { isSensorEnabled = isEnabled; }
  static bool SensorEnabled() { return isSensorEnabled; }

  static void SetServerTimingEnabled(bool isEnabled) { isServerTimingEnabled = isEnabled; }
  static bool ServerTimingEnabled() { return isServerTimingEnabled; }

  static void SetServiceWorkerNavigationPreloadEnabled(bool isEnabled) { isServiceWorkerNavigationPreloadEnabled = isEnabled; }
  static bool ServiceWorkerNavigationPreloadEnabled() { return isServiceWorkerNavigationPreloadEnabled; }

  static void SetServiceWorkerScriptStreamingEnabled(bool isEnabled) { isServiceWorkerScriptStreamingEnabled = isEnabled; }
  static bool ServiceWorkerScriptStreamingEnabled() { return isServiceWorkerScriptStreamingEnabled; }

  static void SetSetRootScrollerEnabled(bool isEnabled) { isSetRootScrollerEnabled = isEnabled; }
  static bool SetRootScrollerEnabled() { return isSetRootScrollerEnabled; }

  static void SetShadowPiercingDescendantCombinatorEnabled(bool isEnabled) { isShadowPiercingDescendantCombinatorEnabled = isEnabled; }
  static bool ShadowPiercingDescendantCombinatorEnabled() { return isShadowPiercingDescendantCombinatorEnabled; }

  static void SetShapeDetectionEnabled(bool isEnabled) { isShapeDetectionEnabled = isEnabled; }
  static bool ShapeDetectionEnabled() { return isShapeDetectionEnabled; }

  static void SetSharedArrayBufferEnabled(bool isEnabled) { isSharedArrayBufferEnabled = isEnabled; }
  static bool SharedArrayBufferEnabled() { return isSharedArrayBufferEnabled; }

  static void SetSharedWorkerEnabled(bool isEnabled) { isSharedWorkerEnabled = isEnabled; }
  static bool SharedWorkerEnabled() { return isSharedWorkerEnabled; }

  static void SetSkipCompositingSmallScrollersEnabled(bool isEnabled) { isSkipCompositingSmallScrollersEnabled = isEnabled; }
  static bool SkipCompositingSmallScrollersEnabled() { return isSkipCompositingSmallScrollersEnabled; }

  static void SetSlimmingPaintStrictCullRectClippingEnabled(bool isEnabled) { isSlimmingPaintStrictCullRectClippingEnabled = isEnabled; }
  static bool SlimmingPaintStrictCullRectClippingEnabled() { return isSlimmingPaintStrictCullRectClippingEnabled; }

  static void SetSlimmingPaintV2Enabled(bool isEnabled) { isSlimmingPaintV2Enabled = isEnabled; }
  static bool SlimmingPaintV2Enabled() { return isSlimmingPaintV2Enabled; }

  static void SetSMILEnabled(bool isEnabled) { isSMILEnabled = isEnabled; }
  static bool SMILEnabled() { return isSMILEnabled; }

  static void SetSmoothScrollJSInterventionEnabled(bool isEnabled) { isSmoothScrollJSInterventionEnabled = isEnabled; }
  static bool SmoothScrollJSInterventionEnabled() { return isSmoothScrollJSInterventionEnabled; }

  static void SetStableBlinkFeaturesEnabled(bool isEnabled) { isStableBlinkFeaturesEnabled = isEnabled; }
  static bool StableBlinkFeaturesEnabled() { return isStableBlinkFeaturesEnabled; }

  static void SetStackedCSSPropertyAnimationsEnabled(bool isEnabled) { isStackedCSSPropertyAnimationsEnabled = isEnabled; }
  static bool StackedCSSPropertyAnimationsEnabled() { return isStackedCSSPropertyAnimationsEnabled; }

  static void SetStorageEstimateEnabled(bool isEnabled) { isStorageEstimateEnabled = isEnabled; }
  static bool StorageEstimateEnabled() { return isStorageEstimateEnabled; }

  static void SetStyleSharingEnabled(bool isEnabled) { isStyleSharingEnabled = isEnabled; }
  static bool StyleSharingEnabled() { return isStyleSharingEnabled; }

  static void SetSuboriginsEnabled(bool isEnabled) { isSuboriginsEnabled = isEnabled; }
  static bool SuboriginsEnabled() { return isSuboriginsEnabled; }

  static void SetTimerThrottlingForBackgroundTabsEnabled(bool isEnabled) { isTimerThrottlingForBackgroundTabsEnabled = isEnabled; }
  static bool TimerThrottlingForBackgroundTabsEnabled() { return isTimerThrottlingForBackgroundTabsEnabled; }

  static void SetTimerThrottlingForHiddenFramesEnabled(bool isEnabled) { isTimerThrottlingForHiddenFramesEnabled = isEnabled; }
  static bool TimerThrottlingForHiddenFramesEnabled() { return isTimerThrottlingForHiddenFramesEnabled; }

  static void SetTopNavByUserActivationInSandboxEnabled(bool isEnabled) { isTopNavByUserActivationInSandboxEnabled = isEnabled; }
  static bool TopNavByUserActivationInSandboxEnabled() { return isTopNavByUserActivationInSandboxEnabled; }

  static void SetTouchEventFeatureDetectionEnabled(bool isEnabled) { isTouchEventFeatureDetectionEnabled = isEnabled; }
  static bool TouchEventFeatureDetectionEnabled() { return isTouchEventFeatureDetectionEnabled; }

  static void SetTouchpadAndWheelScrollLatchingEnabled(bool isEnabled) { isTouchpadAndWheelScrollLatchingEnabled = isEnabled; }
  static bool TouchpadAndWheelScrollLatchingEnabled() { return isTouchpadAndWheelScrollLatchingEnabled; }

  static void SetTrustedEventsDefaultActionEnabled(bool isEnabled) { isTrustedEventsDefaultActionEnabled = isEnabled; }
  static bool TrustedEventsDefaultActionEnabled() { return isTrustedEventsDefaultActionEnabled; }

  static void SetUnclosedFormControlIsInvalidEnabled(bool isEnabled) { isUnclosedFormControlIsInvalidEnabled = isEnabled; }
  static bool UnclosedFormControlIsInvalidEnabled() { return isUnclosedFormControlIsInvalidEnabled; }

  static void SetUpdateHoverPostLayoutEnabled(bool isEnabled) { isUpdateHoverPostLayoutEnabled = isEnabled; }
  static bool UpdateHoverPostLayoutEnabled() { return isUpdateHoverPostLayoutEnabled; }

  static void SetV8IdleTasksEnabled(bool isEnabled) { isV8IdleTasksEnabled = isEnabled; }
  static bool V8IdleTasksEnabled() { return isV8IdleTasksEnabled; }

  static void SetValidationBubbleInRendererEnabled(bool isEnabled) { isValidationBubbleInRendererEnabled = isEnabled; }
  static bool ValidationBubbleInRendererEnabled() { return isValidationBubbleInRendererEnabled; }

  static void SetVibrateRequiresUserGestureEnabled(bool isEnabled) { isVibrateRequiresUserGestureEnabled = isEnabled; }
  static bool VibrateRequiresUserGestureEnabled() { return isVibrateRequiresUserGestureEnabled; }

  static void SetVideoFullscreenDetectionEnabled(bool isEnabled) { isVideoFullscreenDetectionEnabled = isEnabled; }
  static bool VideoFullscreenDetectionEnabled() { return isVideoFullscreenDetectionEnabled; }

  static void SetVideoFullscreenOrientationLockEnabled(bool isEnabled) { isVideoFullscreenOrientationLockEnabled = isEnabled; }
  static bool VideoFullscreenOrientationLockEnabled() { return isVideoFullscreenOrientationLockEnabled; }

  static void SetVideoRotateToFullscreenEnabled(bool isEnabled) { isVideoRotateToFullscreenEnabled = isEnabled; }
  static bool VideoRotateToFullscreenEnabled() { return isVideoRotateToFullscreenEnabled; }

  static void SetVisualViewportAPIEnabled(bool isEnabled) { isVisualViewportAPIEnabled = isEnabled; }
  static bool VisualViewportAPIEnabled() { return isVisualViewportAPIEnabled; }

  static void SetWakeLockEnabled(bool isEnabled) { isWakeLockEnabled = isEnabled; }
  static bool WakeLockEnabled() { return isWakeLockEnabled; }

  static void SetWebAnimationsAPIEnabled(bool isEnabled) { isWebAnimationsAPIEnabled = isEnabled; }
  static bool WebAnimationsAPIEnabled() { return isWebAnimationsAPIEnabled; }

  static void SetWebAnimationsSVGEnabled(bool isEnabled) { isWebAnimationsSVGEnabled = isEnabled; }
  static bool WebAnimationsSVGEnabled() { return isWebAnimationsSVGEnabled; }

  static void SetWebAssemblyStreamingEnabled(bool isEnabled) { isWebAssemblyStreamingEnabled = isEnabled; }
  static bool WebAssemblyStreamingEnabled() { return isWebAssemblyStreamingEnabled; }

  static void SetWebAuthEnabled(bool isEnabled) { isWebAuthEnabled = isEnabled; }
  static bool WebAuthEnabled() { return isWebAuthEnabled; }

  static void SetWebBluetoothEnabled(bool isEnabled) { isWebBluetoothEnabled = isEnabled; }
  static bool WebBluetoothEnabled() { return isWebBluetoothEnabled; }

  static void SetWebFontsCacheAwareTimeoutAdaptationEnabled(bool isEnabled) { isWebFontsCacheAwareTimeoutAdaptationEnabled = isEnabled; }
  static bool WebFontsCacheAwareTimeoutAdaptationEnabled() { return isWebFontsCacheAwareTimeoutAdaptationEnabled; }

  static void SetWebFontsInterventionTriggerEnabled(bool isEnabled) { isWebFontsInterventionTriggerEnabled = isEnabled; }
  static bool WebFontsInterventionTriggerEnabled() { return isWebFontsInterventionTriggerEnabled; }

  static void SetWebFontsInterventionV2With2GEnabled(bool isEnabled) { isWebFontsInterventionV2With2GEnabled = isEnabled; }
  static bool WebFontsInterventionV2With2GEnabled() { return isWebFontsInterventionV2With2GEnabled; }

  static void SetWebFontsInterventionV2With3GEnabled(bool isEnabled) { isWebFontsInterventionV2With3GEnabled = isEnabled; }
  static bool WebFontsInterventionV2With3GEnabled() { return isWebFontsInterventionV2With3GEnabled; }

  static void SetWebFontsInterventionV2WithSlow2GEnabled(bool isEnabled) { isWebFontsInterventionV2WithSlow2GEnabled = isEnabled; }
  static bool WebFontsInterventionV2WithSlow2GEnabled() { return isWebFontsInterventionV2WithSlow2GEnabled; }

  static void SetWebGLDraftExtensionsEnabled(bool isEnabled) { isWebGLDraftExtensionsEnabled = isEnabled; }
  static bool WebGLDraftExtensionsEnabled() { return isWebGLDraftExtensionsEnabled; }

  static void SetWebGLImageChromiumEnabled(bool isEnabled) { isWebGLImageChromiumEnabled = isEnabled; }
  static bool WebGLImageChromiumEnabled() { return isWebGLImageChromiumEnabled; }

  static void SetWebNFCEnabled(bool isEnabled) { isWebNFCEnabled = isEnabled; }
  static bool WebNFCEnabled() { return isWebNFCEnabled; }

  static void SetWebShareEnabled(bool isEnabled) { isWebShareEnabled = isEnabled; }
  static bool WebShareEnabled() { return isWebShareEnabled; }

  static void SetWebUSBEnabled(bool isEnabled) { isWebUSBEnabled = isEnabled; }
  static bool WebUSBEnabled() { return isWebUSBEnabled; }

  static void SetWebVREnabled(bool isEnabled) { isWebVREnabled = isEnabled; }
  static bool WebVREnabled() { return isWebVREnabled; }

  static void SetWebVRExperimentalRenderingEnabled(bool isEnabled) { isWebVRExperimentalRenderingEnabled = isEnabled; }
  static bool WebVRExperimentalRenderingEnabled() { return isWebVRExperimentalRenderingEnabled; }

  static void SetWebVTTRegionsEnabled(bool isEnabled) { isWebVTTRegionsEnabled = isEnabled; }
  static bool WebVTTRegionsEnabled() { return isWebVTTRegionsEnabled; }

  static void SetWorkletEnabled(bool isEnabled) { isWorkletEnabled = isEnabled; }
  static bool WorkletEnabled() { return isWorkletEnabled; }

  static void SetXSLTEnabled(bool isEnabled) { isXSLTEnabled = isEnabled; }
  static bool XSLTEnabled() { return isXSLTEnabled; }


 private:
  static bool isAccelerated2dCanvasEnabled;
  static bool isAccessibilityObjectModelEnabled;
  static bool isAllowContentInitiatedDataUrlNavigationsEnabled;
  static bool isAsyncClipboardEnabled;
  static bool isAudioOutputDevicesEnabled;
  static bool isAudioVideoTracksEnabled;
  static bool isAudioWorkletEnabled;
  static bool isAutoplayMutedVideosEnabled;
  static bool isAuxclickEnabled;
  static bool isBackgroundFetchEnabled;
  static bool isBackgroundSyncEnabled;
  static bool isBackgroundVideoTrackOptimizationEnabled;
  static bool isBlinkRuntimeCallStatsEnabled;
  static bool isBlockCredentialedSubresourcesEnabled;
  static bool isBlockLegacySubresourcesEnabled;
  static bool isBroadcastChannelEnabled;
  static bool isBudgetEnabled;
  static bool isBudgetQueryEnabled;
  static bool isCanMakePaymentEnabled;
  static bool isCanvas2dFixedRenderingModeEnabled;
  static bool isCanvas2dImageChromiumEnabled;
  static bool isClickRetargettingEnabled;
  static bool isClientHintsEnabled;
  static bool isClientPlaceholdersForServerLoFiEnabled;
  static bool isCoalescedEventsEnabled;
  static bool isColorCanvasExtensionsEnabled;
  static bool isColorCorrectRenderingEnabled;
  static bool isCompositedSelectionUpdateEnabled;
  static bool isCompositeOpaqueFixedPositionEnabled;
  static bool isCompositeOpaqueScrollersEnabled;
  static bool isCompositorTouchActionEnabled;
  static bool isCompositorWorkerEnabled;
  static bool isComputedAccessibilityInfoEnabled;
  static bool isConicGradientEnabled;
  static bool isContextMenuEnabled;
  static bool isCorsRFC1918Enabled;
  static bool isCSS3TextEnabled;
  static bool isCSS3TextDecorationsEnabled;
  static bool isCSSAdditiveAnimationsEnabled;
  static bool isCSSApplyAtRulesEnabled;
  static bool isCSSBackdropFilterEnabled;
  static bool isCSSContainmentEnabled;
  static bool isCSSDisplayContentsEnabled;
  static bool isCSSFontDisplayEnabled;
  static bool isCSSFontSizeAdjustEnabled;
  static bool isCSSGridLayoutEnabled;
  static bool isCSSHexAlphaColorEnabled;
  static bool isCSSHyphensEnabled;
  static bool isCSSInBodyDoesNotBlockPaintEnabled;
  static bool isCSSIndependentTransformPropertiesEnabled;
  static bool isCSSLineBreakEnabled;
  static bool isCSSMaskSourceTypeEnabled;
  static bool isCSSOffsetPathRayEnabled;
  static bool isCSSOffsetPathRayContainEnabled;
  static bool isCSSOffsetPositionAnchorEnabled;
  static bool isCSSOMSmoothScrollEnabled;
  static bool isCSSPaintAPIEnabled;
  static bool isCSSPaintAPIArgumentsEnabled;
  static bool isCSSScrollBoundaryBehaviorEnabled;
  static bool isCSSScrollSnapPointsEnabled;
  static bool isCSSSelectorsFocusWithinEnabled;
  static bool isCSSSnapSizeEnabled;
  static bool isCSSStickyPositionEnabled;
  static bool isCSSTransformBoxEnabled;
  static bool isCSSTypedOMEnabled;
  static bool isCSSVariableFontsEnabled;
  static bool isCSSVariables2Enabled;
  static bool isCSSViewportEnabled;
  static bool isCustomElementsBuiltinEnabled;
  static bool isCustomSchemeHandlerEnabled;
  static bool isDatabaseEnabled;
  static bool isDecodeToYUVEnabled;
  static bool isDesktopCaptureDisableLocalEchoControlEnabled;
  static bool isDeviceMemoryHeaderEnabled;
  static bool isDisplayList2dCanvasEnabled;
  static bool isDisplayNoneIFrameCreatesNoLayoutObjectEnabled;
  static bool isDocumentCookieEnabled;
  static bool isDocumentDomainEnabled;
  static bool isDocumentWriteEnabled;
  static bool isDocumentWriteEvaluatorEnabled;
  static bool isDOMConvenienceAPIEnabled;
  static bool isDurableStorageEnabled;
  static bool isEmbedderCSPEnforcementEnabled;
  static bool isEncryptedMediaHdcpPolicyCheckEnabled;
  static bool isExecCommandInJavaScriptEnabled;
  static bool isExpensiveBackgroundTimerThrottlingEnabled;
  static bool isExperimentalCanvasFeaturesEnabled;
  static bool isExperimentalContentSecurityPolicyFeaturesEnabled;
  static bool isExperimentalV8ExtrasEnabled;
  static bool isFastMobileScrollingEnabled;
  static bool isFeaturePolicyEnabled;
  static bool isFeaturePolicyExperimentalFeaturesEnabled;
  static bool isFetchRequestCacheEnabled;
  static bool isFileAPIBlobCloseEnabled;
  static bool isFileSystemEnabled;
  static bool isFontCacheScalingEnabled;
  static bool isForceDisable2dCanvasCopyOnWriteEnabled;
  static bool isForceDisplayList2dCanvasEnabled;
  static bool isForceOverlayFullscreenVideoEnabled;
  static bool isForceTallerSelectPopupEnabled;
  static bool isForeignFetchEnabled;
  static bool isFractionalScrollOffsetsEnabled;
  static bool isFramebustingNeedsSameOriginOrUserGestureEnabled;
  static bool isFramesTimingFunctionEnabled;
  static bool isFrameTimingSupportEnabled;
  static bool isFullscreenUnprefixedEnabled;
  static bool isGamepadExtensionsEnabled;
  static bool isGeometryInterfacesEnabled;
  static bool isGetUserMediaEnabled;
  static bool isGlobalCacheStorageEnabled;
  static bool isHeapCompactionEnabled;
  static bool isHideNonceContentAttributeEnabled;
  static bool isHTMLImportsStyleApplicationEnabled;
  static bool isIDBObserverEnabled;
  static bool isIdleTimeColdModeSpellCheckingEnabled;
  static bool isIdleTimeSpellCheckingEnabled;
  static bool isImageCaptureEnabled;
  static bool isImageOrientationEnabled;
  static bool isInertAttributeEnabled;
  static bool isInputEventEnabled;
  static bool isInputModeAttributeEnabled;
  static bool isInputMultipleFieldsUIEnabled;
  static bool isInstalledAppEnabled;
  static bool isIntersectionObserverEnabled;
  static bool isJSImageDecodeEnabled;
  static bool isKeyboardLockEnabled;
  static bool isLangAttributeAwareFormControlUIEnabled;
  static bool isLayoutNGEnabled;
  static bool isLazyInitializeMediaControlsEnabled;
  static bool isLazyParseCSSEnabled;
  static bool isLinkServiceWorkerEnabled;
  static bool isLoadingWithMojoEnabled;
  static bool isLongTaskObserverEnabled;
  static bool isMediaCapabilitiesEnabled;
  static bool isMediaCaptureEnabled;
  static bool isMediaCaptureDepthEnabled;
  static bool isMediaCaptureFromCanvasEnabled;
  static bool isMediaCaptureFromVideoEnabled;
  static bool isMediaCastOverlayButtonEnabled;
  static bool isMediaControlsOverlayPlayButtonEnabled;
  static bool isMediaDocumentDownloadButtonEnabled;
  static bool isMediaQueryShapeEnabled;
  static bool isMediaSessionEnabled;
  static bool isMediaSourceExperimentalEnabled;
  static bool isMediaSourceNewAbortAndDurationEnabled;
  static bool isMediaStreamSpeechEnabled;
  static bool isMediaStreamTrackContentHintEnabled;
  static bool isMediaTrackApplyConstraintsEnabled;
  static bool isMediaTrackCapabilitiesEnabled;
  static bool isMemoryInfoInWorkersEnabled;
  static bool isMiddleClickAutoscrollEnabled;
  static bool isMobileLayoutThemeEnabled;
  static bool isModuleScriptsEnabled;
  static bool isMojoBlobsEnabled;
  static bool isMojoJSEnabled;
  static bool isMojoJSTestEnabled;
  static bool isMultipleColorStopPositionsEnabled;
  static bool isNavigatorContentUtilsEnabled;
  static bool isNetInfoDownlinkEnabled;
  static bool isNetInfoDownlinkMaxEnabled;
  static bool isNetInfoEffectiveTypeEnabled;
  static bool isNetInfoRttEnabled;
  static bool isNewRemotePlaybackPipelineEnabled;
  static bool isNotificationBadgeEnabled;
  static bool isNotificationConstructorEnabled;
  static bool isNotificationContentImageEnabled;
  static bool isNotificationInlineRepliesEnabled;
  static bool isNotificationsEnabled;
  static bool isNullableDocumentDomainEnabled;
  static bool isOffMainThreadFetchEnabled;
  static bool isOnDeviceChangeEnabled;
  static bool isOrientationEventEnabled;
  static bool isOriginTrialsEnabled;
  static bool isOriginTrialsSampleAPIEnabled;
  static bool isOutOfBlinkCORSEnabled;
  static bool isOverlayScrollbarsEnabled;
  static bool isPagePopupEnabled;
  static bool isPaintUnderInvalidationCheckingEnabled;
  static bool isPassiveDocumentEventListenersEnabled;
  static bool isPassPaintVisualRectToCompositorEnabled;
  static bool isPaymentAppEnabled;
  static bool isPaymentDetailsModifierDataEnabled;
  static bool isPaymentRequestEnabled;
  static bool isPaymentRequestBasicCardEnabled;
  static bool isPerformanceNavigationTiming2Enabled;
  static bool isPerformanceObserverEnabled;
  static bool isPerformancePaintTimingEnabled;
  static bool isPermissionDelegationEnabled;
  static bool isPermissionsEnabled;
  static bool isPermissionsRequestRevokeEnabled;
  static bool isPreciseMemoryInfoEnabled;
  static bool isPreferredImageRasterBoundsEnabled;
  static bool isPrefixedVideoFullscreenEnabled;
  static bool isPresentationEnabled;
  static bool isPresentationReceiverEnabled;
  static bool isPrintBrowserEnabled;
  static bool isPushMessagingEnabled;
  static bool isReducedReferrerGranularityEnabled;
  static bool isRemotePlaybackEnabled;
  static bool isRemotePlaybackBackendEnabled;
  static bool isRenderingPipelineThrottlingEnabled;
  static bool isRenderingPipelineThrottlingLoadingIframesEnabled;
  static bool isRenderUnicodeControlCharactersEnabled;
  static bool isResizeObserverEnabled;
  static bool isResourceLoadSchedulerEnabled;
  static bool isRestrictCanRequestURLCharacterSetEnabled;
  static bool isRootLayerScrollingEnabled;
  static bool isRTCRtpSenderEnabled;
  static bool isScriptedSpeechEnabled;
  static bool isScrollAnchoringEnabled;
  static bool isScrollCustomizationEnabled;
  static bool isScrollTopLeftInteropEnabled;
  static bool isSendBeaconThrowForBlobWithNonSimpleTypeEnabled;
  static bool isSendMouseEventsDisabledFormControlsEnabled;
  static bool isSensorEnabled;
  static bool isServerTimingEnabled;
  static bool isServiceWorkerNavigationPreloadEnabled;
  static bool isServiceWorkerScriptStreamingEnabled;
  static bool isSetRootScrollerEnabled;
  static bool isShadowPiercingDescendantCombinatorEnabled;
  static bool isShapeDetectionEnabled;
  static bool isSharedArrayBufferEnabled;
  static bool isSharedWorkerEnabled;
  static bool isSkipCompositingSmallScrollersEnabled;
  static bool isSlimmingPaintStrictCullRectClippingEnabled;
  static bool isSlimmingPaintV2Enabled;
  static bool isSMILEnabled;
  static bool isSmoothScrollJSInterventionEnabled;
  static bool isStableBlinkFeaturesEnabled;
  static bool isStackedCSSPropertyAnimationsEnabled;
  static bool isStorageEstimateEnabled;
  static bool isStyleSharingEnabled;
  static bool isSuboriginsEnabled;
  static bool isTimerThrottlingForBackgroundTabsEnabled;
  static bool isTimerThrottlingForHiddenFramesEnabled;
  static bool isTopNavByUserActivationInSandboxEnabled;
  static bool isTouchEventFeatureDetectionEnabled;
  static bool isTouchpadAndWheelScrollLatchingEnabled;
  static bool isTrustedEventsDefaultActionEnabled;
  static bool isUnclosedFormControlIsInvalidEnabled;
  static bool isUpdateHoverPostLayoutEnabled;
  static bool isV8IdleTasksEnabled;
  static bool isValidationBubbleInRendererEnabled;
  static bool isVibrateRequiresUserGestureEnabled;
  static bool isVideoFullscreenDetectionEnabled;
  static bool isVideoFullscreenOrientationLockEnabled;
  static bool isVideoRotateToFullscreenEnabled;
  static bool isVisualViewportAPIEnabled;
  static bool isWakeLockEnabled;
  static bool isWebAnimationsAPIEnabled;
  static bool isWebAnimationsSVGEnabled;
  static bool isWebAssemblyStreamingEnabled;
  static bool isWebAuthEnabled;
  static bool isWebBluetoothEnabled;
  static bool isWebFontsCacheAwareTimeoutAdaptationEnabled;
  static bool isWebFontsInterventionTriggerEnabled;
  static bool isWebFontsInterventionV2With2GEnabled;
  static bool isWebFontsInterventionV2With3GEnabled;
  static bool isWebFontsInterventionV2WithSlow2GEnabled;
  static bool isWebGLDraftExtensionsEnabled;
  static bool isWebGLImageChromiumEnabled;
  static bool isWebNFCEnabled;
  static bool isWebShareEnabled;
  static bool isWebUSBEnabled;
  static bool isWebVREnabled;
  static bool isWebVRExperimentalRenderingEnabled;
  static bool isWebVTTRegionsEnabled;
  static bool isWorkletEnabled;
  static bool isXSLTEnabled;
};

} // namespace blink

#endif // RuntimeEnabledFeatures_h
