// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/begin_frame_args.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "ipc/ipc_message_utils.h"
#include "mojo/common/common_custom_types_struct_traits.h"
namespace cc {
namespace mojom {
namespace blink {
BeginFrameArgs::BeginFrameArgs()
    : frame_time(),
      deadline(),
      interval(),
      sequence_number(),
      source_id(),
      type(),
      on_critical_path() {}

BeginFrameArgs::BeginFrameArgs(
    ::mojo::common::mojom::blink::TimeTicksPtr frame_time_in,
    ::mojo::common::mojom::blink::TimeTicksPtr deadline_in,
    WTF::TimeDelta interval_in,
    uint64_t sequence_number_in,
    uint32_t source_id_in,
    BeginFrameArgsType type_in,
    bool on_critical_path_in)
    : frame_time(std::move(frame_time_in)),
      deadline(std::move(deadline_in)),
      interval(std::move(interval_in)),
      sequence_number(std::move(sequence_number_in)),
      source_id(std::move(source_id_in)),
      type(std::move(type_in)),
      on_critical_path(std::move(on_critical_path_in)) {}

BeginFrameArgs::~BeginFrameArgs() = default;

bool BeginFrameArgs::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
BeginFrameAck::BeginFrameAck()
    : sequence_number(),
      source_id() {}

BeginFrameAck::BeginFrameAck(
    uint64_t sequence_number_in,
    uint32_t source_id_in)
    : sequence_number(std::move(sequence_number_in)),
      source_id(std::move(source_id_in)) {}

BeginFrameAck::~BeginFrameAck() = default;

bool BeginFrameAck::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::blink::BeginFrameArgs::DataView, ::cc::mojom::blink::BeginFrameArgsPtr>::Read(
    ::cc::mojom::blink::BeginFrameArgs::DataView input,
    ::cc::mojom::blink::BeginFrameArgsPtr* output) {
  bool success = true;
  ::cc::mojom::blink::BeginFrameArgsPtr result(::cc::mojom::blink::BeginFrameArgs::New());
  
      if (!input.ReadFrameTime(&result->frame_time))
        success = false;
      if (!input.ReadDeadline(&result->deadline))
        success = false;
      if (!input.ReadInterval(&result->interval))
        success = false;
      result->sequence_number = input.sequence_number();
      result->source_id = input.source_id();
      if (!input.ReadType(&result->type))
        success = false;
      result->on_critical_path = input.on_critical_path();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::cc::mojom::blink::BeginFrameAck::DataView, ::cc::mojom::blink::BeginFrameAckPtr>::Read(
    ::cc::mojom::blink::BeginFrameAck::DataView input,
    ::cc::mojom::blink::BeginFrameAckPtr* output) {
  bool success = true;
  ::cc::mojom::blink::BeginFrameAckPtr result(::cc::mojom::blink::BeginFrameAck::New());
  
      result->sequence_number = input.sequence_number();
      result->source_id = input.source_id();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif