// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/copy_output_request.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "gpu/ipc/common/mailbox_holder_struct_traits.h"
#include "gpu/ipc/common/sync_token_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace cc {
namespace mojom {
namespace blink {
CopyOutputRequest::CopyOutputRequest()
    : source(),
      force_bitmap_result(),
      area(),
      texture_mailbox(),
      result_sender() {}

CopyOutputRequest::CopyOutputRequest(
    ::mojo::common::mojom::blink::UnguessableTokenPtr source_in,
    bool force_bitmap_result_in,
    ::gfx::mojom::blink::RectPtr area_in,
    ::cc::mojom::blink::TextureMailboxPtr texture_mailbox_in,
    CopyOutputResultSenderPtr result_sender_in)
    : source(std::move(source_in)),
      force_bitmap_result(std::move(force_bitmap_result_in)),
      area(std::move(area_in)),
      texture_mailbox(std::move(texture_mailbox_in)),
      result_sender(std::move(result_sender_in)) {}

CopyOutputRequest::~CopyOutputRequest() = default;

bool CopyOutputRequest::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char CopyOutputResultSender::Name_[] = "cc::mojom::CopyOutputResultSender";

CopyOutputResultSenderProxy::CopyOutputResultSenderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void CopyOutputResultSenderProxy::SendResult(
    ::cc::mojom::blink::CopyOutputResultPtr in_result) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::CopyOutputResultSender_SendResult_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CopyOutputResultDataView>(
      in_result, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCopyOutputResultSender_SendResult_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::CopyOutputResultSender_SendResult_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->result)::BaseType* result_ptr;
  mojo::internal::Serialize<::cc::mojom::CopyOutputResultDataView>(
      in_result, buffer, &result_ptr, &serialization_context);
  params->result.Set(result_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->result.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null result in CopyOutputResultSender.SendResult request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool CopyOutputResultSenderStubDispatch::Accept(
    CopyOutputResultSender* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kCopyOutputResultSender_SendResult_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CopyOutputResultSender_SendResult_Params_Data* params =
          reinterpret_cast<internal::CopyOutputResultSender_SendResult_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::cc::mojom::blink::CopyOutputResultPtr p_result{};
      CopyOutputResultSender_SendResult_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadResult(&p_result))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CopyOutputResultSender::SendResult deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SendResult(
std::move(p_result));
      return true;
    }
  }
  return false;
}

// static
bool CopyOutputResultSenderStubDispatch::AcceptWithResponder(
    CopyOutputResultSender* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kCopyOutputResultSender_SendResult_Name: {
      break;
    }
  }
  return false;
}

bool CopyOutputResultSenderRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "CopyOutputResultSender RequestValidator");

  switch (message->header()->name) {
    case internal::kCopyOutputResultSender_SendResult_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CopyOutputResultSender_SendResult_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::blink::CopyOutputRequest::DataView, ::cc::mojom::blink::CopyOutputRequestPtr>::Read(
    ::cc::mojom::blink::CopyOutputRequest::DataView input,
    ::cc::mojom::blink::CopyOutputRequestPtr* output) {
  bool success = true;
  ::cc::mojom::blink::CopyOutputRequestPtr result(::cc::mojom::blink::CopyOutputRequest::New());
  
      if (!input.ReadSource(&result->source))
        success = false;
      result->force_bitmap_result = input.force_bitmap_result();
      if (!input.ReadArea(&result->area))
        success = false;
      if (!input.ReadTextureMailbox(&result->texture_mailbox))
        success = false;
      result->result_sender =
          input.TakeResultSender<decltype(result->result_sender)>();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif