// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_COPY_OUTPUT_REQUEST_MOJOM_SHARED_INTERNAL_H_
#define CC_IPC_COPY_OUTPUT_REQUEST_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "cc/ipc/copy_output_result.mojom-shared-internal.h"
#include "cc/ipc/texture_mailbox.mojom-shared-internal.h"
#include "mojo/common/unguessable_token.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace cc {
namespace mojom {
namespace internal {
class CopyOutputRequest_Data;

#pragma pack(push, 1)
class  CopyOutputRequest_Data {
 public:
  static CopyOutputRequest_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::UnguessableToken_Data> source;
  uint8_t force_bitmap_result : 1;
  uint8_t pad1_[7];
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> area;
  mojo::internal::Pointer<::cc::mojom::internal::TextureMailbox_Data> texture_mailbox;
  mojo::internal::Interface_Data result_sender;

 private:
  CopyOutputRequest_Data();
  ~CopyOutputRequest_Data() = delete;
};
static_assert(sizeof(CopyOutputRequest_Data) == 48,
              "Bad sizeof(CopyOutputRequest_Data)");
constexpr uint32_t kCopyOutputResultSender_SendResult_Name = 0;
class  CopyOutputResultSender_SendResult_Params_Data {
 public:
  static CopyOutputResultSender_SendResult_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::CopyOutputResult_Data> result;

 private:
  CopyOutputResultSender_SendResult_Params_Data();
  ~CopyOutputResultSender_SendResult_Params_Data() = delete;
};
static_assert(sizeof(CopyOutputResultSender_SendResult_Params_Data) == 16,
              "Bad sizeof(CopyOutputResultSender_SendResult_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace cc

#endif  // CC_IPC_COPY_OUTPUT_REQUEST_MOJOM_SHARED_INTERNAL_H_