// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/copy_output_result.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "gpu/ipc/common/mailbox_holder_struct_traits.h"
#include "gpu/ipc/common/sync_token_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace cc {
namespace mojom {
namespace blink {
CopyOutputResult::CopyOutputResult()
    : size(),
      bitmap(),
      texture_mailbox(),
      releaser() {}

CopyOutputResult::CopyOutputResult(
    const ::blink::WebSize& size_in,
    ::skia::mojom::blink::BitmapPtr bitmap_in,
    ::cc::mojom::blink::TextureMailboxPtr texture_mailbox_in,
    ::cc::mojom::blink::TextureMailboxReleaserPtr releaser_in)
    : size(std::move(size_in)),
      bitmap(std::move(bitmap_in)),
      texture_mailbox(std::move(texture_mailbox_in)),
      releaser(std::move(releaser_in)) {}

CopyOutputResult::~CopyOutputResult() = default;

bool CopyOutputResult::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::blink::CopyOutputResult::DataView, ::cc::mojom::blink::CopyOutputResultPtr>::Read(
    ::cc::mojom::blink::CopyOutputResult::DataView input,
    ::cc::mojom::blink::CopyOutputResultPtr* output) {
  bool success = true;
  ::cc::mojom::blink::CopyOutputResultPtr result(::cc::mojom::blink::CopyOutputResult::New());
  
      if (!input.ReadSize(&result->size))
        success = false;
      if (!input.ReadBitmap(&result->bitmap))
        success = false;
      if (!input.ReadTextureMailbox(&result->texture_mailbox))
        success = false;
      result->releaser =
          input.TakeReleaser<decltype(result->releaser)>();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif