// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_COPY_OUTPUT_RESULT_MOJOM_SHARED_H_
#define CC_IPC_COPY_OUTPUT_RESULT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "cc/ipc/copy_output_result.mojom-shared-internal.h"
#include "cc/ipc/texture_mailbox.mojom-shared.h"
#include "cc/ipc/texture_mailbox_releaser.mojom-shared.h"
#include "skia/public/interfaces/bitmap.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"


namespace cc {
namespace mojom {
class CopyOutputResultDataView;



}  // namespace mojom
}  // namespace cc

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::cc::mojom::CopyOutputResultDataView> {
  using Data = ::cc::mojom::internal::CopyOutputResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace cc {
namespace mojom {
class CopyOutputResultDataView {
 public:
  CopyOutputResultDataView() {}

  CopyOutputResultDataView(
      internal::CopyOutputResult_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSizeDataView(
      ::gfx::mojom::SizeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSize(UserType* output) {
    auto* pointer = data_->size.Get();
    return mojo::internal::Deserialize<::gfx::mojom::SizeDataView>(
        pointer, output, context_);
  }
  inline void GetBitmapDataView(
      ::skia::mojom::BitmapDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBitmap(UserType* output) {
    auto* pointer = data_->bitmap.Get();
    return mojo::internal::Deserialize<::skia::mojom::BitmapDataView>(
        pointer, output, context_);
  }
  inline void GetTextureMailboxDataView(
      ::cc::mojom::TextureMailboxDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTextureMailbox(UserType* output) {
    auto* pointer = data_->texture_mailbox.Get();
    return mojo::internal::Deserialize<::cc::mojom::TextureMailboxDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeReleaser() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::cc::mojom::TextureMailboxReleaserPtrDataView>(
            &data_->releaser, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::CopyOutputResult_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace cc

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::cc::mojom::CopyOutputResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::cc::mojom::CopyOutputResultDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::cc::mojom::internal::CopyOutputResult_Data);
    decltype(CallWithContext(Traits::size, input, custom_context)) in_size = CallWithContext(Traits::size, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::gfx::mojom::SizeDataView>(
        in_size, context);
    decltype(CallWithContext(Traits::bitmap, input, custom_context)) in_bitmap = CallWithContext(Traits::bitmap, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::skia::mojom::BitmapDataView>(
        in_bitmap, context);
    decltype(CallWithContext(Traits::texture_mailbox, input, custom_context)) in_texture_mailbox = CallWithContext(Traits::texture_mailbox, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::cc::mojom::TextureMailboxDataView>(
        in_texture_mailbox, context);
    decltype(CallWithContext(Traits::releaser, input, custom_context)) in_releaser = CallWithContext(Traits::releaser, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::cc::mojom::TextureMailboxReleaserPtrDataView>(
        in_releaser, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::cc::mojom::internal::CopyOutputResult_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::cc::mojom::internal::CopyOutputResult_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    decltype(CallWithContext(Traits::size, input, custom_context)) in_size = CallWithContext(Traits::size, input, custom_context);
    typename decltype(result->size)::BaseType* size_ptr;
    mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
        in_size, buffer, &size_ptr, context);
    result->size.Set(size_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->size.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null size in CopyOutputResult struct");
    decltype(CallWithContext(Traits::bitmap, input, custom_context)) in_bitmap = CallWithContext(Traits::bitmap, input, custom_context);
    typename decltype(result->bitmap)::BaseType* bitmap_ptr;
    mojo::internal::Serialize<::skia::mojom::BitmapDataView>(
        in_bitmap, buffer, &bitmap_ptr, context);
    result->bitmap.Set(bitmap_ptr);
    decltype(CallWithContext(Traits::texture_mailbox, input, custom_context)) in_texture_mailbox = CallWithContext(Traits::texture_mailbox, input, custom_context);
    typename decltype(result->texture_mailbox)::BaseType* texture_mailbox_ptr;
    mojo::internal::Serialize<::cc::mojom::TextureMailboxDataView>(
        in_texture_mailbox, buffer, &texture_mailbox_ptr, context);
    result->texture_mailbox.Set(texture_mailbox_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->texture_mailbox.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null texture_mailbox in CopyOutputResult struct");
    // Dummy input value. The serialized value is already stored in the
    // SerializationContext.
    typename std::remove_reference<decltype(CallWithContext(Traits::releaser, input, custom_context))>::type
        in_releaser;
    mojo::internal::Serialize<::cc::mojom::TextureMailboxReleaserPtrDataView>(
        in_releaser, &result->releaser, context);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::cc::mojom::internal::CopyOutputResult_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::cc::mojom::CopyOutputResultDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace cc {
namespace mojom {

inline void CopyOutputResultDataView::GetSizeDataView(
    ::gfx::mojom::SizeDataView* output) {
  auto pointer = data_->size.Get();
  *output = ::gfx::mojom::SizeDataView(pointer, context_);
}
inline void CopyOutputResultDataView::GetBitmapDataView(
    ::skia::mojom::BitmapDataView* output) {
  auto pointer = data_->bitmap.Get();
  *output = ::skia::mojom::BitmapDataView(pointer, context_);
}
inline void CopyOutputResultDataView::GetTextureMailboxDataView(
    ::cc::mojom::TextureMailboxDataView* output) {
  auto pointer = data_->texture_mailbox.Get();
  *output = ::cc::mojom::TextureMailboxDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace cc

#endif  // CC_IPC_COPY_OUTPUT_RESULT_MOJOM_SHARED_H_
