// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/filter_operation.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
namespace cc {
namespace mojom {
namespace blink {
FilterOperation::FilterOperation()
    : type(),
      amount(),
      drop_shadow_offset(),
      drop_shadow_color(),
      image_filter(),
      matrix(),
      zoom_inset(),
      blur_tile_mode() {}

FilterOperation::FilterOperation(
    FilterType type_in,
    float amount_in,
    ::gfx::mojom::blink::PointPtr drop_shadow_offset_in,
    uint32_t drop_shadow_color_in,
    ::skia::mojom::blink::ImageFilterPtr image_filter_in,
    const WTF::Optional<WTF::Vector<float>>& matrix_in,
    int32_t zoom_inset_in,
    ::skia::mojom::blink::BlurTileMode blur_tile_mode_in)
    : type(std::move(type_in)),
      amount(std::move(amount_in)),
      drop_shadow_offset(std::move(drop_shadow_offset_in)),
      drop_shadow_color(std::move(drop_shadow_color_in)),
      image_filter(std::move(image_filter_in)),
      matrix(std::move(matrix_in)),
      zoom_inset(std::move(zoom_inset_in)),
      blur_tile_mode(std::move(blur_tile_mode_in)) {}

FilterOperation::~FilterOperation() = default;

bool FilterOperation::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::blink::FilterOperation::DataView, ::cc::mojom::blink::FilterOperationPtr>::Read(
    ::cc::mojom::blink::FilterOperation::DataView input,
    ::cc::mojom::blink::FilterOperationPtr* output) {
  bool success = true;
  ::cc::mojom::blink::FilterOperationPtr result(::cc::mojom::blink::FilterOperation::New());
  
      if (!input.ReadType(&result->type))
        success = false;
      result->amount = input.amount();
      if (!input.ReadDropShadowOffset(&result->drop_shadow_offset))
        success = false;
      result->drop_shadow_color = input.drop_shadow_color();
      if (!input.ReadImageFilter(&result->image_filter))
        success = false;
      if (!input.ReadMatrix(&result->matrix))
        success = false;
      result->zoom_inset = input.zoom_inset();
      if (!input.ReadBlurTileMode(&result->blur_tile_mode))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif