// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_FRAME_SINK_MANAGER_MOJOM_SHARED_INTERNAL_H_
#define CC_IPC_FRAME_SINK_MANAGER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "cc/ipc/frame_sink_id.mojom-shared-internal.h"
#include "cc/ipc/local_surface_id.mojom-shared-internal.h"
#include "cc/ipc/compositor_frame_sink.mojom-shared-internal.h"
#include "cc/ipc/surface_id.mojom-shared-internal.h"
#include "cc/ipc/surface_info.mojom-shared-internal.h"
#include "gpu/ipc/common/surface_handle.mojom-shared-internal.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/color_space.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace cc {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kDisplayPrivate_SetDisplayVisible_Name = 0;
class  DisplayPrivate_SetDisplayVisible_Params_Data {
 public:
  static DisplayPrivate_SetDisplayVisible_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t visible : 1;
  uint8_t padfinal_[7];

 private:
  DisplayPrivate_SetDisplayVisible_Params_Data();
  ~DisplayPrivate_SetDisplayVisible_Params_Data() = delete;
};
static_assert(sizeof(DisplayPrivate_SetDisplayVisible_Params_Data) == 16,
              "Bad sizeof(DisplayPrivate_SetDisplayVisible_Params_Data)");
constexpr uint32_t kDisplayPrivate_ResizeDisplay_Name = 1;
class  DisplayPrivate_ResizeDisplay_Params_Data {
 public:
  static DisplayPrivate_ResizeDisplay_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> size_in_pixel;

 private:
  DisplayPrivate_ResizeDisplay_Params_Data();
  ~DisplayPrivate_ResizeDisplay_Params_Data() = delete;
};
static_assert(sizeof(DisplayPrivate_ResizeDisplay_Params_Data) == 16,
              "Bad sizeof(DisplayPrivate_ResizeDisplay_Params_Data)");
constexpr uint32_t kDisplayPrivate_SetDisplayColorSpace_Name = 2;
class  DisplayPrivate_SetDisplayColorSpace_Params_Data {
 public:
  static DisplayPrivate_SetDisplayColorSpace_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::ColorSpace_Data> color_space;

 private:
  DisplayPrivate_SetDisplayColorSpace_Params_Data();
  ~DisplayPrivate_SetDisplayColorSpace_Params_Data() = delete;
};
static_assert(sizeof(DisplayPrivate_SetDisplayColorSpace_Params_Data) == 16,
              "Bad sizeof(DisplayPrivate_SetDisplayColorSpace_Params_Data)");
constexpr uint32_t kDisplayPrivate_SetOutputIsSecure_Name = 3;
class  DisplayPrivate_SetOutputIsSecure_Params_Data {
 public:
  static DisplayPrivate_SetOutputIsSecure_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t secure : 1;
  uint8_t padfinal_[7];

 private:
  DisplayPrivate_SetOutputIsSecure_Params_Data();
  ~DisplayPrivate_SetOutputIsSecure_Params_Data() = delete;
};
static_assert(sizeof(DisplayPrivate_SetOutputIsSecure_Params_Data) == 16,
              "Bad sizeof(DisplayPrivate_SetOutputIsSecure_Params_Data)");
constexpr uint32_t kDisplayPrivate_SetLocalSurfaceId_Name = 4;
class  DisplayPrivate_SetLocalSurfaceId_Params_Data {
 public:
  static DisplayPrivate_SetLocalSurfaceId_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::LocalSurfaceId_Data> local_surface_id;
  float scale_factor;
  uint8_t padfinal_[4];

 private:
  DisplayPrivate_SetLocalSurfaceId_Params_Data();
  ~DisplayPrivate_SetLocalSurfaceId_Params_Data() = delete;
};
static_assert(sizeof(DisplayPrivate_SetLocalSurfaceId_Params_Data) == 24,
              "Bad sizeof(DisplayPrivate_SetLocalSurfaceId_Params_Data)");
constexpr uint32_t kFrameSinkManager_CreateRootCompositorFrameSink_Name = 0;
class  FrameSinkManager_CreateRootCompositorFrameSink_Params_Data {
 public:
  static FrameSinkManager_CreateRootCompositorFrameSink_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Pointer<::gpu::mojom::internal::SurfaceHandle_Data> widget;
  mojo::internal::AssociatedEndpointHandle_Data compositor_frame_sink;
  mojo::internal::Handle_Data compositor_frame_sink_private;
  mojo::internal::Interface_Data compositor_frame_sink_client;
  mojo::internal::AssociatedEndpointHandle_Data display_private;
  uint8_t padfinal_[4];

 private:
  FrameSinkManager_CreateRootCompositorFrameSink_Params_Data();
  ~FrameSinkManager_CreateRootCompositorFrameSink_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkManager_CreateRootCompositorFrameSink_Params_Data) == 48,
              "Bad sizeof(FrameSinkManager_CreateRootCompositorFrameSink_Params_Data)");
constexpr uint32_t kFrameSinkManager_CreateCompositorFrameSink_Name = 1;
class  FrameSinkManager_CreateCompositorFrameSink_Params_Data {
 public:
  static FrameSinkManager_CreateCompositorFrameSink_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Handle_Data compositor_frame_sink;
  mojo::internal::Handle_Data compositor_frame_sink_private;
  mojo::internal::Interface_Data compositor_frame_sink_client;

 private:
  FrameSinkManager_CreateCompositorFrameSink_Params_Data();
  ~FrameSinkManager_CreateCompositorFrameSink_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkManager_CreateCompositorFrameSink_Params_Data) == 32,
              "Bad sizeof(FrameSinkManager_CreateCompositorFrameSink_Params_Data)");
constexpr uint32_t kFrameSinkManager_RegisterFrameSinkHierarchy_Name = 2;
class  FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data {
 public:
  static FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> parent_frame_sink_id;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> child_frame_sink_id;

 private:
  FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data();
  ~FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data) == 24,
              "Bad sizeof(FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data)");
constexpr uint32_t kFrameSinkManager_UnregisterFrameSinkHierarchy_Name = 3;
class  FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data {
 public:
  static FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> parent_frame_sink_id;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> child_frame_sink_id;

 private:
  FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data();
  ~FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data) == 24,
              "Bad sizeof(FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data)");
constexpr uint32_t kFrameSinkManager_DropTemporaryReference_Name = 4;
class  FrameSinkManager_DropTemporaryReference_Params_Data {
 public:
  static FrameSinkManager_DropTemporaryReference_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::SurfaceId_Data> surface_id;

 private:
  FrameSinkManager_DropTemporaryReference_Params_Data();
  ~FrameSinkManager_DropTemporaryReference_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkManager_DropTemporaryReference_Params_Data) == 16,
              "Bad sizeof(FrameSinkManager_DropTemporaryReference_Params_Data)");
constexpr uint32_t kFrameSinkManagerClient_OnSurfaceCreated_Name = 0;
class  FrameSinkManagerClient_OnSurfaceCreated_Params_Data {
 public:
  static FrameSinkManagerClient_OnSurfaceCreated_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::SurfaceInfo_Data> surface_info;

 private:
  FrameSinkManagerClient_OnSurfaceCreated_Params_Data();
  ~FrameSinkManagerClient_OnSurfaceCreated_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkManagerClient_OnSurfaceCreated_Params_Data) == 16,
              "Bad sizeof(FrameSinkManagerClient_OnSurfaceCreated_Params_Data)");
constexpr uint32_t kFrameSinkManagerClient_OnClientConnectionClosed_Name = 1;
class  FrameSinkManagerClient_OnClientConnectionClosed_Params_Data {
 public:
  static FrameSinkManagerClient_OnClientConnectionClosed_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> frame_sink_id;

 private:
  FrameSinkManagerClient_OnClientConnectionClosed_Params_Data();
  ~FrameSinkManagerClient_OnClientConnectionClosed_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkManagerClient_OnClientConnectionClosed_Params_Data) == 16,
              "Bad sizeof(FrameSinkManagerClient_OnClientConnectionClosed_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace cc

#endif  // CC_IPC_FRAME_SINK_MANAGER_MOJOM_SHARED_INTERNAL_H_