// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_INTERNAL_H_
#define CC_IPC_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/mailbox.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace cc {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name = 0;
class  SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data {
 public:
  static SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data buffer;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gpu::mojom::internal::Mailbox_Data> id;

 private:
  SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data();
  ~SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data() = delete;
};
static_assert(sizeof(SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data) == 24,
              "Bad sizeof(SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data)");
constexpr uint32_t kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name = 1;
class  SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data {
 public:
  static SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gpu::mojom::internal::Mailbox_Data> id;

 private:
  SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data();
  ~SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data() = delete;
};
static_assert(sizeof(SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data) == 16,
              "Bad sizeof(SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace cc

#endif  // CC_IPC_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_INTERNAL_H_