// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_INPUT_INPUT_HANDLER_MOJOM_SHARED_H_
#define CONTENT_COMMON_INPUT_INPUT_HANDLER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "content/common/input/input_handler.mojom-shared-internal.h"
#include "content/common/native_types.mojom-shared.h"
#include "mojo/common/string16.mojom-shared.h"
#include "services/ui/public/interfaces/ime/ime.mojom-shared.h"
#include "ui/events/mojo/event.mojom-shared.h"
#include "ui/events/mojo/event_constants.mojom-shared.h"
#include "ui/latency/mojo/latency_info.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"
#include "ui/gfx/range/mojo/range.mojom-shared.h"
#include "content/common/mojo_bindings_shared_export.h"


namespace content {
namespace mojom {
class KeyDataDataView;

class PointerDataDataView;

class WheelDataDataView;

class MouseDataDataView;

class ScrollUpdateDataView;

class ScrollDataDataView;

class PinchDataDataView;

class FlingDataDataView;

class TapDataDataView;

class GestureDataDataView;

class TouchPointDataView;

class TouchDataDataView;

class EventDataView;



}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::content::mojom::KeyDataDataView> {
  using Data = ::content::mojom::internal::KeyData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::PointerDataDataView> {
  using Data = ::content::mojom::internal::PointerData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::WheelDataDataView> {
  using Data = ::content::mojom::internal::WheelData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::MouseDataDataView> {
  using Data = ::content::mojom::internal::MouseData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::ScrollUpdateDataView> {
  using Data = ::content::mojom::internal::ScrollUpdate_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::ScrollDataDataView> {
  using Data = ::content::mojom::internal::ScrollData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::PinchDataDataView> {
  using Data = ::content::mojom::internal::PinchData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::FlingDataDataView> {
  using Data = ::content::mojom::internal::FlingData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::TapDataDataView> {
  using Data = ::content::mojom::internal::TapData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::GestureDataDataView> {
  using Data = ::content::mojom::internal::GestureData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::TouchPointDataView> {
  using Data = ::content::mojom::internal::TouchPoint_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::TouchDataDataView> {
  using Data = ::content::mojom::internal::TouchData_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::content::mojom::EventDataView> {
  using Data = ::content::mojom::internal::Event_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {
// Interface base classes. They are used for type safety check.
class WidgetInputHandlerInterfaceBase {};

using WidgetInputHandlerPtrDataView =
    mojo::InterfacePtrDataView<WidgetInputHandlerInterfaceBase>;
using WidgetInputHandlerRequestDataView =
    mojo::InterfaceRequestDataView<WidgetInputHandlerInterfaceBase>;
using WidgetInputHandlerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WidgetInputHandlerInterfaceBase>;
using WidgetInputHandlerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WidgetInputHandlerInterfaceBase>;
class FrameInputHandlerInterfaceBase {};

using FrameInputHandlerPtrDataView =
    mojo::InterfacePtrDataView<FrameInputHandlerInterfaceBase>;
using FrameInputHandlerRequestDataView =
    mojo::InterfaceRequestDataView<FrameInputHandlerInterfaceBase>;
using FrameInputHandlerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<FrameInputHandlerInterfaceBase>;
using FrameInputHandlerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<FrameInputHandlerInterfaceBase>;
class KeyDataDataView {
 public:
  KeyDataDataView() {}

  KeyDataDataView(
      internal::KeyData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t dom_key() const {
    return data_->dom_key;
  }
  int32_t dom_code() const {
    return data_->dom_code;
  }
  int32_t windows_key_code() const {
    return data_->windows_key_code;
  }
  int32_t native_key_code() const {
    return data_->native_key_code;
  }
  bool is_system_key() const {
    return data_->is_system_key;
  }
  bool is_browser_shortcut() const {
    return data_->is_browser_shortcut;
  }
  inline void GetTextDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadText(UserType* output) {
    auto* pointer = data_->text.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetUnmodifiedTextDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUnmodifiedText(UserType* output) {
    auto* pointer = data_->unmodified_text.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::KeyData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PointerDataDataView {
 public:
  PointerDataDataView() {}

  PointerDataDataView(
      internal::PointerData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t pointer_id() const {
    return data_->pointer_id;
  }
  float force() const {
    return data_->force;
  }
  int32_t tilt_x() const {
    return data_->tilt_x;
  }
  int32_t tilt_y() const {
    return data_->tilt_y;
  }
  float tangential_pressure() const {
    return data_->tangential_pressure;
  }
  int32_t twist() const {
    return data_->twist;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadButton(UserType* output) const {
    auto data_value = data_->button;
    return mojo::internal::Deserialize<::content::mojom::Button>(
        data_value, output);
  }

  ::content::mojom::Button button() const {
    return static_cast<::content::mojom::Button>(data_->button);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPointerType(UserType* output) const {
    auto data_value = data_->pointer_type;
    return mojo::internal::Deserialize<::content::mojom::PointerType>(
        data_value, output);
  }

  ::content::mojom::PointerType pointer_type() const {
    return static_cast<::content::mojom::PointerType>(data_->pointer_type);
  }
  int32_t movement_x() const {
    return data_->movement_x;
  }
  int32_t movement_y() const {
    return data_->movement_y;
  }
  inline void GetWidgetPositionDataView(
      ::gfx::mojom::PointFDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWidgetPosition(UserType* output) {
    auto* pointer = data_->widget_position.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointFDataView>(
        pointer, output, context_);
  }
  inline void GetScreenPositionDataView(
      ::gfx::mojom::PointFDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadScreenPosition(UserType* output) {
    auto* pointer = data_->screen_position.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointFDataView>(
        pointer, output, context_);
  }
  inline void GetMouseDataDataView(
      MouseDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMouseData(UserType* output) {
    auto* pointer = data_->mouse_data.Get();
    return mojo::internal::Deserialize<::content::mojom::MouseDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::PointerData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WheelDataDataView {
 public:
  WheelDataDataView() {}

  WheelDataDataView(
      internal::WheelData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  float delta_x() const {
    return data_->delta_x;
  }
  float delta_y() const {
    return data_->delta_y;
  }
  float wheel_ticks_x() const {
    return data_->wheel_ticks_x;
  }
  float wheel_ticks_y() const {
    return data_->wheel_ticks_y;
  }
  float acceleration_ratio_x() const {
    return data_->acceleration_ratio_x;
  }
  float acceleration_ratio_y() const {
    return data_->acceleration_ratio_y;
  }
  int32_t resending_plugin_id() const {
    return data_->resending_plugin_id;
  }
  uint8_t phase() const {
    return data_->phase;
  }
  uint8_t momentum_phase() const {
    return data_->momentum_phase;
  }
  bool scroll_by_page() const {
    return data_->scroll_by_page;
  }
  bool has_precise_scrolling_deltas() const {
    return data_->has_precise_scrolling_deltas;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCancelable(UserType* output) const {
    auto data_value = data_->cancelable;
    return mojo::internal::Deserialize<::content::mojom::Cancelability>(
        data_value, output);
  }

  ::content::mojom::Cancelability cancelable() const {
    return static_cast<::content::mojom::Cancelability>(data_->cancelable);
  }
 private:
  internal::WheelData_Data* data_ = nullptr;
};

class MouseDataDataView {
 public:
  MouseDataDataView() {}

  MouseDataDataView(
      internal::MouseData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t click_count() const {
    return data_->click_count;
  }
  inline void GetWheelDataDataView(
      WheelDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWheelData(UserType* output) {
    auto* pointer = data_->wheel_data.Get();
    return mojo::internal::Deserialize<::content::mojom::WheelDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::MouseData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ScrollUpdateDataView {
 public:
  ScrollUpdateDataView() {}

  ScrollUpdateDataView(
      internal::ScrollUpdate_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  float velocity_x() const {
    return data_->velocity_x;
  }
  float velocity_y() const {
    return data_->velocity_y;
  }
  bool previous_update_in_sequence_prevented() const {
    return data_->previous_update_in_sequence_prevented;
  }
  bool prevent_propagation() const {
    return data_->prevent_propagation;
  }
 private:
  internal::ScrollUpdate_Data* data_ = nullptr;
};

class ScrollDataDataView {
 public:
  ScrollDataDataView() {}

  ScrollDataDataView(
      internal::ScrollData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  float delta_x() const {
    return data_->delta_x;
  }
  float delta_y() const {
    return data_->delta_y;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDeltaUnits(UserType* output) const {
    auto data_value = data_->delta_units;
    return mojo::internal::Deserialize<::content::mojom::ScrollUnits>(
        data_value, output);
  }

  ::content::mojom::ScrollUnits delta_units() const {
    return static_cast<::content::mojom::ScrollUnits>(data_->delta_units);
  }
  bool target_viewport() const {
    return data_->target_viewport;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInertialPhase(UserType* output) const {
    auto data_value = data_->inertial_phase;
    return mojo::internal::Deserialize<::content::mojom::InertialPhaseState>(
        data_value, output);
  }

  ::content::mojom::InertialPhaseState inertial_phase() const {
    return static_cast<::content::mojom::InertialPhaseState>(data_->inertial_phase);
  }
  bool synthetic() const {
    return data_->synthetic;
  }
  int32_t pointer_count() const {
    return data_->pointer_count;
  }
  inline void GetUpdateDetailsDataView(
      ScrollUpdateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdateDetails(UserType* output) {
    auto* pointer = data_->update_details.Get();
    return mojo::internal::Deserialize<::content::mojom::ScrollUpdateDataView>(
        pointer, output, context_);
  }
 private:
  internal::ScrollData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PinchDataDataView {
 public:
  PinchDataDataView() {}

  PinchDataDataView(
      internal::PinchData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool zoom_disabled() const {
    return data_->zoom_disabled;
  }
  float scale() const {
    return data_->scale;
  }
 private:
  internal::PinchData_Data* data_ = nullptr;
};

class FlingDataDataView {
 public:
  FlingDataDataView() {}

  FlingDataDataView(
      internal::FlingData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  float velocity_x() const {
    return data_->velocity_x;
  }
  float velocity_y() const {
    return data_->velocity_y;
  }
  bool target_viewport() const {
    return data_->target_viewport;
  }
  bool prevent_boosting() const {
    return data_->prevent_boosting;
  }
 private:
  internal::FlingData_Data* data_ = nullptr;
};

class TapDataDataView {
 public:
  TapDataDataView() {}

  TapDataDataView(
      internal::TapData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t tap_count() const {
    return data_->tap_count;
  }
 private:
  internal::TapData_Data* data_ = nullptr;
};

class GestureDataDataView {
 public:
  GestureDataDataView() {}

  GestureDataDataView(
      internal::GestureData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetScreenPositionDataView(
      ::gfx::mojom::PointFDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadScreenPosition(UserType* output) {
    auto* pointer = data_->screen_position.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointFDataView>(
        pointer, output, context_);
  }
  inline void GetWidgetPositionDataView(
      ::gfx::mojom::PointFDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWidgetPosition(UserType* output) {
    auto* pointer = data_->widget_position.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointFDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceDevice(UserType* output) const {
    auto data_value = data_->source_device;
    return mojo::internal::Deserialize<::content::mojom::GestureDevice>(
        data_value, output);
  }

  ::content::mojom::GestureDevice source_device() const {
    return static_cast<::content::mojom::GestureDevice>(data_->source_device);
  }
  int32_t unique_touch_event_id() const {
    return data_->unique_touch_event_id;
  }
  int32_t resending_plugin_id() const {
    return data_->resending_plugin_id;
  }
  inline void GetContactSizeDataView(
      ::gfx::mojom::SizeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadContactSize(UserType* output) {
    auto* pointer = data_->contact_size.Get();
    return mojo::internal::Deserialize<::gfx::mojom::SizeDataView>(
        pointer, output, context_);
  }
  inline void GetScrollDataDataView(
      ScrollDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadScrollData(UserType* output) {
    auto* pointer = data_->scroll_data.Get();
    return mojo::internal::Deserialize<::content::mojom::ScrollDataDataView>(
        pointer, output, context_);
  }
  inline void GetPinchDataDataView(
      PinchDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPinchData(UserType* output) {
    auto* pointer = data_->pinch_data.Get();
    return mojo::internal::Deserialize<::content::mojom::PinchDataDataView>(
        pointer, output, context_);
  }
  inline void GetTapDataDataView(
      TapDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTapData(UserType* output) {
    auto* pointer = data_->tap_data.Get();
    return mojo::internal::Deserialize<::content::mojom::TapDataDataView>(
        pointer, output, context_);
  }
  inline void GetFlingDataDataView(
      FlingDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFlingData(UserType* output) {
    auto* pointer = data_->fling_data.Get();
    return mojo::internal::Deserialize<::content::mojom::FlingDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::GestureData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class TouchPointDataView {
 public:
  TouchPointDataView() {}

  TouchPointDataView(
      internal::TouchPoint_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::content::mojom::TouchState>(
        data_value, output);
  }

  ::content::mojom::TouchState state() const {
    return static_cast<::content::mojom::TouchState>(data_->state);
  }
  float radius_x() const {
    return data_->radius_x;
  }
  float radius_y() const {
    return data_->radius_y;
  }
  float rotation_angle() const {
    return data_->rotation_angle;
  }
  inline void GetPointerDataDataView(
      PointerDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPointerData(UserType* output) {
    auto* pointer = data_->pointer_data.Get();
    return mojo::internal::Deserialize<::content::mojom::PointerDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::TouchPoint_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class TouchDataDataView {
 public:
  TouchDataDataView() {}

  TouchDataDataView(
      internal::TouchData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCancelable(UserType* output) const {
    auto data_value = data_->cancelable;
    return mojo::internal::Deserialize<::content::mojom::Cancelability>(
        data_value, output);
  }

  ::content::mojom::Cancelability cancelable() const {
    return static_cast<::content::mojom::Cancelability>(data_->cancelable);
  }
  bool moved_beyond_slop_region() const {
    return data_->moved_beyond_slop_region;
  }
  bool touch_start_or_first_move() const {
    return data_->touch_start_or_first_move;
  }
  uint32_t unique_touch_event_id() const {
    return data_->unique_touch_event_id;
  }
  inline void GetTouchesDataView(
      mojo::ArrayDataView<TouchPointDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTouches(UserType* output) {
    auto* pointer = data_->touches.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::content::mojom::TouchPointDataView>>(
        pointer, output, context_);
  }
 private:
  internal::TouchData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EventDataView {
 public:
  EventDataView() {}

  EventDataView(
      internal::Event_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::content::mojom::EventType>(
        data_value, output);
  }

  ::content::mojom::EventType type() const {
    return static_cast<::content::mojom::EventType>(data_->type);
  }
  int32_t modifiers() const {
    return data_->modifiers;
  }
  double timestamp_seconds() const {
    return data_->timestamp_seconds;
  }
  inline void GetLatencyDataView(
      ::ui::mojom::LatencyInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLatency(UserType* output) {
    auto* pointer = data_->latency.Get();
    return mojo::internal::Deserialize<::ui::mojom::LatencyInfoDataView>(
        pointer, output, context_);
  }
  inline void GetKeyDataDataView(
      KeyDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyData(UserType* output) {
    auto* pointer = data_->key_data.Get();
    return mojo::internal::Deserialize<::content::mojom::KeyDataDataView>(
        pointer, output, context_);
  }
  inline void GetPointerDataDataView(
      PointerDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPointerData(UserType* output) {
    auto* pointer = data_->pointer_data.Get();
    return mojo::internal::Deserialize<::content::mojom::PointerDataDataView>(
        pointer, output, context_);
  }
  inline void GetGestureDataDataView(
      GestureDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGestureData(UserType* output) {
    auto* pointer = data_->gesture_data.Get();
    return mojo::internal::Deserialize<::content::mojom::GestureDataDataView>(
        pointer, output, context_);
  }
  inline void GetTouchDataDataView(
      TouchDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTouchData(UserType* output) {
    auto* pointer = data_->touch_data.Get();
    return mojo::internal::Deserialize<::content::mojom::TouchDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::Event_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WidgetInputHandler_SetFocus_ParamsDataView {
 public:
  WidgetInputHandler_SetFocus_ParamsDataView() {}

  WidgetInputHandler_SetFocus_ParamsDataView(
      internal::WidgetInputHandler_SetFocus_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool focused() const {
    return data_->focused;
  }
 private:
  internal::WidgetInputHandler_SetFocus_Params_Data* data_ = nullptr;
};

class WidgetInputHandler_MouseCaptureLost_ParamsDataView {
 public:
  WidgetInputHandler_MouseCaptureLost_ParamsDataView() {}

  WidgetInputHandler_MouseCaptureLost_ParamsDataView(
      internal::WidgetInputHandler_MouseCaptureLost_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::WidgetInputHandler_MouseCaptureLost_Params_Data* data_ = nullptr;
};

class WidgetInputHandler_SetEditCommandsForNextKeyEvent_ParamsDataView {
 public:
  WidgetInputHandler_SetEditCommandsForNextKeyEvent_ParamsDataView() {}

  WidgetInputHandler_SetEditCommandsForNextKeyEvent_ParamsDataView(
      internal::WidgetInputHandler_SetEditCommandsForNextKeyEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCommandsDataView(
      mojo::ArrayDataView<::content::mojom::EditCommandDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCommands(UserType* output) {
    auto* pointer = data_->commands.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::content::mojom::EditCommandDataView>>(
        pointer, output, context_);
  }
 private:
  internal::WidgetInputHandler_SetEditCommandsForNextKeyEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WidgetInputHandler_CursorVisibilityChanged_ParamsDataView {
 public:
  WidgetInputHandler_CursorVisibilityChanged_ParamsDataView() {}

  WidgetInputHandler_CursorVisibilityChanged_ParamsDataView(
      internal::WidgetInputHandler_CursorVisibilityChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool visible() const {
    return data_->visible;
  }
 private:
  internal::WidgetInputHandler_CursorVisibilityChanged_Params_Data* data_ = nullptr;
};

class WidgetInputHandler_ImeSetComposition_ParamsDataView {
 public:
  WidgetInputHandler_ImeSetComposition_ParamsDataView() {}

  WidgetInputHandler_ImeSetComposition_ParamsDataView(
      internal::WidgetInputHandler_ImeSetComposition_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTextDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadText(UserType* output) {
    auto* pointer = data_->text.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetUnderlinesDataView(
      mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUnderlines(UserType* output) {
    auto* pointer = data_->underlines.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>>(
        pointer, output, context_);
  }
  inline void GetRangeDataView(
      ::gfx::mojom::RangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRange(UserType* output) {
    auto* pointer = data_->range.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RangeDataView>(
        pointer, output, context_);
  }
  int32_t start() const {
    return data_->start;
  }
  int32_t end() const {
    return data_->end;
  }
 private:
  internal::WidgetInputHandler_ImeSetComposition_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WidgetInputHandler_ImeCommitText_ParamsDataView {
 public:
  WidgetInputHandler_ImeCommitText_ParamsDataView() {}

  WidgetInputHandler_ImeCommitText_ParamsDataView(
      internal::WidgetInputHandler_ImeCommitText_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTextDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadText(UserType* output) {
    auto* pointer = data_->text.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetUnderlinesDataView(
      mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUnderlines(UserType* output) {
    auto* pointer = data_->underlines.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>>(
        pointer, output, context_);
  }
  inline void GetRangeDataView(
      ::gfx::mojom::RangeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRange(UserType* output) {
    auto* pointer = data_->range.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RangeDataView>(
        pointer, output, context_);
  }
  int32_t relative_cursor_position() const {
    return data_->relative_cursor_position;
  }
 private:
  internal::WidgetInputHandler_ImeCommitText_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WidgetInputHandler_ImeFinishComposingText_ParamsDataView {
 public:
  WidgetInputHandler_ImeFinishComposingText_ParamsDataView() {}

  WidgetInputHandler_ImeFinishComposingText_ParamsDataView(
      internal::WidgetInputHandler_ImeFinishComposingText_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool keep_selection() const {
    return data_->keep_selection;
  }
 private:
  internal::WidgetInputHandler_ImeFinishComposingText_Params_Data* data_ = nullptr;
};

class WidgetInputHandler_RequestTextInputStateUpdate_ParamsDataView {
 public:
  WidgetInputHandler_RequestTextInputStateUpdate_ParamsDataView() {}

  WidgetInputHandler_RequestTextInputStateUpdate_ParamsDataView(
      internal::WidgetInputHandler_RequestTextInputStateUpdate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::WidgetInputHandler_RequestTextInputStateUpdate_Params_Data* data_ = nullptr;
};

class WidgetInputHandler_RequestCompositionUpdates_ParamsDataView {
 public:
  WidgetInputHandler_RequestCompositionUpdates_ParamsDataView() {}

  WidgetInputHandler_RequestCompositionUpdates_ParamsDataView(
      internal::WidgetInputHandler_RequestCompositionUpdates_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool immediate_request() const {
    return data_->immediate_request;
  }
  bool monitor_request() const {
    return data_->monitor_request;
  }
 private:
  internal::WidgetInputHandler_RequestCompositionUpdates_Params_Data* data_ = nullptr;
};

class WidgetInputHandler_DispatchEvent_ParamsDataView {
 public:
  WidgetInputHandler_DispatchEvent_ParamsDataView() {}

  WidgetInputHandler_DispatchEvent_ParamsDataView(
      internal::WidgetInputHandler_DispatchEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEventDataView(
      EventDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEvent(UserType* output) {
    auto* pointer = data_->event.Get();
    return mojo::internal::Deserialize<::content::mojom::EventDataView>(
        pointer, output, context_);
  }
 private:
  internal::WidgetInputHandler_DispatchEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WidgetInputHandler_DispatchEvent_ResponseParamsDataView {
 public:
  WidgetInputHandler_DispatchEvent_ResponseParamsDataView() {}

  WidgetInputHandler_DispatchEvent_ResponseParamsDataView(
      internal::WidgetInputHandler_DispatchEvent_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSource(UserType* output) const {
    auto data_value = data_->source;
    return mojo::internal::Deserialize<::content::mojom::InputEventAckSource>(
        data_value, output);
  }

  ::content::mojom::InputEventAckSource source() const {
    return static_cast<::content::mojom::InputEventAckSource>(data_->source);
  }
  inline void GetUpdatedLatencyDataView(
      ::ui::mojom::LatencyInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdatedLatency(UserType* output) {
    auto* pointer = data_->updated_latency.Get();
    return mojo::internal::Deserialize<::ui::mojom::LatencyInfoDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::content::mojom::InputEventAckState>(
        data_value, output);
  }

  ::content::mojom::InputEventAckState state() const {
    return static_cast<::content::mojom::InputEventAckState>(data_->state);
  }
  inline void GetOverscrollDataView(
      ::content::mojom::DidOverscrollParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOverscroll(UserType* output) {
    auto* pointer = data_->overscroll.Get();
    return mojo::internal::Deserialize<::content::mojom::DidOverscrollParamsDataView>(
        pointer, output, context_);
  }
 private:
  internal::WidgetInputHandler_DispatchEvent_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WidgetInputHandler_DispatchNonBlockingEvent_ParamsDataView {
 public:
  WidgetInputHandler_DispatchNonBlockingEvent_ParamsDataView() {}

  WidgetInputHandler_DispatchNonBlockingEvent_ParamsDataView(
      internal::WidgetInputHandler_DispatchNonBlockingEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEventDataView(
      EventDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEvent(UserType* output) {
    auto* pointer = data_->event.Get();
    return mojo::internal::Deserialize<::content::mojom::EventDataView>(
        pointer, output, context_);
  }
 private:
  internal::WidgetInputHandler_DispatchNonBlockingEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_SetCompositionFromExistingText_ParamsDataView {
 public:
  FrameInputHandler_SetCompositionFromExistingText_ParamsDataView() {}

  FrameInputHandler_SetCompositionFromExistingText_ParamsDataView(
      internal::FrameInputHandler_SetCompositionFromExistingText_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t start() const {
    return data_->start;
  }
  int32_t end() const {
    return data_->end;
  }
  inline void GetUnderlinesDataView(
      mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUnderlines(UserType* output) {
    auto* pointer = data_->underlines.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_SetCompositionFromExistingText_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_ExtendSelectionAndDelete_ParamsDataView {
 public:
  FrameInputHandler_ExtendSelectionAndDelete_ParamsDataView() {}

  FrameInputHandler_ExtendSelectionAndDelete_ParamsDataView(
      internal::FrameInputHandler_ExtendSelectionAndDelete_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t before() const {
    return data_->before;
  }
  int32_t after() const {
    return data_->after;
  }
 private:
  internal::FrameInputHandler_ExtendSelectionAndDelete_Params_Data* data_ = nullptr;
};

class FrameInputHandler_DeleteSurroundingText_ParamsDataView {
 public:
  FrameInputHandler_DeleteSurroundingText_ParamsDataView() {}

  FrameInputHandler_DeleteSurroundingText_ParamsDataView(
      internal::FrameInputHandler_DeleteSurroundingText_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t before() const {
    return data_->before;
  }
  int32_t after() const {
    return data_->after;
  }
 private:
  internal::FrameInputHandler_DeleteSurroundingText_Params_Data* data_ = nullptr;
};

class FrameInputHandler_DeleteSurroundingTextInCodePoints_ParamsDataView {
 public:
  FrameInputHandler_DeleteSurroundingTextInCodePoints_ParamsDataView() {}

  FrameInputHandler_DeleteSurroundingTextInCodePoints_ParamsDataView(
      internal::FrameInputHandler_DeleteSurroundingTextInCodePoints_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t before() const {
    return data_->before;
  }
  int32_t after() const {
    return data_->after;
  }
 private:
  internal::FrameInputHandler_DeleteSurroundingTextInCodePoints_Params_Data* data_ = nullptr;
};

class FrameInputHandler_SetEditableSelectionOffsets_ParamsDataView {
 public:
  FrameInputHandler_SetEditableSelectionOffsets_ParamsDataView() {}

  FrameInputHandler_SetEditableSelectionOffsets_ParamsDataView(
      internal::FrameInputHandler_SetEditableSelectionOffsets_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t start() const {
    return data_->start;
  }
  int32_t end() const {
    return data_->end;
  }
 private:
  internal::FrameInputHandler_SetEditableSelectionOffsets_Params_Data* data_ = nullptr;
};

class FrameInputHandler_ExecuteEditCommand_ParamsDataView {
 public:
  FrameInputHandler_ExecuteEditCommand_ParamsDataView() {}

  FrameInputHandler_ExecuteEditCommand_ParamsDataView(
      internal::FrameInputHandler_ExecuteEditCommand_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCommandDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCommand(UserType* output) {
    auto* pointer = data_->command.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_ExecuteEditCommand_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_Undo_ParamsDataView {
 public:
  FrameInputHandler_Undo_ParamsDataView() {}

  FrameInputHandler_Undo_ParamsDataView(
      internal::FrameInputHandler_Undo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_Undo_Params_Data* data_ = nullptr;
};

class FrameInputHandler_Redo_ParamsDataView {
 public:
  FrameInputHandler_Redo_ParamsDataView() {}

  FrameInputHandler_Redo_ParamsDataView(
      internal::FrameInputHandler_Redo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_Redo_Params_Data* data_ = nullptr;
};

class FrameInputHandler_Cut_ParamsDataView {
 public:
  FrameInputHandler_Cut_ParamsDataView() {}

  FrameInputHandler_Cut_ParamsDataView(
      internal::FrameInputHandler_Cut_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_Cut_Params_Data* data_ = nullptr;
};

class FrameInputHandler_Copy_ParamsDataView {
 public:
  FrameInputHandler_Copy_ParamsDataView() {}

  FrameInputHandler_Copy_ParamsDataView(
      internal::FrameInputHandler_Copy_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_Copy_Params_Data* data_ = nullptr;
};

class FrameInputHandler_CopyToFindPboard_ParamsDataView {
 public:
  FrameInputHandler_CopyToFindPboard_ParamsDataView() {}

  FrameInputHandler_CopyToFindPboard_ParamsDataView(
      internal::FrameInputHandler_CopyToFindPboard_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_CopyToFindPboard_Params_Data* data_ = nullptr;
};

class FrameInputHandler_Paste_ParamsDataView {
 public:
  FrameInputHandler_Paste_ParamsDataView() {}

  FrameInputHandler_Paste_ParamsDataView(
      internal::FrameInputHandler_Paste_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_Paste_Params_Data* data_ = nullptr;
};

class FrameInputHandler_PasteAndMatchStyle_ParamsDataView {
 public:
  FrameInputHandler_PasteAndMatchStyle_ParamsDataView() {}

  FrameInputHandler_PasteAndMatchStyle_ParamsDataView(
      internal::FrameInputHandler_PasteAndMatchStyle_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_PasteAndMatchStyle_Params_Data* data_ = nullptr;
};

class FrameInputHandler_Delete_ParamsDataView {
 public:
  FrameInputHandler_Delete_ParamsDataView() {}

  FrameInputHandler_Delete_ParamsDataView(
      internal::FrameInputHandler_Delete_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_Delete_Params_Data* data_ = nullptr;
};

class FrameInputHandler_SelectAll_ParamsDataView {
 public:
  FrameInputHandler_SelectAll_ParamsDataView() {}

  FrameInputHandler_SelectAll_ParamsDataView(
      internal::FrameInputHandler_SelectAll_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_SelectAll_Params_Data* data_ = nullptr;
};

class FrameInputHandler_CollapseSelection_ParamsDataView {
 public:
  FrameInputHandler_CollapseSelection_ParamsDataView() {}

  FrameInputHandler_CollapseSelection_ParamsDataView(
      internal::FrameInputHandler_CollapseSelection_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::FrameInputHandler_CollapseSelection_Params_Data* data_ = nullptr;
};

class FrameInputHandler_Replace_ParamsDataView {
 public:
  FrameInputHandler_Replace_ParamsDataView() {}

  FrameInputHandler_Replace_ParamsDataView(
      internal::FrameInputHandler_Replace_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWordDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWord(UserType* output) {
    auto* pointer = data_->word.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_Replace_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_ReplaceMisspelling_ParamsDataView {
 public:
  FrameInputHandler_ReplaceMisspelling_ParamsDataView() {}

  FrameInputHandler_ReplaceMisspelling_ParamsDataView(
      internal::FrameInputHandler_ReplaceMisspelling_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWordDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWord(UserType* output) {
    auto* pointer = data_->word.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_ReplaceMisspelling_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_SelectRange_ParamsDataView {
 public:
  FrameInputHandler_SelectRange_ParamsDataView() {}

  FrameInputHandler_SelectRange_ParamsDataView(
      internal::FrameInputHandler_SelectRange_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetBaseDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBase(UserType* output) {
    auto* pointer = data_->base.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
  inline void GetExtentDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadExtent(UserType* output) {
    auto* pointer = data_->extent.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_SelectRange_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_AdjustSelectionByCharacterOffset_ParamsDataView {
 public:
  FrameInputHandler_AdjustSelectionByCharacterOffset_ParamsDataView() {}

  FrameInputHandler_AdjustSelectionByCharacterOffset_ParamsDataView(
      internal::FrameInputHandler_AdjustSelectionByCharacterOffset_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t start() const {
    return data_->start;
  }
  int32_t end() const {
    return data_->end;
  }
 private:
  internal::FrameInputHandler_AdjustSelectionByCharacterOffset_Params_Data* data_ = nullptr;
};

class FrameInputHandler_MoveRangeSelectionExtent_ParamsDataView {
 public:
  FrameInputHandler_MoveRangeSelectionExtent_ParamsDataView() {}

  FrameInputHandler_MoveRangeSelectionExtent_ParamsDataView(
      internal::FrameInputHandler_MoveRangeSelectionExtent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetExtentDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadExtent(UserType* output) {
    auto* pointer = data_->extent.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_MoveRangeSelectionExtent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_ScrollFocusedEditableNodeIntoRect_ParamsDataView {
 public:
  FrameInputHandler_ScrollFocusedEditableNodeIntoRect_ParamsDataView() {}

  FrameInputHandler_ScrollFocusedEditableNodeIntoRect_ParamsDataView(
      internal::FrameInputHandler_ScrollFocusedEditableNodeIntoRect_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRectDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRect(UserType* output) {
    auto* pointer = data_->rect.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_ScrollFocusedEditableNodeIntoRect_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FrameInputHandler_MoveCaret_ParamsDataView {
 public:
  FrameInputHandler_MoveCaret_ParamsDataView() {}

  FrameInputHandler_MoveCaret_ParamsDataView(
      internal::FrameInputHandler_MoveCaret_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPointDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPoint(UserType* output) {
    auto* pointer = data_->point.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameInputHandler_MoveCaret_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::KeyDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::KeyDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::KeyData_Data);
    decltype(CallWithContext(Traits::text, input, custom_context)) in_text = CallWithContext(Traits::text, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::String16DataView>(
        in_text, context);
    decltype(CallWithContext(Traits::unmodified_text, input, custom_context)) in_unmodified_text = CallWithContext(Traits::unmodified_text, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::String16DataView>(
        in_unmodified_text, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::KeyData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::KeyData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->dom_key = CallWithContext(Traits::dom_key, input, custom_context);
    result->dom_code = CallWithContext(Traits::dom_code, input, custom_context);
    result->windows_key_code = CallWithContext(Traits::windows_key_code, input, custom_context);
    result->native_key_code = CallWithContext(Traits::native_key_code, input, custom_context);
    result->is_system_key = CallWithContext(Traits::is_system_key, input, custom_context);
    result->is_browser_shortcut = CallWithContext(Traits::is_browser_shortcut, input, custom_context);
    decltype(CallWithContext(Traits::text, input, custom_context)) in_text = CallWithContext(Traits::text, input, custom_context);
    typename decltype(result->text)::BaseType* text_ptr;
    mojo::internal::Serialize<::mojo::common::mojom::String16DataView>(
        in_text, buffer, &text_ptr, context);
    result->text.Set(text_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->text.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null text in KeyData struct");
    decltype(CallWithContext(Traits::unmodified_text, input, custom_context)) in_unmodified_text = CallWithContext(Traits::unmodified_text, input, custom_context);
    typename decltype(result->unmodified_text)::BaseType* unmodified_text_ptr;
    mojo::internal::Serialize<::mojo::common::mojom::String16DataView>(
        in_unmodified_text, buffer, &unmodified_text_ptr, context);
    result->unmodified_text.Set(unmodified_text_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->unmodified_text.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null unmodified_text in KeyData struct");
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::KeyData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::KeyDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::PointerDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::PointerDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::PointerData_Data);
    decltype(CallWithContext(Traits::widget_position, input, custom_context)) in_widget_position = CallWithContext(Traits::widget_position, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::gfx::mojom::PointFDataView>(
        in_widget_position, context);
    decltype(CallWithContext(Traits::screen_position, input, custom_context)) in_screen_position = CallWithContext(Traits::screen_position, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::gfx::mojom::PointFDataView>(
        in_screen_position, context);
    decltype(CallWithContext(Traits::mouse_data, input, custom_context)) in_mouse_data = CallWithContext(Traits::mouse_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::MouseDataDataView>(
        in_mouse_data, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::PointerData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::PointerData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->pointer_id = CallWithContext(Traits::pointer_id, input, custom_context);
    result->force = CallWithContext(Traits::force, input, custom_context);
    result->tilt_x = CallWithContext(Traits::tilt_x, input, custom_context);
    result->tilt_y = CallWithContext(Traits::tilt_y, input, custom_context);
    result->tangential_pressure = CallWithContext(Traits::tangential_pressure, input, custom_context);
    result->twist = CallWithContext(Traits::twist, input, custom_context);
    mojo::internal::Serialize<::content::mojom::Button>(
        CallWithContext(Traits::button, input, custom_context), &result->button);
    mojo::internal::Serialize<::content::mojom::PointerType>(
        CallWithContext(Traits::pointer_type, input, custom_context), &result->pointer_type);
    result->movement_x = CallWithContext(Traits::movement_x, input, custom_context);
    result->movement_y = CallWithContext(Traits::movement_y, input, custom_context);
    decltype(CallWithContext(Traits::widget_position, input, custom_context)) in_widget_position = CallWithContext(Traits::widget_position, input, custom_context);
    typename decltype(result->widget_position)::BaseType* widget_position_ptr;
    mojo::internal::Serialize<::gfx::mojom::PointFDataView>(
        in_widget_position, buffer, &widget_position_ptr, context);
    result->widget_position.Set(widget_position_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->widget_position.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null widget_position in PointerData struct");
    decltype(CallWithContext(Traits::screen_position, input, custom_context)) in_screen_position = CallWithContext(Traits::screen_position, input, custom_context);
    typename decltype(result->screen_position)::BaseType* screen_position_ptr;
    mojo::internal::Serialize<::gfx::mojom::PointFDataView>(
        in_screen_position, buffer, &screen_position_ptr, context);
    result->screen_position.Set(screen_position_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->screen_position.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null screen_position in PointerData struct");
    decltype(CallWithContext(Traits::mouse_data, input, custom_context)) in_mouse_data = CallWithContext(Traits::mouse_data, input, custom_context);
    typename decltype(result->mouse_data)::BaseType* mouse_data_ptr;
    mojo::internal::Serialize<::content::mojom::MouseDataDataView>(
        in_mouse_data, buffer, &mouse_data_ptr, context);
    result->mouse_data.Set(mouse_data_ptr);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::PointerData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::PointerDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::WheelDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::WheelDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::WheelData_Data);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::WheelData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::WheelData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->delta_x = CallWithContext(Traits::delta_x, input, custom_context);
    result->delta_y = CallWithContext(Traits::delta_y, input, custom_context);
    result->wheel_ticks_x = CallWithContext(Traits::wheel_ticks_x, input, custom_context);
    result->wheel_ticks_y = CallWithContext(Traits::wheel_ticks_y, input, custom_context);
    result->acceleration_ratio_x = CallWithContext(Traits::acceleration_ratio_x, input, custom_context);
    result->acceleration_ratio_y = CallWithContext(Traits::acceleration_ratio_y, input, custom_context);
    result->resending_plugin_id = CallWithContext(Traits::resending_plugin_id, input, custom_context);
    result->phase = CallWithContext(Traits::phase, input, custom_context);
    result->momentum_phase = CallWithContext(Traits::momentum_phase, input, custom_context);
    result->scroll_by_page = CallWithContext(Traits::scroll_by_page, input, custom_context);
    result->has_precise_scrolling_deltas = CallWithContext(Traits::has_precise_scrolling_deltas, input, custom_context);
    mojo::internal::Serialize<::content::mojom::Cancelability>(
        CallWithContext(Traits::cancelable, input, custom_context), &result->cancelable);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::WheelData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::WheelDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::MouseDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::MouseDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::MouseData_Data);
    decltype(CallWithContext(Traits::wheel_data, input, custom_context)) in_wheel_data = CallWithContext(Traits::wheel_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::WheelDataDataView>(
        in_wheel_data, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::MouseData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::MouseData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->click_count = CallWithContext(Traits::click_count, input, custom_context);
    decltype(CallWithContext(Traits::wheel_data, input, custom_context)) in_wheel_data = CallWithContext(Traits::wheel_data, input, custom_context);
    typename decltype(result->wheel_data)::BaseType* wheel_data_ptr;
    mojo::internal::Serialize<::content::mojom::WheelDataDataView>(
        in_wheel_data, buffer, &wheel_data_ptr, context);
    result->wheel_data.Set(wheel_data_ptr);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::MouseData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::MouseDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::ScrollUpdateDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::ScrollUpdateDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::ScrollUpdate_Data);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::ScrollUpdate_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::ScrollUpdate_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->velocity_x = CallWithContext(Traits::velocity_x, input, custom_context);
    result->velocity_y = CallWithContext(Traits::velocity_y, input, custom_context);
    result->previous_update_in_sequence_prevented = CallWithContext(Traits::previous_update_in_sequence_prevented, input, custom_context);
    result->prevent_propagation = CallWithContext(Traits::prevent_propagation, input, custom_context);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::ScrollUpdate_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::ScrollUpdateDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::ScrollDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::ScrollDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::ScrollData_Data);
    decltype(CallWithContext(Traits::update_details, input, custom_context)) in_update_details = CallWithContext(Traits::update_details, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::ScrollUpdateDataView>(
        in_update_details, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::ScrollData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::ScrollData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->delta_x = CallWithContext(Traits::delta_x, input, custom_context);
    result->delta_y = CallWithContext(Traits::delta_y, input, custom_context);
    mojo::internal::Serialize<::content::mojom::ScrollUnits>(
        CallWithContext(Traits::delta_units, input, custom_context), &result->delta_units);
    result->target_viewport = CallWithContext(Traits::target_viewport, input, custom_context);
    mojo::internal::Serialize<::content::mojom::InertialPhaseState>(
        CallWithContext(Traits::inertial_phase, input, custom_context), &result->inertial_phase);
    result->synthetic = CallWithContext(Traits::synthetic, input, custom_context);
    result->pointer_count = CallWithContext(Traits::pointer_count, input, custom_context);
    decltype(CallWithContext(Traits::update_details, input, custom_context)) in_update_details = CallWithContext(Traits::update_details, input, custom_context);
    typename decltype(result->update_details)::BaseType* update_details_ptr;
    mojo::internal::Serialize<::content::mojom::ScrollUpdateDataView>(
        in_update_details, buffer, &update_details_ptr, context);
    result->update_details.Set(update_details_ptr);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::ScrollData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::ScrollDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::PinchDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::PinchDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::PinchData_Data);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::PinchData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::PinchData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->zoom_disabled = CallWithContext(Traits::zoom_disabled, input, custom_context);
    result->scale = CallWithContext(Traits::scale, input, custom_context);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::PinchData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::PinchDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::FlingDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::FlingDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::FlingData_Data);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::FlingData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::FlingData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->velocity_x = CallWithContext(Traits::velocity_x, input, custom_context);
    result->velocity_y = CallWithContext(Traits::velocity_y, input, custom_context);
    result->target_viewport = CallWithContext(Traits::target_viewport, input, custom_context);
    result->prevent_boosting = CallWithContext(Traits::prevent_boosting, input, custom_context);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::FlingData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::FlingDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::TapDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::TapDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::TapData_Data);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::TapData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::TapData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    result->tap_count = CallWithContext(Traits::tap_count, input, custom_context);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::TapData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::TapDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::GestureDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::GestureDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::GestureData_Data);
    decltype(CallWithContext(Traits::screen_position, input, custom_context)) in_screen_position = CallWithContext(Traits::screen_position, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::gfx::mojom::PointFDataView>(
        in_screen_position, context);
    decltype(CallWithContext(Traits::widget_position, input, custom_context)) in_widget_position = CallWithContext(Traits::widget_position, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::gfx::mojom::PointFDataView>(
        in_widget_position, context);
    decltype(CallWithContext(Traits::contact_size, input, custom_context)) in_contact_size = CallWithContext(Traits::contact_size, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::gfx::mojom::SizeDataView>(
        in_contact_size, context);
    decltype(CallWithContext(Traits::scroll_data, input, custom_context)) in_scroll_data = CallWithContext(Traits::scroll_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::ScrollDataDataView>(
        in_scroll_data, context);
    decltype(CallWithContext(Traits::pinch_data, input, custom_context)) in_pinch_data = CallWithContext(Traits::pinch_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::PinchDataDataView>(
        in_pinch_data, context);
    decltype(CallWithContext(Traits::tap_data, input, custom_context)) in_tap_data = CallWithContext(Traits::tap_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::TapDataDataView>(
        in_tap_data, context);
    decltype(CallWithContext(Traits::fling_data, input, custom_context)) in_fling_data = CallWithContext(Traits::fling_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::FlingDataDataView>(
        in_fling_data, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::GestureData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::GestureData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    decltype(CallWithContext(Traits::screen_position, input, custom_context)) in_screen_position = CallWithContext(Traits::screen_position, input, custom_context);
    typename decltype(result->screen_position)::BaseType* screen_position_ptr;
    mojo::internal::Serialize<::gfx::mojom::PointFDataView>(
        in_screen_position, buffer, &screen_position_ptr, context);
    result->screen_position.Set(screen_position_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->screen_position.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null screen_position in GestureData struct");
    decltype(CallWithContext(Traits::widget_position, input, custom_context)) in_widget_position = CallWithContext(Traits::widget_position, input, custom_context);
    typename decltype(result->widget_position)::BaseType* widget_position_ptr;
    mojo::internal::Serialize<::gfx::mojom::PointFDataView>(
        in_widget_position, buffer, &widget_position_ptr, context);
    result->widget_position.Set(widget_position_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->widget_position.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null widget_position in GestureData struct");
    mojo::internal::Serialize<::content::mojom::GestureDevice>(
        CallWithContext(Traits::source_device, input, custom_context), &result->source_device);
    result->unique_touch_event_id = CallWithContext(Traits::unique_touch_event_id, input, custom_context);
    result->resending_plugin_id = CallWithContext(Traits::resending_plugin_id, input, custom_context);
    decltype(CallWithContext(Traits::contact_size, input, custom_context)) in_contact_size = CallWithContext(Traits::contact_size, input, custom_context);
    typename decltype(result->contact_size)::BaseType* contact_size_ptr;
    mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
        in_contact_size, buffer, &contact_size_ptr, context);
    result->contact_size.Set(contact_size_ptr);
    decltype(CallWithContext(Traits::scroll_data, input, custom_context)) in_scroll_data = CallWithContext(Traits::scroll_data, input, custom_context);
    typename decltype(result->scroll_data)::BaseType* scroll_data_ptr;
    mojo::internal::Serialize<::content::mojom::ScrollDataDataView>(
        in_scroll_data, buffer, &scroll_data_ptr, context);
    result->scroll_data.Set(scroll_data_ptr);
    decltype(CallWithContext(Traits::pinch_data, input, custom_context)) in_pinch_data = CallWithContext(Traits::pinch_data, input, custom_context);
    typename decltype(result->pinch_data)::BaseType* pinch_data_ptr;
    mojo::internal::Serialize<::content::mojom::PinchDataDataView>(
        in_pinch_data, buffer, &pinch_data_ptr, context);
    result->pinch_data.Set(pinch_data_ptr);
    decltype(CallWithContext(Traits::tap_data, input, custom_context)) in_tap_data = CallWithContext(Traits::tap_data, input, custom_context);
    typename decltype(result->tap_data)::BaseType* tap_data_ptr;
    mojo::internal::Serialize<::content::mojom::TapDataDataView>(
        in_tap_data, buffer, &tap_data_ptr, context);
    result->tap_data.Set(tap_data_ptr);
    decltype(CallWithContext(Traits::fling_data, input, custom_context)) in_fling_data = CallWithContext(Traits::fling_data, input, custom_context);
    typename decltype(result->fling_data)::BaseType* fling_data_ptr;
    mojo::internal::Serialize<::content::mojom::FlingDataDataView>(
        in_fling_data, buffer, &fling_data_ptr, context);
    result->fling_data.Set(fling_data_ptr);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::GestureData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::GestureDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::TouchPointDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::TouchPointDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::TouchPoint_Data);
    decltype(CallWithContext(Traits::pointer_data, input, custom_context)) in_pointer_data = CallWithContext(Traits::pointer_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::PointerDataDataView>(
        in_pointer_data, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::TouchPoint_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::TouchPoint_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    mojo::internal::Serialize<::content::mojom::TouchState>(
        CallWithContext(Traits::state, input, custom_context), &result->state);
    result->radius_x = CallWithContext(Traits::radius_x, input, custom_context);
    result->radius_y = CallWithContext(Traits::radius_y, input, custom_context);
    result->rotation_angle = CallWithContext(Traits::rotation_angle, input, custom_context);
    decltype(CallWithContext(Traits::pointer_data, input, custom_context)) in_pointer_data = CallWithContext(Traits::pointer_data, input, custom_context);
    typename decltype(result->pointer_data)::BaseType* pointer_data_ptr;
    mojo::internal::Serialize<::content::mojom::PointerDataDataView>(
        in_pointer_data, buffer, &pointer_data_ptr, context);
    result->pointer_data.Set(pointer_data_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->pointer_data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null pointer_data in TouchPoint struct");
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::TouchPoint_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::TouchPointDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::TouchDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::TouchDataDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::TouchData_Data);
    decltype(CallWithContext(Traits::touches, input, custom_context)) in_touches = CallWithContext(Traits::touches, input, custom_context);
    size += mojo::internal::PrepareToSerialize<mojo::ArrayDataView<::content::mojom::TouchPointDataView>>(
        in_touches, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::TouchData_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::TouchData_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    mojo::internal::Serialize<::content::mojom::Cancelability>(
        CallWithContext(Traits::cancelable, input, custom_context), &result->cancelable);
    result->moved_beyond_slop_region = CallWithContext(Traits::moved_beyond_slop_region, input, custom_context);
    result->touch_start_or_first_move = CallWithContext(Traits::touch_start_or_first_move, input, custom_context);
    result->unique_touch_event_id = CallWithContext(Traits::unique_touch_event_id, input, custom_context);
    decltype(CallWithContext(Traits::touches, input, custom_context)) in_touches = CallWithContext(Traits::touches, input, custom_context);
    typename decltype(result->touches)::BaseType* touches_ptr;
    const mojo::internal::ContainerValidateParams touches_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::content::mojom::TouchPointDataView>>(
        in_touches, buffer, &touches_ptr, &touches_validate_params,
        context);
    result->touches.Set(touches_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->touches.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null touches in TouchData struct");
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::TouchData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::TouchDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::EventDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::EventDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::Event_Data);
    decltype(CallWithContext(Traits::latency, input, custom_context)) in_latency = CallWithContext(Traits::latency, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::ui::mojom::LatencyInfoDataView>(
        in_latency, context);
    decltype(CallWithContext(Traits::key_data, input, custom_context)) in_key_data = CallWithContext(Traits::key_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::KeyDataDataView>(
        in_key_data, context);
    decltype(CallWithContext(Traits::pointer_data, input, custom_context)) in_pointer_data = CallWithContext(Traits::pointer_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::PointerDataDataView>(
        in_pointer_data, context);
    decltype(CallWithContext(Traits::gesture_data, input, custom_context)) in_gesture_data = CallWithContext(Traits::gesture_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::GestureDataDataView>(
        in_gesture_data, context);
    decltype(CallWithContext(Traits::touch_data, input, custom_context)) in_touch_data = CallWithContext(Traits::touch_data, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::content::mojom::TouchDataDataView>(
        in_touch_data, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::Event_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::Event_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    mojo::internal::Serialize<::content::mojom::EventType>(
        CallWithContext(Traits::type, input, custom_context), &result->type);
    result->modifiers = CallWithContext(Traits::modifiers, input, custom_context);
    result->timestamp_seconds = CallWithContext(Traits::timestamp_seconds, input, custom_context);
    decltype(CallWithContext(Traits::latency, input, custom_context)) in_latency = CallWithContext(Traits::latency, input, custom_context);
    typename decltype(result->latency)::BaseType* latency_ptr;
    mojo::internal::Serialize<::ui::mojom::LatencyInfoDataView>(
        in_latency, buffer, &latency_ptr, context);
    result->latency.Set(latency_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->latency.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null latency in Event struct");
    decltype(CallWithContext(Traits::key_data, input, custom_context)) in_key_data = CallWithContext(Traits::key_data, input, custom_context);
    typename decltype(result->key_data)::BaseType* key_data_ptr;
    mojo::internal::Serialize<::content::mojom::KeyDataDataView>(
        in_key_data, buffer, &key_data_ptr, context);
    result->key_data.Set(key_data_ptr);
    decltype(CallWithContext(Traits::pointer_data, input, custom_context)) in_pointer_data = CallWithContext(Traits::pointer_data, input, custom_context);
    typename decltype(result->pointer_data)::BaseType* pointer_data_ptr;
    mojo::internal::Serialize<::content::mojom::PointerDataDataView>(
        in_pointer_data, buffer, &pointer_data_ptr, context);
    result->pointer_data.Set(pointer_data_ptr);
    decltype(CallWithContext(Traits::gesture_data, input, custom_context)) in_gesture_data = CallWithContext(Traits::gesture_data, input, custom_context);
    typename decltype(result->gesture_data)::BaseType* gesture_data_ptr;
    mojo::internal::Serialize<::content::mojom::GestureDataDataView>(
        in_gesture_data, buffer, &gesture_data_ptr, context);
    result->gesture_data.Set(gesture_data_ptr);
    decltype(CallWithContext(Traits::touch_data, input, custom_context)) in_touch_data = CallWithContext(Traits::touch_data, input, custom_context);
    typename decltype(result->touch_data)::BaseType* touch_data_ptr;
    mojo::internal::Serialize<::content::mojom::TouchDataDataView>(
        in_touch_data, buffer, &touch_data_ptr, context);
    result->touch_data.Set(touch_data_ptr);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::Event_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::EventDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace content {
namespace mojom {

inline void KeyDataDataView::GetTextDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->text.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}
inline void KeyDataDataView::GetUnmodifiedTextDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->unmodified_text.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}


inline void PointerDataDataView::GetWidgetPositionDataView(
    ::gfx::mojom::PointFDataView* output) {
  auto pointer = data_->widget_position.Get();
  *output = ::gfx::mojom::PointFDataView(pointer, context_);
}
inline void PointerDataDataView::GetScreenPositionDataView(
    ::gfx::mojom::PointFDataView* output) {
  auto pointer = data_->screen_position.Get();
  *output = ::gfx::mojom::PointFDataView(pointer, context_);
}
inline void PointerDataDataView::GetMouseDataDataView(
    MouseDataDataView* output) {
  auto pointer = data_->mouse_data.Get();
  *output = MouseDataDataView(pointer, context_);
}




inline void MouseDataDataView::GetWheelDataDataView(
    WheelDataDataView* output) {
  auto pointer = data_->wheel_data.Get();
  *output = WheelDataDataView(pointer, context_);
}




inline void ScrollDataDataView::GetUpdateDetailsDataView(
    ScrollUpdateDataView* output) {
  auto pointer = data_->update_details.Get();
  *output = ScrollUpdateDataView(pointer, context_);
}








inline void GestureDataDataView::GetScreenPositionDataView(
    ::gfx::mojom::PointFDataView* output) {
  auto pointer = data_->screen_position.Get();
  *output = ::gfx::mojom::PointFDataView(pointer, context_);
}
inline void GestureDataDataView::GetWidgetPositionDataView(
    ::gfx::mojom::PointFDataView* output) {
  auto pointer = data_->widget_position.Get();
  *output = ::gfx::mojom::PointFDataView(pointer, context_);
}
inline void GestureDataDataView::GetContactSizeDataView(
    ::gfx::mojom::SizeDataView* output) {
  auto pointer = data_->contact_size.Get();
  *output = ::gfx::mojom::SizeDataView(pointer, context_);
}
inline void GestureDataDataView::GetScrollDataDataView(
    ScrollDataDataView* output) {
  auto pointer = data_->scroll_data.Get();
  *output = ScrollDataDataView(pointer, context_);
}
inline void GestureDataDataView::GetPinchDataDataView(
    PinchDataDataView* output) {
  auto pointer = data_->pinch_data.Get();
  *output = PinchDataDataView(pointer, context_);
}
inline void GestureDataDataView::GetTapDataDataView(
    TapDataDataView* output) {
  auto pointer = data_->tap_data.Get();
  *output = TapDataDataView(pointer, context_);
}
inline void GestureDataDataView::GetFlingDataDataView(
    FlingDataDataView* output) {
  auto pointer = data_->fling_data.Get();
  *output = FlingDataDataView(pointer, context_);
}


inline void TouchPointDataView::GetPointerDataDataView(
    PointerDataDataView* output) {
  auto pointer = data_->pointer_data.Get();
  *output = PointerDataDataView(pointer, context_);
}


inline void TouchDataDataView::GetTouchesDataView(
    mojo::ArrayDataView<TouchPointDataView>* output) {
  auto pointer = data_->touches.Get();
  *output = mojo::ArrayDataView<TouchPointDataView>(pointer, context_);
}


inline void EventDataView::GetLatencyDataView(
    ::ui::mojom::LatencyInfoDataView* output) {
  auto pointer = data_->latency.Get();
  *output = ::ui::mojom::LatencyInfoDataView(pointer, context_);
}
inline void EventDataView::GetKeyDataDataView(
    KeyDataDataView* output) {
  auto pointer = data_->key_data.Get();
  *output = KeyDataDataView(pointer, context_);
}
inline void EventDataView::GetPointerDataDataView(
    PointerDataDataView* output) {
  auto pointer = data_->pointer_data.Get();
  *output = PointerDataDataView(pointer, context_);
}
inline void EventDataView::GetGestureDataDataView(
    GestureDataDataView* output) {
  auto pointer = data_->gesture_data.Get();
  *output = GestureDataDataView(pointer, context_);
}
inline void EventDataView::GetTouchDataDataView(
    TouchDataDataView* output) {
  auto pointer = data_->touch_data.Get();
  *output = TouchDataDataView(pointer, context_);
}






inline void WidgetInputHandler_SetEditCommandsForNextKeyEvent_ParamsDataView::GetCommandsDataView(
    mojo::ArrayDataView<::content::mojom::EditCommandDataView>* output) {
  auto pointer = data_->commands.Get();
  *output = mojo::ArrayDataView<::content::mojom::EditCommandDataView>(pointer, context_);
}




inline void WidgetInputHandler_ImeSetComposition_ParamsDataView::GetTextDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->text.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}
inline void WidgetInputHandler_ImeSetComposition_ParamsDataView::GetUnderlinesDataView(
    mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>* output) {
  auto pointer = data_->underlines.Get();
  *output = mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>(pointer, context_);
}
inline void WidgetInputHandler_ImeSetComposition_ParamsDataView::GetRangeDataView(
    ::gfx::mojom::RangeDataView* output) {
  auto pointer = data_->range.Get();
  *output = ::gfx::mojom::RangeDataView(pointer, context_);
}


inline void WidgetInputHandler_ImeCommitText_ParamsDataView::GetTextDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->text.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}
inline void WidgetInputHandler_ImeCommitText_ParamsDataView::GetUnderlinesDataView(
    mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>* output) {
  auto pointer = data_->underlines.Get();
  *output = mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>(pointer, context_);
}
inline void WidgetInputHandler_ImeCommitText_ParamsDataView::GetRangeDataView(
    ::gfx::mojom::RangeDataView* output) {
  auto pointer = data_->range.Get();
  *output = ::gfx::mojom::RangeDataView(pointer, context_);
}








inline void WidgetInputHandler_DispatchEvent_ParamsDataView::GetEventDataView(
    EventDataView* output) {
  auto pointer = data_->event.Get();
  *output = EventDataView(pointer, context_);
}


inline void WidgetInputHandler_DispatchEvent_ResponseParamsDataView::GetUpdatedLatencyDataView(
    ::ui::mojom::LatencyInfoDataView* output) {
  auto pointer = data_->updated_latency.Get();
  *output = ::ui::mojom::LatencyInfoDataView(pointer, context_);
}
inline void WidgetInputHandler_DispatchEvent_ResponseParamsDataView::GetOverscrollDataView(
    ::content::mojom::DidOverscrollParamsDataView* output) {
  auto pointer = data_->overscroll.Get();
  *output = ::content::mojom::DidOverscrollParamsDataView(pointer, context_);
}


inline void WidgetInputHandler_DispatchNonBlockingEvent_ParamsDataView::GetEventDataView(
    EventDataView* output) {
  auto pointer = data_->event.Get();
  *output = EventDataView(pointer, context_);
}


inline void FrameInputHandler_SetCompositionFromExistingText_ParamsDataView::GetUnderlinesDataView(
    mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>* output) {
  auto pointer = data_->underlines.Get();
  *output = mojo::ArrayDataView<::ui::mojom::CompositionUnderlineDataView>(pointer, context_);
}










inline void FrameInputHandler_ExecuteEditCommand_ParamsDataView::GetCommandDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->command.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void FrameInputHandler_ExecuteEditCommand_ParamsDataView::GetValueDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->value.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}






















inline void FrameInputHandler_Replace_ParamsDataView::GetWordDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->word.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}


inline void FrameInputHandler_ReplaceMisspelling_ParamsDataView::GetWordDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->word.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}


inline void FrameInputHandler_SelectRange_ParamsDataView::GetBaseDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->base.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}
inline void FrameInputHandler_SelectRange_ParamsDataView::GetExtentDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->extent.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}




inline void FrameInputHandler_MoveRangeSelectionExtent_ParamsDataView::GetExtentDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->extent.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}


inline void FrameInputHandler_ScrollFocusedEditableNodeIntoRect_ParamsDataView::GetRectDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->rect.Get();
  *output = ::gfx::mojom::RectDataView(pointer, context_);
}


inline void FrameInputHandler_MoveCaret_ParamsDataView::GetPointDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->point.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_INPUT_INPUT_HANDLER_MOJOM_SHARED_H_
