// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/render_frame_message_filter.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "url/mojo/url_gurl_struct_traits.h"
namespace content {
namespace mojom {
const char RenderFrameMessageFilter::Name_[] = "content::mojom::RenderFrameMessageFilter";
bool RenderFrameMessageFilter::GetCookies(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, std::string* cookies) {
  NOTREACHED();
  return false;
}
class RenderFrameMessageFilter_GetCookies_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  RenderFrameMessageFilter_GetCookies_HandleSyncResponse(
      bool* result, std::string* out_cookies)
      : result_(result), out_cookies_(out_cookies) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  bool* result_;
  std::string* out_cookies_;DISALLOW_COPY_AND_ASSIGN(RenderFrameMessageFilter_GetCookies_HandleSyncResponse);
};

class RenderFrameMessageFilter_GetCookies_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  RenderFrameMessageFilter_GetCookies_ForwardToCallback(
      RenderFrameMessageFilter::GetCookiesCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  RenderFrameMessageFilter::GetCookiesCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(RenderFrameMessageFilter_GetCookies_ForwardToCallback);
};

RenderFrameMessageFilterProxy::RenderFrameMessageFilterProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void RenderFrameMessageFilterProxy::SetCookie(
    int32_t in_render_frame_id, const GURL& in_url, const GURL& in_first_party_for_cookies, const std::string& in_cookie) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderFrameMessageFilter_SetCookie_Params_Data);
  size += mojo::internal::PrepareToSerialize<::url::mojom::UrlDataView>(
      in_url, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::url::mojom::UrlDataView>(
      in_first_party_for_cookies, &serialization_context);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_cookie, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderFrameMessageFilter_SetCookie_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderFrameMessageFilter_SetCookie_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->render_frame_id = in_render_frame_id;
  typename decltype(params->url)::BaseType* url_ptr;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_ptr, &serialization_context);
  params->url.Set(url_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in RenderFrameMessageFilter.SetCookie request");
  typename decltype(params->first_party_for_cookies)::BaseType* first_party_for_cookies_ptr;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_first_party_for_cookies, buffer, &first_party_for_cookies_ptr, &serialization_context);
  params->first_party_for_cookies.Set(first_party_for_cookies_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->first_party_for_cookies.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null first_party_for_cookies in RenderFrameMessageFilter.SetCookie request");
  typename decltype(params->cookie)::BaseType* cookie_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_cookie, buffer, &cookie_ptr, &serialization_context);
  params->cookie.Set(cookie_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->cookie.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null cookie in RenderFrameMessageFilter.SetCookie request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
bool RenderFrameMessageFilterProxy::GetCookies(
    int32_t param_render_frame_id, const GURL& param_url, const GURL& param_first_party_for_cookies, std::string* param_cookies) {
  const bool kExpectsResponse = true;
  const bool kIsSync = true;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderFrameMessageFilter_GetCookies_Params_Data);
  size += mojo::internal::PrepareToSerialize<::url::mojom::UrlDataView>(
      param_url, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::url::mojom::UrlDataView>(
      param_first_party_for_cookies, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderFrameMessageFilter_GetCookies_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderFrameMessageFilter_GetCookies_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->render_frame_id = param_render_frame_id;
  typename decltype(params->url)::BaseType* url_ptr;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      param_url, buffer, &url_ptr, &serialization_context);
  params->url.Set(url_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in RenderFrameMessageFilter.GetCookies request");
  typename decltype(params->first_party_for_cookies)::BaseType* first_party_for_cookies_ptr;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      param_first_party_for_cookies, buffer, &first_party_for_cookies_ptr, &serialization_context);
  params->first_party_for_cookies.Set(first_party_for_cookies_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->first_party_for_cookies.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null first_party_for_cookies in RenderFrameMessageFilter.GetCookies request");

  bool result = false;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderFrameMessageFilter_GetCookies_HandleSyncResponse(
          &result, param_cookies));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
  return result;
}

void RenderFrameMessageFilterProxy::GetCookies(
    int32_t in_render_frame_id, const GURL& in_url, const GURL& in_first_party_for_cookies, GetCookiesCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderFrameMessageFilter_GetCookies_Params_Data);
  size += mojo::internal::PrepareToSerialize<::url::mojom::UrlDataView>(
      in_url, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::url::mojom::UrlDataView>(
      in_first_party_for_cookies, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderFrameMessageFilter_GetCookies_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderFrameMessageFilter_GetCookies_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->render_frame_id = in_render_frame_id;
  typename decltype(params->url)::BaseType* url_ptr;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_ptr, &serialization_context);
  params->url.Set(url_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in RenderFrameMessageFilter.GetCookies request");
  typename decltype(params->first_party_for_cookies)::BaseType* first_party_for_cookies_ptr;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_first_party_for_cookies, buffer, &first_party_for_cookies_ptr, &serialization_context);
  params->first_party_for_cookies.Set(first_party_for_cookies_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->first_party_for_cookies.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null first_party_for_cookies in RenderFrameMessageFilter.GetCookies request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderFrameMessageFilter_GetCookies_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class RenderFrameMessageFilter_GetCookies_ProxyToResponder {
 public:
  static RenderFrameMessageFilter::GetCookiesCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<RenderFrameMessageFilter_GetCookies_ProxyToResponder> proxy(
        new RenderFrameMessageFilter_GetCookies_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&RenderFrameMessageFilter_GetCookies_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~RenderFrameMessageFilter_GetCookies_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "RenderFrameMessageFilter::GetCookies() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  RenderFrameMessageFilter_GetCookies_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      const std::string& in_cookies);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(RenderFrameMessageFilter_GetCookies_ProxyToResponder);
};

bool RenderFrameMessageFilter_GetCookies_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data* params =
      reinterpret_cast<
          internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::string p_cookies{};
  RenderFrameMessageFilter_GetCookies_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadCookies(&p_cookies))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderFrameMessageFilter::GetCookies response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_cookies));
  return true;
}

void RenderFrameMessageFilter_GetCookies_ProxyToResponder::Run(
    const std::string& in_cookies) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_cookies, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderFrameMessageFilter_GetCookies_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->cookies)::BaseType* cookies_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_cookies, buffer, &cookies_ptr, &serialization_context);
  params->cookies.Set(cookies_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->cookies.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null cookies in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
bool RenderFrameMessageFilter_GetCookies_HandleSyncResponse::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data* params =
      reinterpret_cast<internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data*>(
          message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::string p_cookies{};
  RenderFrameMessageFilter_GetCookies_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadCookies(&p_cookies))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderFrameMessageFilter::GetCookies response deserializer");
    return false;
  }
  *out_cookies_ = std::move(p_cookies);
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}

// static
bool RenderFrameMessageFilterStubDispatch::Accept(
    RenderFrameMessageFilter* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kRenderFrameMessageFilter_SetCookie_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::RenderFrameMessageFilter_SetCookie_Params_Data* params =
          reinterpret_cast<internal::RenderFrameMessageFilter_SetCookie_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_render_frame_id{};
      GURL p_url{};
      GURL p_first_party_for_cookies{};
      std::string p_cookie{};
      RenderFrameMessageFilter_SetCookie_ParamsDataView input_data_view(params, &serialization_context);
      
      p_render_frame_id = input_data_view.render_frame_id();
      if (!input_data_view.ReadUrl(&p_url))
        success = false;
      if (!input_data_view.ReadFirstPartyForCookies(&p_first_party_for_cookies))
        success = false;
      if (!input_data_view.ReadCookie(&p_cookie))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "RenderFrameMessageFilter::SetCookie deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetCookie(
std::move(p_render_frame_id), 
std::move(p_url), 
std::move(p_first_party_for_cookies), 
std::move(p_cookie));
      return true;
    }
    case internal::kRenderFrameMessageFilter_GetCookies_Name: {
      break;
    }
  }
  return false;
}

// static
bool RenderFrameMessageFilterStubDispatch::AcceptWithResponder(
    RenderFrameMessageFilter* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kRenderFrameMessageFilter_SetCookie_Name: {
      break;
    }
    case internal::kRenderFrameMessageFilter_GetCookies_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::RenderFrameMessageFilter_GetCookies_Params_Data* params =
          reinterpret_cast<
              internal::RenderFrameMessageFilter_GetCookies_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_render_frame_id{};
      GURL p_url{};
      GURL p_first_party_for_cookies{};
      RenderFrameMessageFilter_GetCookies_ParamsDataView input_data_view(params, &serialization_context);
      
      p_render_frame_id = input_data_view.render_frame_id();
      if (!input_data_view.ReadUrl(&p_url))
        success = false;
      if (!input_data_view.ReadFirstPartyForCookies(&p_first_party_for_cookies))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "RenderFrameMessageFilter::GetCookies deserializer");
        return false;
      }
      RenderFrameMessageFilter::GetCookiesCallback callback =
          RenderFrameMessageFilter_GetCookies_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetCookies(
std::move(p_render_frame_id), 
std::move(p_url), 
std::move(p_first_party_for_cookies), std::move(callback));
      return true;
    }
  }
  return false;
}

bool RenderFrameMessageFilterRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "RenderFrameMessageFilter RequestValidator");

  switch (message->header()->name) {
    case internal::kRenderFrameMessageFilter_SetCookie_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderFrameMessageFilter_SetCookie_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kRenderFrameMessageFilter_GetCookies_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderFrameMessageFilter_GetCookies_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool RenderFrameMessageFilterResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "RenderFrameMessageFilter ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kRenderFrameMessageFilter_GetCookies_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif