// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDER_MESSAGE_FILTER_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_RENDER_MESSAGE_FILTER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "cc/ipc/shared_bitmap_allocation_notifier.mojom-shared-internal.h"
#include "content/common/input/input_handler.mojom-shared-internal.h"
#include "content/common/native_types.mojom-shared-internal.h"
#include "content/common/widget.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kRenderMessageFilter_GenerateRoutingID_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT RenderMessageFilter_GenerateRoutingID_Params_Data {
 public:
  static RenderMessageFilter_GenerateRoutingID_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  RenderMessageFilter_GenerateRoutingID_Params_Data();
  ~RenderMessageFilter_GenerateRoutingID_Params_Data() = delete;
};
static_assert(sizeof(RenderMessageFilter_GenerateRoutingID_Params_Data) == 8,
              "Bad sizeof(RenderMessageFilter_GenerateRoutingID_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT RenderMessageFilter_GenerateRoutingID_ResponseParams_Data {
 public:
  static RenderMessageFilter_GenerateRoutingID_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t routing_id;
  uint8_t padfinal_[4];

 private:
  RenderMessageFilter_GenerateRoutingID_ResponseParams_Data();
  ~RenderMessageFilter_GenerateRoutingID_ResponseParams_Data() = delete;
};
static_assert(sizeof(RenderMessageFilter_GenerateRoutingID_ResponseParams_Data) == 16,
              "Bad sizeof(RenderMessageFilter_GenerateRoutingID_ResponseParams_Data)");
constexpr uint32_t kRenderMessageFilter_CreateNewWidget_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT RenderMessageFilter_CreateNewWidget_Params_Data {
 public:
  static RenderMessageFilter_CreateNewWidget_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t opener_id;
  int32_t popup_type;
  mojo::internal::Interface_Data widget;

 private:
  RenderMessageFilter_CreateNewWidget_Params_Data();
  ~RenderMessageFilter_CreateNewWidget_Params_Data() = delete;
};
static_assert(sizeof(RenderMessageFilter_CreateNewWidget_Params_Data) == 24,
              "Bad sizeof(RenderMessageFilter_CreateNewWidget_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT RenderMessageFilter_CreateNewWidget_ResponseParams_Data {
 public:
  static RenderMessageFilter_CreateNewWidget_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t route_id;
  uint8_t padfinal_[4];

 private:
  RenderMessageFilter_CreateNewWidget_ResponseParams_Data();
  ~RenderMessageFilter_CreateNewWidget_ResponseParams_Data() = delete;
};
static_assert(sizeof(RenderMessageFilter_CreateNewWidget_ResponseParams_Data) == 16,
              "Bad sizeof(RenderMessageFilter_CreateNewWidget_ResponseParams_Data)");
constexpr uint32_t kRenderMessageFilter_CreateFullscreenWidget_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT RenderMessageFilter_CreateFullscreenWidget_Params_Data {
 public:
  static RenderMessageFilter_CreateFullscreenWidget_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t opener_id;
  mojo::internal::Interface_Data widget;
  uint8_t padfinal_[4];

 private:
  RenderMessageFilter_CreateFullscreenWidget_Params_Data();
  ~RenderMessageFilter_CreateFullscreenWidget_Params_Data() = delete;
};
static_assert(sizeof(RenderMessageFilter_CreateFullscreenWidget_Params_Data) == 24,
              "Bad sizeof(RenderMessageFilter_CreateFullscreenWidget_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data {
 public:
  static RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t route_id;
  uint8_t padfinal_[4];

 private:
  RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data();
  ~RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data() = delete;
};
static_assert(sizeof(RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data) == 16,
              "Bad sizeof(RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_RENDER_MESSAGE_FILTER_MOJOM_SHARED_INTERNAL_H_