// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_SERVICE_WORKER_EMBEDDED_WORKER_MOJOM_SHARED_H_
#define CONTENT_COMMON_SERVICE_WORKER_EMBEDDED_WORKER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "content/common/service_worker/embedded_worker.mojom-shared-internal.h"
#include "content/common/service_worker/service_worker_event_dispatcher.mojom-shared.h"
#include "content/common/service_worker/service_worker_installed_scripts_manager.mojom-shared.h"
#include "mojo/common/string16.mojom-shared.h"
#include "mojo/common/time.mojom-shared.h"
#include "services/service_manager/public/interfaces/interface_provider.mojom-shared.h"
#include "third_party/WebKit/public/web/console_message.mojom-shared.h"
#include "url/mojo/url.mojom-shared.h"
#include "content/common/mojo_bindings_shared_export.h"


namespace content {
namespace mojom {
using EmbeddedWorkerStartParamsDataView = mojo::NativeStructDataView;

class EmbeddedWorkerStartTimingDataView;



}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::content::mojom::EmbeddedWorkerStartTimingDataView> {
  using Data = ::content::mojom::internal::EmbeddedWorkerStartTiming_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {
// Interface base classes. They are used for type safety check.
class EmbeddedWorkerInstanceClientInterfaceBase {};

using EmbeddedWorkerInstanceClientPtrDataView =
    mojo::InterfacePtrDataView<EmbeddedWorkerInstanceClientInterfaceBase>;
using EmbeddedWorkerInstanceClientRequestDataView =
    mojo::InterfaceRequestDataView<EmbeddedWorkerInstanceClientInterfaceBase>;
using EmbeddedWorkerInstanceClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<EmbeddedWorkerInstanceClientInterfaceBase>;
using EmbeddedWorkerInstanceClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<EmbeddedWorkerInstanceClientInterfaceBase>;
class EmbeddedWorkerInstanceHostInterfaceBase {};

using EmbeddedWorkerInstanceHostPtrDataView =
    mojo::InterfacePtrDataView<EmbeddedWorkerInstanceHostInterfaceBase>;
using EmbeddedWorkerInstanceHostRequestDataView =
    mojo::InterfaceRequestDataView<EmbeddedWorkerInstanceHostInterfaceBase>;
using EmbeddedWorkerInstanceHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<EmbeddedWorkerInstanceHostInterfaceBase>;
using EmbeddedWorkerInstanceHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<EmbeddedWorkerInstanceHostInterfaceBase>;
class EmbeddedWorkerStartTimingDataView {
 public:
  EmbeddedWorkerStartTimingDataView() {}

  EmbeddedWorkerStartTimingDataView(
      internal::EmbeddedWorkerStartTiming_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetBlinkInitializedTimeDataView(
      ::mojo::common::mojom::TimeTicksDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBlinkInitializedTime(UserType* output) {
    auto* pointer = data_->blink_initialized_time.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::TimeTicksDataView>(
        pointer, output, context_);
  }
  inline void GetStartWorkerReceivedTimeDataView(
      ::mojo::common::mojom::TimeTicksDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStartWorkerReceivedTime(UserType* output) {
    auto* pointer = data_->start_worker_received_time.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::TimeTicksDataView>(
        pointer, output, context_);
  }
 private:
  internal::EmbeddedWorkerStartTiming_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EmbeddedWorkerInstanceClient_StartWorker_ParamsDataView {
 public:
  EmbeddedWorkerInstanceClient_StartWorker_ParamsDataView() {}

  EmbeddedWorkerInstanceClient_StartWorker_ParamsDataView(
      internal::EmbeddedWorkerInstanceClient_StartWorker_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetParamsDataView(
      EmbeddedWorkerStartParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadParams(UserType* output) {
    auto* pointer = data_->params.Get();
    return mojo::internal::Deserialize<::content::mojom::EmbeddedWorkerStartParamsDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeDispatcherRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::content::mojom::ServiceWorkerEventDispatcherRequestDataView>(
            &data_->dispatcher_request, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetInstalledScriptsInfoDataView(
      ::content::mojom::ServiceWorkerInstalledScriptsInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInstalledScriptsInfo(UserType* output) {
    auto* pointer = data_->installed_scripts_info.Get();
    return mojo::internal::Deserialize<::content::mojom::ServiceWorkerInstalledScriptsInfoDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeInstanceHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::content::mojom::EmbeddedWorkerInstanceHostAssociatedPtrInfoDataView>(
            &data_->instance_host, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::EmbeddedWorkerInstanceClient_StartWorker_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EmbeddedWorkerInstanceClient_StopWorker_ParamsDataView {
 public:
  EmbeddedWorkerInstanceClient_StopWorker_ParamsDataView() {}

  EmbeddedWorkerInstanceClient_StopWorker_ParamsDataView(
      internal::EmbeddedWorkerInstanceClient_StopWorker_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::EmbeddedWorkerInstanceClient_StopWorker_Params_Data* data_ = nullptr;
};

class EmbeddedWorkerInstanceClient_ResumeAfterDownload_ParamsDataView {
 public:
  EmbeddedWorkerInstanceClient_ResumeAfterDownload_ParamsDataView() {}

  EmbeddedWorkerInstanceClient_ResumeAfterDownload_ParamsDataView(
      internal::EmbeddedWorkerInstanceClient_ResumeAfterDownload_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::EmbeddedWorkerInstanceClient_ResumeAfterDownload_Params_Data* data_ = nullptr;
};

class EmbeddedWorkerInstanceClient_AddMessageToConsole_ParamsDataView {
 public:
  EmbeddedWorkerInstanceClient_AddMessageToConsole_ParamsDataView() {}

  EmbeddedWorkerInstanceClient_AddMessageToConsole_ParamsDataView(
      internal::EmbeddedWorkerInstanceClient_AddMessageToConsole_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLevel(UserType* output) const {
    auto data_value = data_->level;
    return mojo::internal::Deserialize<::blink::mojom::ConsoleMessageLevel>(
        data_value, output);
  }

  ::blink::mojom::ConsoleMessageLevel level() const {
    return static_cast<::blink::mojom::ConsoleMessageLevel>(data_->level);
  }
  inline void GetMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::EmbeddedWorkerInstanceClient_AddMessageToConsole_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnReadyForInspection_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnReadyForInspection_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnReadyForInspection_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnReadyForInspection_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::EmbeddedWorkerInstanceHost_OnReadyForInspection_Params_Data* data_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnScriptLoaded_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnScriptLoaded_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnScriptLoaded_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnScriptLoaded_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::EmbeddedWorkerInstanceHost_OnScriptLoaded_Params_Data* data_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnScriptLoadFailed_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnScriptLoadFailed_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnScriptLoadFailed_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnScriptLoadFailed_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::EmbeddedWorkerInstanceHost_OnScriptLoadFailed_Params_Data* data_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnThreadStarted_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnThreadStarted_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnThreadStarted_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnThreadStarted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t thread_id() const {
    return data_->thread_id;
  }
  int32_t provider_id() const {
    return data_->provider_id;
  }
 private:
  internal::EmbeddedWorkerInstanceHost_OnThreadStarted_Params_Data* data_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnScriptEvaluated_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnScriptEvaluated_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnScriptEvaluated_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnScriptEvaluated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::EmbeddedWorkerInstanceHost_OnScriptEvaluated_Params_Data* data_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnStarted_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnStarted_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnStarted_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnStarted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetStartTimingDataView(
      EmbeddedWorkerStartTimingDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStartTiming(UserType* output) {
    auto* pointer = data_->start_timing.Get();
    return mojo::internal::Deserialize<::content::mojom::EmbeddedWorkerStartTimingDataView>(
        pointer, output, context_);
  }
 private:
  internal::EmbeddedWorkerInstanceHost_OnStarted_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnReportException_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnReportException_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnReportException_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnReportException_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetErrorMessageDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadErrorMessage(UserType* output) {
    auto* pointer = data_->error_message.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
  int32_t line_number() const {
    return data_->line_number;
  }
  int32_t column_number() const {
    return data_->column_number;
  }
  inline void GetSourceUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceUrl(UserType* output) {
    auto* pointer = data_->source_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::EmbeddedWorkerInstanceHost_OnReportException_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnReportConsoleMessage_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnReportConsoleMessage_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnReportConsoleMessage_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnReportConsoleMessage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t source_identifier() const {
    return data_->source_identifier;
  }
  int32_t message_level() const {
    return data_->message_level;
  }
  inline void GetMessageDataView(
      ::mojo::common::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::String16DataView>(
        pointer, output, context_);
  }
  int32_t line_number() const {
    return data_->line_number;
  }
  inline void GetSourceUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSourceUrl(UserType* output) {
    auto* pointer = data_->source_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::EmbeddedWorkerInstanceHost_OnReportConsoleMessage_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class EmbeddedWorkerInstanceHost_OnStopped_ParamsDataView {
 public:
  EmbeddedWorkerInstanceHost_OnStopped_ParamsDataView() {}

  EmbeddedWorkerInstanceHost_OnStopped_ParamsDataView(
      internal::EmbeddedWorkerInstanceHost_OnStopped_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::EmbeddedWorkerInstanceHost_OnStopped_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::content::mojom::EmbeddedWorkerStartTimingDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::content::mojom::EmbeddedWorkerStartTimingDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::content::mojom::internal::EmbeddedWorkerStartTiming_Data);
    decltype(CallWithContext(Traits::blink_initialized_time, input, custom_context)) in_blink_initialized_time = CallWithContext(Traits::blink_initialized_time, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeTicksDataView>(
        in_blink_initialized_time, context);
    decltype(CallWithContext(Traits::start_worker_received_time, input, custom_context)) in_start_worker_received_time = CallWithContext(Traits::start_worker_received_time, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeTicksDataView>(
        in_start_worker_received_time, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::content::mojom::internal::EmbeddedWorkerStartTiming_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::content::mojom::internal::EmbeddedWorkerStartTiming_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    decltype(CallWithContext(Traits::blink_initialized_time, input, custom_context)) in_blink_initialized_time = CallWithContext(Traits::blink_initialized_time, input, custom_context);
    typename decltype(result->blink_initialized_time)::BaseType* blink_initialized_time_ptr;
    mojo::internal::Serialize<::mojo::common::mojom::TimeTicksDataView>(
        in_blink_initialized_time, buffer, &blink_initialized_time_ptr, context);
    result->blink_initialized_time.Set(blink_initialized_time_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->blink_initialized_time.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null blink_initialized_time in EmbeddedWorkerStartTiming struct");
    decltype(CallWithContext(Traits::start_worker_received_time, input, custom_context)) in_start_worker_received_time = CallWithContext(Traits::start_worker_received_time, input, custom_context);
    typename decltype(result->start_worker_received_time)::BaseType* start_worker_received_time_ptr;
    mojo::internal::Serialize<::mojo::common::mojom::TimeTicksDataView>(
        in_start_worker_received_time, buffer, &start_worker_received_time_ptr, context);
    result->start_worker_received_time.Set(start_worker_received_time_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->start_worker_received_time.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null start_worker_received_time in EmbeddedWorkerStartTiming struct");
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::content::mojom::internal::EmbeddedWorkerStartTiming_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::content::mojom::EmbeddedWorkerStartTimingDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace content {
namespace mojom {

inline void EmbeddedWorkerStartTimingDataView::GetBlinkInitializedTimeDataView(
    ::mojo::common::mojom::TimeTicksDataView* output) {
  auto pointer = data_->blink_initialized_time.Get();
  *output = ::mojo::common::mojom::TimeTicksDataView(pointer, context_);
}
inline void EmbeddedWorkerStartTimingDataView::GetStartWorkerReceivedTimeDataView(
    ::mojo::common::mojom::TimeTicksDataView* output) {
  auto pointer = data_->start_worker_received_time.Get();
  *output = ::mojo::common::mojom::TimeTicksDataView(pointer, context_);
}


inline void EmbeddedWorkerInstanceClient_StartWorker_ParamsDataView::GetParamsDataView(
    EmbeddedWorkerStartParamsDataView* output) {
  auto pointer = data_->params.Get();
  *output = EmbeddedWorkerStartParamsDataView(pointer, context_);
}
inline void EmbeddedWorkerInstanceClient_StartWorker_ParamsDataView::GetInstalledScriptsInfoDataView(
    ::content::mojom::ServiceWorkerInstalledScriptsInfoDataView* output) {
  auto pointer = data_->installed_scripts_info.Get();
  *output = ::content::mojom::ServiceWorkerInstalledScriptsInfoDataView(pointer, context_);
}






inline void EmbeddedWorkerInstanceClient_AddMessageToConsole_ParamsDataView::GetMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->message.Get();
  *output = mojo::StringDataView(pointer, context_);
}












inline void EmbeddedWorkerInstanceHost_OnStarted_ParamsDataView::GetStartTimingDataView(
    EmbeddedWorkerStartTimingDataView* output) {
  auto pointer = data_->start_timing.Get();
  *output = EmbeddedWorkerStartTimingDataView(pointer, context_);
}


inline void EmbeddedWorkerInstanceHost_OnReportException_ParamsDataView::GetErrorMessageDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->error_message.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}
inline void EmbeddedWorkerInstanceHost_OnReportException_ParamsDataView::GetSourceUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->source_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void EmbeddedWorkerInstanceHost_OnReportConsoleMessage_ParamsDataView::GetMessageDataView(
    ::mojo::common::mojom::String16DataView* output) {
  auto pointer = data_->message.Get();
  *output = ::mojo::common::mojom::String16DataView(pointer, context_);
}
inline void EmbeddedWorkerInstanceHost_OnReportConsoleMessage_ParamsDataView::GetSourceUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->source_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_SERVICE_WORKER_EMBEDDED_WORKER_MOJOM_SHARED_H_
