// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/service_worker/service_worker_event_dispatcher.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "content/common/background_fetch/background_fetch_struct_traits.h"
#include "content/common/platform_notification_messages.h"
#include "content/common/service_worker/service_worker_fetch_request_struct_traits.h"
#include "content/common/service_worker/service_worker_messages.h"
#include "content/common/service_worker/service_worker_status_code_traits.h"
#include "content/public/common/referrer_struct_traits.h"
#include "ipc/ipc_message_utils.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "third_party/WebKit/public/platform/ReferrerPolicyEnumTraits.h"
#include "url/mojo/origin_struct_traits.h"
#include "url/mojo/url_gurl_struct_traits.h"
namespace content {
namespace mojom {
BackgroundFetchSettledFetch::BackgroundFetchSettledFetch()
    : request(),
      response() {}

BackgroundFetchSettledFetch::BackgroundFetchSettledFetch(
    const ::content::ServiceWorkerFetchRequest& request_in,
    const ::content::ServiceWorkerResponse& response_in)
    : request(std::move(request_in)),
      response(std::move(response_in)) {}

BackgroundFetchSettledFetch::~BackgroundFetchSettledFetch() = default;

bool BackgroundFetchSettledFetch::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
FetchEventPreloadHandle::FetchEventPreloadHandle()
    : url_loader(),
      url_loader_client_request() {}

FetchEventPreloadHandle::FetchEventPreloadHandle(
    ::content::mojom::URLLoaderPtr url_loader_in,
    ::content::mojom::URLLoaderClientRequest url_loader_client_request_in)
    : url_loader(std::move(url_loader_in)),
      url_loader_client_request(std::move(url_loader_client_request_in)) {}

FetchEventPreloadHandle::~FetchEventPreloadHandle() = default;

bool FetchEventPreloadHandle::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ExtendableMessageEvent::ExtendableMessageEvent()
    : message(),
      source_origin(),
      message_ports(),
      source() {}

ExtendableMessageEvent::ExtendableMessageEvent(
    const base::string16& message_in,
    const url::Origin& source_origin_in,
    std::vector<mojo::ScopedMessagePipeHandle> message_ports_in,
    const ::content::ExtendableMessageEventSource& source_in)
    : message(std::move(message_in)),
      source_origin(std::move(source_origin_in)),
      message_ports(std::move(message_ports_in)),
      source(std::move(source_in)) {}

ExtendableMessageEvent::~ExtendableMessageEvent() = default;

bool ExtendableMessageEvent::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char ServiceWorkerFetchResponseCallback::Name_[] = "content::mojom::ServiceWorkerFetchResponseCallback";

ServiceWorkerFetchResponseCallbackProxy::ServiceWorkerFetchResponseCallbackProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ServiceWorkerFetchResponseCallbackProxy::OnResponse(
    const ::content::ServiceWorkerResponse& in_response, base::Time in_dispatch_event_time) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerFetchResponseCallback_OnResponse_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ServiceWorkerResponseDataView>(
      in_response, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerFetchResponseCallback_OnResponse_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerFetchResponseCallback_OnResponse_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->response)::BaseType* response_ptr;
  mojo::internal::Serialize<::content::mojom::ServiceWorkerResponseDataView>(
      in_response, buffer, &response_ptr, &serialization_context);
  params->response.Set(response_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->response.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null response in ServiceWorkerFetchResponseCallback.OnResponse request");
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ServiceWorkerFetchResponseCallback.OnResponse request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ServiceWorkerFetchResponseCallbackProxy::OnResponseStream(
    const ::content::ServiceWorkerResponse& in_response, ::blink::mojom::ServiceWorkerStreamHandlePtr in_body_as_stream, base::Time in_dispatch_event_time) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ServiceWorkerResponseDataView>(
      in_response, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::blink::mojom::ServiceWorkerStreamHandleDataView>(
      in_body_as_stream, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerFetchResponseCallback_OnResponseStream_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->response)::BaseType* response_ptr;
  mojo::internal::Serialize<::content::mojom::ServiceWorkerResponseDataView>(
      in_response, buffer, &response_ptr, &serialization_context);
  params->response.Set(response_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->response.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null response in ServiceWorkerFetchResponseCallback.OnResponseStream request");
  typename decltype(params->body_as_stream)::BaseType* body_as_stream_ptr;
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerStreamHandleDataView>(
      in_body_as_stream, buffer, &body_as_stream_ptr, &serialization_context);
  params->body_as_stream.Set(body_as_stream_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->body_as_stream.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null body_as_stream in ServiceWorkerFetchResponseCallback.OnResponseStream request");
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ServiceWorkerFetchResponseCallback.OnResponseStream request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ServiceWorkerFetchResponseCallbackProxy::OnFallback(
    base::Time in_dispatch_event_time) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerFetchResponseCallback_OnFallback_Params_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerFetchResponseCallback_OnFallback_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerFetchResponseCallback_OnFallback_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ServiceWorkerFetchResponseCallback.OnFallback request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ServiceWorkerFetchResponseCallbackStubDispatch::Accept(
    ServiceWorkerFetchResponseCallback* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kServiceWorkerFetchResponseCallback_OnResponse_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceWorkerFetchResponseCallback_OnResponse_Params_Data* params =
          reinterpret_cast<internal::ServiceWorkerFetchResponseCallback_OnResponse_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::content::ServiceWorkerResponse p_response{};
      base::Time p_dispatch_event_time{};
      ServiceWorkerFetchResponseCallback_OnResponse_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadResponse(&p_response))
        success = false;
      if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerFetchResponseCallback::OnResponse deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnResponse(
std::move(p_response), 
std::move(p_dispatch_event_time));
      return true;
    }
    case internal::kServiceWorkerFetchResponseCallback_OnResponseStream_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data* params =
          reinterpret_cast<internal::ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::content::ServiceWorkerResponse p_response{};
      ::blink::mojom::ServiceWorkerStreamHandlePtr p_body_as_stream{};
      base::Time p_dispatch_event_time{};
      ServiceWorkerFetchResponseCallback_OnResponseStream_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadResponse(&p_response))
        success = false;
      if (!input_data_view.ReadBodyAsStream(&p_body_as_stream))
        success = false;
      if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerFetchResponseCallback::OnResponseStream deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnResponseStream(
std::move(p_response), 
std::move(p_body_as_stream), 
std::move(p_dispatch_event_time));
      return true;
    }
    case internal::kServiceWorkerFetchResponseCallback_OnFallback_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceWorkerFetchResponseCallback_OnFallback_Params_Data* params =
          reinterpret_cast<internal::ServiceWorkerFetchResponseCallback_OnFallback_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      base::Time p_dispatch_event_time{};
      ServiceWorkerFetchResponseCallback_OnFallback_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerFetchResponseCallback::OnFallback deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnFallback(
std::move(p_dispatch_event_time));
      return true;
    }
  }
  return false;
}

// static
bool ServiceWorkerFetchResponseCallbackStubDispatch::AcceptWithResponder(
    ServiceWorkerFetchResponseCallback* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kServiceWorkerFetchResponseCallback_OnResponse_Name: {
      break;
    }
    case internal::kServiceWorkerFetchResponseCallback_OnResponseStream_Name: {
      break;
    }
    case internal::kServiceWorkerFetchResponseCallback_OnFallback_Name: {
      break;
    }
  }
  return false;
}

bool ServiceWorkerFetchResponseCallbackRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceWorkerFetchResponseCallback RequestValidator");

  switch (message->header()->name) {
    case internal::kServiceWorkerFetchResponseCallback_OnResponse_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerFetchResponseCallback_OnResponse_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerFetchResponseCallback_OnResponseStream_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerFetchResponseCallback_OnFallback_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerFetchResponseCallback_OnFallback_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char ServiceWorkerEventDispatcher::Name_[] = "content::mojom::ServiceWorkerEventDispatcher";

class ServiceWorkerEventDispatcher_DispatchInstallEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchInstallEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchInstallEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchInstallEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchInstallEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchActivateEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchActivateEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchActivateEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchActivateEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchActivateEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchAbortEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchBackgroundFetchAbortEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchClickEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchBackgroundFetchClickEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchFailEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchBackgroundFetchFailEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchedEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchBackgroundFetchedEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchFetchEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchFetchEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchFetchEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchFetchEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchFetchEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchNotificationClickEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchNotificationClickEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchNotificationCloseEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchNotificationCloseEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchPushEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchPushEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchPushEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchPushEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchPushEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchSyncEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchSyncEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchSyncEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchSyncEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchSyncEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchPaymentRequestEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchPaymentRequestEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ForwardToCallback(
      ServiceWorkerEventDispatcher::DispatchExtendableMessageEventCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::DispatchExtendableMessageEventCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ForwardToCallback);
};

class ServiceWorkerEventDispatcher_Ping_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceWorkerEventDispatcher_Ping_ForwardToCallback(
      ServiceWorkerEventDispatcher::PingCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceWorkerEventDispatcher::PingCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_Ping_ForwardToCallback);
};

ServiceWorkerEventDispatcherProxy::ServiceWorkerEventDispatcherProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ServiceWorkerEventDispatcherProxy::DispatchInstallEvent(
    ServiceWorkerInstallEventMethodsAssociatedPtrInfo in_method, DispatchInstallEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ServiceWorkerInstallEventMethodsAssociatedPtrInfoDataView>(
      in_method, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchInstallEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::content::mojom::ServiceWorkerInstallEventMethodsAssociatedPtrInfoDataView>(
      in_method, &params->method, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->method),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid method in ServiceWorkerEventDispatcher.DispatchInstallEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchInstallEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchActivateEvent(
    DispatchActivateEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchActivateEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchActivateEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchBackgroundFetchAbortEvent(
    const std::string& in_tag, DispatchBackgroundFetchAbortEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_tag, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->tag)::BaseType* tag_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_tag, buffer, &tag_ptr, &serialization_context);
  params->tag.Set(tag_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tag.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tag in ServiceWorkerEventDispatcher.DispatchBackgroundFetchAbortEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchBackgroundFetchClickEvent(
    const std::string& in_tag, BackgroundFetchState in_state, DispatchBackgroundFetchClickEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_tag, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->tag)::BaseType* tag_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_tag, buffer, &tag_ptr, &serialization_context);
  params->tag.Set(tag_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tag.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tag in ServiceWorkerEventDispatcher.DispatchBackgroundFetchClickEvent request");
  mojo::internal::Serialize<::content::mojom::BackgroundFetchState>(
      in_state, &params->state);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchBackgroundFetchFailEvent(
    const std::string& in_tag, const std::vector<::content::BackgroundFetchSettledFetch>& in_fetches, DispatchBackgroundFetchFailEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_tag, &serialization_context);
  size += mojo::internal::PrepareToSerialize<mojo::ArrayDataView<::content::mojom::BackgroundFetchSettledFetchDataView>>(
      in_fetches, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->tag)::BaseType* tag_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_tag, buffer, &tag_ptr, &serialization_context);
  params->tag.Set(tag_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tag.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tag in ServiceWorkerEventDispatcher.DispatchBackgroundFetchFailEvent request");
  typename decltype(params->fetches)::BaseType* fetches_ptr;
  const mojo::internal::ContainerValidateParams fetches_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::content::mojom::BackgroundFetchSettledFetchDataView>>(
      in_fetches, buffer, &fetches_ptr, &fetches_validate_params,
      &serialization_context);
  params->fetches.Set(fetches_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->fetches.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null fetches in ServiceWorkerEventDispatcher.DispatchBackgroundFetchFailEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchBackgroundFetchedEvent(
    const std::string& in_tag, const std::vector<::content::BackgroundFetchSettledFetch>& in_fetches, DispatchBackgroundFetchedEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_tag, &serialization_context);
  size += mojo::internal::PrepareToSerialize<mojo::ArrayDataView<::content::mojom::BackgroundFetchSettledFetchDataView>>(
      in_fetches, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->tag)::BaseType* tag_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_tag, buffer, &tag_ptr, &serialization_context);
  params->tag.Set(tag_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tag.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tag in ServiceWorkerEventDispatcher.DispatchBackgroundFetchedEvent request");
  typename decltype(params->fetches)::BaseType* fetches_ptr;
  const mojo::internal::ContainerValidateParams fetches_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::content::mojom::BackgroundFetchSettledFetchDataView>>(
      in_fetches, buffer, &fetches_ptr, &fetches_validate_params,
      &serialization_context);
  params->fetches.Set(fetches_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->fetches.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null fetches in ServiceWorkerEventDispatcher.DispatchBackgroundFetchedEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchFetchEvent(
    int32_t in_fetch_event_id, const ::content::ServiceWorkerFetchRequest& in_request, FetchEventPreloadHandlePtr in_preload_handle, ServiceWorkerFetchResponseCallbackPtr in_response_callback, DispatchFetchEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::blink::mojom::FetchAPIRequestDataView>(
      in_request, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::FetchEventPreloadHandleDataView>(
      in_preload_handle, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ServiceWorkerFetchResponseCallbackPtrDataView>(
      in_response_callback, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchFetchEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->fetch_event_id = in_fetch_event_id;
  typename decltype(params->request)::BaseType* request_ptr;
  mojo::internal::Serialize<::blink::mojom::FetchAPIRequestDataView>(
      in_request, buffer, &request_ptr, &serialization_context);
  params->request.Set(request_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->request.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null request in ServiceWorkerEventDispatcher.DispatchFetchEvent request");
  typename decltype(params->preload_handle)::BaseType* preload_handle_ptr;
  mojo::internal::Serialize<::content::mojom::FetchEventPreloadHandleDataView>(
      in_preload_handle, buffer, &preload_handle_ptr, &serialization_context);
  params->preload_handle.Set(preload_handle_ptr);
  mojo::internal::Serialize<::content::mojom::ServiceWorkerFetchResponseCallbackPtrDataView>(
      in_response_callback, &params->response_callback, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->response_callback),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid response_callback in ServiceWorkerEventDispatcher.DispatchFetchEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchFetchEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchNotificationClickEvent(
    const std::string& in_notification_id, const ::content::PlatformNotificationData& in_notification_data, int32_t in_action_index, const base::Optional<base::string16>& in_reply, DispatchNotificationClickEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_notification_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::PlatformNotificationDataDataView>(
      in_notification_data, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::String16DataView>(
      in_reply, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->notification_id)::BaseType* notification_id_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_notification_id, buffer, &notification_id_ptr, &serialization_context);
  params->notification_id.Set(notification_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->notification_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null notification_id in ServiceWorkerEventDispatcher.DispatchNotificationClickEvent request");
  typename decltype(params->notification_data)::BaseType* notification_data_ptr;
  mojo::internal::Serialize<::content::mojom::PlatformNotificationDataDataView>(
      in_notification_data, buffer, &notification_data_ptr, &serialization_context);
  params->notification_data.Set(notification_data_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->notification_data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null notification_data in ServiceWorkerEventDispatcher.DispatchNotificationClickEvent request");
  params->action_index = in_action_index;
  typename decltype(params->reply)::BaseType* reply_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::String16DataView>(
      in_reply, buffer, &reply_ptr, &serialization_context);
  params->reply.Set(reply_ptr);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchNotificationCloseEvent(
    const std::string& in_notification_id, const ::content::PlatformNotificationData& in_notification_data, DispatchNotificationCloseEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_notification_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::PlatformNotificationDataDataView>(
      in_notification_data, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->notification_id)::BaseType* notification_id_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_notification_id, buffer, &notification_id_ptr, &serialization_context);
  params->notification_id.Set(notification_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->notification_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null notification_id in ServiceWorkerEventDispatcher.DispatchNotificationCloseEvent request");
  typename decltype(params->notification_data)::BaseType* notification_data_ptr;
  mojo::internal::Serialize<::content::mojom::PlatformNotificationDataDataView>(
      in_notification_data, buffer, &notification_data_ptr, &serialization_context);
  params->notification_data.Set(notification_data_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->notification_data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null notification_data in ServiceWorkerEventDispatcher.DispatchNotificationCloseEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchPushEvent(
    const ::content::PushEventPayload& in_payload, DispatchPushEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::PushEventPayloadDataView>(
      in_payload, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchPushEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->payload)::BaseType* payload_ptr;
  mojo::internal::Serialize<::content::mojom::PushEventPayloadDataView>(
      in_payload, buffer, &payload_ptr, &serialization_context);
  params->payload.Set(payload_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->payload.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null payload in ServiceWorkerEventDispatcher.DispatchPushEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchPushEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchSyncEvent(
    const std::string& in_tag, ::blink::mojom::BackgroundSyncEventLastChance in_last_chance, DispatchSyncEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_tag, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchSyncEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->tag)::BaseType* tag_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_tag, buffer, &tag_ptr, &serialization_context);
  params->tag.Set(tag_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tag.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tag in ServiceWorkerEventDispatcher.DispatchSyncEvent request");
  mojo::internal::Serialize<::blink::mojom::BackgroundSyncEventLastChance>(
      in_last_chance, &params->last_chance);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchSyncEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchPaymentRequestEvent(
    int32_t in_payment_request_id, ::payments::mojom::PaymentRequestEventDataPtr in_request_data, ::payments::mojom::PaymentHandlerResponseCallbackPtr in_response_callback, DispatchPaymentRequestEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::payments::mojom::PaymentRequestEventDataDataView>(
      in_request_data, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::payments::mojom::PaymentHandlerResponseCallbackPtrDataView>(
      in_response_callback, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->payment_request_id = in_payment_request_id;
  typename decltype(params->request_data)::BaseType* request_data_ptr;
  mojo::internal::Serialize<::payments::mojom::PaymentRequestEventDataDataView>(
      in_request_data, buffer, &request_data_ptr, &serialization_context);
  params->request_data.Set(request_data_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->request_data.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null request_data in ServiceWorkerEventDispatcher.DispatchPaymentRequestEvent request");
  mojo::internal::Serialize<::payments::mojom::PaymentHandlerResponseCallbackPtrDataView>(
      in_response_callback, &params->response_callback, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->response_callback),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid response_callback in ServiceWorkerEventDispatcher.DispatchPaymentRequestEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::DispatchExtendableMessageEvent(
    ExtendableMessageEventPtr in_event, DispatchExtendableMessageEventCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ExtendableMessageEventDataView>(
      in_event, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->event)::BaseType* event_ptr;
  mojo::internal::Serialize<::content::mojom::ExtendableMessageEventDataView>(
      in_event, buffer, &event_ptr, &serialization_context);
  params->event.Set(event_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->event.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null event in ServiceWorkerEventDispatcher.DispatchExtendableMessageEvent request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceWorkerEventDispatcherProxy::Ping(
    PingCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_Ping_Params_Data);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_Ping_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_Ping_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceWorkerEventDispatcher_Ping_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchInstallEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchInstallEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, bool in_has_fetch_handler, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchInstallEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  bool p_has_fetch_handler{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  p_has_fetch_handler = input_data_view.has_fetch_handler();
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchInstallEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_has_fetch_handler), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, bool in_has_fetch_handler, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchInstallEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  params->has_fetch_handler = in_has_fetch_handler;
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchActivateEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchActivateEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchActivateEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchActivateEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchActivateEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchBackgroundFetchAbortEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchBackgroundFetchAbortEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchBackgroundFetchAbortEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchBackgroundFetchClickEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchBackgroundFetchClickEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchBackgroundFetchClickEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchBackgroundFetchFailEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchBackgroundFetchFailEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchBackgroundFetchFailEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchBackgroundFetchedEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchBackgroundFetchedEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchBackgroundFetchedEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchFetchEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchFetchEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchFetchEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchFetchEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchFetchEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchNotificationClickEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchNotificationClickEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchNotificationClickEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchNotificationCloseEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchNotificationCloseEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchNotificationCloseEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchPushEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchPushEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchPushEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchPushEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchPushEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchSyncEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchSyncEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchSyncEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchSyncEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchSyncEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchPaymentRequestEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchPaymentRequestEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchPaymentRequestEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::DispatchExtendableMessageEventCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::DispatchExtendableMessageEvent() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::content::ServiceWorkerStatusCode p_status{};
  base::Time p_dispatch_event_time{};
  ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadDispatchEventTime(&p_dispatch_event_time))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::DispatchExtendableMessageEvent response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_dispatch_event_time));
  return true;
}

void ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder::Run(
    ::content::ServiceWorkerStatusCode in_status, base::Time in_dispatch_event_time) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::blink::mojom::ServiceWorkerEventStatus>(
      in_status, &params->status);
  typename decltype(params->dispatch_event_time)::BaseType* dispatch_event_time_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeDataView>(
      in_dispatch_event_time, buffer, &dispatch_event_time_ptr, &serialization_context);
  params->dispatch_event_time.Set(dispatch_event_time_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->dispatch_event_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null dispatch_event_time in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class ServiceWorkerEventDispatcher_Ping_ProxyToResponder {
 public:
  static ServiceWorkerEventDispatcher::PingCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceWorkerEventDispatcher_Ping_ProxyToResponder> proxy(
        new ServiceWorkerEventDispatcher_Ping_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceWorkerEventDispatcher_Ping_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceWorkerEventDispatcher_Ping_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceWorkerEventDispatcher::Ping() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceWorkerEventDispatcher_Ping_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerEventDispatcher_Ping_ProxyToResponder);
};

bool ServiceWorkerEventDispatcher_Ping_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceWorkerEventDispatcher_Ping_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceWorkerEventDispatcher_Ping_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ServiceWorkerEventDispatcher_Ping_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceWorkerEventDispatcher::Ping response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void ServiceWorkerEventDispatcher_Ping_ProxyToResponder::Run(
    ) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerEventDispatcher_Ping_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerEventDispatcher_Ping_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerEventDispatcher_Ping_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool ServiceWorkerEventDispatcherStubDispatch::Accept(
    ServiceWorkerEventDispatcher* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kServiceWorkerEventDispatcher_DispatchInstallEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchActivateEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchFetchEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPushEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchSyncEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Name: {
      break;
    }
    case internal::kServiceWorkerEventDispatcher_Ping_Name: {
      break;
    }
  }
  return false;
}

// static
bool ServiceWorkerEventDispatcherStubDispatch::AcceptWithResponder(
    ServiceWorkerEventDispatcher* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kServiceWorkerEventDispatcher_DispatchInstallEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ServiceWorkerInstallEventMethodsAssociatedPtrInfo p_method{};
      ServiceWorkerEventDispatcher_DispatchInstallEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      p_method =
          input_data_view.TakeMethod<decltype(p_method)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchInstallEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchInstallEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchInstallEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchInstallEvent(
std::move(p_method), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchActivateEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ServiceWorkerEventDispatcher_DispatchActivateEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchActivateEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchActivateEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchActivateEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchActivateEvent(std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_tag{};
      ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTag(&p_tag))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchBackgroundFetchAbortEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchAbortEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchBackgroundFetchAbortEvent(
std::move(p_tag), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_tag{};
      BackgroundFetchState p_state{};
      ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTag(&p_tag))
        success = false;
      if (!input_data_view.ReadState(&p_state))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchBackgroundFetchClickEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchClickEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchBackgroundFetchClickEvent(
std::move(p_tag), 
std::move(p_state), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_tag{};
      std::vector<::content::BackgroundFetchSettledFetch> p_fetches{};
      ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTag(&p_tag))
        success = false;
      if (!input_data_view.ReadFetches(&p_fetches))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchBackgroundFetchFailEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchFailEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchBackgroundFetchFailEvent(
std::move(p_tag), 
std::move(p_fetches), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_tag{};
      std::vector<::content::BackgroundFetchSettledFetch> p_fetches{};
      ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTag(&p_tag))
        success = false;
      if (!input_data_view.ReadFetches(&p_fetches))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchBackgroundFetchedEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchBackgroundFetchedEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchBackgroundFetchedEvent(
std::move(p_tag), 
std::move(p_fetches), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchFetchEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_fetch_event_id{};
      ::content::ServiceWorkerFetchRequest p_request{};
      FetchEventPreloadHandlePtr p_preload_handle{};
      ServiceWorkerFetchResponseCallbackPtr p_response_callback{};
      ServiceWorkerEventDispatcher_DispatchFetchEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      p_fetch_event_id = input_data_view.fetch_event_id();
      if (!input_data_view.ReadRequest(&p_request))
        success = false;
      if (!input_data_view.ReadPreloadHandle(&p_preload_handle))
        success = false;
      p_response_callback =
          input_data_view.TakeResponseCallback<decltype(p_response_callback)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchFetchEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchFetchEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchFetchEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchFetchEvent(
std::move(p_fetch_event_id), 
std::move(p_request), 
std::move(p_preload_handle), 
std::move(p_response_callback), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_notification_id{};
      ::content::PlatformNotificationData p_notification_data{};
      int32_t p_action_index{};
      base::Optional<base::string16> p_reply{};
      ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadNotificationId(&p_notification_id))
        success = false;
      if (!input_data_view.ReadNotificationData(&p_notification_data))
        success = false;
      p_action_index = input_data_view.action_index();
      if (!input_data_view.ReadReply(&p_reply))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchNotificationClickEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchNotificationClickEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchNotificationClickEvent(
std::move(p_notification_id), 
std::move(p_notification_data), 
std::move(p_action_index), 
std::move(p_reply), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_notification_id{};
      ::content::PlatformNotificationData p_notification_data{};
      ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadNotificationId(&p_notification_id))
        success = false;
      if (!input_data_view.ReadNotificationData(&p_notification_data))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchNotificationCloseEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchNotificationCloseEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchNotificationCloseEvent(
std::move(p_notification_id), 
std::move(p_notification_data), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPushEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::content::PushEventPayload p_payload{};
      ServiceWorkerEventDispatcher_DispatchPushEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadPayload(&p_payload))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchPushEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchPushEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchPushEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchPushEvent(
std::move(p_payload), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchSyncEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_tag{};
      ::blink::mojom::BackgroundSyncEventLastChance p_last_chance{};
      ServiceWorkerEventDispatcher_DispatchSyncEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTag(&p_tag))
        success = false;
      if (!input_data_view.ReadLastChance(&p_last_chance))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchSyncEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchSyncEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchSyncEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchSyncEvent(
std::move(p_tag), 
std::move(p_last_chance), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_payment_request_id{};
      ::payments::mojom::PaymentRequestEventDataPtr p_request_data{};
      ::payments::mojom::PaymentHandlerResponseCallbackPtr p_response_callback{};
      ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      p_payment_request_id = input_data_view.payment_request_id();
      if (!input_data_view.ReadRequestData(&p_request_data))
        success = false;
      p_response_callback =
          input_data_view.TakeResponseCallback<decltype(p_response_callback)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchPaymentRequestEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchPaymentRequestEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchPaymentRequestEvent(
std::move(p_payment_request_id), 
std::move(p_request_data), 
std::move(p_response_callback), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ExtendableMessageEventPtr p_event{};
      ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadEvent(&p_event))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::DispatchExtendableMessageEvent deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::DispatchExtendableMessageEventCallback callback =
          ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DispatchExtendableMessageEvent(
std::move(p_event), std::move(callback));
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_Ping_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceWorkerEventDispatcher_Ping_Params_Data* params =
          reinterpret_cast<
              internal::ServiceWorkerEventDispatcher_Ping_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ServiceWorkerEventDispatcher_Ping_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerEventDispatcher::Ping deserializer");
        return false;
      }
      ServiceWorkerEventDispatcher::PingCallback callback =
          ServiceWorkerEventDispatcher_Ping_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->Ping(std::move(callback));
      return true;
    }
  }
  return false;
}

bool ServiceWorkerEventDispatcherRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceWorkerEventDispatcher RequestValidator");

  switch (message->header()->name) {
    case internal::kServiceWorkerEventDispatcher_DispatchInstallEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchActivateEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchFetchEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPushEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchSyncEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_Ping_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_Ping_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool ServiceWorkerEventDispatcherResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceWorkerEventDispatcher ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kServiceWorkerEventDispatcher_DispatchInstallEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchActivateEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchFetchEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPushEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchSyncEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerEventDispatcher_Ping_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerEventDispatcher_Ping_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
const char ServiceWorkerInstallEventMethods::Name_[] = "content::mojom::ServiceWorkerInstallEventMethods";

ServiceWorkerInstallEventMethodsProxy::ServiceWorkerInstallEventMethodsProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ServiceWorkerInstallEventMethodsProxy::RegisterForeignFetchScopes(
    const std::vector<GURL>& in_sub_scopes, const std::vector<url::Origin>& in_origins) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::ArrayDataView<::url::mojom::UrlDataView>>(
      in_sub_scopes, &serialization_context);
  size += mojo::internal::PrepareToSerialize<mojo::ArrayDataView<::url::mojom::OriginDataView>>(
      in_origins, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->sub_scopes)::BaseType* sub_scopes_ptr;
  const mojo::internal::ContainerValidateParams sub_scopes_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::url::mojom::UrlDataView>>(
      in_sub_scopes, buffer, &sub_scopes_ptr, &sub_scopes_validate_params,
      &serialization_context);
  params->sub_scopes.Set(sub_scopes_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->sub_scopes.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null sub_scopes in ServiceWorkerInstallEventMethods.RegisterForeignFetchScopes request");
  typename decltype(params->origins)::BaseType* origins_ptr;
  const mojo::internal::ContainerValidateParams origins_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::url::mojom::OriginDataView>>(
      in_origins, buffer, &origins_ptr, &origins_validate_params,
      &serialization_context);
  params->origins.Set(origins_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->origins.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null origins in ServiceWorkerInstallEventMethods.RegisterForeignFetchScopes request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ServiceWorkerInstallEventMethodsStubDispatch::Accept(
    ServiceWorkerInstallEventMethods* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data* params =
          reinterpret_cast<internal::ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<GURL> p_sub_scopes{};
      std::vector<url::Origin> p_origins{};
      ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSubScopes(&p_sub_scopes))
        success = false;
      if (!input_data_view.ReadOrigins(&p_origins))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerInstallEventMethods::RegisterForeignFetchScopes deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RegisterForeignFetchScopes(
std::move(p_sub_scopes), 
std::move(p_origins));
      return true;
    }
  }
  return false;
}

// static
bool ServiceWorkerInstallEventMethodsStubDispatch::AcceptWithResponder(
    ServiceWorkerInstallEventMethods* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Name: {
      break;
    }
  }
  return false;
}

bool ServiceWorkerInstallEventMethodsRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceWorkerInstallEventMethods RequestValidator");

  switch (message->header()->name) {
    case internal::kServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace content

namespace mojo {


// static
bool StructTraits<::content::mojom::BackgroundFetchSettledFetch::DataView, ::content::mojom::BackgroundFetchSettledFetchPtr>::Read(
    ::content::mojom::BackgroundFetchSettledFetch::DataView input,
    ::content::mojom::BackgroundFetchSettledFetchPtr* output) {
  bool success = true;
  ::content::mojom::BackgroundFetchSettledFetchPtr result(::content::mojom::BackgroundFetchSettledFetch::New());
  
      if (!input.ReadRequest(&result->request))
        success = false;
      if (!input.ReadResponse(&result->response))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::content::mojom::FetchEventPreloadHandle::DataView, ::content::mojom::FetchEventPreloadHandlePtr>::Read(
    ::content::mojom::FetchEventPreloadHandle::DataView input,
    ::content::mojom::FetchEventPreloadHandlePtr* output) {
  bool success = true;
  ::content::mojom::FetchEventPreloadHandlePtr result(::content::mojom::FetchEventPreloadHandle::New());
  
      result->url_loader =
          input.TakeUrlLoader<decltype(result->url_loader)>();
      result->url_loader_client_request =
          input.TakeUrlLoaderClientRequest<decltype(result->url_loader_client_request)>();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::content::mojom::ExtendableMessageEvent::DataView, ::content::mojom::ExtendableMessageEventPtr>::Read(
    ::content::mojom::ExtendableMessageEvent::DataView input,
    ::content::mojom::ExtendableMessageEventPtr* output) {
  bool success = true;
  ::content::mojom::ExtendableMessageEventPtr result(::content::mojom::ExtendableMessageEvent::New());
  
      if (!input.ReadMessage(&result->message))
        success = false;
      if (!input.ReadSourceOrigin(&result->source_origin))
        success = false;
      if (!input.ReadMessagePorts(&result->message_ports))
        success = false;
      if (!input.ReadSource(&result->source))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif