// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_EVENT_DISPATCHER_MOJOM_H_
#define CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_EVENT_DISPATCHER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/common/service_worker/service_worker_event_dispatcher.mojom-shared.h"
#include "content/public/common/url_loader.mojom.h"
#include "mojo/common/string16.mojom.h"
#include "mojo/common/time.mojom.h"
#include "third_party/WebKit/public/platform/modules/background_sync/background_sync.mojom.h"
#include "third_party/WebKit/public/platform/modules/fetch/fetch_api_request.mojom.h"
#include "third_party/WebKit/public/platform/modules/payments/payment_app.mojom.h"
#include "third_party/WebKit/public/platform/modules/serviceworker/service_worker_event_status.mojom.h"
#include "third_party/WebKit/public/platform/modules/serviceworker/service_worker_stream_handle.mojom.h"
#include "url/mojo/origin.mojom.h"
#include "url/mojo/url.mojom.h"
#include <string>
#include <vector>
#include "content/common/background_fetch/background_fetch_types.h"
#include "content/common/service_worker/service_worker_client_info.h"
#include "content/common/service_worker/service_worker_status_code.h"
#include "content/common/service_worker/service_worker_types.h"
#include "content/public/common/platform_notification_data.h"
#include "content/public/common/push_event_payload.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {
class ServiceWorkerFetchResponseCallback;
using ServiceWorkerFetchResponseCallbackPtr = mojo::InterfacePtr<ServiceWorkerFetchResponseCallback>;
using ServiceWorkerFetchResponseCallbackPtrInfo = mojo::InterfacePtrInfo<ServiceWorkerFetchResponseCallback>;
using ThreadSafeServiceWorkerFetchResponseCallbackPtr =
    mojo::ThreadSafeInterfacePtr<ServiceWorkerFetchResponseCallback>;
using ServiceWorkerFetchResponseCallbackRequest = mojo::InterfaceRequest<ServiceWorkerFetchResponseCallback>;
using ServiceWorkerFetchResponseCallbackAssociatedPtr =
    mojo::AssociatedInterfacePtr<ServiceWorkerFetchResponseCallback>;
using ThreadSafeServiceWorkerFetchResponseCallbackAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<ServiceWorkerFetchResponseCallback>;
using ServiceWorkerFetchResponseCallbackAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<ServiceWorkerFetchResponseCallback>;
using ServiceWorkerFetchResponseCallbackAssociatedRequest =
    mojo::AssociatedInterfaceRequest<ServiceWorkerFetchResponseCallback>;

class ServiceWorkerEventDispatcher;
using ServiceWorkerEventDispatcherPtr = mojo::InterfacePtr<ServiceWorkerEventDispatcher>;
using ServiceWorkerEventDispatcherPtrInfo = mojo::InterfacePtrInfo<ServiceWorkerEventDispatcher>;
using ThreadSafeServiceWorkerEventDispatcherPtr =
    mojo::ThreadSafeInterfacePtr<ServiceWorkerEventDispatcher>;
using ServiceWorkerEventDispatcherRequest = mojo::InterfaceRequest<ServiceWorkerEventDispatcher>;
using ServiceWorkerEventDispatcherAssociatedPtr =
    mojo::AssociatedInterfacePtr<ServiceWorkerEventDispatcher>;
using ThreadSafeServiceWorkerEventDispatcherAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<ServiceWorkerEventDispatcher>;
using ServiceWorkerEventDispatcherAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<ServiceWorkerEventDispatcher>;
using ServiceWorkerEventDispatcherAssociatedRequest =
    mojo::AssociatedInterfaceRequest<ServiceWorkerEventDispatcher>;

class ServiceWorkerInstallEventMethods;
using ServiceWorkerInstallEventMethodsPtr = mojo::InterfacePtr<ServiceWorkerInstallEventMethods>;
using ServiceWorkerInstallEventMethodsPtrInfo = mojo::InterfacePtrInfo<ServiceWorkerInstallEventMethods>;
using ThreadSafeServiceWorkerInstallEventMethodsPtr =
    mojo::ThreadSafeInterfacePtr<ServiceWorkerInstallEventMethods>;
using ServiceWorkerInstallEventMethodsRequest = mojo::InterfaceRequest<ServiceWorkerInstallEventMethods>;
using ServiceWorkerInstallEventMethodsAssociatedPtr =
    mojo::AssociatedInterfacePtr<ServiceWorkerInstallEventMethods>;
using ThreadSafeServiceWorkerInstallEventMethodsAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<ServiceWorkerInstallEventMethods>;
using ServiceWorkerInstallEventMethodsAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<ServiceWorkerInstallEventMethods>;
using ServiceWorkerInstallEventMethodsAssociatedRequest =
    mojo::AssociatedInterfaceRequest<ServiceWorkerInstallEventMethods>;

using PlatformNotificationData = mojo::NativeStruct;
using PlatformNotificationDataPtr = mojo::NativeStructPtr;

using PushEventPayload = mojo::NativeStruct;
using PushEventPayloadPtr = mojo::NativeStructPtr;

using ServiceWorkerResponse = mojo::NativeStruct;
using ServiceWorkerResponsePtr = mojo::NativeStructPtr;

using ExtendableMessageEventSource = mojo::NativeStruct;
using ExtendableMessageEventSourcePtr = mojo::NativeStructPtr;

class BackgroundFetchSettledFetch;
using BackgroundFetchSettledFetchPtr = mojo::StructPtr<BackgroundFetchSettledFetch>;

class FetchEventPreloadHandle;
using FetchEventPreloadHandlePtr = mojo::StructPtr<FetchEventPreloadHandle>;

class ExtendableMessageEvent;
using ExtendableMessageEventPtr = mojo::StructPtr<ExtendableMessageEvent>;


class ServiceWorkerFetchResponseCallbackProxy;

template <typename ImplRefTraits>
class ServiceWorkerFetchResponseCallbackStub;

class ServiceWorkerFetchResponseCallbackRequestValidator;

class CONTENT_EXPORT ServiceWorkerFetchResponseCallback
    : public ServiceWorkerFetchResponseCallbackInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = ServiceWorkerFetchResponseCallbackProxy;

  template <typename ImplRefTraits>
  using Stub_ = ServiceWorkerFetchResponseCallbackStub<ImplRefTraits>;

  using RequestValidator_ = ServiceWorkerFetchResponseCallbackRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnResponseMinVersion = 0,
    kOnResponseStreamMinVersion = 0,
    kOnFallbackMinVersion = 0,
  };
  virtual ~ServiceWorkerFetchResponseCallback() {}

  virtual void OnResponse(const ::content::ServiceWorkerResponse& response, base::Time dispatch_event_time) = 0;

  virtual void OnResponseStream(const ::content::ServiceWorkerResponse& response, ::blink::mojom::ServiceWorkerStreamHandlePtr body_as_stream, base::Time dispatch_event_time) = 0;

  virtual void OnFallback(base::Time dispatch_event_time) = 0;
};

class ServiceWorkerEventDispatcherProxy;

template <typename ImplRefTraits>
class ServiceWorkerEventDispatcherStub;

class ServiceWorkerEventDispatcherRequestValidator;
class ServiceWorkerEventDispatcherResponseValidator;

class CONTENT_EXPORT ServiceWorkerEventDispatcher
    : public ServiceWorkerEventDispatcherInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = ServiceWorkerEventDispatcherProxy;

  template <typename ImplRefTraits>
  using Stub_ = ServiceWorkerEventDispatcherStub<ImplRefTraits>;

  using RequestValidator_ = ServiceWorkerEventDispatcherRequestValidator;
  using ResponseValidator_ = ServiceWorkerEventDispatcherResponseValidator;
  enum MethodMinVersions : uint32_t {
    kDispatchInstallEventMinVersion = 0,
    kDispatchActivateEventMinVersion = 0,
    kDispatchBackgroundFetchAbortEventMinVersion = 0,
    kDispatchBackgroundFetchClickEventMinVersion = 0,
    kDispatchBackgroundFetchFailEventMinVersion = 0,
    kDispatchBackgroundFetchedEventMinVersion = 0,
    kDispatchFetchEventMinVersion = 0,
    kDispatchNotificationClickEventMinVersion = 0,
    kDispatchNotificationCloseEventMinVersion = 0,
    kDispatchPushEventMinVersion = 0,
    kDispatchSyncEventMinVersion = 0,
    kDispatchPaymentRequestEventMinVersion = 0,
    kDispatchExtendableMessageEventMinVersion = 0,
    kPingMinVersion = 0,
  };
  virtual ~ServiceWorkerEventDispatcher() {}


  using DispatchInstallEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, bool, base::Time)>;
  virtual void DispatchInstallEvent(ServiceWorkerInstallEventMethodsAssociatedPtrInfo method, DispatchInstallEventCallback callback) = 0;


  using DispatchActivateEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchActivateEvent(DispatchActivateEventCallback callback) = 0;


  using DispatchBackgroundFetchAbortEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchBackgroundFetchAbortEvent(const std::string& tag, DispatchBackgroundFetchAbortEventCallback callback) = 0;


  using DispatchBackgroundFetchClickEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchBackgroundFetchClickEvent(const std::string& tag, BackgroundFetchState state, DispatchBackgroundFetchClickEventCallback callback) = 0;


  using DispatchBackgroundFetchFailEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchBackgroundFetchFailEvent(const std::string& tag, const std::vector<::content::BackgroundFetchSettledFetch>& fetches, DispatchBackgroundFetchFailEventCallback callback) = 0;


  using DispatchBackgroundFetchedEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchBackgroundFetchedEvent(const std::string& tag, const std::vector<::content::BackgroundFetchSettledFetch>& fetches, DispatchBackgroundFetchedEventCallback callback) = 0;


  using DispatchFetchEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchFetchEvent(int32_t fetch_event_id, const ::content::ServiceWorkerFetchRequest& request, FetchEventPreloadHandlePtr preload_handle, ServiceWorkerFetchResponseCallbackPtr response_callback, DispatchFetchEventCallback callback) = 0;


  using DispatchNotificationClickEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchNotificationClickEvent(const std::string& notification_id, const ::content::PlatformNotificationData& notification_data, int32_t action_index, const base::Optional<base::string16>& reply, DispatchNotificationClickEventCallback callback) = 0;


  using DispatchNotificationCloseEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchNotificationCloseEvent(const std::string& notification_id, const ::content::PlatformNotificationData& notification_data, DispatchNotificationCloseEventCallback callback) = 0;


  using DispatchPushEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchPushEvent(const ::content::PushEventPayload& payload, DispatchPushEventCallback callback) = 0;


  using DispatchSyncEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchSyncEvent(const std::string& tag, ::blink::mojom::BackgroundSyncEventLastChance last_chance, DispatchSyncEventCallback callback) = 0;


  using DispatchPaymentRequestEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchPaymentRequestEvent(int32_t payment_request_id, ::payments::mojom::PaymentRequestEventDataPtr request_data, ::payments::mojom::PaymentHandlerResponseCallbackPtr response_callback, DispatchPaymentRequestEventCallback callback) = 0;


  using DispatchExtendableMessageEventCallback = base::OnceCallback<void(::content::ServiceWorkerStatusCode, base::Time)>;
  virtual void DispatchExtendableMessageEvent(ExtendableMessageEventPtr event, DispatchExtendableMessageEventCallback callback) = 0;


  using PingCallback = base::OnceCallback<void()>;
  virtual void Ping(PingCallback callback) = 0;
};

class ServiceWorkerInstallEventMethodsProxy;

template <typename ImplRefTraits>
class ServiceWorkerInstallEventMethodsStub;

class ServiceWorkerInstallEventMethodsRequestValidator;

class CONTENT_EXPORT ServiceWorkerInstallEventMethods
    : public ServiceWorkerInstallEventMethodsInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = ServiceWorkerInstallEventMethodsProxy;

  template <typename ImplRefTraits>
  using Stub_ = ServiceWorkerInstallEventMethodsStub<ImplRefTraits>;

  using RequestValidator_ = ServiceWorkerInstallEventMethodsRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kRegisterForeignFetchScopesMinVersion = 0,
  };
  virtual ~ServiceWorkerInstallEventMethods() {}

  virtual void RegisterForeignFetchScopes(const std::vector<GURL>& sub_scopes, const std::vector<url::Origin>& origins) = 0;
};

class CONTENT_EXPORT ServiceWorkerFetchResponseCallbackProxy
    : public ServiceWorkerFetchResponseCallback {
 public:
  explicit ServiceWorkerFetchResponseCallbackProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnResponse(const ::content::ServiceWorkerResponse& response, base::Time dispatch_event_time) override;
  void OnResponseStream(const ::content::ServiceWorkerResponse& response, ::blink::mojom::ServiceWorkerStreamHandlePtr body_as_stream, base::Time dispatch_event_time) override;
  void OnFallback(base::Time dispatch_event_time) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class CONTENT_EXPORT ServiceWorkerEventDispatcherProxy
    : public ServiceWorkerEventDispatcher {
 public:
  explicit ServiceWorkerEventDispatcherProxy(mojo::MessageReceiverWithResponder* receiver);
  void DispatchInstallEvent(ServiceWorkerInstallEventMethodsAssociatedPtrInfo method, DispatchInstallEventCallback callback) override;
  void DispatchActivateEvent(DispatchActivateEventCallback callback) override;
  void DispatchBackgroundFetchAbortEvent(const std::string& tag, DispatchBackgroundFetchAbortEventCallback callback) override;
  void DispatchBackgroundFetchClickEvent(const std::string& tag, BackgroundFetchState state, DispatchBackgroundFetchClickEventCallback callback) override;
  void DispatchBackgroundFetchFailEvent(const std::string& tag, const std::vector<::content::BackgroundFetchSettledFetch>& fetches, DispatchBackgroundFetchFailEventCallback callback) override;
  void DispatchBackgroundFetchedEvent(const std::string& tag, const std::vector<::content::BackgroundFetchSettledFetch>& fetches, DispatchBackgroundFetchedEventCallback callback) override;
  void DispatchFetchEvent(int32_t fetch_event_id, const ::content::ServiceWorkerFetchRequest& request, FetchEventPreloadHandlePtr preload_handle, ServiceWorkerFetchResponseCallbackPtr response_callback, DispatchFetchEventCallback callback) override;
  void DispatchNotificationClickEvent(const std::string& notification_id, const ::content::PlatformNotificationData& notification_data, int32_t action_index, const base::Optional<base::string16>& reply, DispatchNotificationClickEventCallback callback) override;
  void DispatchNotificationCloseEvent(const std::string& notification_id, const ::content::PlatformNotificationData& notification_data, DispatchNotificationCloseEventCallback callback) override;
  void DispatchPushEvent(const ::content::PushEventPayload& payload, DispatchPushEventCallback callback) override;
  void DispatchSyncEvent(const std::string& tag, ::blink::mojom::BackgroundSyncEventLastChance last_chance, DispatchSyncEventCallback callback) override;
  void DispatchPaymentRequestEvent(int32_t payment_request_id, ::payments::mojom::PaymentRequestEventDataPtr request_data, ::payments::mojom::PaymentHandlerResponseCallbackPtr response_callback, DispatchPaymentRequestEventCallback callback) override;
  void DispatchExtendableMessageEvent(ExtendableMessageEventPtr event, DispatchExtendableMessageEventCallback callback) override;
  void Ping(PingCallback callback) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class CONTENT_EXPORT ServiceWorkerInstallEventMethodsProxy
    : public ServiceWorkerInstallEventMethods {
 public:
  explicit ServiceWorkerInstallEventMethodsProxy(mojo::MessageReceiverWithResponder* receiver);
  void RegisterForeignFetchScopes(const std::vector<GURL>& sub_scopes, const std::vector<url::Origin>& origins) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT ServiceWorkerFetchResponseCallbackStubDispatch {
 public:
  static bool Accept(ServiceWorkerFetchResponseCallback* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ServiceWorkerFetchResponseCallback* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ServiceWorkerFetchResponseCallback>>
class ServiceWorkerFetchResponseCallbackStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ServiceWorkerFetchResponseCallbackStub() {}
  ~ServiceWorkerFetchResponseCallbackStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerFetchResponseCallbackStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerFetchResponseCallbackStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT ServiceWorkerEventDispatcherStubDispatch {
 public:
  static bool Accept(ServiceWorkerEventDispatcher* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ServiceWorkerEventDispatcher* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ServiceWorkerEventDispatcher>>
class ServiceWorkerEventDispatcherStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ServiceWorkerEventDispatcherStub() {}
  ~ServiceWorkerEventDispatcherStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerEventDispatcherStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerEventDispatcherStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT ServiceWorkerInstallEventMethodsStubDispatch {
 public:
  static bool Accept(ServiceWorkerInstallEventMethods* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ServiceWorkerInstallEventMethods* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ServiceWorkerInstallEventMethods>>
class ServiceWorkerInstallEventMethodsStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ServiceWorkerInstallEventMethodsStub() {}
  ~ServiceWorkerInstallEventMethodsStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerInstallEventMethodsStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ServiceWorkerInstallEventMethodsStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT ServiceWorkerFetchResponseCallbackRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT ServiceWorkerEventDispatcherRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT ServiceWorkerInstallEventMethodsRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT ServiceWorkerEventDispatcherResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};















class CONTENT_EXPORT BackgroundFetchSettledFetch {
 public:
  using DataView = BackgroundFetchSettledFetchDataView;
  using Data_ = internal::BackgroundFetchSettledFetch_Data;

  template <typename... Args>
  static BackgroundFetchSettledFetchPtr New(Args&&... args) {
    return BackgroundFetchSettledFetchPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static BackgroundFetchSettledFetchPtr From(const U& u) {
    return mojo::TypeConverter<BackgroundFetchSettledFetchPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BackgroundFetchSettledFetch>::Convert(*this);
  }


  BackgroundFetchSettledFetch();

  BackgroundFetchSettledFetch(
      const ::content::ServiceWorkerFetchRequest& request,
      const ::content::ServiceWorkerResponse& response);

  ~BackgroundFetchSettledFetch();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BackgroundFetchSettledFetchPtr>
  BackgroundFetchSettledFetchPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, BackgroundFetchSettledFetch>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        BackgroundFetchSettledFetch::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        BackgroundFetchSettledFetch::DataView, std::vector<uint8_t>>(
            input, output, Validate);
  }

  ::content::ServiceWorkerFetchRequest request;
  ::content::ServiceWorkerResponse response;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};



class CONTENT_EXPORT FetchEventPreloadHandle {
 public:
  using DataView = FetchEventPreloadHandleDataView;
  using Data_ = internal::FetchEventPreloadHandle_Data;

  template <typename... Args>
  static FetchEventPreloadHandlePtr New(Args&&... args) {
    return FetchEventPreloadHandlePtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static FetchEventPreloadHandlePtr From(const U& u) {
    return mojo::TypeConverter<FetchEventPreloadHandlePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FetchEventPreloadHandle>::Convert(*this);
  }


  FetchEventPreloadHandle();

  FetchEventPreloadHandle(
      ::content::mojom::URLLoaderPtr url_loader,
      ::content::mojom::URLLoaderClientRequest url_loader_client_request);

  ~FetchEventPreloadHandle();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FetchEventPreloadHandlePtr>
  FetchEventPreloadHandlePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, FetchEventPreloadHandle>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        FetchEventPreloadHandle::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        FetchEventPreloadHandle::DataView, std::vector<uint8_t>>(
            input, output, Validate);
  }

  ::content::mojom::URLLoaderPtr url_loader;
  ::content::mojom::URLLoaderClientRequest url_loader_client_request;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(FetchEventPreloadHandle);
};



class CONTENT_EXPORT ExtendableMessageEvent {
 public:
  using DataView = ExtendableMessageEventDataView;
  using Data_ = internal::ExtendableMessageEvent_Data;

  template <typename... Args>
  static ExtendableMessageEventPtr New(Args&&... args) {
    return ExtendableMessageEventPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static ExtendableMessageEventPtr From(const U& u) {
    return mojo::TypeConverter<ExtendableMessageEventPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ExtendableMessageEvent>::Convert(*this);
  }


  ExtendableMessageEvent();

  ExtendableMessageEvent(
      const base::string16& message,
      const url::Origin& source_origin,
      std::vector<mojo::ScopedMessagePipeHandle> message_ports,
      const ::content::ExtendableMessageEventSource& source);

  ~ExtendableMessageEvent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ExtendableMessageEventPtr>
  ExtendableMessageEventPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ExtendableMessageEvent>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        ExtendableMessageEvent::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        ExtendableMessageEvent::DataView, std::vector<uint8_t>>(
            input, output, Validate);
  }

  base::string16 message;
  url::Origin source_origin;
  std::vector<mojo::ScopedMessagePipeHandle> message_ports;
  ::content::ExtendableMessageEventSource source;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ExtendableMessageEvent);
};


template <typename StructPtrType>
BackgroundFetchSettledFetchPtr BackgroundFetchSettledFetch::Clone() const {
  return New(
      mojo::Clone(request),
      mojo::Clone(response)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, BackgroundFetchSettledFetch>::value>::type*>
bool BackgroundFetchSettledFetch::Equals(const T& other) const {
  if (!mojo::Equals(this->request, other.request))
    return false;
  if (!mojo::Equals(this->response, other.response))
    return false;
  return true;
}
template <typename StructPtrType>
FetchEventPreloadHandlePtr FetchEventPreloadHandle::Clone() const {
  return New(
      mojo::Clone(url_loader),
      mojo::Clone(url_loader_client_request)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, FetchEventPreloadHandle>::value>::type*>
bool FetchEventPreloadHandle::Equals(const T& other) const {
  if (!mojo::Equals(this->url_loader, other.url_loader))
    return false;
  if (!mojo::Equals(this->url_loader_client_request, other.url_loader_client_request))
    return false;
  return true;
}
template <typename StructPtrType>
ExtendableMessageEventPtr ExtendableMessageEvent::Clone() const {
  return New(
      mojo::Clone(message),
      mojo::Clone(source_origin),
      mojo::Clone(message_ports),
      mojo::Clone(source)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ExtendableMessageEvent>::value>::type*>
bool ExtendableMessageEvent::Equals(const T& other) const {
  if (!mojo::Equals(this->message, other.message))
    return false;
  if (!mojo::Equals(this->source_origin, other.source_origin))
    return false;
  if (!mojo::Equals(this->message_ports, other.message_ports))
    return false;
  if (!mojo::Equals(this->source, other.source))
    return false;
  return true;
}


}  // namespace mojom
}  // namespace content

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::BackgroundFetchSettledFetch::DataView,
                                         ::content::mojom::BackgroundFetchSettledFetchPtr> {
  static bool IsNull(const ::content::mojom::BackgroundFetchSettledFetchPtr& input) { return !input; }
  static void SetToNull(::content::mojom::BackgroundFetchSettledFetchPtr* output) { output->reset(); }

  static const decltype(::content::mojom::BackgroundFetchSettledFetch::request)& request(
      const ::content::mojom::BackgroundFetchSettledFetchPtr& input) {
    return input->request;
  }

  static const decltype(::content::mojom::BackgroundFetchSettledFetch::response)& response(
      const ::content::mojom::BackgroundFetchSettledFetchPtr& input) {
    return input->response;
  }

  static bool Read(::content::mojom::BackgroundFetchSettledFetch::DataView input, ::content::mojom::BackgroundFetchSettledFetchPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::FetchEventPreloadHandle::DataView,
                                         ::content::mojom::FetchEventPreloadHandlePtr> {
  static bool IsNull(const ::content::mojom::FetchEventPreloadHandlePtr& input) { return !input; }
  static void SetToNull(::content::mojom::FetchEventPreloadHandlePtr* output) { output->reset(); }

  static  decltype(::content::mojom::FetchEventPreloadHandle::url_loader)& url_loader(
       ::content::mojom::FetchEventPreloadHandlePtr& input) {
    return input->url_loader;
  }

  static  decltype(::content::mojom::FetchEventPreloadHandle::url_loader_client_request)& url_loader_client_request(
       ::content::mojom::FetchEventPreloadHandlePtr& input) {
    return input->url_loader_client_request;
  }

  static bool Read(::content::mojom::FetchEventPreloadHandle::DataView input, ::content::mojom::FetchEventPreloadHandlePtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::content::mojom::ExtendableMessageEvent::DataView,
                                         ::content::mojom::ExtendableMessageEventPtr> {
  static bool IsNull(const ::content::mojom::ExtendableMessageEventPtr& input) { return !input; }
  static void SetToNull(::content::mojom::ExtendableMessageEventPtr* output) { output->reset(); }

  static const decltype(::content::mojom::ExtendableMessageEvent::message)& message(
      const ::content::mojom::ExtendableMessageEventPtr& input) {
    return input->message;
  }

  static const decltype(::content::mojom::ExtendableMessageEvent::source_origin)& source_origin(
      const ::content::mojom::ExtendableMessageEventPtr& input) {
    return input->source_origin;
  }

  static  decltype(::content::mojom::ExtendableMessageEvent::message_ports)& message_ports(
       ::content::mojom::ExtendableMessageEventPtr& input) {
    return input->message_ports;
  }

  static const decltype(::content::mojom::ExtendableMessageEvent::source)& source(
      const ::content::mojom::ExtendableMessageEventPtr& input) {
    return input->source;
  }

  static bool Read(::content::mojom::ExtendableMessageEvent::DataView input, ::content::mojom::ExtendableMessageEventPtr* output);
};

}  // namespace mojo

#endif  // CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_EVENT_DISPATCHER_MOJOM_H_