// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_WORKER_URL_LOADER_FACTORY_PROVIDER_MOJOM_SHARED_H_
#define CONTENT_COMMON_WORKER_URL_LOADER_FACTORY_PROVIDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "content/common/worker_url_loader_factory_provider.mojom-shared-internal.h"
#include "content/public/common/url_loader_factory.mojom-shared.h"
#include "content/common/mojo_bindings_shared_export.h"


namespace content {
namespace mojom {


}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ServiceWorkerWorkerClientInterfaceBase {};

using ServiceWorkerWorkerClientPtrDataView =
    mojo::InterfacePtrDataView<ServiceWorkerWorkerClientInterfaceBase>;
using ServiceWorkerWorkerClientRequestDataView =
    mojo::InterfaceRequestDataView<ServiceWorkerWorkerClientInterfaceBase>;
using ServiceWorkerWorkerClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ServiceWorkerWorkerClientInterfaceBase>;
using ServiceWorkerWorkerClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ServiceWorkerWorkerClientInterfaceBase>;
class WorkerURLLoaderFactoryProviderInterfaceBase {};

using WorkerURLLoaderFactoryProviderPtrDataView =
    mojo::InterfacePtrDataView<WorkerURLLoaderFactoryProviderInterfaceBase>;
using WorkerURLLoaderFactoryProviderRequestDataView =
    mojo::InterfaceRequestDataView<WorkerURLLoaderFactoryProviderInterfaceBase>;
using WorkerURLLoaderFactoryProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WorkerURLLoaderFactoryProviderInterfaceBase>;
using WorkerURLLoaderFactoryProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WorkerURLLoaderFactoryProviderInterfaceBase>;
class ServiceWorkerWorkerClient_SetControllerServiceWorker_ParamsDataView {
 public:
  ServiceWorkerWorkerClient_SetControllerServiceWorker_ParamsDataView() {}

  ServiceWorkerWorkerClient_SetControllerServiceWorker_ParamsDataView(
      internal::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t controller_version_id() const {
    return data_->controller_version_id;
  }
 private:
  internal::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data* data_ = nullptr;
};

class WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_ParamsDataView {
 public:
  WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_ParamsDataView() {}

  WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_ParamsDataView(
      internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeLoader() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
            &data_->loader, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::content::mojom::ServiceWorkerWorkerClientAssociatedPtrInfoDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
  int32_t service_worker_provider_id() const {
    return data_->service_worker_provider_id;
  }
 private:
  internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_ParamsDataView {
 public:
  WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_ParamsDataView() {}

  WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_ParamsDataView(
      internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeLoader() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
            &data_->loader, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace content {
namespace mojom {








}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_WORKER_URL_LOADER_FACTORY_PROVIDER_MOJOM_SHARED_H_
