// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/public/common/url_loader_factory.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "content/common/resource_messages.h"
#include "content/common/url_request_struct_traits.h"
#include "content/public/common/mutable_network_traffic_annotation_tag_struct_traits.h"
namespace content {
namespace mojom {
const char URLLoaderFactory::Name_[] = "content::mojom::URLLoaderFactory";
bool URLLoaderFactory::SyncLoad(int32_t routing_id, int32_t request_id, const content::ResourceRequest& request, content::SyncLoadResult* result) {
  NOTREACHED();
  return false;
}
class URLLoaderFactory_SyncLoad_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  URLLoaderFactory_SyncLoad_HandleSyncResponse(
      bool* result, content::SyncLoadResult* out_result)
      : result_(result), out_result_(out_result) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  bool* result_;
  content::SyncLoadResult* out_result_;DISALLOW_COPY_AND_ASSIGN(URLLoaderFactory_SyncLoad_HandleSyncResponse);
};

class URLLoaderFactory_SyncLoad_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  URLLoaderFactory_SyncLoad_ForwardToCallback(
      URLLoaderFactory::SyncLoadCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  URLLoaderFactory::SyncLoadCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(URLLoaderFactory_SyncLoad_ForwardToCallback);
};

URLLoaderFactoryProxy::URLLoaderFactoryProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void URLLoaderFactoryProxy::CreateLoaderAndStart(
    ::content::mojom::URLLoaderAssociatedRequest in_loader, int32_t in_routing_id, int32_t in_request_id, uint32_t in_options, const content::ResourceRequest& in_request, ::content::mojom::URLLoaderClientPtr in_client, const net::MutableNetworkTrafficAnnotationTag& in_traffic_annotation) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::URLLoaderFactory_CreateLoaderAndStart_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLLoaderAssociatedRequestDataView>(
      in_loader, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLRequestDataView>(
      in_request, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLLoaderClientPtrDataView>(
      in_client, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::MutableNetworkTrafficAnnotationTagDataView>(
      in_traffic_annotation, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kURLLoaderFactory_CreateLoaderAndStart_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::URLLoaderFactory_CreateLoaderAndStart_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::content::mojom::URLLoaderAssociatedRequestDataView>(
      in_loader, &params->loader, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->loader),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid loader in URLLoaderFactory.CreateLoaderAndStart request");
  params->routing_id = in_routing_id;
  params->request_id = in_request_id;
  params->options = in_options;
  typename decltype(params->request)::BaseType* request_ptr;
  mojo::internal::Serialize<::content::mojom::URLRequestDataView>(
      in_request, buffer, &request_ptr, &serialization_context);
  params->request.Set(request_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->request.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null request in URLLoaderFactory.CreateLoaderAndStart request");
  mojo::internal::Serialize<::content::mojom::URLLoaderClientPtrDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in URLLoaderFactory.CreateLoaderAndStart request");
  typename decltype(params->traffic_annotation)::BaseType* traffic_annotation_ptr;
  mojo::internal::Serialize<::content::mojom::MutableNetworkTrafficAnnotationTagDataView>(
      in_traffic_annotation, buffer, &traffic_annotation_ptr, &serialization_context);
  params->traffic_annotation.Set(traffic_annotation_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->traffic_annotation.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null traffic_annotation in URLLoaderFactory.CreateLoaderAndStart request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
bool URLLoaderFactoryProxy::SyncLoad(
    int32_t param_routing_id, int32_t param_request_id, const content::ResourceRequest& param_request, content::SyncLoadResult* param_result) {
  const bool kExpectsResponse = true;
  const bool kIsSync = true;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::URLLoaderFactory_SyncLoad_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLRequestDataView>(
      param_request, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kURLLoaderFactory_SyncLoad_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::URLLoaderFactory_SyncLoad_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->routing_id = param_routing_id;
  params->request_id = param_request_id;
  typename decltype(params->request)::BaseType* request_ptr;
  mojo::internal::Serialize<::content::mojom::URLRequestDataView>(
      param_request, buffer, &request_ptr, &serialization_context);
  params->request.Set(request_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->request.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null request in URLLoaderFactory.SyncLoad request");

  bool result = false;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new URLLoaderFactory_SyncLoad_HandleSyncResponse(
          &result, param_result));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
  return result;
}

void URLLoaderFactoryProxy::SyncLoad(
    int32_t in_routing_id, int32_t in_request_id, const content::ResourceRequest& in_request, SyncLoadCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::URLLoaderFactory_SyncLoad_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLRequestDataView>(
      in_request, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kURLLoaderFactory_SyncLoad_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::URLLoaderFactory_SyncLoad_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->routing_id = in_routing_id;
  params->request_id = in_request_id;
  typename decltype(params->request)::BaseType* request_ptr;
  mojo::internal::Serialize<::content::mojom::URLRequestDataView>(
      in_request, buffer, &request_ptr, &serialization_context);
  params->request.Set(request_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->request.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null request in URLLoaderFactory.SyncLoad request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new URLLoaderFactory_SyncLoad_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class URLLoaderFactory_SyncLoad_ProxyToResponder {
 public:
  static URLLoaderFactory::SyncLoadCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<URLLoaderFactory_SyncLoad_ProxyToResponder> proxy(
        new URLLoaderFactory_SyncLoad_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&URLLoaderFactory_SyncLoad_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~URLLoaderFactory_SyncLoad_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "URLLoaderFactory::SyncLoad() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  URLLoaderFactory_SyncLoad_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      const content::SyncLoadResult& in_result);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(URLLoaderFactory_SyncLoad_ProxyToResponder);
};

bool URLLoaderFactory_SyncLoad_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::URLLoaderFactory_SyncLoad_ResponseParams_Data* params =
      reinterpret_cast<
          internal::URLLoaderFactory_SyncLoad_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  content::SyncLoadResult p_result{};
  URLLoaderFactory_SyncLoad_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "URLLoaderFactory::SyncLoad response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void URLLoaderFactory_SyncLoad_ProxyToResponder::Run(
    const content::SyncLoadResult& in_result) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::URLLoaderFactory_SyncLoad_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLSyncLoadResultDataView>(
      in_result, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kURLLoaderFactory_SyncLoad_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::URLLoaderFactory_SyncLoad_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->result)::BaseType* result_ptr;
  mojo::internal::Serialize<::content::mojom::URLSyncLoadResultDataView>(
      in_result, buffer, &result_ptr, &serialization_context);
  params->result.Set(result_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->result.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null result in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
bool URLLoaderFactory_SyncLoad_HandleSyncResponse::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::URLLoaderFactory_SyncLoad_ResponseParams_Data* params =
      reinterpret_cast<internal::URLLoaderFactory_SyncLoad_ResponseParams_Data*>(
          message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  content::SyncLoadResult p_result{};
  URLLoaderFactory_SyncLoad_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "URLLoaderFactory::SyncLoad response deserializer");
    return false;
  }
  *out_result_ = std::move(p_result);
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}

// static
bool URLLoaderFactoryStubDispatch::Accept(
    URLLoaderFactory* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kURLLoaderFactory_CreateLoaderAndStart_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::URLLoaderFactory_CreateLoaderAndStart_Params_Data* params =
          reinterpret_cast<internal::URLLoaderFactory_CreateLoaderAndStart_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::content::mojom::URLLoaderAssociatedRequest p_loader{};
      int32_t p_routing_id{};
      int32_t p_request_id{};
      uint32_t p_options{};
      content::ResourceRequest p_request{};
      ::content::mojom::URLLoaderClientPtr p_client{};
      net::MutableNetworkTrafficAnnotationTag p_traffic_annotation{};
      URLLoaderFactory_CreateLoaderAndStart_ParamsDataView input_data_view(params, &serialization_context);
      
      p_loader =
          input_data_view.TakeLoader<decltype(p_loader)>();
      p_routing_id = input_data_view.routing_id();
      p_request_id = input_data_view.request_id();
      p_options = input_data_view.options();
      if (!input_data_view.ReadRequest(&p_request))
        success = false;
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      if (!input_data_view.ReadTrafficAnnotation(&p_traffic_annotation))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "URLLoaderFactory::CreateLoaderAndStart deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateLoaderAndStart(
std::move(p_loader), 
std::move(p_routing_id), 
std::move(p_request_id), 
std::move(p_options), 
std::move(p_request), 
std::move(p_client), 
std::move(p_traffic_annotation));
      return true;
    }
    case internal::kURLLoaderFactory_SyncLoad_Name: {
      break;
    }
  }
  return false;
}

// static
bool URLLoaderFactoryStubDispatch::AcceptWithResponder(
    URLLoaderFactory* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kURLLoaderFactory_CreateLoaderAndStart_Name: {
      break;
    }
    case internal::kURLLoaderFactory_SyncLoad_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::URLLoaderFactory_SyncLoad_Params_Data* params =
          reinterpret_cast<
              internal::URLLoaderFactory_SyncLoad_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_routing_id{};
      int32_t p_request_id{};
      content::ResourceRequest p_request{};
      URLLoaderFactory_SyncLoad_ParamsDataView input_data_view(params, &serialization_context);
      
      p_routing_id = input_data_view.routing_id();
      p_request_id = input_data_view.request_id();
      if (!input_data_view.ReadRequest(&p_request))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "URLLoaderFactory::SyncLoad deserializer");
        return false;
      }
      URLLoaderFactory::SyncLoadCallback callback =
          URLLoaderFactory_SyncLoad_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SyncLoad(
std::move(p_routing_id), 
std::move(p_request_id), 
std::move(p_request), std::move(callback));
      return true;
    }
  }
  return false;
}

bool URLLoaderFactoryRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "URLLoaderFactory RequestValidator");

  switch (message->header()->name) {
    case internal::kURLLoaderFactory_CreateLoaderAndStart_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::URLLoaderFactory_CreateLoaderAndStart_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kURLLoaderFactory_SyncLoad_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::URLLoaderFactory_SyncLoad_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool URLLoaderFactoryResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "URLLoaderFactory ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kURLLoaderFactory_SyncLoad_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::URLLoaderFactory_SyncLoad_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif