// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_VR_VR_SERVICE_MOJOM_BLINK_H_
#define DEVICE_VR_VR_SERVICE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "device/vr/vr_service.mojom-shared.h"
#include "mojo/common/time.mojom-blink.h"
#include "gpu/ipc/common/mailbox_holder.mojom-blink.h"
#include "gpu/ipc/common/sync_token.mojom-blink.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/WebKit/Source/platform/wtf/HashFunctions.h"
#include "third_party/WebKit/Source/platform/wtf/Optional.h"
#include "third_party/WebKit/Source/platform/wtf/text/WTFString.h"
#include "device/vr/mojo_bindings_blink_export.h"


namespace WTF {
struct device_mojom_internal_VRDisplayEventReason_DataHashFn {
  static unsigned GetHash(const ::device::mojom::VRDisplayEventReason& value) {
    using utype = std::underlying_type<::device::mojom::VRDisplayEventReason>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::device::mojom::VRDisplayEventReason& left, const ::device::mojom::VRDisplayEventReason& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::device::mojom::VRDisplayEventReason> {
  using Hash = device_mojom_internal_VRDisplayEventReason_DataHashFn;
};

template <>
struct HashTraits<::device::mojom::VRDisplayEventReason>
    : public GenericHashTraits<::device::mojom::VRDisplayEventReason> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::device::mojom::VRDisplayEventReason& value) {
    return value == static_cast<::device::mojom::VRDisplayEventReason>(-1000000);
  }
  static void ConstructDeletedValue(::device::mojom::VRDisplayEventReason& slot, bool) {
    slot = static_cast<::device::mojom::VRDisplayEventReason>(-1000001);
  }
  static bool IsDeletedValue(const ::device::mojom::VRDisplayEventReason& value) {
    return value == static_cast<::device::mojom::VRDisplayEventReason>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct device_mojom_internal_VRPresentationProvider_VSyncStatus_DataHashFn {
  static unsigned GetHash(const ::device::mojom::VRPresentationProvider_VSyncStatus& value) {
    using utype = std::underlying_type<::device::mojom::VRPresentationProvider_VSyncStatus>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::device::mojom::VRPresentationProvider_VSyncStatus& left, const ::device::mojom::VRPresentationProvider_VSyncStatus& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::device::mojom::VRPresentationProvider_VSyncStatus> {
  using Hash = device_mojom_internal_VRPresentationProvider_VSyncStatus_DataHashFn;
};

template <>
struct HashTraits<::device::mojom::VRPresentationProvider_VSyncStatus>
    : public GenericHashTraits<::device::mojom::VRPresentationProvider_VSyncStatus> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::device::mojom::VRPresentationProvider_VSyncStatus& value) {
    return value == static_cast<::device::mojom::VRPresentationProvider_VSyncStatus>(-1000000);
  }
  static void ConstructDeletedValue(::device::mojom::VRPresentationProvider_VSyncStatus& slot, bool) {
    slot = static_cast<::device::mojom::VRPresentationProvider_VSyncStatus>(-1000001);
  }
  static bool IsDeletedValue(const ::device::mojom::VRPresentationProvider_VSyncStatus& value) {
    return value == static_cast<::device::mojom::VRPresentationProvider_VSyncStatus>(-1000001);
  }
};
}  // namespace WTF


namespace device {
namespace mojom {
namespace blink {
using VRDisplayEventReason = VRDisplayEventReason;  // Alias for definition in the parent namespace.
class VRService;
using VRServicePtr = mojo::InterfacePtr<VRService>;
using VRServicePtrInfo = mojo::InterfacePtrInfo<VRService>;
using ThreadSafeVRServicePtr =
    mojo::ThreadSafeInterfacePtr<VRService>;
using VRServiceRequest = mojo::InterfaceRequest<VRService>;
using VRServiceAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRService>;
using ThreadSafeVRServiceAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRService>;
using VRServiceAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRService>;
using VRServiceAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRService>;

class VRServiceClient;
using VRServiceClientPtr = mojo::InterfacePtr<VRServiceClient>;
using VRServiceClientPtrInfo = mojo::InterfacePtrInfo<VRServiceClient>;
using ThreadSafeVRServiceClientPtr =
    mojo::ThreadSafeInterfacePtr<VRServiceClient>;
using VRServiceClientRequest = mojo::InterfaceRequest<VRServiceClient>;
using VRServiceClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRServiceClient>;
using ThreadSafeVRServiceClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRServiceClient>;
using VRServiceClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRServiceClient>;
using VRServiceClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRServiceClient>;

class VRSubmitFrameClient;
using VRSubmitFrameClientPtr = mojo::InterfacePtr<VRSubmitFrameClient>;
using VRSubmitFrameClientPtrInfo = mojo::InterfacePtrInfo<VRSubmitFrameClient>;
using ThreadSafeVRSubmitFrameClientPtr =
    mojo::ThreadSafeInterfacePtr<VRSubmitFrameClient>;
using VRSubmitFrameClientRequest = mojo::InterfaceRequest<VRSubmitFrameClient>;
using VRSubmitFrameClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRSubmitFrameClient>;
using ThreadSafeVRSubmitFrameClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRSubmitFrameClient>;
using VRSubmitFrameClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRSubmitFrameClient>;
using VRSubmitFrameClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRSubmitFrameClient>;

class VRDisplay;
using VRDisplayPtr = mojo::InterfacePtr<VRDisplay>;
using VRDisplayPtrInfo = mojo::InterfacePtrInfo<VRDisplay>;
using ThreadSafeVRDisplayPtr =
    mojo::ThreadSafeInterfacePtr<VRDisplay>;
using VRDisplayRequest = mojo::InterfaceRequest<VRDisplay>;
using VRDisplayAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRDisplay>;
using ThreadSafeVRDisplayAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRDisplay>;
using VRDisplayAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRDisplay>;
using VRDisplayAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRDisplay>;

class VRPresentationProvider;
using VRPresentationProviderPtr = mojo::InterfacePtr<VRPresentationProvider>;
using VRPresentationProviderPtrInfo = mojo::InterfacePtrInfo<VRPresentationProvider>;
using ThreadSafeVRPresentationProviderPtr =
    mojo::ThreadSafeInterfacePtr<VRPresentationProvider>;
using VRPresentationProviderRequest = mojo::InterfaceRequest<VRPresentationProvider>;
using VRPresentationProviderAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRPresentationProvider>;
using ThreadSafeVRPresentationProviderAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRPresentationProvider>;
using VRPresentationProviderAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRPresentationProvider>;
using VRPresentationProviderAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRPresentationProvider>;

class VRDisplayClient;
using VRDisplayClientPtr = mojo::InterfacePtr<VRDisplayClient>;
using VRDisplayClientPtrInfo = mojo::InterfacePtrInfo<VRDisplayClient>;
using ThreadSafeVRDisplayClientPtr =
    mojo::ThreadSafeInterfacePtr<VRDisplayClient>;
using VRDisplayClientRequest = mojo::InterfaceRequest<VRDisplayClient>;
using VRDisplayClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRDisplayClient>;
using ThreadSafeVRDisplayClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRDisplayClient>;
using VRDisplayClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRDisplayClient>;
using VRDisplayClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRDisplayClient>;

class VRFieldOfView;
using VRFieldOfViewPtr = mojo::InlinedStructPtr<VRFieldOfView>;

class VRPose;
using VRPosePtr = mojo::StructPtr<VRPose>;

class VRDisplayCapabilities;
using VRDisplayCapabilitiesPtr = mojo::InlinedStructPtr<VRDisplayCapabilities>;

class VREyeParameters;
using VREyeParametersPtr = mojo::StructPtr<VREyeParameters>;

class VRStageParameters;
using VRStageParametersPtr = mojo::StructPtr<VRStageParameters>;

class VRDisplayInfo;
using VRDisplayInfoPtr = mojo::StructPtr<VRDisplayInfo>;


class VRServiceProxy;

template <typename ImplRefTraits>
class VRServiceStub;

class VRServiceRequestValidator;
class VRServiceResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRService
    : public VRServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRServiceStub<ImplRefTraits>;

  using RequestValidator_ = VRServiceRequestValidator;
  using ResponseValidator_ = VRServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSetClientMinVersion = 0,
    kSetListeningForActivateMinVersion = 0,
  };
  virtual ~VRService() {}


  using SetClientCallback = base::OnceCallback<void(uint32_t)>;
  virtual void SetClient(VRServiceClientPtr client, SetClientCallback callback) = 0;

  virtual void SetListeningForActivate(bool listening) = 0;
};

class VRServiceClientProxy;

template <typename ImplRefTraits>
class VRServiceClientStub;

class VRServiceClientRequestValidator;

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceClient
    : public VRServiceClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRServiceClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRServiceClientStub<ImplRefTraits>;

  using RequestValidator_ = VRServiceClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnDisplayConnectedMinVersion = 0,
  };
  virtual ~VRServiceClient() {}

  virtual void OnDisplayConnected(VRDisplayPtr display, VRDisplayClientRequest request, VRDisplayInfoPtr display_info) = 0;
};

class VRSubmitFrameClientProxy;

template <typename ImplRefTraits>
class VRSubmitFrameClientStub;

class VRSubmitFrameClientRequestValidator;

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRSubmitFrameClient
    : public VRSubmitFrameClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRSubmitFrameClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRSubmitFrameClientStub<ImplRefTraits>;

  using RequestValidator_ = VRSubmitFrameClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnSubmitFrameTransferredMinVersion = 0,
    kOnSubmitFrameRenderedMinVersion = 0,
  };
  virtual ~VRSubmitFrameClient() {}

  virtual void OnSubmitFrameTransferred() = 0;

  virtual void OnSubmitFrameRendered() = 0;
};

class VRDisplayProxy;

template <typename ImplRefTraits>
class VRDisplayStub;

class VRDisplayRequestValidator;
class VRDisplayResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplay
    : public VRDisplayInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRDisplayProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRDisplayStub<ImplRefTraits>;

  using RequestValidator_ = VRDisplayRequestValidator;
  using ResponseValidator_ = VRDisplayResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestPresentMinVersion = 0,
    kExitPresentMinVersion = 0,
    kGetNextMagicWindowPoseMinVersion = 0,
  };
  virtual ~VRDisplay() {}


  using RequestPresentCallback = base::OnceCallback<void(bool)>;
  virtual void RequestPresent(bool secure_origin, VRSubmitFrameClientPtr client, VRPresentationProviderRequest request, RequestPresentCallback callback) = 0;

  virtual void ExitPresent() = 0;


  using GetNextMagicWindowPoseCallback = base::OnceCallback<void(VRPosePtr)>;
  virtual void GetNextMagicWindowPose(GetNextMagicWindowPoseCallback callback) = 0;
};

class VRPresentationProviderProxy;

template <typename ImplRefTraits>
class VRPresentationProviderStub;

class VRPresentationProviderRequestValidator;
class VRPresentationProviderResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRPresentationProvider
    : public VRPresentationProviderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRPresentationProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRPresentationProviderStub<ImplRefTraits>;

  using RequestValidator_ = VRPresentationProviderRequestValidator;
  using ResponseValidator_ = VRPresentationProviderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetVSyncMinVersion = 0,
    kSubmitFrameMinVersion = 0,
    kUpdateLayerBoundsMinVersion = 0,
  };
  using VSyncStatus = VRPresentationProvider_VSyncStatus;
  virtual ~VRPresentationProvider() {}


  using GetVSyncCallback = base::OnceCallback<void(VRPosePtr, WTF::TimeDelta, int16_t, VRPresentationProvider::VSyncStatus)>;
  virtual void GetVSync(GetVSyncCallback callback) = 0;

  virtual void SubmitFrame(int16_t frame_id, const ::gpu::MailboxHolder& mailbox_holder) = 0;

  virtual void UpdateLayerBounds(int16_t frame_id, const ::blink::WebFloatRect& left_bounds, const ::blink::WebFloatRect& right_bounds, const ::blink::WebSize& source_size) = 0;
};

class VRDisplayClientProxy;

template <typename ImplRefTraits>
class VRDisplayClientStub;

class VRDisplayClientRequestValidator;
class VRDisplayClientResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayClient
    : public VRDisplayClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRDisplayClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRDisplayClientStub<ImplRefTraits>;

  using RequestValidator_ = VRDisplayClientRequestValidator;
  using ResponseValidator_ = VRDisplayClientResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnChangedMinVersion = 0,
    kOnExitPresentMinVersion = 0,
    kOnBlurMinVersion = 0,
    kOnFocusMinVersion = 0,
    kOnActivateMinVersion = 0,
    kOnDeactivateMinVersion = 0,
  };
  virtual ~VRDisplayClient() {}

  virtual void OnChanged(VRDisplayInfoPtr display) = 0;

  virtual void OnExitPresent() = 0;

  virtual void OnBlur() = 0;

  virtual void OnFocus() = 0;


  using OnActivateCallback = base::OnceCallback<void(bool)>;
  virtual void OnActivate(VRDisplayEventReason reason, OnActivateCallback callback) = 0;

  virtual void OnDeactivate(VRDisplayEventReason reason) = 0;
};

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceProxy
    : public VRService {
 public:
  explicit VRServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  void SetClient(VRServiceClientPtr client, SetClientCallback callback) override;
  void SetListeningForActivate(bool listening) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceClientProxy
    : public VRServiceClient {
 public:
  explicit VRServiceClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnDisplayConnected(VRDisplayPtr display, VRDisplayClientRequest request, VRDisplayInfoPtr display_info) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRSubmitFrameClientProxy
    : public VRSubmitFrameClient {
 public:
  explicit VRSubmitFrameClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnSubmitFrameTransferred() override;
  void OnSubmitFrameRendered() override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayProxy
    : public VRDisplay {
 public:
  explicit VRDisplayProxy(mojo::MessageReceiverWithResponder* receiver);
  void RequestPresent(bool secure_origin, VRSubmitFrameClientPtr client, VRPresentationProviderRequest request, RequestPresentCallback callback) override;
  void ExitPresent() override;
  void GetNextMagicWindowPose(GetNextMagicWindowPoseCallback callback) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRPresentationProviderProxy
    : public VRPresentationProvider {
 public:
  explicit VRPresentationProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  void GetVSync(GetVSyncCallback callback) override;
  void SubmitFrame(int16_t frame_id, const ::gpu::MailboxHolder& mailbox_holder) override;
  void UpdateLayerBounds(int16_t frame_id, const ::blink::WebFloatRect& left_bounds, const ::blink::WebFloatRect& right_bounds, const ::blink::WebSize& source_size) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayClientProxy
    : public VRDisplayClient {
 public:
  explicit VRDisplayClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnChanged(VRDisplayInfoPtr display) override;
  void OnExitPresent() override;
  void OnBlur() override;
  void OnFocus() override;
  void OnActivate(VRDisplayEventReason reason, OnActivateCallback callback) override;
  void OnDeactivate(VRDisplayEventReason reason) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceStubDispatch {
 public:
  static bool Accept(VRService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRService>>
class VRServiceStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRServiceStub() {}
  ~VRServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceClientStubDispatch {
 public:
  static bool Accept(VRServiceClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRServiceClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRServiceClient>>
class VRServiceClientStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRServiceClientStub() {}
  ~VRServiceClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRSubmitFrameClientStubDispatch {
 public:
  static bool Accept(VRSubmitFrameClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRSubmitFrameClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRSubmitFrameClient>>
class VRSubmitFrameClientStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRSubmitFrameClientStub() {}
  ~VRSubmitFrameClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRSubmitFrameClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRSubmitFrameClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayStubDispatch {
 public:
  static bool Accept(VRDisplay* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRDisplay* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRDisplay>>
class VRDisplayStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRDisplayStub() {}
  ~VRDisplayStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRPresentationProviderStubDispatch {
 public:
  static bool Accept(VRPresentationProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRPresentationProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRPresentationProvider>>
class VRPresentationProviderStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRPresentationProviderStub() {}
  ~VRPresentationProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRPresentationProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRPresentationProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayClientStubDispatch {
 public:
  static bool Accept(VRDisplayClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRDisplayClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRDisplayClient>>
class VRDisplayClientStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRDisplayClientStub() {}
  ~VRDisplayClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceClientRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRSubmitFrameClientRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRPresentationProviderRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayClientRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRServiceResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRPresentationProviderResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayClientResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};


class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRFieldOfView {
 public:
  using DataView = VRFieldOfViewDataView;
  using Data_ = internal::VRFieldOfView_Data;

  template <typename... Args>
  static VRFieldOfViewPtr New(Args&&... args) {
    return VRFieldOfViewPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRFieldOfViewPtr From(const U& u) {
    return mojo::TypeConverter<VRFieldOfViewPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRFieldOfView>::Convert(*this);
  }


  VRFieldOfView();

  VRFieldOfView(
      float upDegrees,
      float downDegrees,
      float leftDegrees,
      float rightDegrees);

  ~VRFieldOfView();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRFieldOfViewPtr>
  VRFieldOfViewPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRFieldOfView>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        VRFieldOfView::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        VRFieldOfView::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  float upDegrees;
  float downDegrees;
  float leftDegrees;
  float rightDegrees;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};




class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayCapabilities {
 public:
  using DataView = VRDisplayCapabilitiesDataView;
  using Data_ = internal::VRDisplayCapabilities_Data;

  template <typename... Args>
  static VRDisplayCapabilitiesPtr New(Args&&... args) {
    return VRDisplayCapabilitiesPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRDisplayCapabilitiesPtr From(const U& u) {
    return mojo::TypeConverter<VRDisplayCapabilitiesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRDisplayCapabilities>::Convert(*this);
  }


  VRDisplayCapabilities();

  VRDisplayCapabilities(
      bool hasPosition,
      bool hasExternalDisplay,
      bool canPresent);

  ~VRDisplayCapabilities();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRDisplayCapabilitiesPtr>
  VRDisplayCapabilitiesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRDisplayCapabilities>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        VRDisplayCapabilities::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        VRDisplayCapabilities::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  bool hasPosition;
  bool hasExternalDisplay;
  bool canPresent;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};









class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRPose {
 public:
  using DataView = VRPoseDataView;
  using Data_ = internal::VRPose_Data;

  template <typename... Args>
  static VRPosePtr New(Args&&... args) {
    return VRPosePtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRPosePtr From(const U& u) {
    return mojo::TypeConverter<VRPosePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRPose>::Convert(*this);
  }


  VRPose();

  VRPose(
      const WTF::Optional<WTF::Vector<float>>& orientation,
      const WTF::Optional<WTF::Vector<float>>& position,
      const WTF::Optional<WTF::Vector<float>>& angularVelocity,
      const WTF::Optional<WTF::Vector<float>>& linearVelocity,
      const WTF::Optional<WTF::Vector<float>>& angularAcceleration,
      const WTF::Optional<WTF::Vector<float>>& linearAcceleration);

  ~VRPose();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRPosePtr>
  VRPosePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRPose>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        VRPose::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        VRPose::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  WTF::Optional<WTF::Vector<float>> orientation;
  WTF::Optional<WTF::Vector<float>> position;
  WTF::Optional<WTF::Vector<float>> angularVelocity;
  WTF::Optional<WTF::Vector<float>> linearVelocity;
  WTF::Optional<WTF::Vector<float>> angularAcceleration;
  WTF::Optional<WTF::Vector<float>> linearAcceleration;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};




class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VREyeParameters {
 public:
  using DataView = VREyeParametersDataView;
  using Data_ = internal::VREyeParameters_Data;

  template <typename... Args>
  static VREyeParametersPtr New(Args&&... args) {
    return VREyeParametersPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VREyeParametersPtr From(const U& u) {
    return mojo::TypeConverter<VREyeParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VREyeParameters>::Convert(*this);
  }


  VREyeParameters();

  VREyeParameters(
      VRFieldOfViewPtr fieldOfView,
      const WTF::Vector<float>& offset,
      uint32_t renderWidth,
      uint32_t renderHeight);

  ~VREyeParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VREyeParametersPtr>
  VREyeParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VREyeParameters>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        VREyeParameters::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        VREyeParameters::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  VRFieldOfViewPtr fieldOfView;
  WTF::Vector<float> offset;
  uint32_t renderWidth;
  uint32_t renderHeight;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(VREyeParameters);
};



class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRStageParameters {
 public:
  using DataView = VRStageParametersDataView;
  using Data_ = internal::VRStageParameters_Data;

  template <typename... Args>
  static VRStageParametersPtr New(Args&&... args) {
    return VRStageParametersPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRStageParametersPtr From(const U& u) {
    return mojo::TypeConverter<VRStageParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRStageParameters>::Convert(*this);
  }


  VRStageParameters();

  VRStageParameters(
      const WTF::Vector<float>& standingTransform,
      float sizeX,
      float sizeZ);

  ~VRStageParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRStageParametersPtr>
  VRStageParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRStageParameters>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        VRStageParameters::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        VRStageParameters::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  WTF::Vector<float> standingTransform;
  float sizeX;
  float sizeZ;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};



class DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT VRDisplayInfo {
 public:
  using DataView = VRDisplayInfoDataView;
  using Data_ = internal::VRDisplayInfo_Data;

  template <typename... Args>
  static VRDisplayInfoPtr New(Args&&... args) {
    return VRDisplayInfoPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRDisplayInfoPtr From(const U& u) {
    return mojo::TypeConverter<VRDisplayInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRDisplayInfo>::Convert(*this);
  }


  VRDisplayInfo();

  VRDisplayInfo(
      uint32_t index,
      const WTF::String& displayName,
      VRDisplayCapabilitiesPtr capabilities,
      VRStageParametersPtr stageParameters,
      VREyeParametersPtr leftEye,
      VREyeParametersPtr rightEye);

  ~VRDisplayInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRDisplayInfoPtr>
  VRDisplayInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRDisplayInfo>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        VRDisplayInfo::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        VRDisplayInfo::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  uint32_t index;
  WTF::String displayName;
  VRDisplayCapabilitiesPtr capabilities;
  VRStageParametersPtr stageParameters;
  VREyeParametersPtr leftEye;
  VREyeParametersPtr rightEye;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(VRDisplayInfo);
};


template <typename StructPtrType>
VRFieldOfViewPtr VRFieldOfView::Clone() const {
  return New(
      mojo::Clone(upDegrees),
      mojo::Clone(downDegrees),
      mojo::Clone(leftDegrees),
      mojo::Clone(rightDegrees)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRFieldOfView>::value>::type*>
bool VRFieldOfView::Equals(const T& other) const {
  if (!mojo::Equals(this->upDegrees, other.upDegrees))
    return false;
  if (!mojo::Equals(this->downDegrees, other.downDegrees))
    return false;
  if (!mojo::Equals(this->leftDegrees, other.leftDegrees))
    return false;
  if (!mojo::Equals(this->rightDegrees, other.rightDegrees))
    return false;
  return true;
}
template <typename StructPtrType>
VRPosePtr VRPose::Clone() const {
  return New(
      mojo::Clone(orientation),
      mojo::Clone(position),
      mojo::Clone(angularVelocity),
      mojo::Clone(linearVelocity),
      mojo::Clone(angularAcceleration),
      mojo::Clone(linearAcceleration)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRPose>::value>::type*>
bool VRPose::Equals(const T& other) const {
  if (!mojo::Equals(this->orientation, other.orientation))
    return false;
  if (!mojo::Equals(this->position, other.position))
    return false;
  if (!mojo::Equals(this->angularVelocity, other.angularVelocity))
    return false;
  if (!mojo::Equals(this->linearVelocity, other.linearVelocity))
    return false;
  if (!mojo::Equals(this->angularAcceleration, other.angularAcceleration))
    return false;
  if (!mojo::Equals(this->linearAcceleration, other.linearAcceleration))
    return false;
  return true;
}
template <typename StructPtrType>
VRDisplayCapabilitiesPtr VRDisplayCapabilities::Clone() const {
  return New(
      mojo::Clone(hasPosition),
      mojo::Clone(hasExternalDisplay),
      mojo::Clone(canPresent)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRDisplayCapabilities>::value>::type*>
bool VRDisplayCapabilities::Equals(const T& other) const {
  if (!mojo::Equals(this->hasPosition, other.hasPosition))
    return false;
  if (!mojo::Equals(this->hasExternalDisplay, other.hasExternalDisplay))
    return false;
  if (!mojo::Equals(this->canPresent, other.canPresent))
    return false;
  return true;
}
template <typename StructPtrType>
VREyeParametersPtr VREyeParameters::Clone() const {
  return New(
      mojo::Clone(fieldOfView),
      mojo::Clone(offset),
      mojo::Clone(renderWidth),
      mojo::Clone(renderHeight)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VREyeParameters>::value>::type*>
bool VREyeParameters::Equals(const T& other) const {
  if (!mojo::Equals(this->fieldOfView, other.fieldOfView))
    return false;
  if (!mojo::Equals(this->offset, other.offset))
    return false;
  if (!mojo::Equals(this->renderWidth, other.renderWidth))
    return false;
  if (!mojo::Equals(this->renderHeight, other.renderHeight))
    return false;
  return true;
}
template <typename StructPtrType>
VRStageParametersPtr VRStageParameters::Clone() const {
  return New(
      mojo::Clone(standingTransform),
      mojo::Clone(sizeX),
      mojo::Clone(sizeZ)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRStageParameters>::value>::type*>
bool VRStageParameters::Equals(const T& other) const {
  if (!mojo::Equals(this->standingTransform, other.standingTransform))
    return false;
  if (!mojo::Equals(this->sizeX, other.sizeX))
    return false;
  if (!mojo::Equals(this->sizeZ, other.sizeZ))
    return false;
  return true;
}
template <typename StructPtrType>
VRDisplayInfoPtr VRDisplayInfo::Clone() const {
  return New(
      mojo::Clone(index),
      mojo::Clone(displayName),
      mojo::Clone(capabilities),
      mojo::Clone(stageParameters),
      mojo::Clone(leftEye),
      mojo::Clone(rightEye)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRDisplayInfo>::value>::type*>
bool VRDisplayInfo::Equals(const T& other) const {
  if (!mojo::Equals(this->index, other.index))
    return false;
  if (!mojo::Equals(this->displayName, other.displayName))
    return false;
  if (!mojo::Equals(this->capabilities, other.capabilities))
    return false;
  if (!mojo::Equals(this->stageParameters, other.stageParameters))
    return false;
  if (!mojo::Equals(this->leftEye, other.leftEye))
    return false;
  if (!mojo::Equals(this->rightEye, other.rightEye))
    return false;
  return true;
}


}  // namespace blink
}  // namespace mojom
}  // namespace device

namespace mojo {


template <>
struct DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT StructTraits<::device::mojom::blink::VRFieldOfView::DataView,
                                         ::device::mojom::blink::VRFieldOfViewPtr> {
  static bool IsNull(const ::device::mojom::blink::VRFieldOfViewPtr& input) { return !input; }
  static void SetToNull(::device::mojom::blink::VRFieldOfViewPtr* output) { output->reset(); }

  static decltype(::device::mojom::blink::VRFieldOfView::upDegrees) upDegrees(
      const ::device::mojom::blink::VRFieldOfViewPtr& input) {
    return input->upDegrees;
  }

  static decltype(::device::mojom::blink::VRFieldOfView::downDegrees) downDegrees(
      const ::device::mojom::blink::VRFieldOfViewPtr& input) {
    return input->downDegrees;
  }

  static decltype(::device::mojom::blink::VRFieldOfView::leftDegrees) leftDegrees(
      const ::device::mojom::blink::VRFieldOfViewPtr& input) {
    return input->leftDegrees;
  }

  static decltype(::device::mojom::blink::VRFieldOfView::rightDegrees) rightDegrees(
      const ::device::mojom::blink::VRFieldOfViewPtr& input) {
    return input->rightDegrees;
  }

  static bool Read(::device::mojom::blink::VRFieldOfView::DataView input, ::device::mojom::blink::VRFieldOfViewPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT StructTraits<::device::mojom::blink::VRPose::DataView,
                                         ::device::mojom::blink::VRPosePtr> {
  static bool IsNull(const ::device::mojom::blink::VRPosePtr& input) { return !input; }
  static void SetToNull(::device::mojom::blink::VRPosePtr* output) { output->reset(); }

  static const decltype(::device::mojom::blink::VRPose::orientation)& orientation(
      const ::device::mojom::blink::VRPosePtr& input) {
    return input->orientation;
  }

  static const decltype(::device::mojom::blink::VRPose::position)& position(
      const ::device::mojom::blink::VRPosePtr& input) {
    return input->position;
  }

  static const decltype(::device::mojom::blink::VRPose::angularVelocity)& angularVelocity(
      const ::device::mojom::blink::VRPosePtr& input) {
    return input->angularVelocity;
  }

  static const decltype(::device::mojom::blink::VRPose::linearVelocity)& linearVelocity(
      const ::device::mojom::blink::VRPosePtr& input) {
    return input->linearVelocity;
  }

  static const decltype(::device::mojom::blink::VRPose::angularAcceleration)& angularAcceleration(
      const ::device::mojom::blink::VRPosePtr& input) {
    return input->angularAcceleration;
  }

  static const decltype(::device::mojom::blink::VRPose::linearAcceleration)& linearAcceleration(
      const ::device::mojom::blink::VRPosePtr& input) {
    return input->linearAcceleration;
  }

  static bool Read(::device::mojom::blink::VRPose::DataView input, ::device::mojom::blink::VRPosePtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT StructTraits<::device::mojom::blink::VRDisplayCapabilities::DataView,
                                         ::device::mojom::blink::VRDisplayCapabilitiesPtr> {
  static bool IsNull(const ::device::mojom::blink::VRDisplayCapabilitiesPtr& input) { return !input; }
  static void SetToNull(::device::mojom::blink::VRDisplayCapabilitiesPtr* output) { output->reset(); }

  static decltype(::device::mojom::blink::VRDisplayCapabilities::hasPosition) hasPosition(
      const ::device::mojom::blink::VRDisplayCapabilitiesPtr& input) {
    return input->hasPosition;
  }

  static decltype(::device::mojom::blink::VRDisplayCapabilities::hasExternalDisplay) hasExternalDisplay(
      const ::device::mojom::blink::VRDisplayCapabilitiesPtr& input) {
    return input->hasExternalDisplay;
  }

  static decltype(::device::mojom::blink::VRDisplayCapabilities::canPresent) canPresent(
      const ::device::mojom::blink::VRDisplayCapabilitiesPtr& input) {
    return input->canPresent;
  }

  static bool Read(::device::mojom::blink::VRDisplayCapabilities::DataView input, ::device::mojom::blink::VRDisplayCapabilitiesPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT StructTraits<::device::mojom::blink::VREyeParameters::DataView,
                                         ::device::mojom::blink::VREyeParametersPtr> {
  static bool IsNull(const ::device::mojom::blink::VREyeParametersPtr& input) { return !input; }
  static void SetToNull(::device::mojom::blink::VREyeParametersPtr* output) { output->reset(); }

  static const decltype(::device::mojom::blink::VREyeParameters::fieldOfView)& fieldOfView(
      const ::device::mojom::blink::VREyeParametersPtr& input) {
    return input->fieldOfView;
  }

  static const decltype(::device::mojom::blink::VREyeParameters::offset)& offset(
      const ::device::mojom::blink::VREyeParametersPtr& input) {
    return input->offset;
  }

  static decltype(::device::mojom::blink::VREyeParameters::renderWidth) renderWidth(
      const ::device::mojom::blink::VREyeParametersPtr& input) {
    return input->renderWidth;
  }

  static decltype(::device::mojom::blink::VREyeParameters::renderHeight) renderHeight(
      const ::device::mojom::blink::VREyeParametersPtr& input) {
    return input->renderHeight;
  }

  static bool Read(::device::mojom::blink::VREyeParameters::DataView input, ::device::mojom::blink::VREyeParametersPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT StructTraits<::device::mojom::blink::VRStageParameters::DataView,
                                         ::device::mojom::blink::VRStageParametersPtr> {
  static bool IsNull(const ::device::mojom::blink::VRStageParametersPtr& input) { return !input; }
  static void SetToNull(::device::mojom::blink::VRStageParametersPtr* output) { output->reset(); }

  static const decltype(::device::mojom::blink::VRStageParameters::standingTransform)& standingTransform(
      const ::device::mojom::blink::VRStageParametersPtr& input) {
    return input->standingTransform;
  }

  static decltype(::device::mojom::blink::VRStageParameters::sizeX) sizeX(
      const ::device::mojom::blink::VRStageParametersPtr& input) {
    return input->sizeX;
  }

  static decltype(::device::mojom::blink::VRStageParameters::sizeZ) sizeZ(
      const ::device::mojom::blink::VRStageParametersPtr& input) {
    return input->sizeZ;
  }

  static bool Read(::device::mojom::blink::VRStageParameters::DataView input, ::device::mojom::blink::VRStageParametersPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_BLINK_EXPORT StructTraits<::device::mojom::blink::VRDisplayInfo::DataView,
                                         ::device::mojom::blink::VRDisplayInfoPtr> {
  static bool IsNull(const ::device::mojom::blink::VRDisplayInfoPtr& input) { return !input; }
  static void SetToNull(::device::mojom::blink::VRDisplayInfoPtr* output) { output->reset(); }

  static decltype(::device::mojom::blink::VRDisplayInfo::index) index(
      const ::device::mojom::blink::VRDisplayInfoPtr& input) {
    return input->index;
  }

  static const decltype(::device::mojom::blink::VRDisplayInfo::displayName)& displayName(
      const ::device::mojom::blink::VRDisplayInfoPtr& input) {
    return input->displayName;
  }

  static const decltype(::device::mojom::blink::VRDisplayInfo::capabilities)& capabilities(
      const ::device::mojom::blink::VRDisplayInfoPtr& input) {
    return input->capabilities;
  }

  static const decltype(::device::mojom::blink::VRDisplayInfo::stageParameters)& stageParameters(
      const ::device::mojom::blink::VRDisplayInfoPtr& input) {
    return input->stageParameters;
  }

  static const decltype(::device::mojom::blink::VRDisplayInfo::leftEye)& leftEye(
      const ::device::mojom::blink::VRDisplayInfoPtr& input) {
    return input->leftEye;
  }

  static const decltype(::device::mojom::blink::VRDisplayInfo::rightEye)& rightEye(
      const ::device::mojom::blink::VRDisplayInfoPtr& input) {
    return input->rightEye;
  }

  static bool Read(::device::mojom::blink::VRDisplayInfo::DataView input, ::device::mojom::blink::VRDisplayInfoPtr* output);
};

}  // namespace mojo

#endif  // DEVICE_VR_VR_SERVICE_MOJOM_BLINK_H_