// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "media/gpu/mojo/jpeg_decoder.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "ipc/ipc_message_utils.h"
#include "media/base/ipc/media_param_traits_macros.h"
#include "media/gpu/mojo/jpeg_decoder_typemap_traits.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace media {
namespace mojom {
BitstreamBuffer::BitstreamBuffer()
    : id(),
      memory_handle(),
      size(),
      offset(),
      timestamp(),
      key_id(),
      iv(),
      subsamples() {}

BitstreamBuffer::BitstreamBuffer(
    int32_t id_in,
    mojo::ScopedSharedBufferHandle memory_handle_in,
    uint32_t size_in,
    int64_t offset_in,
    base::TimeDelta timestamp_in,
    const std::string& key_id_in,
    const std::string& iv_in,
    const std::vector<media::SubsampleEntry>& subsamples_in)
    : id(std::move(id_in)),
      memory_handle(std::move(memory_handle_in)),
      size(std::move(size_in)),
      offset(std::move(offset_in)),
      timestamp(std::move(timestamp_in)),
      key_id(std::move(key_id_in)),
      iv(std::move(iv_in)),
      subsamples(std::move(subsamples_in)) {}

BitstreamBuffer::~BitstreamBuffer() = default;

bool BitstreamBuffer::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char GpuJpegDecodeAccelerator::Name_[] = "media::mojom::GpuJpegDecodeAccelerator";

class GpuJpegDecodeAccelerator_Initialize_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  GpuJpegDecodeAccelerator_Initialize_ForwardToCallback(
      GpuJpegDecodeAccelerator::InitializeCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  GpuJpegDecodeAccelerator::InitializeCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(GpuJpegDecodeAccelerator_Initialize_ForwardToCallback);
};

class GpuJpegDecodeAccelerator_Decode_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  GpuJpegDecodeAccelerator_Decode_ForwardToCallback(
      GpuJpegDecodeAccelerator::DecodeCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  GpuJpegDecodeAccelerator::DecodeCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(GpuJpegDecodeAccelerator_Decode_ForwardToCallback);
};

GpuJpegDecodeAcceleratorProxy::GpuJpegDecodeAcceleratorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void GpuJpegDecodeAcceleratorProxy::Initialize(
    InitializeCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::media::mojom::internal::GpuJpegDecodeAccelerator_Initialize_Params_Data);
  serialization_context.PrepareMessage(
      internal::kGpuJpegDecodeAccelerator_Initialize_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::media::mojom::internal::GpuJpegDecodeAccelerator_Initialize_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new GpuJpegDecodeAccelerator_Initialize_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void GpuJpegDecodeAcceleratorProxy::Decode(
    const media::BitstreamBuffer& in_input_buffer, const gfx::Size& in_coded_size, mojo::ScopedSharedBufferHandle in_output_handle, uint32_t in_output_buffer_size, DecodeCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::media::mojom::internal::GpuJpegDecodeAccelerator_Decode_Params_Data);
  size += mojo::internal::PrepareToSerialize<::media::mojom::BitstreamBufferDataView>(
      in_input_buffer, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::gfx::mojom::SizeDataView>(
      in_coded_size, &serialization_context);
  size += mojo::internal::PrepareToSerialize<mojo::ScopedSharedBufferHandle>(
      in_output_handle, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kGpuJpegDecodeAccelerator_Decode_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::media::mojom::internal::GpuJpegDecodeAccelerator_Decode_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->input_buffer)::BaseType* input_buffer_ptr;
  mojo::internal::Serialize<::media::mojom::BitstreamBufferDataView>(
      in_input_buffer, buffer, &input_buffer_ptr, &serialization_context);
  params->input_buffer.Set(input_buffer_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->input_buffer.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null input_buffer in GpuJpegDecodeAccelerator.Decode request");
  typename decltype(params->coded_size)::BaseType* coded_size_ptr;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_coded_size, buffer, &coded_size_ptr, &serialization_context);
  params->coded_size.Set(coded_size_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->coded_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null coded_size in GpuJpegDecodeAccelerator.Decode request");
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_output_handle, &params->output_handle, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->output_handle),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid output_handle in GpuJpegDecodeAccelerator.Decode request");
  params->output_buffer_size = in_output_buffer_size;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new GpuJpegDecodeAccelerator_Decode_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void GpuJpegDecodeAcceleratorProxy::Uninitialize(
    ) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::media::mojom::internal::GpuJpegDecodeAccelerator_Uninitialize_Params_Data);
  serialization_context.PrepareMessage(
      internal::kGpuJpegDecodeAccelerator_Uninitialize_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::media::mojom::internal::GpuJpegDecodeAccelerator_Uninitialize_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class GpuJpegDecodeAccelerator_Initialize_ProxyToResponder {
 public:
  static GpuJpegDecodeAccelerator::InitializeCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<GpuJpegDecodeAccelerator_Initialize_ProxyToResponder> proxy(
        new GpuJpegDecodeAccelerator_Initialize_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&GpuJpegDecodeAccelerator_Initialize_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~GpuJpegDecodeAccelerator_Initialize_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "GpuJpegDecodeAccelerator::Initialize() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  GpuJpegDecodeAccelerator_Initialize_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(GpuJpegDecodeAccelerator_Initialize_ProxyToResponder);
};

bool GpuJpegDecodeAccelerator_Initialize_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data* params =
      reinterpret_cast<
          internal::GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  GpuJpegDecodeAccelerator_Initialize_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "GpuJpegDecodeAccelerator::Initialize response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void GpuJpegDecodeAccelerator_Initialize_ProxyToResponder::Run(
    bool in_success) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::media::mojom::internal::GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kGpuJpegDecodeAccelerator_Initialize_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::media::mojom::internal::GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->success = in_success;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class GpuJpegDecodeAccelerator_Decode_ProxyToResponder {
 public:
  static GpuJpegDecodeAccelerator::DecodeCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<GpuJpegDecodeAccelerator_Decode_ProxyToResponder> proxy(
        new GpuJpegDecodeAccelerator_Decode_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&GpuJpegDecodeAccelerator_Decode_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~GpuJpegDecodeAccelerator_Decode_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "GpuJpegDecodeAccelerator::Decode() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  GpuJpegDecodeAccelerator_Decode_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      int32_t in_bitstream_buffer_id, media::JpegDecodeAccelerator::Error in_error);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(GpuJpegDecodeAccelerator_Decode_ProxyToResponder);
};

bool GpuJpegDecodeAccelerator_Decode_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::GpuJpegDecodeAccelerator_Decode_ResponseParams_Data* params =
      reinterpret_cast<
          internal::GpuJpegDecodeAccelerator_Decode_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_bitstream_buffer_id{};
  media::JpegDecodeAccelerator::Error p_error{};
  GpuJpegDecodeAccelerator_Decode_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_bitstream_buffer_id = input_data_view.bitstream_buffer_id();
  if (!input_data_view.ReadError(&p_error))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "GpuJpegDecodeAccelerator::Decode response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_bitstream_buffer_id), 
std::move(p_error));
  return true;
}

void GpuJpegDecodeAccelerator_Decode_ProxyToResponder::Run(
    int32_t in_bitstream_buffer_id, media::JpegDecodeAccelerator::Error in_error) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::media::mojom::internal::GpuJpegDecodeAccelerator_Decode_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kGpuJpegDecodeAccelerator_Decode_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::media::mojom::internal::GpuJpegDecodeAccelerator_Decode_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->bitstream_buffer_id = in_bitstream_buffer_id;
  mojo::internal::Serialize<::media::mojom::DecodeError>(
      in_error, &params->error);

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool GpuJpegDecodeAcceleratorStubDispatch::Accept(
    GpuJpegDecodeAccelerator* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kGpuJpegDecodeAccelerator_Initialize_Name: {
      break;
    }
    case internal::kGpuJpegDecodeAccelerator_Decode_Name: {
      break;
    }
    case internal::kGpuJpegDecodeAccelerator_Uninitialize_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::GpuJpegDecodeAccelerator_Uninitialize_Params_Data* params =
          reinterpret_cast<internal::GpuJpegDecodeAccelerator_Uninitialize_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      GpuJpegDecodeAccelerator_Uninitialize_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "GpuJpegDecodeAccelerator::Uninitialize deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->Uninitialize();
      return true;
    }
  }
  return false;
}

// static
bool GpuJpegDecodeAcceleratorStubDispatch::AcceptWithResponder(
    GpuJpegDecodeAccelerator* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kGpuJpegDecodeAccelerator_Initialize_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::GpuJpegDecodeAccelerator_Initialize_Params_Data* params =
          reinterpret_cast<
              internal::GpuJpegDecodeAccelerator_Initialize_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      GpuJpegDecodeAccelerator_Initialize_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "GpuJpegDecodeAccelerator::Initialize deserializer");
        return false;
      }
      GpuJpegDecodeAccelerator::InitializeCallback callback =
          GpuJpegDecodeAccelerator_Initialize_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->Initialize(std::move(callback));
      return true;
    }
    case internal::kGpuJpegDecodeAccelerator_Decode_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::GpuJpegDecodeAccelerator_Decode_Params_Data* params =
          reinterpret_cast<
              internal::GpuJpegDecodeAccelerator_Decode_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      media::BitstreamBuffer p_input_buffer{};
      gfx::Size p_coded_size{};
      mojo::ScopedSharedBufferHandle p_output_handle{};
      uint32_t p_output_buffer_size{};
      GpuJpegDecodeAccelerator_Decode_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadInputBuffer(&p_input_buffer))
        success = false;
      if (!input_data_view.ReadCodedSize(&p_coded_size))
        success = false;
      p_output_handle = input_data_view.TakeOutputHandle();
      p_output_buffer_size = input_data_view.output_buffer_size();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "GpuJpegDecodeAccelerator::Decode deserializer");
        return false;
      }
      GpuJpegDecodeAccelerator::DecodeCallback callback =
          GpuJpegDecodeAccelerator_Decode_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->Decode(
std::move(p_input_buffer), 
std::move(p_coded_size), 
std::move(p_output_handle), 
std::move(p_output_buffer_size), std::move(callback));
      return true;
    }
    case internal::kGpuJpegDecodeAccelerator_Uninitialize_Name: {
      break;
    }
  }
  return false;
}

bool GpuJpegDecodeAcceleratorRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "GpuJpegDecodeAccelerator RequestValidator");

  switch (message->header()->name) {
    case internal::kGpuJpegDecodeAccelerator_Initialize_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GpuJpegDecodeAccelerator_Initialize_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kGpuJpegDecodeAccelerator_Decode_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GpuJpegDecodeAccelerator_Decode_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kGpuJpegDecodeAccelerator_Uninitialize_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GpuJpegDecodeAccelerator_Uninitialize_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool GpuJpegDecodeAcceleratorResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "GpuJpegDecodeAccelerator ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kGpuJpegDecodeAccelerator_Initialize_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kGpuJpegDecodeAccelerator_Decode_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::GpuJpegDecodeAccelerator_Decode_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace media

namespace mojo {


// static
bool StructTraits<::media::mojom::BitstreamBuffer::DataView, ::media::mojom::BitstreamBufferPtr>::Read(
    ::media::mojom::BitstreamBuffer::DataView input,
    ::media::mojom::BitstreamBufferPtr* output) {
  bool success = true;
  ::media::mojom::BitstreamBufferPtr result(::media::mojom::BitstreamBuffer::New());
  
      result->id = input.id();
      result->memory_handle = input.TakeMemoryHandle();
      result->size = input.size();
      result->offset = input.offset();
      if (!input.ReadTimestamp(&result->timestamp))
        success = false;
      if (!input.ReadKeyId(&result->key_id))
        success = false;
      if (!input.ReadIv(&result->iv))
        success = false;
      if (!input.ReadSubsamples(&result->subsamples))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif