// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_INTERFACES_WAKE_LOCK_PROVIDER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_DEVICE_PUBLIC_INTERFACES_WAKE_LOCK_PROVIDER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/device/public/interfaces/wake_lock_context.mojom-shared-internal.h"
#include "services/device/public/interfaces/wake_lock.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kWakeLockProvider_GetWakeLockContextForID_Name = 0;
class  WakeLockProvider_GetWakeLockContextForID_Params_Data {
 public:
  static WakeLockProvider_GetWakeLockContextForID_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t context_id;
  mojo::internal::Handle_Data context;

 private:
  WakeLockProvider_GetWakeLockContextForID_Params_Data();
  ~WakeLockProvider_GetWakeLockContextForID_Params_Data() = delete;
};
static_assert(sizeof(WakeLockProvider_GetWakeLockContextForID_Params_Data) == 16,
              "Bad sizeof(WakeLockProvider_GetWakeLockContextForID_Params_Data)");
constexpr uint32_t kWakeLockProvider_GetWakeLockWithoutContext_Name = 1;
class  WakeLockProvider_GetWakeLockWithoutContext_Params_Data {
 public:
  static WakeLockProvider_GetWakeLockWithoutContext_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t type;
  int32_t reason;
  mojo::internal::Pointer<mojo::internal::String_Data> description;
  mojo::internal::Handle_Data wake_lock;
  uint8_t padfinal_[4];

 private:
  WakeLockProvider_GetWakeLockWithoutContext_Params_Data();
  ~WakeLockProvider_GetWakeLockWithoutContext_Params_Data() = delete;
};
static_assert(sizeof(WakeLockProvider_GetWakeLockWithoutContext_Params_Data) == 32,
              "Bad sizeof(WakeLockProvider_GetWakeLockWithoutContext_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // SERVICES_DEVICE_PUBLIC_INTERFACES_WAKE_LOCK_PROVIDER_MOJOM_SHARED_INTERNAL_H_