// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_METRICS_PUBLIC_INTERFACES_UKM_INTERFACE_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_METRICS_PUBLIC_INTERFACES_UKM_INTERFACE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "url/mojo/url.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ukm {
namespace mojom {
namespace internal {
class UkmMetric_Data;
class UkmEntry_Data;

#pragma pack(push, 1)
class  UkmMetric_Data {
 public:
  static UkmMetric_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t metric_hash;
  int64_t value;

 private:
  UkmMetric_Data();
  ~UkmMetric_Data() = delete;
};
static_assert(sizeof(UkmMetric_Data) == 24,
              "Bad sizeof(UkmMetric_Data)");
class  UkmEntry_Data {
 public:
  static UkmEntry_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t source_id;
  uint64_t event_hash;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::UkmMetric_Data>>> metrics;

 private:
  UkmEntry_Data();
  ~UkmEntry_Data() = delete;
};
static_assert(sizeof(UkmEntry_Data) == 32,
              "Bad sizeof(UkmEntry_Data)");
constexpr uint32_t kUkmRecorderInterface_AddEntry_Name = 0;
class  UkmRecorderInterface_AddEntry_Params_Data {
 public:
  static UkmRecorderInterface_AddEntry_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::UkmEntry_Data> entry;

 private:
  UkmRecorderInterface_AddEntry_Params_Data();
  ~UkmRecorderInterface_AddEntry_Params_Data() = delete;
};
static_assert(sizeof(UkmRecorderInterface_AddEntry_Params_Data) == 16,
              "Bad sizeof(UkmRecorderInterface_AddEntry_Params_Data)");
constexpr uint32_t kUkmRecorderInterface_UpdateSourceURL_Name = 1;
class  UkmRecorderInterface_UpdateSourceURL_Params_Data {
 public:
  static UkmRecorderInterface_UpdateSourceURL_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t source_id;
  mojo::internal::Pointer<mojo::internal::String_Data> url;

 private:
  UkmRecorderInterface_UpdateSourceURL_Params_Data();
  ~UkmRecorderInterface_UpdateSourceURL_Params_Data() = delete;
};
static_assert(sizeof(UkmRecorderInterface_UpdateSourceURL_Params_Data) == 24,
              "Bad sizeof(UkmRecorderInterface_UpdateSourceURL_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ukm

#endif  // SERVICES_METRICS_PUBLIC_INTERFACES_UKM_INTERFACE_MOJOM_SHARED_INTERNAL_H_