// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/resource_coordinator/public/interfaces/coordination_unit.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "ipc/ipc_message_utils.h"
#include "mojo/common/values_struct_traits.h"
namespace resource_coordinator {
namespace mojom {
namespace blink {
CoordinationUnitID::CoordinationUnitID()
    : type(),
      id() {}

CoordinationUnitID::CoordinationUnitID(
    CoordinationUnitType type_in,
    int64_t id_in)
    : type(std::move(type_in)),
      id(std::move(id_in)) {}

CoordinationUnitID::~CoordinationUnitID() = default;
size_t CoordinationUnitID::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->type);
  seed = mojo::internal::WTFHash(seed, this->id);
  return seed;
}

bool CoordinationUnitID::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
CoordinationPolicy::CoordinationPolicy()
    : use_background_priority() {}

CoordinationPolicy::CoordinationPolicy(
    bool use_background_priority_in)
    : use_background_priority(std::move(use_background_priority_in)) {}

CoordinationPolicy::~CoordinationPolicy() = default;
size_t CoordinationPolicy::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->use_background_priority);
  return seed;
}

bool CoordinationPolicy::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char CoordinationPolicyCallback::Name_[] = "resource_coordinator::mojom::CoordinationPolicyCallback";

CoordinationPolicyCallbackProxy::CoordinationPolicyCallbackProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void CoordinationPolicyCallbackProxy::SetCoordinationPolicy(
    CoordinationPolicyPtr in_policy) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::CoordinationPolicyDataView>(
      in_policy, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationPolicyCallback_SetCoordinationPolicy_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->policy)::BaseType* policy_ptr;
  mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationPolicyDataView>(
      in_policy, buffer, &policy_ptr, &serialization_context);
  params->policy.Set(policy_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->policy.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null policy in CoordinationPolicyCallback.SetCoordinationPolicy request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool CoordinationPolicyCallbackStubDispatch::Accept(
    CoordinationPolicyCallback* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kCoordinationPolicyCallback_SetCoordinationPolicy_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data* params =
          reinterpret_cast<internal::CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      CoordinationPolicyPtr p_policy{};
      CoordinationPolicyCallback_SetCoordinationPolicy_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadPolicy(&p_policy))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationPolicyCallback::SetCoordinationPolicy deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetCoordinationPolicy(
std::move(p_policy));
      return true;
    }
  }
  return false;
}

// static
bool CoordinationPolicyCallbackStubDispatch::AcceptWithResponder(
    CoordinationPolicyCallback* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kCoordinationPolicyCallback_SetCoordinationPolicy_Name: {
      break;
    }
  }
  return false;
}

bool CoordinationPolicyCallbackRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "CoordinationPolicyCallback RequestValidator");

  switch (message->header()->name) {
    case internal::kCoordinationPolicyCallback_SetCoordinationPolicy_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char CoordinationUnit::Name_[] = "resource_coordinator::mojom::CoordinationUnit";

class CoordinationUnit_GetID_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  CoordinationUnit_GetID_ForwardToCallback(
      const CoordinationUnit::GetIDCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  CoordinationUnit::GetIDCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(CoordinationUnit_GetID_ForwardToCallback);
};

CoordinationUnitProxy::CoordinationUnitProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void CoordinationUnitProxy::SendEvent(
    ::resource_coordinator::mojom::blink::EventPtr in_event) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_SendEvent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::EventDataView>(
      in_event, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_SendEvent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_SendEvent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->event)::BaseType* event_ptr;
  mojo::internal::Serialize<::resource_coordinator::mojom::EventDataView>(
      in_event, buffer, &event_ptr, &serialization_context);
  params->event.Set(event_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->event.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null event in CoordinationUnit.SendEvent request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void CoordinationUnitProxy::GetID(
    const GetIDCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_GetID_Params_Data);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_GetID_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_GetID_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new CoordinationUnit_GetID_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void CoordinationUnitProxy::AddBinding(
    CoordinationUnitRequest in_request) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_AddBinding_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::CoordinationUnitRequestDataView>(
      in_request, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_AddBinding_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_AddBinding_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationUnitRequestDataView>(
      in_request, &params->request, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->request),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid request in CoordinationUnit.AddBinding request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void CoordinationUnitProxy::AddChild(
    CoordinationUnitIDPtr in_child_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_AddChild_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_child_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_AddChild_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_AddChild_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->child_id)::BaseType* child_id_ptr;
  mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_child_id, buffer, &child_id_ptr, &serialization_context);
  params->child_id.Set(child_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->child_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null child_id in CoordinationUnit.AddChild request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void CoordinationUnitProxy::RemoveChild(
    CoordinationUnitIDPtr in_child_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_RemoveChild_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_child_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_RemoveChild_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_RemoveChild_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->child_id)::BaseType* child_id_ptr;
  mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_child_id, buffer, &child_id_ptr, &serialization_context);
  params->child_id.Set(child_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->child_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null child_id in CoordinationUnit.RemoveChild request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void CoordinationUnitProxy::SetCoordinationPolicyCallback(
    CoordinationPolicyCallbackPtr in_callback) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_SetCoordinationPolicyCallback_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::CoordinationPolicyCallbackPtrDataView>(
      in_callback, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_SetCoordinationPolicyCallback_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_SetCoordinationPolicyCallback_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationPolicyCallbackPtrDataView>(
      in_callback, &params->callback, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->callback),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid callback in CoordinationUnit.SetCoordinationPolicyCallback request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void CoordinationUnitProxy::SetProperty(
    PropertyType in_property_type, std::unique_ptr<base::Value> in_value) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_SetProperty_Params_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::ValueDataView>(
      in_value, true, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_SetProperty_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_SetProperty_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::resource_coordinator::mojom::PropertyType>(
      in_property_type, &params->property_type);
  auto value_ptr = &params->value;
  mojo::internal::Serialize<::mojo::common::mojom::ValueDataView>(
      in_value, buffer, &value_ptr, true, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->value.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null value in CoordinationUnit.SetProperty request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class CoordinationUnit_GetID_ProxyToResponder {
 public:
  static CoordinationUnit::GetIDCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<CoordinationUnit_GetID_ProxyToResponder> proxy(
        new CoordinationUnit_GetID_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&CoordinationUnit_GetID_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~CoordinationUnit_GetID_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "CoordinationUnit::GetID() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  CoordinationUnit_GetID_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      CoordinationUnitIDPtr in_id);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(CoordinationUnit_GetID_ProxyToResponder);
};

bool CoordinationUnit_GetID_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::CoordinationUnit_GetID_ResponseParams_Data* params =
      reinterpret_cast<
          internal::CoordinationUnit_GetID_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  CoordinationUnitIDPtr p_id{};
  CoordinationUnit_GetID_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadId(&p_id))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "CoordinationUnit::GetID response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_id));
  return true;
}

void CoordinationUnit_GetID_ProxyToResponder::Run(
    CoordinationUnitIDPtr in_id) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::CoordinationUnit_GetID_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinationUnit_GetID_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::CoordinationUnit_GetID_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->id)::BaseType* id_ptr;
  mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_id, buffer, &id_ptr, &serialization_context);
  params->id.Set(id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool CoordinationUnitStubDispatch::Accept(
    CoordinationUnit* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kCoordinationUnit_SendEvent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CoordinationUnit_SendEvent_Params_Data* params =
          reinterpret_cast<internal::CoordinationUnit_SendEvent_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::resource_coordinator::mojom::blink::EventPtr p_event{};
      CoordinationUnit_SendEvent_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadEvent(&p_event))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationUnit::SendEvent deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SendEvent(
std::move(p_event));
      return true;
    }
    case internal::kCoordinationUnit_GetID_Name: {
      break;
    }
    case internal::kCoordinationUnit_AddBinding_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CoordinationUnit_AddBinding_Params_Data* params =
          reinterpret_cast<internal::CoordinationUnit_AddBinding_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      CoordinationUnitRequest p_request{};
      CoordinationUnit_AddBinding_ParamsDataView input_data_view(params, &serialization_context);
      
      p_request =
          input_data_view.TakeRequest<decltype(p_request)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationUnit::AddBinding deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->AddBinding(
std::move(p_request));
      return true;
    }
    case internal::kCoordinationUnit_AddChild_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CoordinationUnit_AddChild_Params_Data* params =
          reinterpret_cast<internal::CoordinationUnit_AddChild_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      CoordinationUnitIDPtr p_child_id{};
      CoordinationUnit_AddChild_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadChildId(&p_child_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationUnit::AddChild deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->AddChild(
std::move(p_child_id));
      return true;
    }
    case internal::kCoordinationUnit_RemoveChild_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CoordinationUnit_RemoveChild_Params_Data* params =
          reinterpret_cast<internal::CoordinationUnit_RemoveChild_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      CoordinationUnitIDPtr p_child_id{};
      CoordinationUnit_RemoveChild_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadChildId(&p_child_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationUnit::RemoveChild deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RemoveChild(
std::move(p_child_id));
      return true;
    }
    case internal::kCoordinationUnit_SetCoordinationPolicyCallback_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CoordinationUnit_SetCoordinationPolicyCallback_Params_Data* params =
          reinterpret_cast<internal::CoordinationUnit_SetCoordinationPolicyCallback_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      CoordinationPolicyCallbackPtr p_callback{};
      CoordinationUnit_SetCoordinationPolicyCallback_ParamsDataView input_data_view(params, &serialization_context);
      
      p_callback =
          input_data_view.TakeCallback<decltype(p_callback)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationUnit::SetCoordinationPolicyCallback deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetCoordinationPolicyCallback(
std::move(p_callback));
      return true;
    }
    case internal::kCoordinationUnit_SetProperty_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CoordinationUnit_SetProperty_Params_Data* params =
          reinterpret_cast<internal::CoordinationUnit_SetProperty_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      PropertyType p_property_type{};
      std::unique_ptr<base::Value> p_value{};
      CoordinationUnit_SetProperty_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadPropertyType(&p_property_type))
        success = false;
      if (!input_data_view.ReadValue(&p_value))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationUnit::SetProperty deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetProperty(
std::move(p_property_type), 
std::move(p_value));
      return true;
    }
  }
  return false;
}

// static
bool CoordinationUnitStubDispatch::AcceptWithResponder(
    CoordinationUnit* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kCoordinationUnit_SendEvent_Name: {
      break;
    }
    case internal::kCoordinationUnit_GetID_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::CoordinationUnit_GetID_Params_Data* params =
          reinterpret_cast<
              internal::CoordinationUnit_GetID_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      CoordinationUnit_GetID_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CoordinationUnit::GetID deserializer");
        return false;
      }
      CoordinationUnit::GetIDCallback callback =
          CoordinationUnit_GetID_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetID(std::move(callback));
      return true;
    }
    case internal::kCoordinationUnit_AddBinding_Name: {
      break;
    }
    case internal::kCoordinationUnit_AddChild_Name: {
      break;
    }
    case internal::kCoordinationUnit_RemoveChild_Name: {
      break;
    }
    case internal::kCoordinationUnit_SetCoordinationPolicyCallback_Name: {
      break;
    }
    case internal::kCoordinationUnit_SetProperty_Name: {
      break;
    }
  }
  return false;
}

bool CoordinationUnitRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "CoordinationUnit RequestValidator");

  switch (message->header()->name) {
    case internal::kCoordinationUnit_SendEvent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_SendEvent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinationUnit_GetID_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_GetID_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinationUnit_AddBinding_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_AddBinding_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinationUnit_AddChild_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_AddChild_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinationUnit_RemoveChild_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_RemoveChild_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinationUnit_SetCoordinationPolicyCallback_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_SetCoordinationPolicyCallback_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinationUnit_SetProperty_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_SetProperty_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool CoordinationUnitResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "CoordinationUnit ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kCoordinationUnit_GetID_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::CoordinationUnit_GetID_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace blink
}  // namespace mojom
}  // namespace resource_coordinator

namespace mojo {


// static
bool StructTraits<::resource_coordinator::mojom::blink::CoordinationUnitID::DataView, ::resource_coordinator::mojom::blink::CoordinationUnitIDPtr>::Read(
    ::resource_coordinator::mojom::blink::CoordinationUnitID::DataView input,
    ::resource_coordinator::mojom::blink::CoordinationUnitIDPtr* output) {
  bool success = true;
  ::resource_coordinator::mojom::blink::CoordinationUnitIDPtr result(::resource_coordinator::mojom::blink::CoordinationUnitID::New());
  
      if (!input.ReadType(&result->type))
        success = false;
      result->id = input.id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::resource_coordinator::mojom::blink::CoordinationPolicy::DataView, ::resource_coordinator::mojom::blink::CoordinationPolicyPtr>::Read(
    ::resource_coordinator::mojom::blink::CoordinationPolicy::DataView input,
    ::resource_coordinator::mojom::blink::CoordinationPolicyPtr* output) {
  bool success = true;
  ::resource_coordinator::mojom::blink::CoordinationPolicyPtr result(::resource_coordinator::mojom::blink::CoordinationPolicy::New());
  
      result->use_background_priority = input.use_background_priority();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif