// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_COORDINATION_UNIT_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_COORDINATION_UNIT_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/resource_coordinator/public/interfaces/events.mojom-shared-internal.h"
#include "mojo/common/values.mojom-shared-internal.h"
#include "services/resource_coordinator/public/interfaces/interfaces_internal_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace resource_coordinator {
namespace mojom {
namespace internal {
class CoordinationUnitID_Data;
class CoordinationPolicy_Data;

struct CoordinationUnitType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct PropertyType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnitID_Data {
 public:
  static CoordinationUnitID_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t type;
  uint8_t pad0_[4];
  int64_t id;

 private:
  CoordinationUnitID_Data();
  ~CoordinationUnitID_Data() = delete;
};
static_assert(sizeof(CoordinationUnitID_Data) == 24,
              "Bad sizeof(CoordinationUnitID_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationPolicy_Data {
 public:
  static CoordinationPolicy_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t use_background_priority : 1;
  uint8_t padfinal_[7];

 private:
  CoordinationPolicy_Data();
  ~CoordinationPolicy_Data() = delete;
};
static_assert(sizeof(CoordinationPolicy_Data) == 16,
              "Bad sizeof(CoordinationPolicy_Data)");
constexpr uint32_t kCoordinationPolicyCallback_SetCoordinationPolicy_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data {
 public:
  static CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationPolicy_Data> policy;

 private:
  CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data();
  ~CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data() = delete;
};
static_assert(sizeof(CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data) == 16,
              "Bad sizeof(CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data)");
constexpr uint32_t kCoordinationUnit_SendEvent_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_SendEvent_Params_Data {
 public:
  static CoordinationUnit_SendEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::resource_coordinator::mojom::internal::Event_Data> event;

 private:
  CoordinationUnit_SendEvent_Params_Data();
  ~CoordinationUnit_SendEvent_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_SendEvent_Params_Data) == 16,
              "Bad sizeof(CoordinationUnit_SendEvent_Params_Data)");
constexpr uint32_t kCoordinationUnit_GetID_Name = 1;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_GetID_Params_Data {
 public:
  static CoordinationUnit_GetID_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  CoordinationUnit_GetID_Params_Data();
  ~CoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(CoordinationUnit_GetID_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_GetID_ResponseParams_Data {
 public:
  static CoordinationUnit_GetID_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  CoordinationUnit_GetID_ResponseParams_Data();
  ~CoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(CoordinationUnit_GetID_ResponseParams_Data)");
constexpr uint32_t kCoordinationUnit_AddBinding_Name = 2;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_AddBinding_Params_Data {
 public:
  static CoordinationUnit_AddBinding_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  CoordinationUnit_AddBinding_Params_Data();
  ~CoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(CoordinationUnit_AddBinding_Params_Data)");
constexpr uint32_t kCoordinationUnit_AddChild_Name = 3;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_AddChild_Params_Data {
 public:
  static CoordinationUnit_AddChild_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> child_id;

 private:
  CoordinationUnit_AddChild_Params_Data();
  ~CoordinationUnit_AddChild_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_AddChild_Params_Data) == 16,
              "Bad sizeof(CoordinationUnit_AddChild_Params_Data)");
constexpr uint32_t kCoordinationUnit_RemoveChild_Name = 4;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_RemoveChild_Params_Data {
 public:
  static CoordinationUnit_RemoveChild_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> child_id;

 private:
  CoordinationUnit_RemoveChild_Params_Data();
  ~CoordinationUnit_RemoveChild_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_RemoveChild_Params_Data) == 16,
              "Bad sizeof(CoordinationUnit_RemoveChild_Params_Data)");
constexpr uint32_t kCoordinationUnit_SetCoordinationPolicyCallback_Name = 5;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_SetCoordinationPolicyCallback_Params_Data {
 public:
  static CoordinationUnit_SetCoordinationPolicyCallback_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data callback;

 private:
  CoordinationUnit_SetCoordinationPolicyCallback_Params_Data();
  ~CoordinationUnit_SetCoordinationPolicyCallback_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_SetCoordinationPolicyCallback_Params_Data) == 16,
              "Bad sizeof(CoordinationUnit_SetCoordinationPolicyCallback_Params_Data)");
constexpr uint32_t kCoordinationUnit_SetProperty_Name = 6;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT CoordinationUnit_SetProperty_Params_Data {
 public:
  static CoordinationUnit_SetProperty_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t property_type;
  uint8_t pad0_[4];
  ::mojo::common::mojom::internal::Value_Data value;

 private:
  CoordinationUnit_SetProperty_Params_Data();
  ~CoordinationUnit_SetProperty_Params_Data() = delete;
};
static_assert(sizeof(CoordinationUnit_SetProperty_Params_Data) == 32,
              "Bad sizeof(CoordinationUnit_SetProperty_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_COORDINATION_UNIT_MOJOM_SHARED_INTERNAL_H_