// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/resource_coordinator/public/interfaces/service_callbacks.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
namespace resource_coordinator {
namespace mojom {
namespace blink {
const char ServiceCallbacks::Name_[] = "resource_coordinator::mojom::ServiceCallbacks";

class ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ForwardToCallback(
      const ServiceCallbacks::IsUkmRecorderInterfaceInitializedCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  ServiceCallbacks::IsUkmRecorderInterfaceInitializedCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ForwardToCallback);
};

ServiceCallbacksProxy::ServiceCallbacksProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ServiceCallbacksProxy::IsUkmRecorderInterfaceInitialized(
    const IsUkmRecorderInterfaceInitializedCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_Params_Data);
  serialization_context.PrepareMessage(
      internal::kServiceCallbacks_IsUkmRecorderInterfaceInitialized_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void ServiceCallbacksProxy::SetUkmRecorderInterface(
    ::ukm::mojom::blink::UkmRecorderInterfacePtr in_ukm_recorder_interface) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::ServiceCallbacks_SetUkmRecorderInterface_Params_Data);
  size += mojo::internal::PrepareToSerialize<::ukm::mojom::UkmRecorderInterfacePtrDataView>(
      in_ukm_recorder_interface, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceCallbacks_SetUkmRecorderInterface_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::ServiceCallbacks_SetUkmRecorderInterface_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::ukm::mojom::UkmRecorderInterfacePtrDataView>(
      in_ukm_recorder_interface, &params->ukm_recorder_interface, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->ukm_recorder_interface),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid ukm_recorder_interface in ServiceCallbacks.SetUkmRecorderInterface request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder {
 public:
  static ServiceCallbacks::IsUkmRecorderInterfaceInitializedCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder> proxy(
        new ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "ServiceCallbacks::IsUkmRecorderInterfaceInitialized() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_ukm_recorder_already_initialized);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder);
};

bool ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParams_Data* params =
      reinterpret_cast<
          internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_ukm_recorder_already_initialized{};
  ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_ukm_recorder_already_initialized = input_data_view.ukm_recorder_already_initialized();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "ServiceCallbacks::IsUkmRecorderInterfaceInitialized response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_ukm_recorder_already_initialized));
  return true;
}

void ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder::Run(
    bool in_ukm_recorder_already_initialized) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kServiceCallbacks_IsUkmRecorderInterfaceInitialized_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->ukm_recorder_already_initialized = in_ukm_recorder_already_initialized;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool ServiceCallbacksStubDispatch::Accept(
    ServiceCallbacks* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kServiceCallbacks_IsUkmRecorderInterfaceInitialized_Name: {
      break;
    }
    case internal::kServiceCallbacks_SetUkmRecorderInterface_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceCallbacks_SetUkmRecorderInterface_Params_Data* params =
          reinterpret_cast<internal::ServiceCallbacks_SetUkmRecorderInterface_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::ukm::mojom::blink::UkmRecorderInterfacePtr p_ukm_recorder_interface{};
      ServiceCallbacks_SetUkmRecorderInterface_ParamsDataView input_data_view(params, &serialization_context);
      
      p_ukm_recorder_interface =
          input_data_view.TakeUkmRecorderInterface<decltype(p_ukm_recorder_interface)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceCallbacks::SetUkmRecorderInterface deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetUkmRecorderInterface(
std::move(p_ukm_recorder_interface));
      return true;
    }
  }
  return false;
}

// static
bool ServiceCallbacksStubDispatch::AcceptWithResponder(
    ServiceCallbacks* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kServiceCallbacks_IsUkmRecorderInterfaceInitialized_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_Params_Data* params =
          reinterpret_cast<
              internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceCallbacks::IsUkmRecorderInterfaceInitialized deserializer");
        return false;
      }
      ServiceCallbacks::IsUkmRecorderInterfaceInitializedCallback callback =
          ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->IsUkmRecorderInterfaceInitialized(std::move(callback));
      return true;
    }
    case internal::kServiceCallbacks_SetUkmRecorderInterface_Name: {
      break;
    }
  }
  return false;
}

bool ServiceCallbacksRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceCallbacks RequestValidator");

  switch (message->header()->name) {
    case internal::kServiceCallbacks_IsUkmRecorderInterfaceInitialized_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceCallbacks_SetUkmRecorderInterface_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceCallbacks_SetUkmRecorderInterface_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool ServiceCallbacksResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceCallbacks ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kServiceCallbacks_IsUkmRecorderInterfaceInitialized_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace blink
}  // namespace mojom
}  // namespace resource_coordinator

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif