// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TAB_SIGNAL_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TAB_SIGNAL_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/resource_coordinator/public/interfaces/coordination_unit.mojom-shared-internal.h"
#include "mojo/common/values.mojom-shared-internal.h"
#include "services/resource_coordinator/public/interfaces/interfaces_internal_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace resource_coordinator {
namespace mojom {
namespace internal {

struct TabEvent_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
constexpr uint32_t kTabSignalObserver_OnEventReceived_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT TabSignalObserver_OnEventReceived_Params_Data {
 public:
  static TabSignalObserver_OnEventReceived_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::resource_coordinator::mojom::internal::CoordinationUnitID_Data> cu_id;
  int32_t event;
  uint8_t padfinal_[4];

 private:
  TabSignalObserver_OnEventReceived_Params_Data();
  ~TabSignalObserver_OnEventReceived_Params_Data() = delete;
};
static_assert(sizeof(TabSignalObserver_OnEventReceived_Params_Data) == 24,
              "Bad sizeof(TabSignalObserver_OnEventReceived_Params_Data)");
constexpr uint32_t kTabSignalGenerator_AddObserver_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT TabSignalGenerator_AddObserver_Params_Data {
 public:
  static TabSignalGenerator_AddObserver_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data observer;

 private:
  TabSignalGenerator_AddObserver_Params_Data();
  ~TabSignalGenerator_AddObserver_Params_Data() = delete;
};
static_assert(sizeof(TabSignalGenerator_AddObserver_Params_Data) == 16,
              "Bad sizeof(TabSignalGenerator_AddObserver_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TAB_SIGNAL_MOJOM_SHARED_INTERNAL_H_