// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TAB_SIGNAL_MOJOM_SHARED_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TAB_SIGNAL_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/resource_coordinator/public/interfaces/tab_signal.mojom-shared-internal.h"
#include "services/resource_coordinator/public/interfaces/coordination_unit.mojom-shared.h"
#include "mojo/common/values.mojom-shared.h"
#include "services/resource_coordinator/public/interfaces/interfaces_internal_shared_export.h"


namespace resource_coordinator {
namespace mojom {


}  // namespace mojom
}  // namespace resource_coordinator

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace resource_coordinator {
namespace mojom {

enum class TabEvent : int32_t {
  kDoneLoading,
};

inline std::ostream& operator<<(std::ostream& os, TabEvent value) {
  switch(value) {
    case TabEvent::kDoneLoading:
      return os << "TabEvent::kDoneLoading";
    default:
      return os << "Unknown TabEvent value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(TabEvent value) {
  return internal::TabEvent_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class TabSignalObserverInterfaceBase {};

using TabSignalObserverPtrDataView =
    mojo::InterfacePtrDataView<TabSignalObserverInterfaceBase>;
using TabSignalObserverRequestDataView =
    mojo::InterfaceRequestDataView<TabSignalObserverInterfaceBase>;
using TabSignalObserverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<TabSignalObserverInterfaceBase>;
using TabSignalObserverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<TabSignalObserverInterfaceBase>;
class TabSignalGeneratorInterfaceBase {};

using TabSignalGeneratorPtrDataView =
    mojo::InterfacePtrDataView<TabSignalGeneratorInterfaceBase>;
using TabSignalGeneratorRequestDataView =
    mojo::InterfaceRequestDataView<TabSignalGeneratorInterfaceBase>;
using TabSignalGeneratorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<TabSignalGeneratorInterfaceBase>;
using TabSignalGeneratorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<TabSignalGeneratorInterfaceBase>;
class TabSignalObserver_OnEventReceived_ParamsDataView {
 public:
  TabSignalObserver_OnEventReceived_ParamsDataView() {}

  TabSignalObserver_OnEventReceived_ParamsDataView(
      internal::TabSignalObserver_OnEventReceived_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCuIdDataView(
      ::resource_coordinator::mojom::CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCuId(UserType* output) {
    auto* pointer = data_->cu_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEvent(UserType* output) const {
    auto data_value = data_->event;
    return mojo::internal::Deserialize<::resource_coordinator::mojom::TabEvent>(
        data_value, output);
  }

  TabEvent event() const {
    return static_cast<TabEvent>(data_->event);
  }
 private:
  internal::TabSignalObserver_OnEventReceived_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class TabSignalGenerator_AddObserver_ParamsDataView {
 public:
  TabSignalGenerator_AddObserver_ParamsDataView() {}

  TabSignalGenerator_AddObserver_ParamsDataView(
      internal::TabSignalGenerator_AddObserver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeObserver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::TabSignalObserverPtrDataView>(
            &data_->observer, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::TabSignalGenerator_AddObserver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace resource_coordinator

namespace std {

template <>
struct hash<::resource_coordinator::mojom::TabEvent>
    : public mojo::internal::EnumHashImpl<::resource_coordinator::mojom::TabEvent> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::resource_coordinator::mojom::TabEvent, ::resource_coordinator::mojom::TabEvent> {
  static ::resource_coordinator::mojom::TabEvent ToMojom(::resource_coordinator::mojom::TabEvent input) { return input; }
  static bool FromMojom(::resource_coordinator::mojom::TabEvent input, ::resource_coordinator::mojom::TabEvent* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::resource_coordinator::mojom::TabEvent, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::resource_coordinator::mojom::TabEvent, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::resource_coordinator::mojom::TabEvent>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace resource_coordinator {
namespace mojom {

inline void TabSignalObserver_OnEventReceived_ParamsDataView::GetCuIdDataView(
    ::resource_coordinator::mojom::CoordinationUnitIDDataView* output) {
  auto pointer = data_->cu_id.Get();
  *output = ::resource_coordinator::mojom::CoordinationUnitIDDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TAB_SIGNAL_MOJOM_SHARED_H_
