// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/resource_coordinator/public/interfaces/tab_signal.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "services/resource_coordinator/public/cpp/coordination_unit_struct_traits.h"
namespace resource_coordinator {
namespace mojom {
const char TabSignalObserver::Name_[] = "resource_coordinator::mojom::TabSignalObserver";

TabSignalObserverProxy::TabSignalObserverProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void TabSignalObserverProxy::OnEventReceived(
    const ::resource_coordinator::CoordinationUnitID& in_cu_id, TabEvent in_event) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::TabSignalObserver_OnEventReceived_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_cu_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kTabSignalObserver_OnEventReceived_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::TabSignalObserver_OnEventReceived_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->cu_id)::BaseType* cu_id_ptr;
  mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
      in_cu_id, buffer, &cu_id_ptr, &serialization_context);
  params->cu_id.Set(cu_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->cu_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null cu_id in TabSignalObserver.OnEventReceived request");
  mojo::internal::Serialize<::resource_coordinator::mojom::TabEvent>(
      in_event, &params->event);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool TabSignalObserverStubDispatch::Accept(
    TabSignalObserver* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kTabSignalObserver_OnEventReceived_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::TabSignalObserver_OnEventReceived_Params_Data* params =
          reinterpret_cast<internal::TabSignalObserver_OnEventReceived_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::resource_coordinator::CoordinationUnitID p_cu_id{};
      TabEvent p_event{};
      TabSignalObserver_OnEventReceived_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadCuId(&p_cu_id))
        success = false;
      if (!input_data_view.ReadEvent(&p_event))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "TabSignalObserver::OnEventReceived deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnEventReceived(
std::move(p_cu_id), 
std::move(p_event));
      return true;
    }
  }
  return false;
}

// static
bool TabSignalObserverStubDispatch::AcceptWithResponder(
    TabSignalObserver* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kTabSignalObserver_OnEventReceived_Name: {
      break;
    }
  }
  return false;
}

bool TabSignalObserverRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "TabSignalObserver RequestValidator");

  switch (message->header()->name) {
    case internal::kTabSignalObserver_OnEventReceived_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::TabSignalObserver_OnEventReceived_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char TabSignalGenerator::Name_[] = "resource_coordinator::mojom::TabSignalGenerator";

TabSignalGeneratorProxy::TabSignalGeneratorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void TabSignalGeneratorProxy::AddObserver(
    TabSignalObserverPtr in_observer) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::resource_coordinator::mojom::internal::TabSignalGenerator_AddObserver_Params_Data);
  size += mojo::internal::PrepareToSerialize<::resource_coordinator::mojom::TabSignalObserverPtrDataView>(
      in_observer, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kTabSignalGenerator_AddObserver_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::resource_coordinator::mojom::internal::TabSignalGenerator_AddObserver_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::resource_coordinator::mojom::TabSignalObserverPtrDataView>(
      in_observer, &params->observer, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->observer),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid observer in TabSignalGenerator.AddObserver request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool TabSignalGeneratorStubDispatch::Accept(
    TabSignalGenerator* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kTabSignalGenerator_AddObserver_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::TabSignalGenerator_AddObserver_Params_Data* params =
          reinterpret_cast<internal::TabSignalGenerator_AddObserver_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      TabSignalObserverPtr p_observer{};
      TabSignalGenerator_AddObserver_ParamsDataView input_data_view(params, &serialization_context);
      
      p_observer =
          input_data_view.TakeObserver<decltype(p_observer)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "TabSignalGenerator::AddObserver deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->AddObserver(
std::move(p_observer));
      return true;
    }
  }
  return false;
}

// static
bool TabSignalGeneratorStubDispatch::AcceptWithResponder(
    TabSignalGenerator* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kTabSignalGenerator_AddObserver_Name: {
      break;
    }
  }
  return false;
}

bool TabSignalGeneratorRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "TabSignalGenerator RequestValidator");

  switch (message->header()->name) {
    case internal::kTabSignalGenerator_AddObserver_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::TabSignalGenerator_AddObserver_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace resource_coordinator

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif