// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TRACING_TRACING_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TRACING_TRACING_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "mojo/common/values.mojom-shared-internal.h"
#include "services/resource_coordinator/public/interfaces/interfaces_internal_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace tracing {
namespace mojom {
namespace internal {

struct TraceDataType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
constexpr uint32_t kAgentRegistry_RegisterAgent_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT AgentRegistry_RegisterAgent_Params_Data {
 public:
  static AgentRegistry_RegisterAgent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data agent;
  mojo::internal::Pointer<mojo::internal::String_Data> label;
  int32_t type;
  uint8_t supports_explicit_clock_sync_ : 1;
  uint8_t padfinal_[3];

 private:
  AgentRegistry_RegisterAgent_Params_Data();
  ~AgentRegistry_RegisterAgent_Params_Data() = delete;
};
static_assert(sizeof(AgentRegistry_RegisterAgent_Params_Data) == 32,
              "Bad sizeof(AgentRegistry_RegisterAgent_Params_Data)");
constexpr uint32_t kAgent_StartTracing_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_StartTracing_Params_Data {
 public:
  static Agent_StartTracing_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> config;

 private:
  Agent_StartTracing_Params_Data();
  ~Agent_StartTracing_Params_Data() = delete;
};
static_assert(sizeof(Agent_StartTracing_Params_Data) == 16,
              "Bad sizeof(Agent_StartTracing_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_StartTracing_ResponseParams_Data {
 public:
  static Agent_StartTracing_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Agent_StartTracing_ResponseParams_Data();
  ~Agent_StartTracing_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_StartTracing_ResponseParams_Data) == 8,
              "Bad sizeof(Agent_StartTracing_ResponseParams_Data)");
constexpr uint32_t kAgent_StopAndFlush_Name = 1;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_StopAndFlush_Params_Data {
 public:
  static Agent_StopAndFlush_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data recorder;

 private:
  Agent_StopAndFlush_Params_Data();
  ~Agent_StopAndFlush_Params_Data() = delete;
};
static_assert(sizeof(Agent_StopAndFlush_Params_Data) == 16,
              "Bad sizeof(Agent_StopAndFlush_Params_Data)");
constexpr uint32_t kAgent_RequestClockSyncMarker_Name = 2;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_RequestClockSyncMarker_Params_Data {
 public:
  static Agent_RequestClockSyncMarker_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> sync_id;

 private:
  Agent_RequestClockSyncMarker_Params_Data();
  ~Agent_RequestClockSyncMarker_Params_Data() = delete;
};
static_assert(sizeof(Agent_RequestClockSyncMarker_Params_Data) == 16,
              "Bad sizeof(Agent_RequestClockSyncMarker_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_RequestClockSyncMarker_ResponseParams_Data {
 public:
  static Agent_RequestClockSyncMarker_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeTicks_Data> issue_ts;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeTicks_Data> issue_end_ts;

 private:
  Agent_RequestClockSyncMarker_ResponseParams_Data();
  ~Agent_RequestClockSyncMarker_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_RequestClockSyncMarker_ResponseParams_Data) == 24,
              "Bad sizeof(Agent_RequestClockSyncMarker_ResponseParams_Data)");
constexpr uint32_t kAgent_RequestBufferStatus_Name = 3;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_RequestBufferStatus_Params_Data {
 public:
  static Agent_RequestBufferStatus_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Agent_RequestBufferStatus_Params_Data();
  ~Agent_RequestBufferStatus_Params_Data() = delete;
};
static_assert(sizeof(Agent_RequestBufferStatus_Params_Data) == 8,
              "Bad sizeof(Agent_RequestBufferStatus_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_RequestBufferStatus_ResponseParams_Data {
 public:
  static Agent_RequestBufferStatus_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t capacity;
  uint32_t count;

 private:
  Agent_RequestBufferStatus_ResponseParams_Data();
  ~Agent_RequestBufferStatus_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_RequestBufferStatus_ResponseParams_Data) == 16,
              "Bad sizeof(Agent_RequestBufferStatus_ResponseParams_Data)");
constexpr uint32_t kAgent_GetCategories_Name = 4;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_GetCategories_Params_Data {
 public:
  static Agent_GetCategories_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Agent_GetCategories_Params_Data();
  ~Agent_GetCategories_Params_Data() = delete;
};
static_assert(sizeof(Agent_GetCategories_Params_Data) == 8,
              "Bad sizeof(Agent_GetCategories_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Agent_GetCategories_ResponseParams_Data {
 public:
  static Agent_GetCategories_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> categories;

 private:
  Agent_GetCategories_ResponseParams_Data();
  ~Agent_GetCategories_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_GetCategories_ResponseParams_Data) == 16,
              "Bad sizeof(Agent_GetCategories_ResponseParams_Data)");
constexpr uint32_t kRecorder_AddChunk_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Recorder_AddChunk_Params_Data {
 public:
  static Recorder_AddChunk_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> chunk;

 private:
  Recorder_AddChunk_Params_Data();
  ~Recorder_AddChunk_Params_Data() = delete;
};
static_assert(sizeof(Recorder_AddChunk_Params_Data) == 16,
              "Bad sizeof(Recorder_AddChunk_Params_Data)");
constexpr uint32_t kRecorder_AddMetadata_Name = 1;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Recorder_AddMetadata_Params_Data {
 public:
  static Recorder_AddMetadata_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::DictionaryValue_Data> metadata;

 private:
  Recorder_AddMetadata_Params_Data();
  ~Recorder_AddMetadata_Params_Data() = delete;
};
static_assert(sizeof(Recorder_AddMetadata_Params_Data) == 16,
              "Bad sizeof(Recorder_AddMetadata_Params_Data)");
constexpr uint32_t kCoordinator_StartTracing_Name = 0;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_StartTracing_Params_Data {
 public:
  static Coordinator_StartTracing_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> config;

 private:
  Coordinator_StartTracing_Params_Data();
  ~Coordinator_StartTracing_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_StartTracing_Params_Data) == 16,
              "Bad sizeof(Coordinator_StartTracing_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_StartTracing_ResponseParams_Data {
 public:
  static Coordinator_StartTracing_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  Coordinator_StartTracing_ResponseParams_Data();
  ~Coordinator_StartTracing_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_StartTracing_ResponseParams_Data) == 16,
              "Bad sizeof(Coordinator_StartTracing_ResponseParams_Data)");
constexpr uint32_t kCoordinator_StopAndFlush_Name = 1;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_StopAndFlush_Params_Data {
 public:
  static Coordinator_StopAndFlush_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data stream;
  uint8_t padfinal_[4];

 private:
  Coordinator_StopAndFlush_Params_Data();
  ~Coordinator_StopAndFlush_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_StopAndFlush_Params_Data) == 16,
              "Bad sizeof(Coordinator_StopAndFlush_Params_Data)");
constexpr uint32_t kCoordinator_IsTracing_Name = 2;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_IsTracing_Params_Data {
 public:
  static Coordinator_IsTracing_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Coordinator_IsTracing_Params_Data();
  ~Coordinator_IsTracing_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_IsTracing_Params_Data) == 8,
              "Bad sizeof(Coordinator_IsTracing_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_IsTracing_ResponseParams_Data {
 public:
  static Coordinator_IsTracing_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t is_tracing : 1;
  uint8_t padfinal_[7];

 private:
  Coordinator_IsTracing_ResponseParams_Data();
  ~Coordinator_IsTracing_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_IsTracing_ResponseParams_Data) == 16,
              "Bad sizeof(Coordinator_IsTracing_ResponseParams_Data)");
constexpr uint32_t kCoordinator_RequestBufferUsage_Name = 3;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_RequestBufferUsage_Params_Data {
 public:
  static Coordinator_RequestBufferUsage_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Coordinator_RequestBufferUsage_Params_Data();
  ~Coordinator_RequestBufferUsage_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_RequestBufferUsage_Params_Data) == 8,
              "Bad sizeof(Coordinator_RequestBufferUsage_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_RequestBufferUsage_ResponseParams_Data {
 public:
  static Coordinator_RequestBufferUsage_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[3];
  float percent_full;
  uint32_t approximate_count;
  uint8_t padfinal_[4];

 private:
  Coordinator_RequestBufferUsage_ResponseParams_Data();
  ~Coordinator_RequestBufferUsage_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_RequestBufferUsage_ResponseParams_Data) == 24,
              "Bad sizeof(Coordinator_RequestBufferUsage_ResponseParams_Data)");
constexpr uint32_t kCoordinator_GetCategories_Name = 4;
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_GetCategories_Params_Data {
 public:
  static Coordinator_GetCategories_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Coordinator_GetCategories_Params_Data();
  ~Coordinator_GetCategories_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_GetCategories_Params_Data) == 8,
              "Bad sizeof(Coordinator_GetCategories_Params_Data)");
class MOJOM_SHARED_SERVICES_RESOURCE_COORDINATOR_PUBLIC_CPP_EXPORT Coordinator_GetCategories_ResponseParams_Data {
 public:
  static Coordinator_GetCategories_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<mojo::internal::String_Data> categories;

 private:
  Coordinator_GetCategories_ResponseParams_Data();
  ~Coordinator_GetCategories_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_GetCategories_ResponseParams_Data) == 24,
              "Bad sizeof(Coordinator_GetCategories_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace tracing

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TRACING_TRACING_MOJOM_SHARED_INTERNAL_H_