// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/ui/gpu/interfaces/gpu_main.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "gpu/ipc/common/gpu_preferences_struct_traits.h"
namespace ui {
namespace mojom {
const char GpuMain::Name_[] = "ui::mojom::GpuMain";

GpuMainProxy::GpuMainProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void GpuMainProxy::CreateFrameSinkManager(
    ::cc::mojom::FrameSinkManagerRequest in_frame_sink_manager, ::cc::mojom::FrameSinkManagerClientPtr in_frame_sink_manager_client) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::ui::mojom::internal::GpuMain_CreateFrameSinkManager_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkManagerRequestDataView>(
      in_frame_sink_manager, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkManagerClientPtrDataView>(
      in_frame_sink_manager_client, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kGpuMain_CreateFrameSinkManager_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::ui::mojom::internal::GpuMain_CreateFrameSinkManager_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::cc::mojom::FrameSinkManagerRequestDataView>(
      in_frame_sink_manager, &params->frame_sink_manager, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->frame_sink_manager),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid frame_sink_manager in GpuMain.CreateFrameSinkManager request");
  mojo::internal::Serialize<::cc::mojom::FrameSinkManagerClientPtrDataView>(
      in_frame_sink_manager_client, &params->frame_sink_manager_client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->frame_sink_manager_client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid frame_sink_manager_client in GpuMain.CreateFrameSinkManager request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void GpuMainProxy::CreateGpuService(
    ::ui::mojom::GpuServiceRequest in_gpu_service, ::ui::mojom::GpuHostPtr in_gpu_host, const gpu::GpuPreferences& in_preferences, mojo::ScopedSharedBufferHandle in_activity_flags) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::ui::mojom::internal::GpuMain_CreateGpuService_Params_Data);
  size += mojo::internal::PrepareToSerialize<::ui::mojom::GpuServiceRequestDataView>(
      in_gpu_service, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::ui::mojom::GpuHostPtrDataView>(
      in_gpu_host, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::gpu::mojom::GpuPreferencesDataView>(
      in_preferences, &serialization_context);
  size += mojo::internal::PrepareToSerialize<mojo::ScopedSharedBufferHandle>(
      in_activity_flags, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kGpuMain_CreateGpuService_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::ui::mojom::internal::GpuMain_CreateGpuService_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::ui::mojom::GpuServiceRequestDataView>(
      in_gpu_service, &params->gpu_service, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->gpu_service),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid gpu_service in GpuMain.CreateGpuService request");
  mojo::internal::Serialize<::ui::mojom::GpuHostPtrDataView>(
      in_gpu_host, &params->gpu_host, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->gpu_host),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid gpu_host in GpuMain.CreateGpuService request");
  typename decltype(params->preferences)::BaseType* preferences_ptr;
  mojo::internal::Serialize<::gpu::mojom::GpuPreferencesDataView>(
      in_preferences, buffer, &preferences_ptr, &serialization_context);
  params->preferences.Set(preferences_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->preferences.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null preferences in GpuMain.CreateGpuService request");
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_activity_flags, &params->activity_flags, &serialization_context);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool GpuMainStubDispatch::Accept(
    GpuMain* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kGpuMain_CreateFrameSinkManager_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::GpuMain_CreateFrameSinkManager_Params_Data* params =
          reinterpret_cast<internal::GpuMain_CreateFrameSinkManager_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::cc::mojom::FrameSinkManagerRequest p_frame_sink_manager{};
      ::cc::mojom::FrameSinkManagerClientPtr p_frame_sink_manager_client{};
      GpuMain_CreateFrameSinkManager_ParamsDataView input_data_view(params, &serialization_context);
      
      p_frame_sink_manager =
          input_data_view.TakeFrameSinkManager<decltype(p_frame_sink_manager)>();
      p_frame_sink_manager_client =
          input_data_view.TakeFrameSinkManagerClient<decltype(p_frame_sink_manager_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "GpuMain::CreateFrameSinkManager deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateFrameSinkManager(
std::move(p_frame_sink_manager), 
std::move(p_frame_sink_manager_client));
      return true;
    }
    case internal::kGpuMain_CreateGpuService_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::GpuMain_CreateGpuService_Params_Data* params =
          reinterpret_cast<internal::GpuMain_CreateGpuService_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::ui::mojom::GpuServiceRequest p_gpu_service{};
      ::ui::mojom::GpuHostPtr p_gpu_host{};
      gpu::GpuPreferences p_preferences{};
      mojo::ScopedSharedBufferHandle p_activity_flags{};
      GpuMain_CreateGpuService_ParamsDataView input_data_view(params, &serialization_context);
      
      p_gpu_service =
          input_data_view.TakeGpuService<decltype(p_gpu_service)>();
      p_gpu_host =
          input_data_view.TakeGpuHost<decltype(p_gpu_host)>();
      if (!input_data_view.ReadPreferences(&p_preferences))
        success = false;
      p_activity_flags = input_data_view.TakeActivityFlags();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "GpuMain::CreateGpuService deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateGpuService(
std::move(p_gpu_service), 
std::move(p_gpu_host), 
std::move(p_preferences), 
std::move(p_activity_flags));
      return true;
    }
  }
  return false;
}

// static
bool GpuMainStubDispatch::AcceptWithResponder(
    GpuMain* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kGpuMain_CreateFrameSinkManager_Name: {
      break;
    }
    case internal::kGpuMain_CreateGpuService_Name: {
      break;
    }
  }
  return false;
}

bool GpuMainRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "GpuMain RequestValidator");

  switch (message->header()->name) {
    case internal::kGpuMain_CreateFrameSinkManager_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GpuMain_CreateFrameSinkManager_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kGpuMain_CreateGpuService_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GpuMain_CreateGpuService_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace ui

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif