// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/ui/public/interfaces/display/display_controller.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace display {
namespace mojom {
const char DisplayController::Name_[] = "display::mojom::DisplayController";

class DisplayController_TakeDisplayControl_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DisplayController_TakeDisplayControl_ForwardToCallback(
      const DisplayController::TakeDisplayControlCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DisplayController::TakeDisplayControlCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DisplayController_TakeDisplayControl_ForwardToCallback);
};

class DisplayController_RelinquishDisplayControl_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DisplayController_RelinquishDisplayControl_ForwardToCallback(
      const DisplayController::RelinquishDisplayControlCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DisplayController::RelinquishDisplayControlCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DisplayController_RelinquishDisplayControl_ForwardToCallback);
};

DisplayControllerProxy::DisplayControllerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void DisplayControllerProxy::IncreaseInternalDisplayZoom(
    ) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_IncreaseInternalDisplayZoom_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_IncreaseInternalDisplayZoom_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_IncreaseInternalDisplayZoom_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayControllerProxy::DecreaseInternalDisplayZoom(
    ) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_DecreaseInternalDisplayZoom_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_DecreaseInternalDisplayZoom_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_DecreaseInternalDisplayZoom_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayControllerProxy::ResetInternalDisplayZoom(
    ) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_ResetInternalDisplayZoom_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_ResetInternalDisplayZoom_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_ResetInternalDisplayZoom_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayControllerProxy::RotateCurrentDisplayCW(
    ) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_RotateCurrentDisplayCW_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_RotateCurrentDisplayCW_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_RotateCurrentDisplayCW_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayControllerProxy::SwapPrimaryDisplay(
    ) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_SwapPrimaryDisplay_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_SwapPrimaryDisplay_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_SwapPrimaryDisplay_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayControllerProxy::ToggleMirrorMode(
    ) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_ToggleMirrorMode_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_ToggleMirrorMode_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_ToggleMirrorMode_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayControllerProxy::TakeDisplayControl(
    const TakeDisplayControlCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_TakeDisplayControl_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_TakeDisplayControl_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_TakeDisplayControl_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DisplayController_TakeDisplayControl_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DisplayControllerProxy::RelinquishDisplayControl(
    const RelinquishDisplayControlCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_RelinquishDisplayControl_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_RelinquishDisplayControl_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_RelinquishDisplayControl_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DisplayController_RelinquishDisplayControl_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DisplayControllerProxy::SetDisplayWorkArea(
    int64_t in_display_id, const gfx::Size& in_size, const gfx::Insets& in_insets) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_SetDisplayWorkArea_Params_Data);
  size += mojo::internal::PrepareToSerialize<::gfx::mojom::SizeDataView>(
      in_size, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::gfx::mojom::InsetsDataView>(
      in_insets, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kDisplayController_SetDisplayWorkArea_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_SetDisplayWorkArea_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->display_id = in_display_id;
  typename decltype(params->size)::BaseType* size_ptr;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_size, buffer, &size_ptr, &serialization_context);
  params->size.Set(size_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null size in DisplayController.SetDisplayWorkArea request");
  typename decltype(params->insets)::BaseType* insets_ptr;
  mojo::internal::Serialize<::gfx::mojom::InsetsDataView>(
      in_insets, buffer, &insets_ptr, &serialization_context);
  params->insets.Set(insets_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->insets.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null insets in DisplayController.SetDisplayWorkArea request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class DisplayController_TakeDisplayControl_ProxyToResponder {
 public:
  static DisplayController::TakeDisplayControlCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DisplayController_TakeDisplayControl_ProxyToResponder> proxy(
        new DisplayController_TakeDisplayControl_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&DisplayController_TakeDisplayControl_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~DisplayController_TakeDisplayControl_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "DisplayController::TakeDisplayControl() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DisplayController_TakeDisplayControl_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_status);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DisplayController_TakeDisplayControl_ProxyToResponder);
};

bool DisplayController_TakeDisplayControl_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DisplayController_TakeDisplayControl_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DisplayController_TakeDisplayControl_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_status{};
  DisplayController_TakeDisplayControl_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_status = input_data_view.status();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DisplayController::TakeDisplayControl response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status));
  return true;
}

void DisplayController_TakeDisplayControl_ProxyToResponder::Run(
    bool in_status) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_TakeDisplayControl_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_TakeDisplayControl_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_TakeDisplayControl_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->status = in_status;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DisplayController_RelinquishDisplayControl_ProxyToResponder {
 public:
  static DisplayController::RelinquishDisplayControlCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DisplayController_RelinquishDisplayControl_ProxyToResponder> proxy(
        new DisplayController_RelinquishDisplayControl_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&DisplayController_RelinquishDisplayControl_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~DisplayController_RelinquishDisplayControl_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "DisplayController::RelinquishDisplayControl() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DisplayController_RelinquishDisplayControl_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_status);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DisplayController_RelinquishDisplayControl_ProxyToResponder);
};

bool DisplayController_RelinquishDisplayControl_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DisplayController_RelinquishDisplayControl_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DisplayController_RelinquishDisplayControl_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_status{};
  DisplayController_RelinquishDisplayControl_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_status = input_data_view.status();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DisplayController::RelinquishDisplayControl response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status));
  return true;
}

void DisplayController_RelinquishDisplayControl_ProxyToResponder::Run(
    bool in_status) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::DisplayController_RelinquishDisplayControl_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayController_RelinquishDisplayControl_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::DisplayController_RelinquishDisplayControl_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->status = in_status;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool DisplayControllerStubDispatch::Accept(
    DisplayController* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kDisplayController_IncreaseInternalDisplayZoom_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayController_IncreaseInternalDisplayZoom_Params_Data* params =
          reinterpret_cast<internal::DisplayController_IncreaseInternalDisplayZoom_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_IncreaseInternalDisplayZoom_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::IncreaseInternalDisplayZoom deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->IncreaseInternalDisplayZoom();
      return true;
    }
    case internal::kDisplayController_DecreaseInternalDisplayZoom_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayController_DecreaseInternalDisplayZoom_Params_Data* params =
          reinterpret_cast<internal::DisplayController_DecreaseInternalDisplayZoom_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_DecreaseInternalDisplayZoom_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::DecreaseInternalDisplayZoom deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DecreaseInternalDisplayZoom();
      return true;
    }
    case internal::kDisplayController_ResetInternalDisplayZoom_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayController_ResetInternalDisplayZoom_Params_Data* params =
          reinterpret_cast<internal::DisplayController_ResetInternalDisplayZoom_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_ResetInternalDisplayZoom_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::ResetInternalDisplayZoom deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->ResetInternalDisplayZoom();
      return true;
    }
    case internal::kDisplayController_RotateCurrentDisplayCW_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayController_RotateCurrentDisplayCW_Params_Data* params =
          reinterpret_cast<internal::DisplayController_RotateCurrentDisplayCW_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_RotateCurrentDisplayCW_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::RotateCurrentDisplayCW deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RotateCurrentDisplayCW();
      return true;
    }
    case internal::kDisplayController_SwapPrimaryDisplay_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayController_SwapPrimaryDisplay_Params_Data* params =
          reinterpret_cast<internal::DisplayController_SwapPrimaryDisplay_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_SwapPrimaryDisplay_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::SwapPrimaryDisplay deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SwapPrimaryDisplay();
      return true;
    }
    case internal::kDisplayController_ToggleMirrorMode_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayController_ToggleMirrorMode_Params_Data* params =
          reinterpret_cast<internal::DisplayController_ToggleMirrorMode_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_ToggleMirrorMode_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::ToggleMirrorMode deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->ToggleMirrorMode();
      return true;
    }
    case internal::kDisplayController_TakeDisplayControl_Name: {
      break;
    }
    case internal::kDisplayController_RelinquishDisplayControl_Name: {
      break;
    }
    case internal::kDisplayController_SetDisplayWorkArea_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayController_SetDisplayWorkArea_Params_Data* params =
          reinterpret_cast<internal::DisplayController_SetDisplayWorkArea_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      gfx::Size p_size{};
      gfx::Insets p_insets{};
      DisplayController_SetDisplayWorkArea_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!input_data_view.ReadSize(&p_size))
        success = false;
      if (!input_data_view.ReadInsets(&p_insets))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::SetDisplayWorkArea deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetDisplayWorkArea(
std::move(p_display_id), 
std::move(p_size), 
std::move(p_insets));
      return true;
    }
  }
  return false;
}

// static
bool DisplayControllerStubDispatch::AcceptWithResponder(
    DisplayController* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kDisplayController_IncreaseInternalDisplayZoom_Name: {
      break;
    }
    case internal::kDisplayController_DecreaseInternalDisplayZoom_Name: {
      break;
    }
    case internal::kDisplayController_ResetInternalDisplayZoom_Name: {
      break;
    }
    case internal::kDisplayController_RotateCurrentDisplayCW_Name: {
      break;
    }
    case internal::kDisplayController_SwapPrimaryDisplay_Name: {
      break;
    }
    case internal::kDisplayController_ToggleMirrorMode_Name: {
      break;
    }
    case internal::kDisplayController_TakeDisplayControl_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::DisplayController_TakeDisplayControl_Params_Data* params =
          reinterpret_cast<
              internal::DisplayController_TakeDisplayControl_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_TakeDisplayControl_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::TakeDisplayControl deserializer");
        return false;
      }
      DisplayController::TakeDisplayControlCallback callback =
          DisplayController_TakeDisplayControl_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->TakeDisplayControl(std::move(callback));
      return true;
    }
    case internal::kDisplayController_RelinquishDisplayControl_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::DisplayController_RelinquishDisplayControl_Params_Data* params =
          reinterpret_cast<
              internal::DisplayController_RelinquishDisplayControl_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DisplayController_RelinquishDisplayControl_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayController::RelinquishDisplayControl deserializer");
        return false;
      }
      DisplayController::RelinquishDisplayControlCallback callback =
          DisplayController_RelinquishDisplayControl_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RelinquishDisplayControl(std::move(callback));
      return true;
    }
    case internal::kDisplayController_SetDisplayWorkArea_Name: {
      break;
    }
  }
  return false;
}

bool DisplayControllerRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DisplayController RequestValidator");

  switch (message->header()->name) {
    case internal::kDisplayController_IncreaseInternalDisplayZoom_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_IncreaseInternalDisplayZoom_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_DecreaseInternalDisplayZoom_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_DecreaseInternalDisplayZoom_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_ResetInternalDisplayZoom_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_ResetInternalDisplayZoom_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_RotateCurrentDisplayCW_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_RotateCurrentDisplayCW_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_SwapPrimaryDisplay_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_SwapPrimaryDisplay_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_ToggleMirrorMode_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_ToggleMirrorMode_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_TakeDisplayControl_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_TakeDisplayControl_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_RelinquishDisplayControl_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_RelinquishDisplayControl_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_SetDisplayWorkArea_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_SetDisplayWorkArea_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool DisplayControllerResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DisplayController ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kDisplayController_TakeDisplayControl_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_TakeDisplayControl_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayController_RelinquishDisplayControl_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayController_RelinquishDisplayControl_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace display

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif