// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_UI_PUBLIC_INTERFACES_GPU_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_UI_PUBLIC_INTERFACES_GPU_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/gpu_info.mojom-shared-internal.h"
#include "gpu/ipc/common/sync_token.mojom-shared-internal.h"
#include "media/gpu/mojo/jpeg_decoder.mojom-shared-internal.h"
#include "media/mojo/interfaces/video_encode_accelerator.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/buffer_types.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kGpu_EstablishGpuChannel_Name = 0;
class  Gpu_EstablishGpuChannel_Params_Data {
 public:
  static Gpu_EstablishGpuChannel_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Gpu_EstablishGpuChannel_Params_Data();
  ~Gpu_EstablishGpuChannel_Params_Data() = delete;
};
static_assert(sizeof(Gpu_EstablishGpuChannel_Params_Data) == 8,
              "Bad sizeof(Gpu_EstablishGpuChannel_Params_Data)");
class  Gpu_EstablishGpuChannel_ResponseParams_Data {
 public:
  static Gpu_EstablishGpuChannel_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t client_id;
  mojo::internal::Handle_Data channel_handle;
  mojo::internal::Pointer<::gpu::mojom::internal::GpuInfo_Data> gpu_info;

 private:
  Gpu_EstablishGpuChannel_ResponseParams_Data();
  ~Gpu_EstablishGpuChannel_ResponseParams_Data() = delete;
};
static_assert(sizeof(Gpu_EstablishGpuChannel_ResponseParams_Data) == 24,
              "Bad sizeof(Gpu_EstablishGpuChannel_ResponseParams_Data)");
constexpr uint32_t kGpu_CreateJpegDecodeAccelerator_Name = 1;
class  Gpu_CreateJpegDecodeAccelerator_Params_Data {
 public:
  static Gpu_CreateJpegDecodeAccelerator_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data jda;
  uint8_t padfinal_[4];

 private:
  Gpu_CreateJpegDecodeAccelerator_Params_Data();
  ~Gpu_CreateJpegDecodeAccelerator_Params_Data() = delete;
};
static_assert(sizeof(Gpu_CreateJpegDecodeAccelerator_Params_Data) == 16,
              "Bad sizeof(Gpu_CreateJpegDecodeAccelerator_Params_Data)");
constexpr uint32_t kGpu_CreateVideoEncodeAccelerator_Name = 2;
class  Gpu_CreateVideoEncodeAccelerator_Params_Data {
 public:
  static Gpu_CreateVideoEncodeAccelerator_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data vea;
  uint8_t padfinal_[4];

 private:
  Gpu_CreateVideoEncodeAccelerator_Params_Data();
  ~Gpu_CreateVideoEncodeAccelerator_Params_Data() = delete;
};
static_assert(sizeof(Gpu_CreateVideoEncodeAccelerator_Params_Data) == 16,
              "Bad sizeof(Gpu_CreateVideoEncodeAccelerator_Params_Data)");
constexpr uint32_t kGpu_CreateGpuMemoryBuffer_Name = 3;
class  Gpu_CreateGpuMemoryBuffer_Params_Data {
 public:
  static Gpu_CreateGpuMemoryBuffer_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::GpuMemoryBufferId_Data> id;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> size;
  int32_t format;
  int32_t usage;

 private:
  Gpu_CreateGpuMemoryBuffer_Params_Data();
  ~Gpu_CreateGpuMemoryBuffer_Params_Data() = delete;
};
static_assert(sizeof(Gpu_CreateGpuMemoryBuffer_Params_Data) == 32,
              "Bad sizeof(Gpu_CreateGpuMemoryBuffer_Params_Data)");
class  Gpu_CreateGpuMemoryBuffer_ResponseParams_Data {
 public:
  static Gpu_CreateGpuMemoryBuffer_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::GpuMemoryBufferHandle_Data> buffer_handle;

 private:
  Gpu_CreateGpuMemoryBuffer_ResponseParams_Data();
  ~Gpu_CreateGpuMemoryBuffer_ResponseParams_Data() = delete;
};
static_assert(sizeof(Gpu_CreateGpuMemoryBuffer_ResponseParams_Data) == 16,
              "Bad sizeof(Gpu_CreateGpuMemoryBuffer_ResponseParams_Data)");
constexpr uint32_t kGpu_DestroyGpuMemoryBuffer_Name = 4;
class  Gpu_DestroyGpuMemoryBuffer_Params_Data {
 public:
  static Gpu_DestroyGpuMemoryBuffer_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::GpuMemoryBufferId_Data> id;
  mojo::internal::Pointer<::gpu::mojom::internal::SyncToken_Data> sync_token;

 private:
  Gpu_DestroyGpuMemoryBuffer_Params_Data();
  ~Gpu_DestroyGpuMemoryBuffer_Params_Data() = delete;
};
static_assert(sizeof(Gpu_DestroyGpuMemoryBuffer_Params_Data) == 24,
              "Bad sizeof(Gpu_DestroyGpuMemoryBuffer_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ui

#endif  // SERVICES_UI_PUBLIC_INTERFACES_GPU_MOJOM_SHARED_INTERNAL_H_