// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_BACKGROUND_FETCH_BACKGROUND_FETCH_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_BACKGROUND_FETCH_BACKGROUND_FETCH_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "third_party/WebKit/public/platform/modules/fetch/fetch_api_request.mojom-shared-internal.h"
#include "url/mojo/origin.mojom-shared-internal.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class IconDefinition_Data;
class BackgroundFetchOptions_Data;
class BackgroundFetchRegistration_Data;

struct BackgroundFetchError_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class MOJOM_SHARED_CONTENT_EXPORT IconDefinition_Data {
 public:
  static IconDefinition_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> src;
  mojo::internal::Pointer<mojo::internal::String_Data> sizes;
  mojo::internal::Pointer<mojo::internal::String_Data> type;

 private:
  IconDefinition_Data();
  ~IconDefinition_Data() = delete;
};
static_assert(sizeof(IconDefinition_Data) == 32,
              "Bad sizeof(IconDefinition_Data)");
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchOptions_Data {
 public:
  static BackgroundFetchOptions_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::IconDefinition_Data>>> icons;
  int64_t total_download_size;
  mojo::internal::Pointer<mojo::internal::String_Data> title;

 private:
  BackgroundFetchOptions_Data();
  ~BackgroundFetchOptions_Data() = delete;
};
static_assert(sizeof(BackgroundFetchOptions_Data) == 32,
              "Bad sizeof(BackgroundFetchOptions_Data)");
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchRegistration_Data {
 public:
  static BackgroundFetchRegistration_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::IconDefinition_Data>>> icons;
  int64_t total_download_size;
  mojo::internal::Pointer<mojo::internal::String_Data> title;

 private:
  BackgroundFetchRegistration_Data();
  ~BackgroundFetchRegistration_Data() = delete;
};
static_assert(sizeof(BackgroundFetchRegistration_Data) == 40,
              "Bad sizeof(BackgroundFetchRegistration_Data)");
constexpr uint32_t kBackgroundFetchService_Fetch_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_Fetch_Params_Data {
 public:
  static BackgroundFetchService_Fetch_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t service_worker_registration_id;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> origin;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::blink::mojom::internal::FetchAPIRequest_Data>>> requests;
  mojo::internal::Pointer<internal::BackgroundFetchOptions_Data> options;

 private:
  BackgroundFetchService_Fetch_Params_Data();
  ~BackgroundFetchService_Fetch_Params_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_Fetch_Params_Data) == 48,
              "Bad sizeof(BackgroundFetchService_Fetch_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_Fetch_ResponseParams_Data {
 public:
  static BackgroundFetchService_Fetch_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<internal::BackgroundFetchRegistration_Data> registration;

 private:
  BackgroundFetchService_Fetch_ResponseParams_Data();
  ~BackgroundFetchService_Fetch_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_Fetch_ResponseParams_Data) == 24,
              "Bad sizeof(BackgroundFetchService_Fetch_ResponseParams_Data)");
constexpr uint32_t kBackgroundFetchService_UpdateUI_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_UpdateUI_Params_Data {
 public:
  static BackgroundFetchService_UpdateUI_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t service_worker_registration_id;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> origin;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;
  mojo::internal::Pointer<mojo::internal::String_Data> title;

 private:
  BackgroundFetchService_UpdateUI_Params_Data();
  ~BackgroundFetchService_UpdateUI_Params_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_UpdateUI_Params_Data) == 40,
              "Bad sizeof(BackgroundFetchService_UpdateUI_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_UpdateUI_ResponseParams_Data {
 public:
  static BackgroundFetchService_UpdateUI_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t padfinal_[4];

 private:
  BackgroundFetchService_UpdateUI_ResponseParams_Data();
  ~BackgroundFetchService_UpdateUI_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_UpdateUI_ResponseParams_Data) == 16,
              "Bad sizeof(BackgroundFetchService_UpdateUI_ResponseParams_Data)");
constexpr uint32_t kBackgroundFetchService_Abort_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_Abort_Params_Data {
 public:
  static BackgroundFetchService_Abort_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t service_worker_registration_id;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> origin;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;

 private:
  BackgroundFetchService_Abort_Params_Data();
  ~BackgroundFetchService_Abort_Params_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_Abort_Params_Data) == 32,
              "Bad sizeof(BackgroundFetchService_Abort_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_Abort_ResponseParams_Data {
 public:
  static BackgroundFetchService_Abort_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t padfinal_[4];

 private:
  BackgroundFetchService_Abort_ResponseParams_Data();
  ~BackgroundFetchService_Abort_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_Abort_ResponseParams_Data) == 16,
              "Bad sizeof(BackgroundFetchService_Abort_ResponseParams_Data)");
constexpr uint32_t kBackgroundFetchService_GetRegistration_Name = 3;
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_GetRegistration_Params_Data {
 public:
  static BackgroundFetchService_GetRegistration_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t service_worker_registration_id;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> origin;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;

 private:
  BackgroundFetchService_GetRegistration_Params_Data();
  ~BackgroundFetchService_GetRegistration_Params_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_GetRegistration_Params_Data) == 32,
              "Bad sizeof(BackgroundFetchService_GetRegistration_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_GetRegistration_ResponseParams_Data {
 public:
  static BackgroundFetchService_GetRegistration_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<internal::BackgroundFetchRegistration_Data> registration;

 private:
  BackgroundFetchService_GetRegistration_ResponseParams_Data();
  ~BackgroundFetchService_GetRegistration_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_GetRegistration_ResponseParams_Data) == 24,
              "Bad sizeof(BackgroundFetchService_GetRegistration_ResponseParams_Data)");
constexpr uint32_t kBackgroundFetchService_GetTags_Name = 4;
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_GetTags_Params_Data {
 public:
  static BackgroundFetchService_GetTags_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t service_worker_registration_id;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> origin;

 private:
  BackgroundFetchService_GetTags_Params_Data();
  ~BackgroundFetchService_GetTags_Params_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_GetTags_Params_Data) == 24,
              "Bad sizeof(BackgroundFetchService_GetTags_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchService_GetTags_ResponseParams_Data {
 public:
  static BackgroundFetchService_GetTags_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> tags;

 private:
  BackgroundFetchService_GetTags_ResponseParams_Data();
  ~BackgroundFetchService_GetTags_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundFetchService_GetTags_ResponseParams_Data) == 24,
              "Bad sizeof(BackgroundFetchService_GetTags_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_BACKGROUND_FETCH_BACKGROUND_FETCH_MOJOM_SHARED_INTERNAL_H_