// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_DOCUMENT_METADATA_COPYLESS_PASTE_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_DOCUMENT_METADATA_COPYLESS_PASTE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "third_party/WebKit/public/android_mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace document_metadata {
namespace internal {
class Property_Data;
class Entity_Data;
class WebPage_Data;
class Values_Data;

#pragma pack(push, 1)


class MOJOM_SHARED_CONTENT_EXPORT Values_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  Values_Data() {}
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~Values_Data() {}

  static Values_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(Values_Data))) Values_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<Values_Tag>(0);
    data.unknown = 0U;
  }

  enum class Values_Tag : uint32_t {

    BOOL_VALUES,
    LONG_VALUES,
    STRING_VALUES,
    ENTITY_VALUES,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    mojo::internal::Pointer<mojo::internal::Array_Data<bool>> f_bool_values;
    mojo::internal::Pointer<mojo::internal::Array_Data<int64_t>> f_long_values;
    mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> f_string_values;
    mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::Entity_Data>>> f_entity_values;
    uint64_t unknown;
  };

  uint32_t size;
  Values_Tag tag;
  Union_ data;
};
static_assert(sizeof(Values_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(Values_Data)");
class MOJOM_SHARED_CONTENT_EXPORT Property_Data {
 public:
  static Property_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  internal::Values_Data values;

 private:
  Property_Data();
  ~Property_Data() = delete;
};
static_assert(sizeof(Property_Data) == 32,
              "Bad sizeof(Property_Data)");
class MOJOM_SHARED_CONTENT_EXPORT Entity_Data {
 public:
  static Entity_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> type;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::Property_Data>>> properties;

 private:
  Entity_Data();
  ~Entity_Data() = delete;
};
static_assert(sizeof(Entity_Data) == 24,
              "Bad sizeof(Entity_Data)");
class MOJOM_SHARED_CONTENT_EXPORT WebPage_Data {
 public:
  static WebPage_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<mojo::internal::String_Data> title;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::Entity_Data>>> entities;

 private:
  WebPage_Data();
  ~WebPage_Data() = delete;
};
static_assert(sizeof(WebPage_Data) == 32,
              "Bad sizeof(WebPage_Data)");
constexpr uint32_t kCopylessPaste_GetEntities_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT CopylessPaste_GetEntities_Params_Data {
 public:
  static CopylessPaste_GetEntities_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  CopylessPaste_GetEntities_Params_Data();
  ~CopylessPaste_GetEntities_Params_Data() = delete;
};
static_assert(sizeof(CopylessPaste_GetEntities_Params_Data) == 8,
              "Bad sizeof(CopylessPaste_GetEntities_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT CopylessPaste_GetEntities_ResponseParams_Data {
 public:
  static CopylessPaste_GetEntities_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebPage_Data> page;

 private:
  CopylessPaste_GetEntities_ResponseParams_Data();
  ~CopylessPaste_GetEntities_ResponseParams_Data() = delete;
};
static_assert(sizeof(CopylessPaste_GetEntities_ResponseParams_Data) == 16,
              "Bad sizeof(CopylessPaste_GetEntities_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace document_metadata
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_DOCUMENT_METADATA_COPYLESS_PASTE_MOJOM_SHARED_INTERNAL_H_