// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_FETCH_FETCH_API_REQUEST_MOJOM_BLINK_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_FETCH_FETCH_API_REQUEST_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/WebKit/public/platform/modules/fetch/fetch_api_request.mojom-shared.h"
#include "third_party/WebKit/public/platform/referrer.mojom-blink.h"
#include "url/mojo/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/WebKit/Source/platform/wtf/HashFunctions.h"
#include "third_party/WebKit/Source/platform/wtf/Optional.h"
#include "third_party/WebKit/Source/platform/wtf/text/WTFString.h"
#include "third_party/WebKit/public/platform/WebURLRequest.h"
#include "third_party/WebKit/public/platform/modules/serviceworker/WebServiceWorkerRequest.h"
#include "third_party/WebKit/public/platform/WebCommon.h"


namespace WTF {
struct blink_mojom_internal_FetchRequestMode_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::FetchRequestMode& value) {
    using utype = std::underlying_type<::blink::mojom::FetchRequestMode>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::FetchRequestMode& left, const ::blink::mojom::FetchRequestMode& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::FetchRequestMode> {
  using Hash = blink_mojom_internal_FetchRequestMode_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::FetchRequestMode>
    : public GenericHashTraits<::blink::mojom::FetchRequestMode> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::FetchRequestMode& value) {
    return value == static_cast<::blink::mojom::FetchRequestMode>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::FetchRequestMode& slot, bool) {
    slot = static_cast<::blink::mojom::FetchRequestMode>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::FetchRequestMode& value) {
    return value == static_cast<::blink::mojom::FetchRequestMode>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct blink_mojom_internal_RequestContextType_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::RequestContextType& value) {
    using utype = std::underlying_type<::blink::mojom::RequestContextType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::RequestContextType& left, const ::blink::mojom::RequestContextType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::RequestContextType> {
  using Hash = blink_mojom_internal_RequestContextType_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::RequestContextType>
    : public GenericHashTraits<::blink::mojom::RequestContextType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::RequestContextType& value) {
    return value == static_cast<::blink::mojom::RequestContextType>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::RequestContextType& slot, bool) {
    slot = static_cast<::blink::mojom::RequestContextType>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::RequestContextType& value) {
    return value == static_cast<::blink::mojom::RequestContextType>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct blink_mojom_internal_RequestContextFrameType_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::RequestContextFrameType& value) {
    using utype = std::underlying_type<::blink::mojom::RequestContextFrameType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::RequestContextFrameType& left, const ::blink::mojom::RequestContextFrameType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::RequestContextFrameType> {
  using Hash = blink_mojom_internal_RequestContextFrameType_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::RequestContextFrameType>
    : public GenericHashTraits<::blink::mojom::RequestContextFrameType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::RequestContextFrameType& value) {
    return value == static_cast<::blink::mojom::RequestContextFrameType>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::RequestContextFrameType& slot, bool) {
    slot = static_cast<::blink::mojom::RequestContextFrameType>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::RequestContextFrameType& value) {
    return value == static_cast<::blink::mojom::RequestContextFrameType>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct blink_mojom_internal_FetchCredentialsMode_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::FetchCredentialsMode& value) {
    using utype = std::underlying_type<::blink::mojom::FetchCredentialsMode>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::FetchCredentialsMode& left, const ::blink::mojom::FetchCredentialsMode& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::FetchCredentialsMode> {
  using Hash = blink_mojom_internal_FetchCredentialsMode_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::FetchCredentialsMode>
    : public GenericHashTraits<::blink::mojom::FetchCredentialsMode> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::FetchCredentialsMode& value) {
    return value == static_cast<::blink::mojom::FetchCredentialsMode>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::FetchCredentialsMode& slot, bool) {
    slot = static_cast<::blink::mojom::FetchCredentialsMode>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::FetchCredentialsMode& value) {
    return value == static_cast<::blink::mojom::FetchCredentialsMode>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct blink_mojom_internal_FetchRedirectMode_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::FetchRedirectMode& value) {
    using utype = std::underlying_type<::blink::mojom::FetchRedirectMode>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::FetchRedirectMode& left, const ::blink::mojom::FetchRedirectMode& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::FetchRedirectMode> {
  using Hash = blink_mojom_internal_FetchRedirectMode_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::FetchRedirectMode>
    : public GenericHashTraits<::blink::mojom::FetchRedirectMode> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::FetchRedirectMode& value) {
    return value == static_cast<::blink::mojom::FetchRedirectMode>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::FetchRedirectMode& slot, bool) {
    slot = static_cast<::blink::mojom::FetchRedirectMode>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::FetchRedirectMode& value) {
    return value == static_cast<::blink::mojom::FetchRedirectMode>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct blink_mojom_internal_ServiceWorkerFetchType_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::ServiceWorkerFetchType& value) {
    using utype = std::underlying_type<::blink::mojom::ServiceWorkerFetchType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::ServiceWorkerFetchType& left, const ::blink::mojom::ServiceWorkerFetchType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::ServiceWorkerFetchType> {
  using Hash = blink_mojom_internal_ServiceWorkerFetchType_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::ServiceWorkerFetchType>
    : public GenericHashTraits<::blink::mojom::ServiceWorkerFetchType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::ServiceWorkerFetchType& value) {
    return value == static_cast<::blink::mojom::ServiceWorkerFetchType>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::ServiceWorkerFetchType& slot, bool) {
    slot = static_cast<::blink::mojom::ServiceWorkerFetchType>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::ServiceWorkerFetchType& value) {
    return value == static_cast<::blink::mojom::ServiceWorkerFetchType>(-1000001);
  }
};
}  // namespace WTF


namespace blink {
namespace mojom {
namespace blink {
using FetchRequestMode = FetchRequestMode;  // Alias for definition in the parent namespace.
using RequestContextType = RequestContextType;  // Alias for definition in the parent namespace.
using RequestContextFrameType = RequestContextFrameType;  // Alias for definition in the parent namespace.
using FetchCredentialsMode = FetchCredentialsMode;  // Alias for definition in the parent namespace.
using FetchRedirectMode = FetchRedirectMode;  // Alias for definition in the parent namespace.
using ServiceWorkerFetchType = ServiceWorkerFetchType;  // Alias for definition in the parent namespace.
class FetchAPIRequest;
using FetchAPIRequestPtr = mojo::StructPtr<FetchAPIRequest>;






class BLINK_PLATFORM_EXPORT FetchAPIRequest {
 public:
  using DataView = FetchAPIRequestDataView;
  using Data_ = internal::FetchAPIRequest_Data;

  template <typename... Args>
  static FetchAPIRequestPtr New(Args&&... args) {
    return FetchAPIRequestPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static FetchAPIRequestPtr From(const U& u) {
    return mojo::TypeConverter<FetchAPIRequestPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FetchAPIRequest>::Convert(*this);
  }


  FetchAPIRequest();

  FetchAPIRequest(
      ::blink::WebURLRequest::FetchRequestMode mode,
      bool is_main_resource_load,
      ::blink::WebURLRequest::RequestContext request_context_type,
      ::blink::WebURLRequest::FrameType frame_type,
      const ::blink::KURL& url,
      const WTF::String& method,
      const WTF::HashMap<WTF::String, WTF::String>& headers,
      const WTF::String& blob_uuid,
      uint64_t blob_size,
      const ::blink::Referrer& referrer,
      ::blink::WebURLRequest::FetchCredentialsMode credentials_mode,
      ::blink::WebURLRequest::FetchRedirectMode redirect_mode,
      const WTF::String& integrity,
      const WTF::String& client_id,
      bool is_reload,
      ServiceWorkerFetchType fetch_type);

  ~FetchAPIRequest();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FetchAPIRequestPtr>
  FetchAPIRequestPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, FetchAPIRequest>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        FetchAPIRequest::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        FetchAPIRequest::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  ::blink::WebURLRequest::FetchRequestMode mode;
  bool is_main_resource_load;
  ::blink::WebURLRequest::RequestContext request_context_type;
  ::blink::WebURLRequest::FrameType frame_type;
  ::blink::KURL url;
  WTF::String method;
  WTF::HashMap<WTF::String, WTF::String> headers;
  WTF::String blob_uuid;
  uint64_t blob_size;
  ::blink::Referrer referrer;
  ::blink::WebURLRequest::FetchCredentialsMode credentials_mode;
  ::blink::WebURLRequest::FetchRedirectMode redirect_mode;
  WTF::String integrity;
  WTF::String client_id;
  bool is_reload;
  ServiceWorkerFetchType fetch_type;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};


template <typename StructPtrType>
FetchAPIRequestPtr FetchAPIRequest::Clone() const {
  return New(
      mojo::Clone(mode),
      mojo::Clone(is_main_resource_load),
      mojo::Clone(request_context_type),
      mojo::Clone(frame_type),
      mojo::Clone(url),
      mojo::Clone(method),
      mojo::Clone(headers),
      mojo::Clone(blob_uuid),
      mojo::Clone(blob_size),
      mojo::Clone(referrer),
      mojo::Clone(credentials_mode),
      mojo::Clone(redirect_mode),
      mojo::Clone(integrity),
      mojo::Clone(client_id),
      mojo::Clone(is_reload),
      mojo::Clone(fetch_type)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, FetchAPIRequest>::value>::type*>
bool FetchAPIRequest::Equals(const T& other) const {
  if (!mojo::Equals(this->mode, other.mode))
    return false;
  if (!mojo::Equals(this->is_main_resource_load, other.is_main_resource_load))
    return false;
  if (!mojo::Equals(this->request_context_type, other.request_context_type))
    return false;
  if (!mojo::Equals(this->frame_type, other.frame_type))
    return false;
  if (!mojo::Equals(this->url, other.url))
    return false;
  if (!mojo::Equals(this->method, other.method))
    return false;
  if (!mojo::Equals(this->headers, other.headers))
    return false;
  if (!mojo::Equals(this->blob_uuid, other.blob_uuid))
    return false;
  if (!mojo::Equals(this->blob_size, other.blob_size))
    return false;
  if (!mojo::Equals(this->referrer, other.referrer))
    return false;
  if (!mojo::Equals(this->credentials_mode, other.credentials_mode))
    return false;
  if (!mojo::Equals(this->redirect_mode, other.redirect_mode))
    return false;
  if (!mojo::Equals(this->integrity, other.integrity))
    return false;
  if (!mojo::Equals(this->client_id, other.client_id))
    return false;
  if (!mojo::Equals(this->is_reload, other.is_reload))
    return false;
  if (!mojo::Equals(this->fetch_type, other.fetch_type))
    return false;
  return true;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::blink::mojom::blink::FetchAPIRequest::DataView,
                                         ::blink::mojom::blink::FetchAPIRequestPtr> {
  static bool IsNull(const ::blink::mojom::blink::FetchAPIRequestPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::FetchAPIRequestPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::FetchAPIRequest::mode) mode(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->mode;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::is_main_resource_load) is_main_resource_load(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->is_main_resource_load;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::request_context_type) request_context_type(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->request_context_type;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::frame_type) frame_type(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->frame_type;
  }

  static const decltype(::blink::mojom::blink::FetchAPIRequest::url)& url(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->url;
  }

  static const decltype(::blink::mojom::blink::FetchAPIRequest::method)& method(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->method;
  }

  static const decltype(::blink::mojom::blink::FetchAPIRequest::headers)& headers(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->headers;
  }

  static const decltype(::blink::mojom::blink::FetchAPIRequest::blob_uuid)& blob_uuid(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->blob_uuid;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::blob_size) blob_size(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->blob_size;
  }

  static const decltype(::blink::mojom::blink::FetchAPIRequest::referrer)& referrer(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->referrer;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::credentials_mode) credentials_mode(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->credentials_mode;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::redirect_mode) redirect_mode(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->redirect_mode;
  }

  static const decltype(::blink::mojom::blink::FetchAPIRequest::integrity)& integrity(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->integrity;
  }

  static const decltype(::blink::mojom::blink::FetchAPIRequest::client_id)& client_id(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->client_id;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::is_reload) is_reload(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->is_reload;
  }

  static decltype(::blink::mojom::blink::FetchAPIRequest::fetch_type) fetch_type(
      const ::blink::mojom::blink::FetchAPIRequestPtr& input) {
    return input->fetch_type;
  }

  static bool Read(::blink::mojom::blink::FetchAPIRequest::DataView input, ::blink::mojom::blink::FetchAPIRequestPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_FETCH_FETCH_API_REQUEST_MOJOM_BLINK_H_