// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_FETCH_FETCH_API_REQUEST_MOJOM_SHARED_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_FETCH_FETCH_API_REQUEST_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/WebKit/public/platform/modules/fetch/fetch_api_request.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/referrer.mojom-shared.h"
#include "url/mojo/url.mojom-shared.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"


namespace blink {
namespace mojom {
class FetchAPIRequestDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::FetchAPIRequestDataView> {
  using Data = ::blink::mojom::internal::FetchAPIRequest_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {

enum class FetchRequestMode : int32_t {
  SAME_ORIGIN,
  NO_CORS,
  CORS,
  CORS_WITH_FORCED_PREFLIGHT,
  NAVIGATE,
};

inline std::ostream& operator<<(std::ostream& os, FetchRequestMode value) {
  switch(value) {
    case FetchRequestMode::SAME_ORIGIN:
      return os << "FetchRequestMode::SAME_ORIGIN";
    case FetchRequestMode::NO_CORS:
      return os << "FetchRequestMode::NO_CORS";
    case FetchRequestMode::CORS:
      return os << "FetchRequestMode::CORS";
    case FetchRequestMode::CORS_WITH_FORCED_PREFLIGHT:
      return os << "FetchRequestMode::CORS_WITH_FORCED_PREFLIGHT";
    case FetchRequestMode::NAVIGATE:
      return os << "FetchRequestMode::NAVIGATE";
    default:
      return os << "Unknown FetchRequestMode value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(FetchRequestMode value) {
  return internal::FetchRequestMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class RequestContextType : int32_t {
  UNSPECIFIED,
  AUDIO,
  BEACON,
  CSP_REPORT,
  DOWNLOAD,
  EMBED,
  EVENT_SOURCE,
  FAVICON,
  FETCH,
  FONT,
  FORM,
  FRAME,
  HYPERLINK,
  IFRAME,
  IMAGE,
  IMAGE_SET,
  IMPORT,
  INTERNAL,
  LOCATION,
  MANIFEST,
  OBJECT,
  PING,
  PLUGIN,
  PREFETCH,
  SCRIPT,
  SERVICE_WORKER,
  SHARED_WORKER,
  SUBRESOURCE,
  STYLE,
  TRACK,
  VIDEO,
  WORKER,
  XML_HTTP_REQUEST,
  XSLT,
};

inline std::ostream& operator<<(std::ostream& os, RequestContextType value) {
  switch(value) {
    case RequestContextType::UNSPECIFIED:
      return os << "RequestContextType::UNSPECIFIED";
    case RequestContextType::AUDIO:
      return os << "RequestContextType::AUDIO";
    case RequestContextType::BEACON:
      return os << "RequestContextType::BEACON";
    case RequestContextType::CSP_REPORT:
      return os << "RequestContextType::CSP_REPORT";
    case RequestContextType::DOWNLOAD:
      return os << "RequestContextType::DOWNLOAD";
    case RequestContextType::EMBED:
      return os << "RequestContextType::EMBED";
    case RequestContextType::EVENT_SOURCE:
      return os << "RequestContextType::EVENT_SOURCE";
    case RequestContextType::FAVICON:
      return os << "RequestContextType::FAVICON";
    case RequestContextType::FETCH:
      return os << "RequestContextType::FETCH";
    case RequestContextType::FONT:
      return os << "RequestContextType::FONT";
    case RequestContextType::FORM:
      return os << "RequestContextType::FORM";
    case RequestContextType::FRAME:
      return os << "RequestContextType::FRAME";
    case RequestContextType::HYPERLINK:
      return os << "RequestContextType::HYPERLINK";
    case RequestContextType::IFRAME:
      return os << "RequestContextType::IFRAME";
    case RequestContextType::IMAGE:
      return os << "RequestContextType::IMAGE";
    case RequestContextType::IMAGE_SET:
      return os << "RequestContextType::IMAGE_SET";
    case RequestContextType::IMPORT:
      return os << "RequestContextType::IMPORT";
    case RequestContextType::INTERNAL:
      return os << "RequestContextType::INTERNAL";
    case RequestContextType::LOCATION:
      return os << "RequestContextType::LOCATION";
    case RequestContextType::MANIFEST:
      return os << "RequestContextType::MANIFEST";
    case RequestContextType::OBJECT:
      return os << "RequestContextType::OBJECT";
    case RequestContextType::PING:
      return os << "RequestContextType::PING";
    case RequestContextType::PLUGIN:
      return os << "RequestContextType::PLUGIN";
    case RequestContextType::PREFETCH:
      return os << "RequestContextType::PREFETCH";
    case RequestContextType::SCRIPT:
      return os << "RequestContextType::SCRIPT";
    case RequestContextType::SERVICE_WORKER:
      return os << "RequestContextType::SERVICE_WORKER";
    case RequestContextType::SHARED_WORKER:
      return os << "RequestContextType::SHARED_WORKER";
    case RequestContextType::SUBRESOURCE:
      return os << "RequestContextType::SUBRESOURCE";
    case RequestContextType::STYLE:
      return os << "RequestContextType::STYLE";
    case RequestContextType::TRACK:
      return os << "RequestContextType::TRACK";
    case RequestContextType::VIDEO:
      return os << "RequestContextType::VIDEO";
    case RequestContextType::WORKER:
      return os << "RequestContextType::WORKER";
    case RequestContextType::XML_HTTP_REQUEST:
      return os << "RequestContextType::XML_HTTP_REQUEST";
    case RequestContextType::XSLT:
      return os << "RequestContextType::XSLT";
    default:
      return os << "Unknown RequestContextType value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(RequestContextType value) {
  return internal::RequestContextType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class RequestContextFrameType : int32_t {
  AUXILIARY,
  NESTED,
  NONE,
  TOP_LEVEL,
};

inline std::ostream& operator<<(std::ostream& os, RequestContextFrameType value) {
  switch(value) {
    case RequestContextFrameType::AUXILIARY:
      return os << "RequestContextFrameType::AUXILIARY";
    case RequestContextFrameType::NESTED:
      return os << "RequestContextFrameType::NESTED";
    case RequestContextFrameType::NONE:
      return os << "RequestContextFrameType::NONE";
    case RequestContextFrameType::TOP_LEVEL:
      return os << "RequestContextFrameType::TOP_LEVEL";
    default:
      return os << "Unknown RequestContextFrameType value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(RequestContextFrameType value) {
  return internal::RequestContextFrameType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class FetchCredentialsMode : int32_t {
  OMIT,
  SAME_ORIGIN,
  INCLUDE,
  PASSWORD,
};

inline std::ostream& operator<<(std::ostream& os, FetchCredentialsMode value) {
  switch(value) {
    case FetchCredentialsMode::OMIT:
      return os << "FetchCredentialsMode::OMIT";
    case FetchCredentialsMode::SAME_ORIGIN:
      return os << "FetchCredentialsMode::SAME_ORIGIN";
    case FetchCredentialsMode::INCLUDE:
      return os << "FetchCredentialsMode::INCLUDE";
    case FetchCredentialsMode::PASSWORD:
      return os << "FetchCredentialsMode::PASSWORD";
    default:
      return os << "Unknown FetchCredentialsMode value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(FetchCredentialsMode value) {
  return internal::FetchCredentialsMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class FetchRedirectMode : int32_t {
  FOLLOW,
  ERROR_MODE,
  MANUAL,
};

inline std::ostream& operator<<(std::ostream& os, FetchRedirectMode value) {
  switch(value) {
    case FetchRedirectMode::FOLLOW:
      return os << "FetchRedirectMode::FOLLOW";
    case FetchRedirectMode::ERROR_MODE:
      return os << "FetchRedirectMode::ERROR_MODE";
    case FetchRedirectMode::MANUAL:
      return os << "FetchRedirectMode::MANUAL";
    default:
      return os << "Unknown FetchRedirectMode value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(FetchRedirectMode value) {
  return internal::FetchRedirectMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}

enum class ServiceWorkerFetchType : int32_t {
  FETCH,
  FOREIGN_FETCH,
};

inline std::ostream& operator<<(std::ostream& os, ServiceWorkerFetchType value) {
  switch(value) {
    case ServiceWorkerFetchType::FETCH:
      return os << "ServiceWorkerFetchType::FETCH";
    case ServiceWorkerFetchType::FOREIGN_FETCH:
      return os << "ServiceWorkerFetchType::FOREIGN_FETCH";
    default:
      return os << "Unknown ServiceWorkerFetchType value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(ServiceWorkerFetchType value) {
  return internal::ServiceWorkerFetchType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
class FetchAPIRequestDataView {
 public:
  FetchAPIRequestDataView() {}

  FetchAPIRequestDataView(
      internal::FetchAPIRequest_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMode(UserType* output) const {
    auto data_value = data_->mode;
    return mojo::internal::Deserialize<::blink::mojom::FetchRequestMode>(
        data_value, output);
  }

  FetchRequestMode mode() const {
    return static_cast<FetchRequestMode>(data_->mode);
  }
  bool is_main_resource_load() const {
    return data_->is_main_resource_load;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRequestContextType(UserType* output) const {
    auto data_value = data_->request_context_type;
    return mojo::internal::Deserialize<::blink::mojom::RequestContextType>(
        data_value, output);
  }

  RequestContextType request_context_type() const {
    return static_cast<RequestContextType>(data_->request_context_type);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrameType(UserType* output) const {
    auto data_value = data_->frame_type;
    return mojo::internal::Deserialize<::blink::mojom::RequestContextFrameType>(
        data_value, output);
  }

  RequestContextFrameType frame_type() const {
    return static_cast<RequestContextFrameType>(data_->frame_type);
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetMethodDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMethod(UserType* output) {
    auto* pointer = data_->method.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetHeadersDataView(
      mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHeaders(UserType* output) {
    auto* pointer = data_->headers.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>>(
        pointer, output, context_);
  }
  inline void GetBlobUuidDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBlobUuid(UserType* output) {
    auto* pointer = data_->blob_uuid.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  uint64_t blob_size() const {
    return data_->blob_size;
  }
  inline void GetReferrerDataView(
      ::blink::mojom::ReferrerDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReferrer(UserType* output) {
    auto* pointer = data_->referrer.Get();
    return mojo::internal::Deserialize<::blink::mojom::ReferrerDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCredentialsMode(UserType* output) const {
    auto data_value = data_->credentials_mode;
    return mojo::internal::Deserialize<::blink::mojom::FetchCredentialsMode>(
        data_value, output);
  }

  FetchCredentialsMode credentials_mode() const {
    return static_cast<FetchCredentialsMode>(data_->credentials_mode);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRedirectMode(UserType* output) const {
    auto data_value = data_->redirect_mode;
    return mojo::internal::Deserialize<::blink::mojom::FetchRedirectMode>(
        data_value, output);
  }

  FetchRedirectMode redirect_mode() const {
    return static_cast<FetchRedirectMode>(data_->redirect_mode);
  }
  inline void GetIntegrityDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIntegrity(UserType* output) {
    auto* pointer = data_->integrity.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetClientIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadClientId(UserType* output) {
    auto* pointer = data_->client_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool is_reload() const {
    return data_->is_reload;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFetchType(UserType* output) const {
    auto data_value = data_->fetch_type;
    return mojo::internal::Deserialize<::blink::mojom::ServiceWorkerFetchType>(
        data_value, output);
  }

  ServiceWorkerFetchType fetch_type() const {
    return static_cast<ServiceWorkerFetchType>(data_->fetch_type);
  }
 private:
  internal::FetchAPIRequest_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::FetchRequestMode>
    : public mojo::internal::EnumHashImpl<::blink::mojom::FetchRequestMode> {};

template <>
struct hash<::blink::mojom::RequestContextType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::RequestContextType> {};

template <>
struct hash<::blink::mojom::RequestContextFrameType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::RequestContextFrameType> {};

template <>
struct hash<::blink::mojom::FetchCredentialsMode>
    : public mojo::internal::EnumHashImpl<::blink::mojom::FetchCredentialsMode> {};

template <>
struct hash<::blink::mojom::FetchRedirectMode>
    : public mojo::internal::EnumHashImpl<::blink::mojom::FetchRedirectMode> {};

template <>
struct hash<::blink::mojom::ServiceWorkerFetchType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::ServiceWorkerFetchType> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::blink::mojom::FetchRequestMode, ::blink::mojom::FetchRequestMode> {
  static ::blink::mojom::FetchRequestMode ToMojom(::blink::mojom::FetchRequestMode input) { return input; }
  static bool FromMojom(::blink::mojom::FetchRequestMode input, ::blink::mojom::FetchRequestMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::FetchRequestMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::FetchRequestMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::FetchRequestMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::RequestContextType, ::blink::mojom::RequestContextType> {
  static ::blink::mojom::RequestContextType ToMojom(::blink::mojom::RequestContextType input) { return input; }
  static bool FromMojom(::blink::mojom::RequestContextType input, ::blink::mojom::RequestContextType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::RequestContextType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::RequestContextType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::RequestContextType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::RequestContextFrameType, ::blink::mojom::RequestContextFrameType> {
  static ::blink::mojom::RequestContextFrameType ToMojom(::blink::mojom::RequestContextFrameType input) { return input; }
  static bool FromMojom(::blink::mojom::RequestContextFrameType input, ::blink::mojom::RequestContextFrameType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::RequestContextFrameType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::RequestContextFrameType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::RequestContextFrameType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::FetchCredentialsMode, ::blink::mojom::FetchCredentialsMode> {
  static ::blink::mojom::FetchCredentialsMode ToMojom(::blink::mojom::FetchCredentialsMode input) { return input; }
  static bool FromMojom(::blink::mojom::FetchCredentialsMode input, ::blink::mojom::FetchCredentialsMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::FetchCredentialsMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::FetchCredentialsMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::FetchCredentialsMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::FetchRedirectMode, ::blink::mojom::FetchRedirectMode> {
  static ::blink::mojom::FetchRedirectMode ToMojom(::blink::mojom::FetchRedirectMode input) { return input; }
  static bool FromMojom(::blink::mojom::FetchRedirectMode input, ::blink::mojom::FetchRedirectMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::FetchRedirectMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::FetchRedirectMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::FetchRedirectMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::ServiceWorkerFetchType, ::blink::mojom::ServiceWorkerFetchType> {
  static ::blink::mojom::ServiceWorkerFetchType ToMojom(::blink::mojom::ServiceWorkerFetchType input) { return input; }
  static bool FromMojom(::blink::mojom::ServiceWorkerFetchType input, ::blink::mojom::ServiceWorkerFetchType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ServiceWorkerFetchType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::ServiceWorkerFetchType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::ServiceWorkerFetchType>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::FetchAPIRequestDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::FetchAPIRequestDataView, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    const bool is_null = CallIsNullIfExists<Traits>(input);
    context->PushNextNullState(is_null);
    if (is_null)
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::blink::mojom::internal::FetchAPIRequest_Data);
    decltype(CallWithContext(Traits::url, input, custom_context)) in_url = CallWithContext(Traits::url, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::url::mojom::UrlDataView>(
        in_url, context);
    decltype(CallWithContext(Traits::method, input, custom_context)) in_method = CallWithContext(Traits::method, input, custom_context);
    size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
        in_method, context);
    decltype(CallWithContext(Traits::headers, input, custom_context)) in_headers = CallWithContext(Traits::headers, input, custom_context);
    size += mojo::internal::PrepareToSerialize<mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>>(
        in_headers, context);
    decltype(CallWithContext(Traits::blob_uuid, input, custom_context)) in_blob_uuid = CallWithContext(Traits::blob_uuid, input, custom_context);
    size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
        in_blob_uuid, context);
    decltype(CallWithContext(Traits::referrer, input, custom_context)) in_referrer = CallWithContext(Traits::referrer, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::blink::mojom::ReferrerDataView>(
        in_referrer, context);
    decltype(CallWithContext(Traits::integrity, input, custom_context)) in_integrity = CallWithContext(Traits::integrity, input, custom_context);
    size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
        in_integrity, context);
    decltype(CallWithContext(Traits::client_id, input, custom_context)) in_client_id = CallWithContext(Traits::client_id, input, custom_context);
    size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
        in_client_id, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::FetchAPIRequest_Data** output,
                        SerializationContext* context) {
    if (context->IsNextFieldNull()) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
        ::blink::mojom::internal::FetchAPIRequest_Data::New(buffer);
    ALLOW_UNUSED_LOCAL(result);
    mojo::internal::Serialize<::blink::mojom::FetchRequestMode>(
        CallWithContext(Traits::mode, input, custom_context), &result->mode);
    result->is_main_resource_load = CallWithContext(Traits::is_main_resource_load, input, custom_context);
    mojo::internal::Serialize<::blink::mojom::RequestContextType>(
        CallWithContext(Traits::request_context_type, input, custom_context), &result->request_context_type);
    mojo::internal::Serialize<::blink::mojom::RequestContextFrameType>(
        CallWithContext(Traits::frame_type, input, custom_context), &result->frame_type);
    decltype(CallWithContext(Traits::url, input, custom_context)) in_url = CallWithContext(Traits::url, input, custom_context);
    typename decltype(result->url)::BaseType* url_ptr;
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_url, buffer, &url_ptr, context);
    result->url.Set(url_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null url in FetchAPIRequest struct");
    decltype(CallWithContext(Traits::method, input, custom_context)) in_method = CallWithContext(Traits::method, input, custom_context);
    typename decltype(result->method)::BaseType* method_ptr;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_method, buffer, &method_ptr, context);
    result->method.Set(method_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->method.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null method in FetchAPIRequest struct");
    decltype(CallWithContext(Traits::headers, input, custom_context)) in_headers = CallWithContext(Traits::headers, input, custom_context);
    typename decltype(result->headers)::BaseType* headers_ptr;
    const mojo::internal::ContainerValidateParams headers_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)), new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)));
    mojo::internal::Serialize<mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>>(
        in_headers, buffer, &headers_ptr, &headers_validate_params,
        context);
    result->headers.Set(headers_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->headers.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null headers in FetchAPIRequest struct");
    decltype(CallWithContext(Traits::blob_uuid, input, custom_context)) in_blob_uuid = CallWithContext(Traits::blob_uuid, input, custom_context);
    typename decltype(result->blob_uuid)::BaseType* blob_uuid_ptr;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_blob_uuid, buffer, &blob_uuid_ptr, context);
    result->blob_uuid.Set(blob_uuid_ptr);
    result->blob_size = CallWithContext(Traits::blob_size, input, custom_context);
    decltype(CallWithContext(Traits::referrer, input, custom_context)) in_referrer = CallWithContext(Traits::referrer, input, custom_context);
    typename decltype(result->referrer)::BaseType* referrer_ptr;
    mojo::internal::Serialize<::blink::mojom::ReferrerDataView>(
        in_referrer, buffer, &referrer_ptr, context);
    result->referrer.Set(referrer_ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        result->referrer.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null referrer in FetchAPIRequest struct");
    mojo::internal::Serialize<::blink::mojom::FetchCredentialsMode>(
        CallWithContext(Traits::credentials_mode, input, custom_context), &result->credentials_mode);
    mojo::internal::Serialize<::blink::mojom::FetchRedirectMode>(
        CallWithContext(Traits::redirect_mode, input, custom_context), &result->redirect_mode);
    decltype(CallWithContext(Traits::integrity, input, custom_context)) in_integrity = CallWithContext(Traits::integrity, input, custom_context);
    typename decltype(result->integrity)::BaseType* integrity_ptr;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_integrity, buffer, &integrity_ptr, context);
    result->integrity.Set(integrity_ptr);
    decltype(CallWithContext(Traits::client_id, input, custom_context)) in_client_id = CallWithContext(Traits::client_id, input, custom_context);
    typename decltype(result->client_id)::BaseType* client_id_ptr;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_client_id, buffer, &client_id_ptr, context);
    result->client_id.Set(client_id_ptr);
    result->is_reload = CallWithContext(Traits::is_reload, input, custom_context);
    mojo::internal::Serialize<::blink::mojom::ServiceWorkerFetchType>(
        CallWithContext(Traits::fetch_type, input, custom_context), &result->fetch_type);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::FetchAPIRequest_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::FetchAPIRequestDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void FetchAPIRequestDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void FetchAPIRequestDataView::GetMethodDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->method.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void FetchAPIRequestDataView::GetHeadersDataView(
    mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>* output) {
  auto pointer = data_->headers.Get();
  *output = mojo::MapDataView<mojo::StringDataView, mojo::StringDataView>(pointer, context_);
}
inline void FetchAPIRequestDataView::GetBlobUuidDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->blob_uuid.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void FetchAPIRequestDataView::GetReferrerDataView(
    ::blink::mojom::ReferrerDataView* output) {
  auto pointer = data_->referrer.Get();
  *output = ::blink::mojom::ReferrerDataView(pointer, context_);
}
inline void FetchAPIRequestDataView::GetIntegrityDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->integrity.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void FetchAPIRequestDataView::GetClientIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->client_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_FETCH_FETCH_API_REQUEST_MOJOM_SHARED_H_
