// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

struct KeyboardLockRequestResult_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
constexpr uint32_t kKeyboardLockService_RequestKeyboardLock_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT KeyboardLockService_RequestKeyboardLock_Params_Data {
 public:
  static KeyboardLockService_RequestKeyboardLock_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> key_codes;

 private:
  KeyboardLockService_RequestKeyboardLock_Params_Data();
  ~KeyboardLockService_RequestKeyboardLock_Params_Data() = delete;
};
static_assert(sizeof(KeyboardLockService_RequestKeyboardLock_Params_Data) == 16,
              "Bad sizeof(KeyboardLockService_RequestKeyboardLock_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT KeyboardLockService_RequestKeyboardLock_ResponseParams_Data {
 public:
  static KeyboardLockService_RequestKeyboardLock_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  KeyboardLockService_RequestKeyboardLock_ResponseParams_Data();
  ~KeyboardLockService_RequestKeyboardLock_ResponseParams_Data() = delete;
};
static_assert(sizeof(KeyboardLockService_RequestKeyboardLock_ResponseParams_Data) == 16,
              "Bad sizeof(KeyboardLockService_RequestKeyboardLock_ResponseParams_Data)");
constexpr uint32_t kKeyboardLockService_CancelKeyboardLock_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT KeyboardLockService_CancelKeyboardLock_Params_Data {
 public:
  static KeyboardLockService_CancelKeyboardLock_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  KeyboardLockService_CancelKeyboardLock_Params_Data();
  ~KeyboardLockService_CancelKeyboardLock_Params_Data() = delete;
};
static_assert(sizeof(KeyboardLockService_CancelKeyboardLock_Params_Data) == 8,
              "Bad sizeof(KeyboardLockService_CancelKeyboardLock_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_INTERNAL_H_