// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/WebKit/public/platform/modules/offscreencanvas/offscreen_canvas_surface.mojom-shared.h"
#include "cc/ipc/frame_sink_id.mojom.h"
#include "cc/ipc/frame_sink_manager.mojom.h"
#include "cc/ipc/compositor_frame_sink.mojom.h"
#include "cc/ipc/surface_id.mojom.h"
#include "cc/ipc/surface_info.mojom.h"
#include "cc/ipc/surface_sequence.mojom.h"
#include <string>
#include <vector>
#include "content/common/content_export.h"


namespace blink {
namespace mojom {
class OffscreenCanvasSurface;
using OffscreenCanvasSurfacePtr = mojo::InterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfacePtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasSurface>;
using ThreadSafeOffscreenCanvasSurfacePtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceRequest = mojo::InterfaceRequest<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasSurface>;
using ThreadSafeOffscreenCanvasSurfaceAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasSurface>;

class OffscreenCanvasSurfaceClient;
using OffscreenCanvasSurfaceClientPtr = mojo::InterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientPtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasSurfaceClient>;
using ThreadSafeOffscreenCanvasSurfaceClientPtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientRequest = mojo::InterfaceRequest<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasSurfaceClient>;
using ThreadSafeOffscreenCanvasSurfaceClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasSurfaceClient>;

class OffscreenCanvasProvider;
using OffscreenCanvasProviderPtr = mojo::InterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderPtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasProvider>;
using ThreadSafeOffscreenCanvasProviderPtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderRequest = mojo::InterfaceRequest<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasProvider>;
using ThreadSafeOffscreenCanvasProviderAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasProvider>;


class OffscreenCanvasSurfaceProxy;

template <typename ImplRefTraits>
class OffscreenCanvasSurfaceStub;

class OffscreenCanvasSurfaceRequestValidator;

class CONTENT_EXPORT OffscreenCanvasSurface
    : public OffscreenCanvasSurfaceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasSurfaceProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasSurfaceStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasSurfaceRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kRequireMinVersion = 0,
    kSatisfyMinVersion = 0,
  };
  virtual ~OffscreenCanvasSurface() {}

  virtual void Require(const viz::SurfaceId& surface_id, const viz::SurfaceSequence& sequence) = 0;

  virtual void Satisfy(const viz::SurfaceSequence& sequence) = 0;
};

class OffscreenCanvasSurfaceClientProxy;

template <typename ImplRefTraits>
class OffscreenCanvasSurfaceClientStub;

class OffscreenCanvasSurfaceClientRequestValidator;

class CONTENT_EXPORT OffscreenCanvasSurfaceClient
    : public OffscreenCanvasSurfaceClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasSurfaceClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasSurfaceClientStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasSurfaceClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnSurfaceCreatedMinVersion = 0,
  };
  virtual ~OffscreenCanvasSurfaceClient() {}

  virtual void OnSurfaceCreated(const viz::SurfaceInfo& surface_info) = 0;
};

class OffscreenCanvasProviderProxy;

template <typename ImplRefTraits>
class OffscreenCanvasProviderStub;

class OffscreenCanvasProviderRequestValidator;

class CONTENT_EXPORT OffscreenCanvasProvider
    : public OffscreenCanvasProviderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasProviderStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasProviderRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateOffscreenCanvasSurfaceMinVersion = 0,
    kCreateCompositorFrameSinkMinVersion = 0,
  };
  virtual ~OffscreenCanvasProvider() {}

  virtual void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client, OffscreenCanvasSurfaceRequest surface) = 0;

  virtual void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::cc::mojom::CompositorFrameSinkClientPtr client, ::cc::mojom::CompositorFrameSinkRequest sink) = 0;
};

class CONTENT_EXPORT OffscreenCanvasSurfaceProxy
    : public OffscreenCanvasSurface {
 public:
  explicit OffscreenCanvasSurfaceProxy(mojo::MessageReceiverWithResponder* receiver);
  void Require(const viz::SurfaceId& surface_id, const viz::SurfaceSequence& sequence) override;
  void Satisfy(const viz::SurfaceSequence& sequence) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class CONTENT_EXPORT OffscreenCanvasSurfaceClientProxy
    : public OffscreenCanvasSurfaceClient {
 public:
  explicit OffscreenCanvasSurfaceClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnSurfaceCreated(const viz::SurfaceInfo& surface_info) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class CONTENT_EXPORT OffscreenCanvasProviderProxy
    : public OffscreenCanvasProvider {
 public:
  explicit OffscreenCanvasProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client, OffscreenCanvasSurfaceRequest surface) override;
  void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::cc::mojom::CompositorFrameSinkClientPtr client, ::cc::mojom::CompositorFrameSinkRequest sink) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceStubDispatch {
 public:
  static bool Accept(OffscreenCanvasSurface* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasSurface* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasSurface>>
class OffscreenCanvasSurfaceStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasSurfaceStub() {}
  ~OffscreenCanvasSurfaceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceClientStubDispatch {
 public:
  static bool Accept(OffscreenCanvasSurfaceClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasSurfaceClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasSurfaceClient>>
class OffscreenCanvasSurfaceClientStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasSurfaceClientStub() {}
  ~OffscreenCanvasSurfaceClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT OffscreenCanvasProviderStubDispatch {
 public:
  static bool Accept(OffscreenCanvasProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasProvider>>
class OffscreenCanvasProviderStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasProviderStub() {}
  ~OffscreenCanvasProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceClientRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT OffscreenCanvasProviderRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_H_